/* theme-manager.c generated by valac 0.56.18, the Vala compiler
 * generated from theme-manager.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2020 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <librsvg/rsvg.h>
#include <gtk/gtk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME_MANAGER (theme_manager_get_type ())
#define THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_MANAGER, ThemeManager))
#define THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_MANAGER, ThemeManagerClass))
#define IS_THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_MANAGER))
#define IS_THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_MANAGER))
#define THEME_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_MANAGER, ThemeManagerClass))

typedef struct _ThemeManager ThemeManager;
typedef struct _ThemeManagerClass ThemeManagerClass;
typedef struct _ThemeManagerPrivate ThemeManagerPrivate;
enum  {
	THEME_MANAGER_0_PROPERTY,
	THEME_MANAGER_THEME_PROPERTY,
	THEME_MANAGER_BACKGROUND_RED_PROPERTY,
	THEME_MANAGER_BACKGROUND_GREEN_PROPERTY,
	THEME_MANAGER_BACKGROUND_BLUE_PROPERTY,
	THEME_MANAGER_BACKGROUND_RADIUS_PROPERTY,
	THEME_MANAGER_TEXTURE_ALPHA_PROPERTY,
	THEME_MANAGER_APPLY_TEXTURE_PROPERTY,
	THEME_MANAGER_BORDER_RED_PROPERTY,
	THEME_MANAGER_BORDER_GREEN_PROPERTY,
	THEME_MANAGER_BORDER_BLUE_PROPERTY,
	THEME_MANAGER_BORDER_WIDTH_PROPERTY,
	THEME_MANAGER_HALF_BORDER_WIDTH_PROPERTY,
	THEME_MANAGER_SPACING_RED_PROPERTY,
	THEME_MANAGER_SPACING_GREEN_PROPERTY,
	THEME_MANAGER_SPACING_BLUE_PROPERTY,
	THEME_MANAGER_SPACING_WIDTH_PROPERTY,
	THEME_MANAGER_HIGHLIGHT_HARD_RED_PROPERTY,
	THEME_MANAGER_HIGHLIGHT_HARD_GREEN_PROPERTY,
	THEME_MANAGER_HIGHLIGHT_HARD_BLUE_PROPERTY,
	THEME_MANAGER_HIGHLIGHT_HARD_ALPHA_PROPERTY,
	THEME_MANAGER_HIGHLIGHT_SOFT_RED_PROPERTY,
	THEME_MANAGER_HIGHLIGHT_SOFT_GREEN_PROPERTY,
	THEME_MANAGER_HIGHLIGHT_SOFT_BLUE_PROPERTY,
	THEME_MANAGER_HIGHLIGHT_SOFT_ALPHA_PROPERTY,
	THEME_MANAGER_SOUND_FLIP_PROPERTY,
	THEME_MANAGER_SOUND_GAMEOVER_PROPERTY,
	THEME_MANAGER_TILESET_HANDLE_PROPERTY,
	THEME_MANAGER_NUM_PROPERTIES
};
static GParamSpec* theme_manager_properties[THEME_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
enum  {
	THEME_MANAGER_THEME_CHANGED_SIGNAL,
	THEME_MANAGER_NUM_SIGNALS
};
static guint theme_manager_signals[THEME_MANAGER_NUM_SIGNALS] = {0};

struct _ThemeManager {
	GObject parent_instance;
	ThemeManagerPrivate * priv;
};

struct _ThemeManagerClass {
	GObjectClass parent_class;
};

struct _ThemeManagerPrivate {
	gboolean theme_set;
	gchar* _theme;
	gchar* pieces_file;
	gdouble _background_red;
	gdouble _background_green;
	gdouble _background_blue;
	gint _background_radius;
	gdouble _texture_alpha;
	gboolean _apply_texture;
	gdouble _border_red;
	gdouble _border_green;
	gdouble _border_blue;
	gint _border_width;
	gdouble _half_border_width;
	gdouble _spacing_red;
	gdouble _spacing_green;
	gdouble _spacing_blue;
	gint _spacing_width;
	gdouble _highlight_hard_red;
	gdouble _highlight_hard_green;
	gdouble _highlight_hard_blue;
	gdouble _highlight_hard_alpha;
	gdouble _highlight_soft_red;
	gdouble _highlight_soft_green;
	gdouble _highlight_soft_blue;
	gdouble _highlight_soft_alpha;
	gchar* _sound_flip;
	gchar* _sound_gameover;
	gboolean handle_loaded;
	RsvgHandle* _tileset_handle;
	gchar* old_pieces_file;
};

static gint ThemeManager_private_offset;
static gpointer theme_manager_parent_class = NULL;

VALA_EXTERN GType theme_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeManager, g_object_unref)
VALA_EXTERN void theme_manager_gtk_theme_changed (ThemeManager* self);
static const gchar* theme_manager_get_theme (ThemeManager* self);
VALA_EXTERN void theme_manager_set_theme (ThemeManager* self,
                              const gchar* value);
static void theme_manager_set_default_theme (ThemeManager* self,
                                      GKeyFile** key);
static inline void theme_manager_load_theme (ThemeManager* self,
                               GKeyFile* key);
static inline void theme_manager_load_handle (ThemeManager* self);
static void theme_manager_set_background_red (ThemeManager* self,
                                       gdouble value);
static void theme_manager_set_background_green (ThemeManager* self,
                                         gdouble value);
static void theme_manager_set_background_blue (ThemeManager* self,
                                        gdouble value);
static void theme_manager_set_background_radius (ThemeManager* self,
                                          gint value);
static void theme_manager_set_texture_alpha (ThemeManager* self,
                                      gdouble value);
VALA_EXTERN gdouble theme_manager_get_texture_alpha (ThemeManager* self);
static void theme_manager_set_apply_texture (ThemeManager* self,
                                      gboolean value);
static void theme_manager_set_border_red (ThemeManager* self,
                                   gdouble value);
static void theme_manager_set_border_green (ThemeManager* self,
                                     gdouble value);
static void theme_manager_set_border_blue (ThemeManager* self,
                                    gdouble value);
static void theme_manager_set_border_width (ThemeManager* self,
                                     gint value);
VALA_EXTERN gint theme_manager_get_border_width (ThemeManager* self);
static void theme_manager_set_half_border_width (ThemeManager* self,
                                          gdouble value);
static void theme_manager_set_spacing_red (ThemeManager* self,
                                    gdouble value);
static void theme_manager_set_spacing_green (ThemeManager* self,
                                      gdouble value);
static void theme_manager_set_spacing_blue (ThemeManager* self,
                                     gdouble value);
static void theme_manager_set_spacing_width (ThemeManager* self,
                                      gint value);
static void theme_manager_set_highlight_hard_red (ThemeManager* self,
                                           gdouble value);
static void theme_manager_set_highlight_hard_green (ThemeManager* self,
                                             gdouble value);
static void theme_manager_set_highlight_hard_blue (ThemeManager* self,
                                            gdouble value);
static void theme_manager_set_highlight_hard_alpha (ThemeManager* self,
                                             gdouble value);
static void theme_manager_set_highlight_soft_red (ThemeManager* self,
                                           gdouble value);
static void theme_manager_set_highlight_soft_green (ThemeManager* self,
                                             gdouble value);
static void theme_manager_set_highlight_soft_blue (ThemeManager* self,
                                            gdouble value);
static void theme_manager_set_highlight_soft_alpha (ThemeManager* self,
                                             gdouble value);
static void theme_manager_set_sound_flip (ThemeManager* self,
                                   const gchar* value);
static void theme_manager_set_sound_gameover (ThemeManager* self,
                                       const gchar* value);
VALA_EXTERN ThemeManager* theme_manager_new (void);
VALA_EXTERN ThemeManager* theme_manager_construct (GType object_type);
VALA_EXTERN gdouble theme_manager_get_background_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_background_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_background_blue (ThemeManager* self);
VALA_EXTERN gint theme_manager_get_background_radius (ThemeManager* self);
VALA_EXTERN gboolean theme_manager_get_apply_texture (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_border_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_border_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_border_blue (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_half_border_width (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_spacing_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_spacing_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_spacing_blue (ThemeManager* self);
VALA_EXTERN gint theme_manager_get_spacing_width (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_hard_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_hard_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_hard_blue (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_hard_alpha (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_soft_red (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_soft_green (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_soft_blue (ThemeManager* self);
VALA_EXTERN gdouble theme_manager_get_highlight_soft_alpha (ThemeManager* self);
VALA_EXTERN const gchar* theme_manager_get_sound_flip (ThemeManager* self);
VALA_EXTERN const gchar* theme_manager_get_sound_gameover (ThemeManager* self);
VALA_EXTERN RsvgHandle* theme_manager_get_tileset_handle (ThemeManager* self);
static void theme_manager_finalize (GObject * obj);
static GType theme_manager_get_type_once (void);
static void _vala_theme_manager_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_theme_manager_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
theme_manager_get_instance_private (ThemeManager* self)
{
	return G_STRUCT_MEMBER_P (self, ThemeManager_private_offset);
}

void
theme_manager_gtk_theme_changed (ThemeManager* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 29 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/theme-manager.vala"
	_tmp1_ = theme_manager_get_theme (self);
#line 31 "../src/theme-manager.vala"
	_tmp2_ = _tmp1_;
#line 31 "../src/theme-manager.vala"
	if (g_strcmp0 (_tmp2_, "") == 0) {
#line 31 "../src/theme-manager.vala"
		_tmp0_ = TRUE;
#line 274 "theme-manager.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 31 "../src/theme-manager.vala"
		_tmp3_ = theme_manager_get_theme (self);
#line 31 "../src/theme-manager.vala"
		_tmp4_ = _tmp3_;
#line 31 "../src/theme-manager.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, "default") == 0;
#line 284 "theme-manager.c"
	}
#line 31 "../src/theme-manager.vala"
	if (_tmp0_) {
#line 32 "../src/theme-manager.vala"
		theme_manager_set_theme (self, "default");
#line 290 "theme-manager.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 73 "../src/theme-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 299 "theme-manager.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 318 "theme-manager.c"
}

static void
theme_manager_set_default_theme (ThemeManager* self,
                                 GKeyFile** key)
{
	GtkSettings* defaults = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* filename = NULL;
	gboolean _tmp2_ = FALSE;
	GtkSettings* _tmp3_;
	gchar* filepath = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
#line 71 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/theme-manager.vala"
	g_return_if_fail (*key != NULL);
#line 73 "../src/theme-manager.vala"
	_tmp0_ = gtk_settings_get_default ();
#line 73 "../src/theme-manager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 73 "../src/theme-manager.vala"
	defaults = _tmp1_;
#line 76 "../src/theme-manager.vala"
	_tmp3_ = defaults;
#line 76 "../src/theme-manager.vala"
	if (_tmp3_ != NULL) {
#line 349 "theme-manager.c"
		GtkSettings* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 76 "../src/theme-manager.vala"
		_tmp4_ = defaults;
#line 76 "../src/theme-manager.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp5_, NULL);
#line 76 "../src/theme-manager.vala"
		_tmp6_ = _tmp5_;
#line 76 "../src/theme-manager.vala"
		_tmp7_ = _tmp6_;
#line 76 "../src/theme-manager.vala"
		_tmp2_ = string_contains (_tmp7_, "HighContrast");
#line 76 "../src/theme-manager.vala"
		_g_free0 (_tmp7_);
#line 366 "theme-manager.c"
	} else {
#line 76 "../src/theme-manager.vala"
		_tmp2_ = FALSE;
#line 370 "theme-manager.c"
	}
#line 76 "../src/theme-manager.vala"
	if (_tmp2_) {
#line 374 "theme-manager.c"
		gchar* _tmp8_;
#line 77 "../src/theme-manager.vala"
		_tmp8_ = g_strdup ("high_contrast.theme");
#line 77 "../src/theme-manager.vala"
		_g_free0 (filename);
#line 77 "../src/theme-manager.vala"
		filename = _tmp8_;
#line 382 "theme-manager.c"
	} else {
		gboolean _tmp9_ = FALSE;
		GtkSettings* _tmp10_;
#line 78 "../src/theme-manager.vala"
		_tmp10_ = defaults;
#line 78 "../src/theme-manager.vala"
		if (_tmp10_ != NULL) {
#line 390 "theme-manager.c"
			gboolean _tmp11_ = FALSE;
			GtkSettings* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 78 "../src/theme-manager.vala"
			_tmp12_ = defaults;
#line 78 "../src/theme-manager.vala"
			g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_settings_get_type (), GtkSettings), "gtk-application-prefer-dark-theme", &_tmp13_, NULL);
#line 78 "../src/theme-manager.vala"
			_tmp14_ = _tmp13_;
#line 78 "../src/theme-manager.vala"
			if (_tmp14_ == TRUE) {
#line 78 "../src/theme-manager.vala"
				_tmp11_ = TRUE;
#line 405 "theme-manager.c"
			} else {
				GtkSettings* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
#line 79 "../src/theme-manager.vala"
				_tmp15_ = defaults;
#line 79 "../src/theme-manager.vala"
				g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_settings_get_type (), GtkSettings), "gtk-theme-name", &_tmp16_, NULL);
#line 79 "../src/theme-manager.vala"
				_tmp17_ = _tmp16_;
#line 79 "../src/theme-manager.vala"
				_tmp18_ = _tmp17_;
#line 79 "../src/theme-manager.vala"
				_tmp11_ = g_strcmp0 (_tmp18_, "Adwaita-dark") == 0;
#line 79 "../src/theme-manager.vala"
				_g_free0 (_tmp18_);
#line 423 "theme-manager.c"
			}
#line 78 "../src/theme-manager.vala"
			_tmp9_ = _tmp11_;
#line 427 "theme-manager.c"
		} else {
#line 78 "../src/theme-manager.vala"
			_tmp9_ = FALSE;
#line 431 "theme-manager.c"
		}
#line 78 "../src/theme-manager.vala"
		if (_tmp9_) {
#line 435 "theme-manager.c"
			gchar* _tmp19_;
#line 80 "../src/theme-manager.vala"
			_tmp19_ = g_strdup ("adwaita.theme");
#line 80 "../src/theme-manager.vala"
			_g_free0 (filename);
#line 80 "../src/theme-manager.vala"
			filename = _tmp19_;
#line 443 "theme-manager.c"
		} else {
			gchar* _tmp20_;
#line 82 "../src/theme-manager.vala"
			_tmp20_ = g_strdup ("classic.theme");
#line 82 "../src/theme-manager.vala"
			_g_free0 (filename);
#line 82 "../src/theme-manager.vala"
			filename = _tmp20_;
#line 452 "theme-manager.c"
		}
	}
#line 84 "../src/theme-manager.vala"
	_tmp21_ = filename;
#line 84 "../src/theme-manager.vala"
	_tmp22_ = g_build_filename (DATA_DIRECTORY, "themes", "key", _tmp21_, NULL);
#line 84 "../src/theme-manager.vala"
	filepath = _tmp22_;
#line 461 "theme-manager.c"
	{
#line 87 "../src/theme-manager.vala"
		g_key_file_load_from_file (*key, filepath, G_KEY_FILE_NONE, &_inner_error0_);
#line 87 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 467 "theme-manager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 85 "../src/theme-manager.vala"
		g_clear_error (&_inner_error0_);
#line 89 "../src/theme-manager.vala"
		g_assert_not_reached ();
#line 478 "theme-manager.c"
	}
	__finally0:
#line 85 "../src/theme-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/theme-manager.vala"
		_g_free0 (filepath);
#line 85 "../src/theme-manager.vala"
		_g_free0 (filename);
#line 85 "../src/theme-manager.vala"
		_g_object_unref0 (defaults);
#line 85 "../src/theme-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/theme-manager.vala"
		g_clear_error (&_inner_error0_);
#line 85 "../src/theme-manager.vala"
		return;
#line 495 "theme-manager.c"
	}
#line 71 "../src/theme-manager.vala"
	_g_free0 (filepath);
#line 71 "../src/theme-manager.vala"
	_g_free0 (filename);
#line 71 "../src/theme-manager.vala"
	_g_object_unref0 (defaults);
#line 503 "theme-manager.c"
}

static inline void
theme_manager_load_theme (ThemeManager* self,
                          GKeyFile* key)
{
	GError* _inner_error0_ = NULL;
#line 137 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/theme-manager.vala"
	g_return_if_fail (key != NULL);
#line 515 "theme-manager.c"
	{
		gchar* svg_path = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gboolean _tmp9_;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gint _tmp15_ = 0;
		gdouble _tmp16_ = 0.0;
		gboolean _tmp17_ = FALSE;
		gdouble _tmp18_;
		gdouble _tmp20_ = 0.0;
		gdouble _tmp21_ = 0.0;
		gdouble _tmp22_ = 0.0;
		gint _tmp23_ = 0;
		gint _tmp24_;
		gdouble _tmp25_ = 0.0;
		gdouble _tmp26_ = 0.0;
		gdouble _tmp27_ = 0.0;
		gint _tmp28_ = 0;
		gdouble _tmp29_ = 0.0;
		gdouble _tmp30_ = 0.0;
		gdouble _tmp31_ = 0.0;
		gdouble _tmp32_ = 0.0;
		gdouble _tmp33_ = 0.0;
		gdouble _tmp34_ = 0.0;
		gdouble _tmp35_ = 0.0;
		gdouble _tmp36_ = 0.0;
		gchar* _tmp37_ = NULL;
		gchar* _tmp38_;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_;
#line 141 "../src/theme-manager.vala"
		_tmp0_ = g_build_filename (DATA_DIRECTORY, "themes", "svg", NULL);
#line 141 "../src/theme-manager.vala"
		svg_path = _tmp0_;
#line 142 "../src/theme-manager.vala"
		_tmp2_ = g_key_file_get_string (key, "Pieces", "File", &_inner_error0_);
#line 142 "../src/theme-manager.vala"
		_tmp1_ = _tmp2_;
#line 142 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 142 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 570 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 142 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 142 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 142 "../src/theme-manager.vala"
			return;
#line 579 "theme-manager.c"
		}
#line 142 "../src/theme-manager.vala"
		_tmp3_ = svg_path;
#line 142 "../src/theme-manager.vala"
		_tmp4_ = g_build_filename (_tmp3_, _tmp1_, NULL);
#line 142 "../src/theme-manager.vala"
		_g_free0 (self->priv->pieces_file);
#line 142 "../src/theme-manager.vala"
		self->priv->pieces_file = _tmp4_;
#line 143 "../src/theme-manager.vala"
		_tmp5_ = self->priv->pieces_file;
#line 143 "../src/theme-manager.vala"
		_tmp6_ = g_path_get_dirname (_tmp5_);
#line 143 "../src/theme-manager.vala"
		_tmp7_ = _tmp6_;
#line 143 "../src/theme-manager.vala"
		_tmp8_ = svg_path;
#line 143 "../src/theme-manager.vala"
		_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 143 "../src/theme-manager.vala"
		_g_free0 (_tmp7_);
#line 143 "../src/theme-manager.vala"
		if (_tmp9_) {
#line 603 "theme-manager.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 144 "../src/theme-manager.vala"
			_tmp10_ = svg_path;
#line 144 "../src/theme-manager.vala"
			_tmp11_ = g_build_filename (_tmp10_, "black_and_white.svg", NULL);
#line 144 "../src/theme-manager.vala"
			_g_free0 (self->priv->pieces_file);
#line 144 "../src/theme-manager.vala"
			self->priv->pieces_file = _tmp11_;
#line 614 "theme-manager.c"
		}
#line 145 "../src/theme-manager.vala"
		theme_manager_load_handle (self);
#line 147 "../src/theme-manager.vala"
		_tmp12_ = g_key_file_get_double (key, "Background", "Red", &_inner_error0_);
#line 147 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 147 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 147 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 628 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 147 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 147 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 147 "../src/theme-manager.vala"
			return;
#line 637 "theme-manager.c"
		}
#line 147 "../src/theme-manager.vala"
		theme_manager_set_background_red (self, _tmp12_);
#line 148 "../src/theme-manager.vala"
		_tmp13_ = g_key_file_get_double (key, "Background", "Green", &_inner_error0_);
#line 148 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 148 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 148 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 651 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 148 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 148 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 148 "../src/theme-manager.vala"
			return;
#line 660 "theme-manager.c"
		}
#line 148 "../src/theme-manager.vala"
		theme_manager_set_background_green (self, _tmp13_);
#line 149 "../src/theme-manager.vala"
		_tmp14_ = g_key_file_get_double (key, "Background", "Blue", &_inner_error0_);
#line 149 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 149 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 149 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 674 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 149 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 149 "../src/theme-manager.vala"
			return;
#line 683 "theme-manager.c"
		}
#line 149 "../src/theme-manager.vala"
		theme_manager_set_background_blue (self, _tmp14_);
#line 150 "../src/theme-manager.vala"
		_tmp15_ = g_key_file_get_integer (key, "Background", "Radius", &_inner_error0_);
#line 150 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 150 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 150 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 697 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 150 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 150 "../src/theme-manager.vala"
			return;
#line 706 "theme-manager.c"
		}
#line 150 "../src/theme-manager.vala"
		theme_manager_set_background_radius (self, _tmp15_);
#line 152 "../src/theme-manager.vala"
		_tmp16_ = g_key_file_get_double (key, "Background", "TextureAlpha", &_inner_error0_);
#line 152 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 152 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 152 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 152 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 720 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 152 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 152 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 152 "../src/theme-manager.vala"
			return;
#line 729 "theme-manager.c"
		}
#line 152 "../src/theme-manager.vala"
		theme_manager_set_texture_alpha (self, _tmp16_);
#line 153 "../src/theme-manager.vala"
		_tmp18_ = self->priv->_texture_alpha;
#line 153 "../src/theme-manager.vala"
		if (_tmp18_ > 0.0) {
#line 737 "theme-manager.c"
			gdouble _tmp19_;
#line 153 "../src/theme-manager.vala"
			_tmp19_ = self->priv->_texture_alpha;
#line 153 "../src/theme-manager.vala"
			_tmp17_ = _tmp19_ <= 1.0;
#line 743 "theme-manager.c"
		} else {
#line 153 "../src/theme-manager.vala"
			_tmp17_ = FALSE;
#line 747 "theme-manager.c"
		}
#line 153 "../src/theme-manager.vala"
		theme_manager_set_apply_texture (self, _tmp17_);
#line 160 "../src/theme-manager.vala"
		_tmp20_ = g_key_file_get_double (key, "Border", "Red", &_inner_error0_);
#line 160 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 160 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 160 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 761 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 160 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 160 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 160 "../src/theme-manager.vala"
			return;
#line 770 "theme-manager.c"
		}
#line 160 "../src/theme-manager.vala"
		theme_manager_set_border_red (self, _tmp20_);
#line 161 "../src/theme-manager.vala"
		_tmp21_ = g_key_file_get_double (key, "Border", "Green", &_inner_error0_);
#line 161 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 161 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 161 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 784 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 161 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 161 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 161 "../src/theme-manager.vala"
			return;
#line 793 "theme-manager.c"
		}
#line 161 "../src/theme-manager.vala"
		theme_manager_set_border_green (self, _tmp21_);
#line 162 "../src/theme-manager.vala"
		_tmp22_ = g_key_file_get_double (key, "Border", "Blue", &_inner_error0_);
#line 162 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 162 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 162 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 162 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 807 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 162 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 162 "../src/theme-manager.vala"
			return;
#line 816 "theme-manager.c"
		}
#line 162 "../src/theme-manager.vala"
		theme_manager_set_border_blue (self, _tmp22_);
#line 163 "../src/theme-manager.vala"
		_tmp23_ = g_key_file_get_integer (key, "Border", "Width", &_inner_error0_);
#line 163 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 163 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 163 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 830 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 163 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 163 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 163 "../src/theme-manager.vala"
			return;
#line 839 "theme-manager.c"
		}
#line 163 "../src/theme-manager.vala"
		theme_manager_set_border_width (self, _tmp23_);
#line 164 "../src/theme-manager.vala"
		_tmp24_ = self->priv->_border_width;
#line 164 "../src/theme-manager.vala"
		theme_manager_set_half_border_width (self, ((gdouble) _tmp24_) / 2.0);
#line 166 "../src/theme-manager.vala"
		_tmp25_ = g_key_file_get_double (key, "Spacing", "Red", &_inner_error0_);
#line 166 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 166 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 166 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 857 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 166 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 166 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 166 "../src/theme-manager.vala"
			return;
#line 866 "theme-manager.c"
		}
#line 166 "../src/theme-manager.vala"
		theme_manager_set_spacing_red (self, _tmp25_);
#line 167 "../src/theme-manager.vala"
		_tmp26_ = g_key_file_get_double (key, "Spacing", "Green", &_inner_error0_);
#line 167 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 167 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 167 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 880 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 167 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 167 "../src/theme-manager.vala"
			return;
#line 889 "theme-manager.c"
		}
#line 167 "../src/theme-manager.vala"
		theme_manager_set_spacing_green (self, _tmp26_);
#line 168 "../src/theme-manager.vala"
		_tmp27_ = g_key_file_get_double (key, "Spacing", "Blue", &_inner_error0_);
#line 168 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 168 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 168 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 168 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 903 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 168 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 168 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 168 "../src/theme-manager.vala"
			return;
#line 912 "theme-manager.c"
		}
#line 168 "../src/theme-manager.vala"
		theme_manager_set_spacing_blue (self, _tmp27_);
#line 169 "../src/theme-manager.vala"
		_tmp28_ = g_key_file_get_integer (key, "Spacing", "Width", &_inner_error0_);
#line 169 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 169 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 169 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 926 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 169 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 169 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 169 "../src/theme-manager.vala"
			return;
#line 935 "theme-manager.c"
		}
#line 169 "../src/theme-manager.vala"
		theme_manager_set_spacing_width (self, _tmp28_);
#line 171 "../src/theme-manager.vala"
		_tmp29_ = g_key_file_get_double (key, "Highlight hard", "Red", &_inner_error0_);
#line 171 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 171 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 171 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 949 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 171 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 171 "../src/theme-manager.vala"
			return;
#line 958 "theme-manager.c"
		}
#line 171 "../src/theme-manager.vala"
		theme_manager_set_highlight_hard_red (self, _tmp29_);
#line 172 "../src/theme-manager.vala"
		_tmp30_ = g_key_file_get_double (key, "Highlight hard", "Green", &_inner_error0_);
#line 172 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 172 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 172 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 972 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 172 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 172 "../src/theme-manager.vala"
			return;
#line 981 "theme-manager.c"
		}
#line 172 "../src/theme-manager.vala"
		theme_manager_set_highlight_hard_green (self, _tmp30_);
#line 173 "../src/theme-manager.vala"
		_tmp31_ = g_key_file_get_double (key, "Highlight hard", "Blue", &_inner_error0_);
#line 173 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 173 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 173 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 995 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 173 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 173 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 173 "../src/theme-manager.vala"
			return;
#line 1004 "theme-manager.c"
		}
#line 173 "../src/theme-manager.vala"
		theme_manager_set_highlight_hard_blue (self, _tmp31_);
#line 174 "../src/theme-manager.vala"
		_tmp32_ = g_key_file_get_double (key, "Highlight hard", "Alpha", &_inner_error0_);
#line 174 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 174 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 174 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1018 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 174 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 174 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 174 "../src/theme-manager.vala"
			return;
#line 1027 "theme-manager.c"
		}
#line 174 "../src/theme-manager.vala"
		theme_manager_set_highlight_hard_alpha (self, _tmp32_);
#line 176 "../src/theme-manager.vala"
		_tmp33_ = g_key_file_get_double (key, "Highlight soft", "Red", &_inner_error0_);
#line 176 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 176 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 176 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1041 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 176 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 176 "../src/theme-manager.vala"
			return;
#line 1050 "theme-manager.c"
		}
#line 176 "../src/theme-manager.vala"
		theme_manager_set_highlight_soft_red (self, _tmp33_);
#line 177 "../src/theme-manager.vala"
		_tmp34_ = g_key_file_get_double (key, "Highlight soft", "Green", &_inner_error0_);
#line 177 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 177 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 177 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 177 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1064 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 177 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 177 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 177 "../src/theme-manager.vala"
			return;
#line 1073 "theme-manager.c"
		}
#line 177 "../src/theme-manager.vala"
		theme_manager_set_highlight_soft_green (self, _tmp34_);
#line 178 "../src/theme-manager.vala"
		_tmp35_ = g_key_file_get_double (key, "Highlight soft", "Blue", &_inner_error0_);
#line 178 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 178 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 178 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 178 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1087 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 178 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 178 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 178 "../src/theme-manager.vala"
			return;
#line 1096 "theme-manager.c"
		}
#line 178 "../src/theme-manager.vala"
		theme_manager_set_highlight_soft_blue (self, _tmp35_);
#line 179 "../src/theme-manager.vala"
		_tmp36_ = g_key_file_get_double (key, "Highlight soft", "Alpha", &_inner_error0_);
#line 179 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 179 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 179 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 179 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1110 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 179 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 179 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 179 "../src/theme-manager.vala"
			return;
#line 1119 "theme-manager.c"
		}
#line 179 "../src/theme-manager.vala"
		theme_manager_set_highlight_soft_alpha (self, _tmp36_);
#line 183 "../src/theme-manager.vala"
		_tmp38_ = g_key_file_get_string (key, "Sound", "Flip", &_inner_error0_);
#line 183 "../src/theme-manager.vala"
		_tmp37_ = _tmp38_;
#line 183 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 183 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 183 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1135 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 183 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 183 "../src/theme-manager.vala"
			return;
#line 1144 "theme-manager.c"
		}
#line 183 "../src/theme-manager.vala"
		theme_manager_set_sound_flip (self, _tmp37_);
#line 184 "../src/theme-manager.vala"
		_tmp40_ = g_key_file_get_string (key, "Sound", "GameOver", &_inner_error0_);
#line 184 "../src/theme-manager.vala"
		_tmp39_ = _tmp40_;
#line 184 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 184 "../src/theme-manager.vala"
			_g_free0 (_tmp37_);
#line 184 "../src/theme-manager.vala"
			_g_free0 (_tmp1_);
#line 184 "../src/theme-manager.vala"
			_g_free0 (svg_path);
#line 184 "../src/theme-manager.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1162 "theme-manager.c"
				goto __catch0_g_key_file_error;
			}
#line 184 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 184 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 184 "../src/theme-manager.vala"
			return;
#line 1171 "theme-manager.c"
		}
#line 184 "../src/theme-manager.vala"
		theme_manager_set_sound_gameover (self, _tmp39_);
#line 139 "../src/theme-manager.vala"
		_g_free0 (_tmp39_);
#line 139 "../src/theme-manager.vala"
		_g_free0 (_tmp37_);
#line 139 "../src/theme-manager.vala"
		_g_free0 (_tmp1_);
#line 139 "../src/theme-manager.vala"
		_g_free0 (svg_path);
#line 1183 "theme-manager.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 139 "../src/theme-manager.vala"
		e = _inner_error0_;
#line 139 "../src/theme-manager.vala"
		_inner_error0_ = NULL;
#line 188 "../src/theme-manager.vala"
		_tmp41_ = e;
#line 188 "../src/theme-manager.vala"
		_tmp42_ = _tmp41_->message;
#line 188 "../src/theme-manager.vala"
		g_warning ("theme-manager.vala:188: Errors when loading theme: %s", _tmp42_);
#line 139 "../src/theme-manager.vala"
		_g_error_free0 (e);
#line 1203 "theme-manager.c"
	}
	__finally0:
#line 139 "../src/theme-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/theme-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "../src/theme-manager.vala"
		g_clear_error (&_inner_error0_);
#line 139 "../src/theme-manager.vala"
		return;
#line 1214 "theme-manager.c"
	}
}

static inline void
theme_manager_load_handle (ThemeManager* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 202 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/theme-manager.vala"
	if (self->priv->handle_loaded) {
#line 1229 "theme-manager.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 204 "../src/theme-manager.vala"
		_tmp1_ = self->priv->old_pieces_file;
#line 204 "../src/theme-manager.vala"
		_tmp2_ = self->priv->pieces_file;
#line 204 "../src/theme-manager.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, _tmp2_) == 0;
#line 1238 "theme-manager.c"
	} else {
#line 204 "../src/theme-manager.vala"
		_tmp0_ = FALSE;
#line 1242 "theme-manager.c"
	}
#line 204 "../src/theme-manager.vala"
	if (_tmp0_) {
#line 205 "../src/theme-manager.vala"
		return;
#line 1248 "theme-manager.c"
	}
	{
		RsvgHandle* _tmp3_ = NULL;
		const gchar* _tmp4_;
		RsvgHandle* _tmp5_;
		RsvgHandle* _tmp6_;
#line 209 "../src/theme-manager.vala"
		_tmp4_ = self->priv->pieces_file;
#line 209 "../src/theme-manager.vala"
		_tmp5_ = rsvg_handle_new_from_file (_tmp4_, &_inner_error0_);
#line 209 "../src/theme-manager.vala"
		_tmp3_ = _tmp5_;
#line 209 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1263 "theme-manager.c"
			goto __catch0_g_error;
		}
#line 209 "../src/theme-manager.vala"
		_tmp6_ = _tmp3_;
#line 209 "../src/theme-manager.vala"
		_tmp3_ = NULL;
#line 209 "../src/theme-manager.vala"
		_g_object_unref0 (self->priv->_tileset_handle);
#line 209 "../src/theme-manager.vala"
		self->priv->_tileset_handle = _tmp6_;
#line 207 "../src/theme-manager.vala"
		_g_object_unref0 (_tmp3_);
#line 1276 "theme-manager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 207 "../src/theme-manager.vala"
		g_clear_error (&_inner_error0_);
#line 213 "../src/theme-manager.vala"
		g_assert_not_reached ();
#line 1285 "theme-manager.c"
	}
	__finally0:
#line 207 "../src/theme-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 207 "../src/theme-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "../src/theme-manager.vala"
		g_clear_error (&_inner_error0_);
#line 207 "../src/theme-manager.vala"
		return;
#line 1296 "theme-manager.c"
	}
#line 216 "../src/theme-manager.vala"
	_tmp7_ = self->priv->pieces_file;
#line 216 "../src/theme-manager.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 216 "../src/theme-manager.vala"
	_g_free0 (self->priv->old_pieces_file);
#line 216 "../src/theme-manager.vala"
	self->priv->old_pieces_file = _tmp8_;
#line 217 "../src/theme-manager.vala"
	self->priv->handle_loaded = TRUE;
#line 1308 "theme-manager.c"
}

ThemeManager*
theme_manager_construct (GType object_type)
{
	ThemeManager * self = NULL;
#line 21 "../src/theme-manager.vala"
	self = (ThemeManager*) g_object_new (object_type, NULL);
#line 21 "../src/theme-manager.vala"
	return self;
#line 1319 "theme-manager.c"
}

ThemeManager*
theme_manager_new (void)
{
#line 21 "../src/theme-manager.vala"
	return theme_manager_construct (TYPE_THEME_MANAGER);
#line 1327 "theme-manager.c"
}

static const gchar*
theme_manager_get_theme (ThemeManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/theme-manager.vala"
	if (!self->priv->theme_set) {
#line 39 "../src/theme-manager.vala"
		g_assert_not_reached ();
#line 1341 "theme-manager.c"
	}
#line 39 "../src/theme-manager.vala"
	_tmp0_ = self->priv->_theme;
#line 39 "../src/theme-manager.vala"
	result = _tmp0_;
#line 39 "../src/theme-manager.vala"
	return result;
#line 1349 "theme-manager.c"
}

void
theme_manager_set_theme (ThemeManager* self,
                         const gchar* value)
{
	GKeyFile* key = NULL;
	GKeyFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GKeyFile* _tmp15_;
	gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 40 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/theme-manager.vala"
	_tmp0_ = g_key_file_new ();
#line 42 "../src/theme-manager.vala"
	key = _tmp0_;
#line 43 "../src/theme-manager.vala"
	if (g_strcmp0 (value, "") == 0) {
#line 43 "../src/theme-manager.vala"
		_tmp1_ = TRUE;
#line 1372 "theme-manager.c"
	} else {
#line 43 "../src/theme-manager.vala"
		_tmp1_ = g_strcmp0 (value, "default") == 0;
#line 1376 "theme-manager.c"
	}
#line 43 "../src/theme-manager.vala"
	if (_tmp1_) {
#line 44 "../src/theme-manager.vala"
		theme_manager_set_default_theme (self, &key);
#line 1382 "theme-manager.c"
	} else {
		{
			gchar* key_path = NULL;
			gchar* _tmp2_;
			gchar* filepath = NULL;
			const gchar* _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			const gchar* _tmp8_;
			gboolean _tmp9_;
			GKeyFile* _tmp11_;
			const gchar* _tmp12_;
#line 48 "../src/theme-manager.vala"
			_tmp2_ = g_build_filename (DATA_DIRECTORY, "themes", "key", NULL);
#line 48 "../src/theme-manager.vala"
			key_path = _tmp2_;
#line 49 "../src/theme-manager.vala"
			_tmp3_ = key_path;
#line 49 "../src/theme-manager.vala"
			_tmp4_ = g_build_filename (_tmp3_, value, NULL);
#line 49 "../src/theme-manager.vala"
			filepath = _tmp4_;
#line 50 "../src/theme-manager.vala"
			_tmp5_ = filepath;
#line 50 "../src/theme-manager.vala"
			_tmp6_ = g_path_get_dirname (_tmp5_);
#line 50 "../src/theme-manager.vala"
			_tmp7_ = _tmp6_;
#line 50 "../src/theme-manager.vala"
			_tmp8_ = key_path;
#line 50 "../src/theme-manager.vala"
			_tmp9_ = g_strcmp0 (_tmp7_, _tmp8_) != 0;
#line 50 "../src/theme-manager.vala"
			_g_free0 (_tmp7_);
#line 50 "../src/theme-manager.vala"
			if (_tmp9_) {
#line 1421 "theme-manager.c"
				GError* _tmp10_;
#line 51 "../src/theme-manager.vala"
				_tmp10_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_FAILED, "Theme file is not in the \"key\" directory.");
#line 51 "../src/theme-manager.vala"
				_inner_error0_ = _tmp10_;
#line 51 "../src/theme-manager.vala"
				_g_free0 (filepath);
#line 51 "../src/theme-manager.vala"
				_g_free0 (key_path);
#line 1431 "theme-manager.c"
				goto __catch0_g_error;
			}
#line 53 "../src/theme-manager.vala"
			_tmp11_ = key;
#line 53 "../src/theme-manager.vala"
			_tmp12_ = filepath;
#line 53 "../src/theme-manager.vala"
			g_key_file_load_from_file (_tmp11_, _tmp12_, G_KEY_FILE_NONE, &_inner_error0_);
#line 53 "../src/theme-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 53 "../src/theme-manager.vala"
				_g_free0 (filepath);
#line 53 "../src/theme-manager.vala"
				_g_free0 (key_path);
#line 1446 "theme-manager.c"
				goto __catch0_g_error;
			}
#line 46 "../src/theme-manager.vala"
			_g_free0 (filepath);
#line 46 "../src/theme-manager.vala"
			_g_free0 (key_path);
#line 1453 "theme-manager.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
#line 46 "../src/theme-manager.vala"
			e = _inner_error0_;
#line 46 "../src/theme-manager.vala"
			_inner_error0_ = NULL;
#line 57 "../src/theme-manager.vala"
			_tmp13_ = e;
#line 57 "../src/theme-manager.vala"
			_tmp14_ = _tmp13_->message;
#line 57 "../src/theme-manager.vala"
			g_warning ("theme-manager.vala:57: Failed to load theme: %s", _tmp14_);
#line 58 "../src/theme-manager.vala"
			theme_manager_set_default_theme (self, &key);
#line 59 "../src/theme-manager.vala"
			value = "default";
#line 46 "../src/theme-manager.vala"
			_g_error_free0 (e);
#line 1477 "theme-manager.c"
		}
		__finally0:
#line 46 "../src/theme-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 46 "../src/theme-manager.vala"
			_g_key_file_unref0 (key);
#line 46 "../src/theme-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 46 "../src/theme-manager.vala"
			g_clear_error (&_inner_error0_);
#line 46 "../src/theme-manager.vala"
			return;
#line 1490 "theme-manager.c"
		}
	}
#line 62 "../src/theme-manager.vala"
	_tmp15_ = key;
#line 62 "../src/theme-manager.vala"
	theme_manager_load_theme (self, _tmp15_);
#line 63 "../src/theme-manager.vala"
	_tmp16_ = g_strdup (value);
#line 63 "../src/theme-manager.vala"
	_g_free0 (self->priv->_theme);
#line 63 "../src/theme-manager.vala"
	self->priv->_theme = _tmp16_;
#line 64 "../src/theme-manager.vala"
	self->priv->theme_set = TRUE;
#line 67 "../src/theme-manager.vala"
	g_signal_emit (self, theme_manager_signals[THEME_MANAGER_THEME_CHANGED_SIGNAL], 0);
#line 40 "../src/theme-manager.vala"
	_g_key_file_unref0 (key);
#line 1509 "theme-manager.c"
}

gdouble
theme_manager_get_background_red (ThemeManager* self)
{
	gdouble result;
#line 98 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 98 "../src/theme-manager.vala"
	result = self->priv->_background_red;
#line 98 "../src/theme-manager.vala"
	return result;
#line 1522 "theme-manager.c"
}

static void
theme_manager_set_background_red (ThemeManager* self,
                                  gdouble value)
{
#line 98 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/theme-manager.vala"
	self->priv->_background_red = value;
#line 1533 "theme-manager.c"
}

gdouble
theme_manager_get_background_green (ThemeManager* self)
{
	gdouble result;
#line 99 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 99 "../src/theme-manager.vala"
	result = self->priv->_background_green;
#line 99 "../src/theme-manager.vala"
	return result;
#line 1546 "theme-manager.c"
}

static void
theme_manager_set_background_green (ThemeManager* self,
                                    gdouble value)
{
#line 99 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/theme-manager.vala"
	self->priv->_background_green = value;
#line 1557 "theme-manager.c"
}

gdouble
theme_manager_get_background_blue (ThemeManager* self)
{
	gdouble result;
#line 100 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 100 "../src/theme-manager.vala"
	result = self->priv->_background_blue;
#line 100 "../src/theme-manager.vala"
	return result;
#line 1570 "theme-manager.c"
}

static void
theme_manager_set_background_blue (ThemeManager* self,
                                   gdouble value)
{
#line 100 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/theme-manager.vala"
	self->priv->_background_blue = value;
#line 1581 "theme-manager.c"
}

gint
theme_manager_get_background_radius (ThemeManager* self)
{
	gint result;
#line 101 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 101 "../src/theme-manager.vala"
	result = self->priv->_background_radius;
#line 101 "../src/theme-manager.vala"
	return result;
#line 1594 "theme-manager.c"
}

static void
theme_manager_set_background_radius (ThemeManager* self,
                                     gint value)
{
#line 101 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/theme-manager.vala"
	self->priv->_background_radius = value;
#line 1605 "theme-manager.c"
}

gdouble
theme_manager_get_texture_alpha (ThemeManager* self)
{
	gdouble result;
#line 103 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 103 "../src/theme-manager.vala"
	result = self->priv->_texture_alpha;
#line 103 "../src/theme-manager.vala"
	return result;
#line 1618 "theme-manager.c"
}

static void
theme_manager_set_texture_alpha (ThemeManager* self,
                                 gdouble value)
{
#line 103 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/theme-manager.vala"
	self->priv->_texture_alpha = value;
#line 1629 "theme-manager.c"
}

gboolean
theme_manager_get_apply_texture (ThemeManager* self)
{
	gboolean result;
#line 104 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 104 "../src/theme-manager.vala"
	result = self->priv->_apply_texture;
#line 104 "../src/theme-manager.vala"
	return result;
#line 1642 "theme-manager.c"
}

static void
theme_manager_set_apply_texture (ThemeManager* self,
                                 gboolean value)
{
#line 104 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/theme-manager.vala"
	self->priv->_apply_texture = value;
#line 1653 "theme-manager.c"
}

gdouble
theme_manager_get_border_red (ThemeManager* self)
{
	gdouble result;
#line 111 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 111 "../src/theme-manager.vala"
	result = self->priv->_border_red;
#line 111 "../src/theme-manager.vala"
	return result;
#line 1666 "theme-manager.c"
}

static void
theme_manager_set_border_red (ThemeManager* self,
                              gdouble value)
{
#line 111 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 111 "../src/theme-manager.vala"
	self->priv->_border_red = value;
#line 1677 "theme-manager.c"
}

gdouble
theme_manager_get_border_green (ThemeManager* self)
{
	gdouble result;
#line 112 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 112 "../src/theme-manager.vala"
	result = self->priv->_border_green;
#line 112 "../src/theme-manager.vala"
	return result;
#line 1690 "theme-manager.c"
}

static void
theme_manager_set_border_green (ThemeManager* self,
                                gdouble value)
{
#line 112 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/theme-manager.vala"
	self->priv->_border_green = value;
#line 1701 "theme-manager.c"
}

gdouble
theme_manager_get_border_blue (ThemeManager* self)
{
	gdouble result;
#line 113 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 113 "../src/theme-manager.vala"
	result = self->priv->_border_blue;
#line 113 "../src/theme-manager.vala"
	return result;
#line 1714 "theme-manager.c"
}

static void
theme_manager_set_border_blue (ThemeManager* self,
                               gdouble value)
{
#line 113 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/theme-manager.vala"
	self->priv->_border_blue = value;
#line 1725 "theme-manager.c"
}

gint
theme_manager_get_border_width (ThemeManager* self)
{
	gint result;
#line 114 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 114 "../src/theme-manager.vala"
	result = self->priv->_border_width;
#line 114 "../src/theme-manager.vala"
	return result;
#line 1738 "theme-manager.c"
}

static void
theme_manager_set_border_width (ThemeManager* self,
                                gint value)
{
#line 114 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/theme-manager.vala"
	self->priv->_border_width = value;
#line 1749 "theme-manager.c"
}

gdouble
theme_manager_get_half_border_width (ThemeManager* self)
{
	gdouble result;
#line 115 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 115 "../src/theme-manager.vala"
	result = self->priv->_half_border_width;
#line 115 "../src/theme-manager.vala"
	return result;
#line 1762 "theme-manager.c"
}

static void
theme_manager_set_half_border_width (ThemeManager* self,
                                     gdouble value)
{
#line 115 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/theme-manager.vala"
	self->priv->_half_border_width = value;
#line 1773 "theme-manager.c"
}

gdouble
theme_manager_get_spacing_red (ThemeManager* self)
{
	gdouble result;
#line 117 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 117 "../src/theme-manager.vala"
	result = self->priv->_spacing_red;
#line 117 "../src/theme-manager.vala"
	return result;
#line 1786 "theme-manager.c"
}

static void
theme_manager_set_spacing_red (ThemeManager* self,
                               gdouble value)
{
#line 117 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/theme-manager.vala"
	self->priv->_spacing_red = value;
#line 1797 "theme-manager.c"
}

gdouble
theme_manager_get_spacing_green (ThemeManager* self)
{
	gdouble result;
#line 118 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 118 "../src/theme-manager.vala"
	result = self->priv->_spacing_green;
#line 118 "../src/theme-manager.vala"
	return result;
#line 1810 "theme-manager.c"
}

static void
theme_manager_set_spacing_green (ThemeManager* self,
                                 gdouble value)
{
#line 118 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/theme-manager.vala"
	self->priv->_spacing_green = value;
#line 1821 "theme-manager.c"
}

gdouble
theme_manager_get_spacing_blue (ThemeManager* self)
{
	gdouble result;
#line 119 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 119 "../src/theme-manager.vala"
	result = self->priv->_spacing_blue;
#line 119 "../src/theme-manager.vala"
	return result;
#line 1834 "theme-manager.c"
}

static void
theme_manager_set_spacing_blue (ThemeManager* self,
                                gdouble value)
{
#line 119 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/theme-manager.vala"
	self->priv->_spacing_blue = value;
#line 1845 "theme-manager.c"
}

gint
theme_manager_get_spacing_width (ThemeManager* self)
{
	gint result;
#line 120 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 120 "../src/theme-manager.vala"
	result = self->priv->_spacing_width;
#line 120 "../src/theme-manager.vala"
	return result;
#line 1858 "theme-manager.c"
}

static void
theme_manager_set_spacing_width (ThemeManager* self,
                                 gint value)
{
#line 120 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/theme-manager.vala"
	self->priv->_spacing_width = value;
#line 1869 "theme-manager.c"
}

gdouble
theme_manager_get_highlight_hard_red (ThemeManager* self)
{
	gdouble result;
#line 122 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 122 "../src/theme-manager.vala"
	result = self->priv->_highlight_hard_red;
#line 122 "../src/theme-manager.vala"
	return result;
#line 1882 "theme-manager.c"
}

static void
theme_manager_set_highlight_hard_red (ThemeManager* self,
                                      gdouble value)
{
#line 122 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/theme-manager.vala"
	self->priv->_highlight_hard_red = value;
#line 1893 "theme-manager.c"
}

gdouble
theme_manager_get_highlight_hard_green (ThemeManager* self)
{
	gdouble result;
#line 123 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 123 "../src/theme-manager.vala"
	result = self->priv->_highlight_hard_green;
#line 123 "../src/theme-manager.vala"
	return result;
#line 1906 "theme-manager.c"
}

static void
theme_manager_set_highlight_hard_green (ThemeManager* self,
                                        gdouble value)
{
#line 123 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/theme-manager.vala"
	self->priv->_highlight_hard_green = value;
#line 1917 "theme-manager.c"
}

gdouble
theme_manager_get_highlight_hard_blue (ThemeManager* self)
{
	gdouble result;
#line 124 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 124 "../src/theme-manager.vala"
	result = self->priv->_highlight_hard_blue;
#line 124 "../src/theme-manager.vala"
	return result;
#line 1930 "theme-manager.c"
}

static void
theme_manager_set_highlight_hard_blue (ThemeManager* self,
                                       gdouble value)
{
#line 124 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/theme-manager.vala"
	self->priv->_highlight_hard_blue = value;
#line 1941 "theme-manager.c"
}

gdouble
theme_manager_get_highlight_hard_alpha (ThemeManager* self)
{
	gdouble result;
#line 125 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 125 "../src/theme-manager.vala"
	result = self->priv->_highlight_hard_alpha;
#line 125 "../src/theme-manager.vala"
	return result;
#line 1954 "theme-manager.c"
}

static void
theme_manager_set_highlight_hard_alpha (ThemeManager* self,
                                        gdouble value)
{
#line 125 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 125 "../src/theme-manager.vala"
	self->priv->_highlight_hard_alpha = value;
#line 1965 "theme-manager.c"
}

gdouble
theme_manager_get_highlight_soft_red (ThemeManager* self)
{
	gdouble result;
#line 127 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 127 "../src/theme-manager.vala"
	result = self->priv->_highlight_soft_red;
#line 127 "../src/theme-manager.vala"
	return result;
#line 1978 "theme-manager.c"
}

static void
theme_manager_set_highlight_soft_red (ThemeManager* self,
                                      gdouble value)
{
#line 127 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/theme-manager.vala"
	self->priv->_highlight_soft_red = value;
#line 1989 "theme-manager.c"
}

gdouble
theme_manager_get_highlight_soft_green (ThemeManager* self)
{
	gdouble result;
#line 128 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 128 "../src/theme-manager.vala"
	result = self->priv->_highlight_soft_green;
#line 128 "../src/theme-manager.vala"
	return result;
#line 2002 "theme-manager.c"
}

static void
theme_manager_set_highlight_soft_green (ThemeManager* self,
                                        gdouble value)
{
#line 128 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/theme-manager.vala"
	self->priv->_highlight_soft_green = value;
#line 2013 "theme-manager.c"
}

gdouble
theme_manager_get_highlight_soft_blue (ThemeManager* self)
{
	gdouble result;
#line 129 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 129 "../src/theme-manager.vala"
	result = self->priv->_highlight_soft_blue;
#line 129 "../src/theme-manager.vala"
	return result;
#line 2026 "theme-manager.c"
}

static void
theme_manager_set_highlight_soft_blue (ThemeManager* self,
                                       gdouble value)
{
#line 129 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/theme-manager.vala"
	self->priv->_highlight_soft_blue = value;
#line 2037 "theme-manager.c"
}

gdouble
theme_manager_get_highlight_soft_alpha (ThemeManager* self)
{
	gdouble result;
#line 130 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 130 "../src/theme-manager.vala"
	result = self->priv->_highlight_soft_alpha;
#line 130 "../src/theme-manager.vala"
	return result;
#line 2050 "theme-manager.c"
}

static void
theme_manager_set_highlight_soft_alpha (ThemeManager* self,
                                        gdouble value)
{
#line 130 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/theme-manager.vala"
	self->priv->_highlight_soft_alpha = value;
#line 2061 "theme-manager.c"
}

const gchar*
theme_manager_get_sound_flip (ThemeManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 134 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 134 "../src/theme-manager.vala"
	_tmp0_ = self->priv->_sound_flip;
#line 134 "../src/theme-manager.vala"
	result = _tmp0_;
#line 134 "../src/theme-manager.vala"
	return result;
#line 2077 "theme-manager.c"
}

static void
theme_manager_set_sound_flip (ThemeManager* self,
                              const gchar* value)
{
	gchar* _tmp0_;
#line 134 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/theme-manager.vala"
	_tmp0_ = g_strdup (value);
#line 134 "../src/theme-manager.vala"
	_g_free0 (self->priv->_sound_flip);
#line 134 "../src/theme-manager.vala"
	self->priv->_sound_flip = _tmp0_;
#line 2093 "theme-manager.c"
}

const gchar*
theme_manager_get_sound_gameover (ThemeManager* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 135 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "../src/theme-manager.vala"
	_tmp0_ = self->priv->_sound_gameover;
#line 135 "../src/theme-manager.vala"
	result = _tmp0_;
#line 135 "../src/theme-manager.vala"
	return result;
#line 2109 "theme-manager.c"
}

static void
theme_manager_set_sound_gameover (ThemeManager* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
#line 135 "../src/theme-manager.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/theme-manager.vala"
	_tmp0_ = g_strdup (value);
#line 135 "../src/theme-manager.vala"
	_g_free0 (self->priv->_sound_gameover);
#line 135 "../src/theme-manager.vala"
	self->priv->_sound_gameover = _tmp0_;
#line 2125 "theme-manager.c"
}

RsvgHandle*
theme_manager_get_tileset_handle (ThemeManager* self)
{
	RsvgHandle* result;
	RsvgHandle* _tmp0_;
#line 197 "../src/theme-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 197 "../src/theme-manager.vala"
	if (!self->priv->handle_loaded) {
#line 197 "../src/theme-manager.vala"
		g_assert_not_reached ();
#line 2139 "theme-manager.c"
	}
#line 197 "../src/theme-manager.vala"
	_tmp0_ = self->priv->_tileset_handle;
#line 197 "../src/theme-manager.vala"
	result = _tmp0_;
#line 197 "../src/theme-manager.vala"
	return result;
#line 2147 "theme-manager.c"
}

static void
theme_manager_class_init (ThemeManagerClass * klass,
                          gpointer klass_data)
{
#line 21 "../src/theme-manager.vala"
	theme_manager_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/theme-manager.vala"
	g_type_class_adjust_private_offset (klass, &ThemeManager_private_offset);
#line 21 "../src/theme-manager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_theme_manager_get_property;
#line 21 "../src/theme-manager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_theme_manager_set_property;
#line 21 "../src/theme-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_manager_finalize;
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_THEME_PROPERTY, theme_manager_properties[THEME_MANAGER_THEME_PROPERTY] = g_param_spec_string ("theme", "theme", "theme", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BACKGROUND_RED_PROPERTY, theme_manager_properties[THEME_MANAGER_BACKGROUND_RED_PROPERTY] = g_param_spec_double ("background-red", "background-red", "background-red", -G_MAXDOUBLE, G_MAXDOUBLE, 0.2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BACKGROUND_GREEN_PROPERTY, theme_manager_properties[THEME_MANAGER_BACKGROUND_GREEN_PROPERTY] = g_param_spec_double ("background-green", "background-green", "background-green", -G_MAXDOUBLE, G_MAXDOUBLE, 0.6, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BACKGROUND_BLUE_PROPERTY, theme_manager_properties[THEME_MANAGER_BACKGROUND_BLUE_PROPERTY] = g_param_spec_double ("background-blue", "background-blue", "background-blue", -G_MAXDOUBLE, G_MAXDOUBLE, 0.4, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BACKGROUND_RADIUS_PROPERTY, theme_manager_properties[THEME_MANAGER_BACKGROUND_RADIUS_PROPERTY] = g_param_spec_int ("background-radius", "background-radius", "background-radius", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_TEXTURE_ALPHA_PROPERTY, theme_manager_properties[THEME_MANAGER_TEXTURE_ALPHA_PROPERTY] = g_param_spec_double ("texture-alpha", "texture-alpha", "texture-alpha", -G_MAXDOUBLE, G_MAXDOUBLE, 0.25, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_APPLY_TEXTURE_PROPERTY, theme_manager_properties[THEME_MANAGER_APPLY_TEXTURE_PROPERTY] = g_param_spec_boolean ("apply-texture", "apply-texture", "apply-texture", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BORDER_RED_PROPERTY, theme_manager_properties[THEME_MANAGER_BORDER_RED_PROPERTY] = g_param_spec_double ("border-red", "border-red", "border-red", -G_MAXDOUBLE, G_MAXDOUBLE, 0.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BORDER_GREEN_PROPERTY, theme_manager_properties[THEME_MANAGER_BORDER_GREEN_PROPERTY] = g_param_spec_double ("border-green", "border-green", "border-green", -G_MAXDOUBLE, G_MAXDOUBLE, 0.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BORDER_BLUE_PROPERTY, theme_manager_properties[THEME_MANAGER_BORDER_BLUE_PROPERTY] = g_param_spec_double ("border-blue", "border-blue", "border-blue", -G_MAXDOUBLE, G_MAXDOUBLE, 0.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_BORDER_WIDTH_PROPERTY, theme_manager_properties[THEME_MANAGER_BORDER_WIDTH_PROPERTY] = g_param_spec_int ("border-width", "border-width", "border-width", G_MININT, G_MAXINT, 3, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HALF_BORDER_WIDTH_PROPERTY, theme_manager_properties[THEME_MANAGER_HALF_BORDER_WIDTH_PROPERTY] = g_param_spec_double ("half-border-width", "half-border-width", "half-border-width", -G_MAXDOUBLE, G_MAXDOUBLE, 1.5, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_SPACING_RED_PROPERTY, theme_manager_properties[THEME_MANAGER_SPACING_RED_PROPERTY] = g_param_spec_double ("spacing-red", "spacing-red", "spacing-red", -G_MAXDOUBLE, G_MAXDOUBLE, 0.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_SPACING_GREEN_PROPERTY, theme_manager_properties[THEME_MANAGER_SPACING_GREEN_PROPERTY] = g_param_spec_double ("spacing-green", "spacing-green", "spacing-green", -G_MAXDOUBLE, G_MAXDOUBLE, 0.3, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_SPACING_BLUE_PROPERTY, theme_manager_properties[THEME_MANAGER_SPACING_BLUE_PROPERTY] = g_param_spec_double ("spacing-blue", "spacing-blue", "spacing-blue", -G_MAXDOUBLE, G_MAXDOUBLE, 0.2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_SPACING_WIDTH_PROPERTY, theme_manager_properties[THEME_MANAGER_SPACING_WIDTH_PROPERTY] = g_param_spec_int ("spacing-width", "spacing-width", "spacing-width", G_MININT, G_MAXINT, 2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HIGHLIGHT_HARD_RED_PROPERTY, theme_manager_properties[THEME_MANAGER_HIGHLIGHT_HARD_RED_PROPERTY] = g_param_spec_double ("highlight-hard-red", "highlight-hard-red", "highlight-hard-red", -G_MAXDOUBLE, G_MAXDOUBLE, 0.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HIGHLIGHT_HARD_GREEN_PROPERTY, theme_manager_properties[THEME_MANAGER_HIGHLIGHT_HARD_GREEN_PROPERTY] = g_param_spec_double ("highlight-hard-green", "highlight-hard-green", "highlight-hard-green", -G_MAXDOUBLE, G_MAXDOUBLE, 0.3, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HIGHLIGHT_HARD_BLUE_PROPERTY, theme_manager_properties[THEME_MANAGER_HIGHLIGHT_HARD_BLUE_PROPERTY] = g_param_spec_double ("highlight-hard-blue", "highlight-hard-blue", "highlight-hard-blue", -G_MAXDOUBLE, G_MAXDOUBLE, 0.2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HIGHLIGHT_HARD_ALPHA_PROPERTY, theme_manager_properties[THEME_MANAGER_HIGHLIGHT_HARD_ALPHA_PROPERTY] = g_param_spec_double ("highlight-hard-alpha", "highlight-hard-alpha", "highlight-hard-alpha", -G_MAXDOUBLE, G_MAXDOUBLE, 0.4, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HIGHLIGHT_SOFT_RED_PROPERTY, theme_manager_properties[THEME_MANAGER_HIGHLIGHT_SOFT_RED_PROPERTY] = g_param_spec_double ("highlight-soft-red", "highlight-soft-red", "highlight-soft-red", -G_MAXDOUBLE, G_MAXDOUBLE, 0.1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HIGHLIGHT_SOFT_GREEN_PROPERTY, theme_manager_properties[THEME_MANAGER_HIGHLIGHT_SOFT_GREEN_PROPERTY] = g_param_spec_double ("highlight-soft-green", "highlight-soft-green", "highlight-soft-green", -G_MAXDOUBLE, G_MAXDOUBLE, 0.3, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HIGHLIGHT_SOFT_BLUE_PROPERTY, theme_manager_properties[THEME_MANAGER_HIGHLIGHT_SOFT_BLUE_PROPERTY] = g_param_spec_double ("highlight-soft-blue", "highlight-soft-blue", "highlight-soft-blue", -G_MAXDOUBLE, G_MAXDOUBLE, 0.2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_HIGHLIGHT_SOFT_ALPHA_PROPERTY, theme_manager_properties[THEME_MANAGER_HIGHLIGHT_SOFT_ALPHA_PROPERTY] = g_param_spec_double ("highlight-soft-alpha", "highlight-soft-alpha", "highlight-soft-alpha", -G_MAXDOUBLE, G_MAXDOUBLE, 0.2, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_SOUND_FLIP_PROPERTY, theme_manager_properties[THEME_MANAGER_SOUND_FLIP_PROPERTY] = g_param_spec_string ("sound-flip", "sound-flip", "sound-flip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_SOUND_GAMEOVER_PROPERTY, theme_manager_properties[THEME_MANAGER_SOUND_GAMEOVER_PROPERTY] = g_param_spec_string ("sound-gameover", "sound-gameover", "sound-gameover", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MANAGER_TILESET_HANDLE_PROPERTY, theme_manager_properties[THEME_MANAGER_TILESET_HANDLE_PROPERTY] = g_param_spec_object ("tileset-handle", "tileset-handle", "tileset-handle", rsvg_handle_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/theme-manager.vala"
	theme_manager_signals[THEME_MANAGER_THEME_CHANGED_SIGNAL] = g_signal_new ("theme-changed", TYPE_THEME_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2220 "theme-manager.c"
}

static void
theme_manager_instance_init (ThemeManager * self,
                             gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 21 "../src/theme-manager.vala"
	self->priv = theme_manager_get_instance_private (self);
#line 35 "../src/theme-manager.vala"
	self->priv->theme_set = FALSE;
#line 96 "../src/theme-manager.vala"
	_tmp0_ = g_strdup ("");
#line 96 "../src/theme-manager.vala"
	self->priv->pieces_file = _tmp0_;
#line 98 "../src/theme-manager.vala"
	self->priv->_background_red = 0.2;
#line 99 "../src/theme-manager.vala"
	self->priv->_background_green = 0.6;
#line 100 "../src/theme-manager.vala"
	self->priv->_background_blue = 0.4;
#line 101 "../src/theme-manager.vala"
	self->priv->_background_radius = 0;
#line 103 "../src/theme-manager.vala"
	self->priv->_texture_alpha = 0.25;
#line 104 "../src/theme-manager.vala"
	self->priv->_apply_texture = FALSE;
#line 111 "../src/theme-manager.vala"
	self->priv->_border_red = 0.1;
#line 112 "../src/theme-manager.vala"
	self->priv->_border_green = 0.1;
#line 113 "../src/theme-manager.vala"
	self->priv->_border_blue = 0.1;
#line 114 "../src/theme-manager.vala"
	self->priv->_border_width = 3;
#line 115 "../src/theme-manager.vala"
	self->priv->_half_border_width = 1.5;
#line 117 "../src/theme-manager.vala"
	self->priv->_spacing_red = 0.1;
#line 118 "../src/theme-manager.vala"
	self->priv->_spacing_green = 0.3;
#line 119 "../src/theme-manager.vala"
	self->priv->_spacing_blue = 0.2;
#line 120 "../src/theme-manager.vala"
	self->priv->_spacing_width = 2;
#line 122 "../src/theme-manager.vala"
	self->priv->_highlight_hard_red = 0.1;
#line 123 "../src/theme-manager.vala"
	self->priv->_highlight_hard_green = 0.3;
#line 124 "../src/theme-manager.vala"
	self->priv->_highlight_hard_blue = 0.2;
#line 125 "../src/theme-manager.vala"
	self->priv->_highlight_hard_alpha = 0.4;
#line 127 "../src/theme-manager.vala"
	self->priv->_highlight_soft_red = 0.1;
#line 128 "../src/theme-manager.vala"
	self->priv->_highlight_soft_green = 0.3;
#line 129 "../src/theme-manager.vala"
	self->priv->_highlight_soft_blue = 0.2;
#line 130 "../src/theme-manager.vala"
	self->priv->_highlight_soft_alpha = 0.2;
#line 134 "../src/theme-manager.vala"
	_tmp1_ = g_strdup ("");
#line 134 "../src/theme-manager.vala"
	self->priv->_sound_flip = _tmp1_;
#line 135 "../src/theme-manager.vala"
	_tmp2_ = g_strdup ("");
#line 135 "../src/theme-manager.vala"
	self->priv->_sound_gameover = _tmp2_;
#line 196 "../src/theme-manager.vala"
	self->priv->handle_loaded = FALSE;
#line 201 "../src/theme-manager.vala"
	_tmp3_ = g_strdup ("");
#line 201 "../src/theme-manager.vala"
	self->priv->old_pieces_file = _tmp3_;
#line 2299 "theme-manager.c"
}

static void
theme_manager_finalize (GObject * obj)
{
	ThemeManager * self;
#line 21 "../src/theme-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME_MANAGER, ThemeManager);
#line 36 "../src/theme-manager.vala"
	_g_free0 (self->priv->_theme);
#line 96 "../src/theme-manager.vala"
	_g_free0 (self->priv->pieces_file);
#line 134 "../src/theme-manager.vala"
	_g_free0 (self->priv->_sound_flip);
#line 135 "../src/theme-manager.vala"
	_g_free0 (self->priv->_sound_gameover);
#line 199 "../src/theme-manager.vala"
	_g_object_unref0 (self->priv->_tileset_handle);
#line 201 "../src/theme-manager.vala"
	_g_free0 (self->priv->old_pieces_file);
#line 21 "../src/theme-manager.vala"
	G_OBJECT_CLASS (theme_manager_parent_class)->finalize (obj);
#line 2322 "theme-manager.c"
}

static GType
theme_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThemeManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemeManager), 0, (GInstanceInitFunc) theme_manager_instance_init, NULL };
	GType theme_manager_type_id;
	theme_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ThemeManager", &g_define_type_info, 0);
	ThemeManager_private_offset = g_type_add_instance_private (theme_manager_type_id, sizeof (ThemeManagerPrivate));
	return theme_manager_type_id;
}

GType
theme_manager_get_type (void)
{
	static volatile gsize theme_manager_type_id__once = 0;
	if (g_once_init_enter (&theme_manager_type_id__once)) {
		GType theme_manager_type_id;
		theme_manager_type_id = theme_manager_get_type_once ();
		g_once_init_leave (&theme_manager_type_id__once, theme_manager_type_id);
	}
	return theme_manager_type_id__once;
}

static void
_vala_theme_manager_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	ThemeManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME_MANAGER, ThemeManager);
#line 21 "../src/theme-manager.vala"
	switch (property_id) {
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_THEME_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_string (value, theme_manager_get_theme (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BACKGROUND_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_background_red (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BACKGROUND_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_background_green (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BACKGROUND_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_background_blue (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BACKGROUND_RADIUS_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_int (value, theme_manager_get_background_radius (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_TEXTURE_ALPHA_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_texture_alpha (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_APPLY_TEXTURE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_boolean (value, theme_manager_get_apply_texture (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BORDER_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_border_red (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BORDER_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_border_green (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BORDER_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_border_blue (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BORDER_WIDTH_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_int (value, theme_manager_get_border_width (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HALF_BORDER_WIDTH_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_half_border_width (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SPACING_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_spacing_red (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SPACING_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_spacing_green (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SPACING_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_spacing_blue (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SPACING_WIDTH_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_int (value, theme_manager_get_spacing_width (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_HARD_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_highlight_hard_red (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_HARD_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_highlight_hard_green (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_HARD_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_highlight_hard_blue (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_HARD_ALPHA_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_highlight_hard_alpha (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_SOFT_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_highlight_soft_red (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_SOFT_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_highlight_soft_green (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_SOFT_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_highlight_soft_blue (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_SOFT_ALPHA_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_double (value, theme_manager_get_highlight_soft_alpha (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SOUND_FLIP_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_string (value, theme_manager_get_sound_flip (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SOUND_GAMEOVER_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_string (value, theme_manager_get_sound_gameover (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_TILESET_HANDLE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		g_value_set_object (value, theme_manager_get_tileset_handle (self));
#line 21 "../src/theme-manager.vala"
		break;
#line 2519 "theme-manager.c"
		default:
#line 21 "../src/theme-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/theme-manager.vala"
		break;
#line 2525 "theme-manager.c"
	}
}

static void
_vala_theme_manager_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	ThemeManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME_MANAGER, ThemeManager);
#line 21 "../src/theme-manager.vala"
	switch (property_id) {
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_THEME_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_theme (self, g_value_get_string (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BACKGROUND_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_background_red (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BACKGROUND_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_background_green (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BACKGROUND_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_background_blue (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BACKGROUND_RADIUS_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_background_radius (self, g_value_get_int (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_TEXTURE_ALPHA_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_texture_alpha (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_APPLY_TEXTURE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_apply_texture (self, g_value_get_boolean (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BORDER_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_border_red (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BORDER_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_border_green (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BORDER_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_border_blue (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_BORDER_WIDTH_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_border_width (self, g_value_get_int (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HALF_BORDER_WIDTH_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_half_border_width (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SPACING_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_spacing_red (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SPACING_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_spacing_green (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SPACING_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_spacing_blue (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SPACING_WIDTH_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_spacing_width (self, g_value_get_int (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_HARD_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_highlight_hard_red (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_HARD_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_highlight_hard_green (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_HARD_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_highlight_hard_blue (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_HARD_ALPHA_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_highlight_hard_alpha (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_SOFT_RED_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_highlight_soft_red (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_SOFT_GREEN_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_highlight_soft_green (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_SOFT_BLUE_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_highlight_soft_blue (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_HIGHLIGHT_SOFT_ALPHA_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_highlight_soft_alpha (self, g_value_get_double (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SOUND_FLIP_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_sound_flip (self, g_value_get_string (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 21 "../src/theme-manager.vala"
		case THEME_MANAGER_SOUND_GAMEOVER_PROPERTY:
#line 21 "../src/theme-manager.vala"
		theme_manager_set_sound_gameover (self, g_value_get_string (value));
#line 21 "../src/theme-manager.vala"
		break;
#line 2695 "theme-manager.c"
		default:
#line 21 "../src/theme-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/theme-manager.vala"
		break;
#line 2701 "theme-manager.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

