/* computer-reversi.c generated by valac 0.56.18, the Vala compiler
 * generated from computer-reversi.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <stdlib.h>

#define COMPUTER_REVERSI_POSITIVE_INFINITY ((gint16) 32000)
#define COMPUTER_REVERSI_NEGATIVE_INFINITY ((gint16) -32000)
#define COMPUTER_REVERSE_HARD_border_penalty ((gint16) 86)
#define COMPUTER_REVERSE_HARD_corner_penalty ((gint16) 86)
#define COMPUTER_REVERSI_HARD_border_penalty ((gint16) 206)
#define COMPUTER_REVERSI_HARD_corner_penalty ((gint16) 206)
#define COMPUTER_REVERSI_LESS_THAN_NEGATIVE_INFINITY ((gint16) -32001)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;

#define TYPE_COMPUTER_PLAYER (computer_player_get_type ())
#define COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayer))
#define COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))
#define IS_COMPUTER_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_PLAYER))
#define IS_COMPUTER_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_PLAYER))
#define COMPUTER_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_PLAYER, ComputerPlayerClass))

typedef struct _ComputerPlayer ComputerPlayer;
typedef struct _ComputerPlayerClass ComputerPlayerClass;
typedef struct _ComputerPlayerPrivate ComputerPlayerPrivate;

#define TYPE_COMPUTER_REVERSI (computer_reversi_get_type ())
#define COMPUTER_REVERSI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_REVERSI, ComputerReversi))
#define COMPUTER_REVERSI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_REVERSI, ComputerReversiClass))
#define IS_COMPUTER_REVERSI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_REVERSI))
#define IS_COMPUTER_REVERSI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_REVERSI))
#define COMPUTER_REVERSI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_REVERSI, ComputerReversiClass))

typedef struct _ComputerReversi ComputerReversi;
typedef struct _ComputerReversiClass ComputerReversiClass;
typedef struct _ComputerReversiPrivate ComputerReversiPrivate;

#define TYPE_GAME_STATE_STRUCT (game_state_struct_get_type ())
typedef struct _GameStateStruct GameStateStruct;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())

#define TYPE_COMPUTER_REVERSE_EASY (computer_reverse_easy_get_type ())
#define COMPUTER_REVERSE_EASY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_REVERSE_EASY, ComputerReverseEasy))
#define COMPUTER_REVERSE_EASY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_REVERSE_EASY, ComputerReverseEasyClass))
#define IS_COMPUTER_REVERSE_EASY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_REVERSE_EASY))
#define IS_COMPUTER_REVERSE_EASY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_REVERSE_EASY))
#define COMPUTER_REVERSE_EASY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_REVERSE_EASY, ComputerReverseEasyClass))

typedef struct _ComputerReverseEasy ComputerReverseEasy;
typedef struct _ComputerReverseEasyClass ComputerReverseEasyClass;
typedef struct _ComputerReverseEasyPrivate ComputerReverseEasyPrivate;
enum  {
	COMPUTER_REVERSE_EASY_0_PROPERTY,
	COMPUTER_REVERSE_EASY_NUM_PROPERTIES
};
static GParamSpec* computer_reverse_easy_properties[COMPUTER_REVERSE_EASY_NUM_PROPERTIES];

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;

#define TYPE_COMPUTER_REVERSE_HARD (computer_reverse_hard_get_type ())
#define COMPUTER_REVERSE_HARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_REVERSE_HARD, ComputerReverseHard))
#define COMPUTER_REVERSE_HARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_REVERSE_HARD, ComputerReverseHardClass))
#define IS_COMPUTER_REVERSE_HARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_REVERSE_HARD))
#define IS_COMPUTER_REVERSE_HARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_REVERSE_HARD))
#define COMPUTER_REVERSE_HARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_REVERSE_HARD, ComputerReverseHardClass))

typedef struct _ComputerReverseHard ComputerReverseHard;
typedef struct _ComputerReverseHardClass ComputerReverseHardClass;
typedef struct _ComputerReverseHardPrivate ComputerReverseHardPrivate;
enum  {
	COMPUTER_REVERSE_HARD_0_PROPERTY,
	COMPUTER_REVERSE_HARD_EVEN_DEPTH_PROPERTY,
	COMPUTER_REVERSE_HARD_FIXED_HEURISTIC_PROPERTY,
	COMPUTER_REVERSE_HARD_NUM_PROPERTIES
};
static GParamSpec* computer_reverse_hard_properties[COMPUTER_REVERSE_HARD_NUM_PROPERTIES];
typedef enum  {
	MAIN_LINE_TOP,
	MAIN_LINE_LEFT,
	MAIN_LINE_RIGHT,
	MAIN_LINE_BOTTOM,
	MAIN_LINE_TOPLEFT,
	MAIN_LINE_TOPRIGHT
} MainLine;

#define TYPE_MAIN_LINE (main_line_get_type ())

#define TYPE_COMPUTER_REVERSI_EASY (computer_reversi_easy_get_type ())
#define COMPUTER_REVERSI_EASY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_REVERSI_EASY, ComputerReversiEasy))
#define COMPUTER_REVERSI_EASY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_REVERSI_EASY, ComputerReversiEasyClass))
#define IS_COMPUTER_REVERSI_EASY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_REVERSI_EASY))
#define IS_COMPUTER_REVERSI_EASY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_REVERSI_EASY))
#define COMPUTER_REVERSI_EASY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_REVERSI_EASY, ComputerReversiEasyClass))

typedef struct _ComputerReversiEasy ComputerReversiEasy;
typedef struct _ComputerReversiEasyClass ComputerReversiEasyClass;
typedef struct _ComputerReversiEasyPrivate ComputerReversiEasyPrivate;
enum  {
	COMPUTER_REVERSI_EASY_0_PROPERTY,
	COMPUTER_REVERSI_EASY_NUM_PROPERTIES
};
static GParamSpec* computer_reversi_easy_properties[COMPUTER_REVERSI_EASY_NUM_PROPERTIES];

#define TYPE_COMPUTER_REVERSI_HARD (computer_reversi_hard_get_type ())
#define COMPUTER_REVERSI_HARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPUTER_REVERSI_HARD, ComputerReversiHard))
#define COMPUTER_REVERSI_HARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPUTER_REVERSI_HARD, ComputerReversiHardClass))
#define IS_COMPUTER_REVERSI_HARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPUTER_REVERSI_HARD))
#define IS_COMPUTER_REVERSI_HARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPUTER_REVERSI_HARD))
#define COMPUTER_REVERSI_HARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPUTER_REVERSI_HARD, ComputerReversiHardClass))

typedef struct _ComputerReversiHard ComputerReversiHard;
typedef struct _ComputerReversiHardClass ComputerReversiHardClass;
typedef struct _ComputerReversiHardPrivate ComputerReversiHardPrivate;
enum  {
	COMPUTER_REVERSI_HARD_0_PROPERTY,
	COMPUTER_REVERSI_HARD_EVEN_DEPTH_PROPERTY,
	COMPUTER_REVERSI_HARD_FIXED_HEURISTIC_PROPERTY,
	COMPUTER_REVERSI_HARD_NUM_PROPERTIES
};
static GParamSpec* computer_reversi_hard_properties[COMPUTER_REVERSI_HARD_NUM_PROPERTIES];
enum  {
	COMPUTER_REVERSI_0_PROPERTY,
	COMPUTER_REVERSI_GAME_PROPERTY,
	COMPUTER_REVERSI_INITIAL_DEPTH_PROPERTY,
	COMPUTER_REVERSI_SIZE_PROPERTY,
	COMPUTER_REVERSI_MOVE_RANDOMLY_PROPERTY,
	COMPUTER_REVERSI_NUM_PROPERTIES
};
static GParamSpec* computer_reversi_properties[COMPUTER_REVERSI_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _ComputerPlayer {
	GObject parent_instance;
	ComputerPlayerPrivate * priv;
};

struct _ComputerPlayerClass {
	GObjectClass parent_class;
	void (*run_search) (ComputerPlayer* self, PossibleMove* chosen_move);
	void (*complete_move) (ComputerPlayer* self, PossibleMove* chosen_move);
};

struct _GameStateStruct {
	Player current_color;
	Player opponent_color;
	guint8 size;
	guint8 n_current_tiles;
	guint8 n_opponent_tiles;
	guint8 n_tiles;
	gboolean current_player_can_move;
	gboolean is_complete;
	Player* tiles;
	gint tiles_length1;
	gint tiles_length2;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	guint8 x_saved;
	guint8 y_saved;
	guint8* empty_neighbors;
	gint empty_neighbors_length1;
	gint empty_neighbors_length2;
};

struct _ComputerReversi {
	ComputerPlayer parent_instance;
	ComputerReversiPrivate * priv;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
};

struct _ComputerReversiClass {
	ComputerPlayerClass parent_class;
	gint16 (*calculate_heuristic) (ComputerReversi* self, GameStateStruct* g);
	gint16 (*end_of_game) (ComputerReversi* self, GameStateStruct* g);
	void (*sort_moves) (ComputerReversi* self, GSList** moves);
};

struct _ComputerReverseEasy {
	ComputerReversi parent_instance;
	ComputerReverseEasyPrivate * priv;
};

struct _ComputerReverseEasyClass {
	ComputerReversiClass parent_class;
};

struct _ComputerReverseHard {
	ComputerReversi parent_instance;
	ComputerReverseHardPrivate * priv;
};

struct _ComputerReverseHardClass {
	ComputerReversiClass parent_class;
};

struct _ComputerReverseHardPrivate {
	gboolean _even_depth;
	gboolean _fixed_heuristic;
	gint16* heuristic;
	gint heuristic_length1;
	gint heuristic_length2;
};

struct _ComputerReversiEasy {
	ComputerReversi parent_instance;
	ComputerReversiEasyPrivate * priv;
};

struct _ComputerReversiEasyClass {
	ComputerReversiClass parent_class;
};

struct _ComputerReversiHard {
	ComputerReversi parent_instance;
	ComputerReversiHardPrivate * priv;
};

struct _ComputerReversiHardClass {
	ComputerReversiClass parent_class;
};

struct _ComputerReversiHardPrivate {
	gboolean _even_depth;
	gboolean _fixed_heuristic;
	gint16* heuristic;
	gint heuristic_length1;
	gint heuristic_length2;
};

struct _ComputerReversiPrivate {
	Game* _game;
	guint8 _initial_depth;
	guint8 _size;
	guint8 _move_randomly;
};

static gpointer computer_reverse_easy_parent_class = NULL;
static gint ComputerReverseHard_private_offset;
static gpointer computer_reverse_hard_parent_class = NULL;
static gpointer computer_reversi_easy_parent_class = NULL;
static gint ComputerReversiHard_private_offset;
static gpointer computer_reversi_hard_parent_class = NULL;
static gint ComputerReversi_private_offset;
static gpointer computer_reversi_parent_class = NULL;

VALA_EXTERN GType possible_move_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PossibleMove* possible_move_dup (const PossibleMove* self);
VALA_EXTERN void possible_move_free (PossibleMove* self);
VALA_EXTERN void possible_move_init (PossibleMove *self,
                         guint8 x,
                         guint8 y);
VALA_EXTERN GType computer_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerPlayer, g_object_unref)
VALA_EXTERN GType computer_reversi_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerReversi, g_object_unref)
VALA_EXTERN GType game_state_struct_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameStateStruct* game_state_struct_dup (const GameStateStruct* self);
VALA_EXTERN void game_state_struct_free (GameStateStruct* self);
VALA_EXTERN void game_state_struct_copy (const GameStateStruct* self,
                             GameStateStruct* dest);
VALA_EXTERN void game_state_struct_destroy (GameStateStruct* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (GameStateStruct, game_state_struct_destroy)
VALA_EXTERN GType computer_reverse_easy_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerReverseEasy, g_object_unref)
VALA_EXTERN void computer_reversi_sort_moves (ComputerReversi* self,
                                  GSList** moves);
VALA_EXTERN gint16 computer_reversi_end_of_game (ComputerReversi* self,
                                     GameStateStruct* g);
VALA_EXTERN gint16 computer_reversi_calculate_heuristic (ComputerReversi* self,
                                             GameStateStruct* g);
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
VALA_EXTERN ComputerReverseEasy* computer_reverse_easy_new (Game* game);
VALA_EXTERN ComputerReverseEasy* computer_reverse_easy_construct (GType object_type,
                                                      Game* game);
static void computer_reverse_easy_real_sort_moves (ComputerReversi* base,
                                            GSList** moves);
static inline gint computer_reverse_easy_compare_move (PossibleMove* a,
                                         PossibleMove* b);
static gint _computer_reverse_easy_compare_move_gcompare_func (gconstpointer a,
                                                        gconstpointer b);
static gint16 computer_reverse_easy_real_end_of_game (ComputerReversi* base,
                                               GameStateStruct* g);
static gint16 computer_reverse_easy_real_calculate_heuristic (ComputerReversi* base,
                                                       GameStateStruct* g);
static GType computer_reverse_easy_get_type_once (void);
VALA_EXTERN GType computer_reverse_hard_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerReverseHard, g_object_unref)
VALA_EXTERN ComputerReverseHard* computer_reverse_hard_new (Game* game,
                                                guint8 initial_depth,
                                                gboolean fixed_heuristic);
VALA_EXTERN ComputerReverseHard* computer_reverse_hard_construct (GType object_type,
                                                      Game* game,
                                                      guint8 initial_depth,
                                                      gboolean fixed_heuristic);
static void computer_reverse_hard_real_sort_moves (ComputerReversi* base,
                                            GSList** moves);
static inline gint computer_reverse_hard_compare_move (ComputerReverseHard* self,
                                         PossibleMove* a,
                                         PossibleMove* b);
static gint _computer_reverse_hard_compare_move_gcompare_data_func (gconstpointer a,
                                                             gconstpointer b,
                                                             gpointer self);
static inline gint computer_reverse_hard_calculate_move_heuristic (ComputerReverseHard* self,
                                                     PossibleMove* move);
static inline void computer_reverse_hard_calculate_dir_heuristic (ComputerReverseHard* self,
                                                    gint* comparator,
                                                    guint8 x,
                                                    guint8 y,
                                                    gint8 x_step,
                                                    gint8 y_step,
                                                    guint8 count);
static gint16 computer_reverse_hard_real_end_of_game (ComputerReversi* base,
                                               GameStateStruct* g);
static gint16 computer_reverse_hard_real_calculate_heuristic (ComputerReversi* base,
                                                       GameStateStruct* g);
static inline gint16 computer_reverse_hard_eval_heuristic (GameStateStruct* g,
                                             gint16** heuristic,
                                             gint* heuristic_length1,
                                             gint* heuristic_length2,
                                             gboolean even_depth);
static gboolean computer_reverse_hard_get_even_depth (ComputerReverseHard* self);
VALA_EXTERN guint8 game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y);
VALA_EXTERN gboolean game_state_struct_is_empty_tile (GameStateStruct *self,
                                          guint8 x,
                                          guint8 y);
VALA_EXTERN gboolean game_state_struct_is_current_color (GameStateStruct *self,
                                             guint8 x,
                                             guint8 y);
VALA_EXTERN GType main_line_get_type (void) G_GNUC_CONST ;
static void computer_reverse_hard_mainline_penalty (GameStateStruct* g,
                                             gint16 penalty,
                                             gint16* count,
                                             MainLine mainline_id);
VALA_EXTERN Player* game_state_struct_get_mainline (GameStateStruct *self,
                                        MainLine mainline_id,
                                        gint* result_length1);
static void computer_reverse_hard_init_heuristic (guint8 size,
                                           gboolean fixed_heuristic,
                                           gint16** heuristic,
                                           gint* heuristic_length1,
                                           gint* heuristic_length2);
static gint16* _vala_array_dup4 (gint16* self,
                          gssize length);
static void computer_reverse_hard_create_heuristic (guint8 size,
                                             gint16** heuristic,
                                             gint* heuristic_length1,
                                             gint* heuristic_length2);
static void computer_reverse_hard_set_even_depth (ComputerReverseHard* self,
                                           gboolean value);
static gboolean computer_reverse_hard_get_fixed_heuristic (ComputerReverseHard* self);
static void computer_reverse_hard_set_fixed_heuristic (ComputerReverseHard* self,
                                                gboolean value);
static GObject * computer_reverse_hard_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
VALA_EXTERN guint8 computer_reversi_get_size (ComputerReversi* self);
static void computer_reverse_hard_finalize (GObject * obj);
static GType computer_reverse_hard_get_type_once (void);
static void _vala_computer_reverse_hard_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_computer_reverse_hard_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
VALA_EXTERN GType computer_reversi_easy_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerReversiEasy, g_object_unref)
VALA_EXTERN ComputerReversiEasy* computer_reversi_easy_new (Game* game);
VALA_EXTERN ComputerReversiEasy* computer_reversi_easy_construct (GType object_type,
                                                      Game* game);
static void computer_reversi_easy_real_sort_moves (ComputerReversi* base,
                                            GSList** moves);
static inline gint computer_reversi_easy_compare_move (PossibleMove* a,
                                         PossibleMove* b);
static gint _computer_reversi_easy_compare_move_gcompare_func (gconstpointer a,
                                                        gconstpointer b);
static gint16 computer_reversi_easy_real_end_of_game (ComputerReversi* base,
                                               GameStateStruct* g);
static gint16 computer_reversi_easy_real_calculate_heuristic (ComputerReversi* base,
                                                       GameStateStruct* g);
static GType computer_reversi_easy_get_type_once (void);
VALA_EXTERN GType computer_reversi_hard_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ComputerReversiHard, g_object_unref)
VALA_EXTERN ComputerReversiHard* computer_reversi_hard_new (Game* game,
                                                guint8 initial_depth,
                                                gboolean fixed_heuristic);
VALA_EXTERN ComputerReversiHard* computer_reversi_hard_construct (GType object_type,
                                                      Game* game,
                                                      guint8 initial_depth,
                                                      gboolean fixed_heuristic);
static void computer_reversi_hard_real_sort_moves (ComputerReversi* base,
                                            GSList** moves);
static inline gint computer_reversi_hard_compare_move (ComputerReversiHard* self,
                                         PossibleMove* a,
                                         PossibleMove* b);
static gint _computer_reversi_hard_compare_move_gcompare_data_func (gconstpointer a,
                                                             gconstpointer b,
                                                             gpointer self);
static inline gint computer_reversi_hard_calculate_move_heuristic (ComputerReversiHard* self,
                                                     PossibleMove* move);
static inline void computer_reversi_hard_calculate_dir_heuristic (ComputerReversiHard* self,
                                                    gint* comparator,
                                                    guint8 x,
                                                    guint8 y,
                                                    gint8 x_step,
                                                    gint8 y_step,
                                                    guint8 count);
static gint16 computer_reversi_hard_real_end_of_game (ComputerReversi* base,
                                               GameStateStruct* g);
static gint16 computer_reversi_hard_real_calculate_heuristic (ComputerReversi* base,
                                                       GameStateStruct* g);
static inline gint16 computer_reversi_hard_eval_heuristic (GameStateStruct* g,
                                             gint16** heuristic,
                                             gint* heuristic_length1,
                                             gint* heuristic_length2,
                                             gboolean even_depth);
static gboolean computer_reversi_hard_get_even_depth (ComputerReversiHard* self);
static void computer_reversi_hard_mainline_penalty (GameStateStruct* g,
                                             gint16 penalty,
                                             gint16* count,
                                             MainLine mainline_id);
static inline void computer_reversi_hard_init_heuristic (guint8 size,
                                           gboolean fixed_heuristic,
                                           gint16** heuristic,
                                           gint* heuristic_length1,
                                           gint* heuristic_length2);
static gint16* _vala_array_dup5 (gint16* self,
                          gssize length);
static void computer_reversi_hard_create_heuristic (guint8 size,
                                             gint16** heuristic,
                                             gint* heuristic_length1,
                                             gint* heuristic_length2);
static void computer_reversi_hard_set_even_depth (ComputerReversiHard* self,
                                           gboolean value);
static gboolean computer_reversi_hard_get_fixed_heuristic (ComputerReversiHard* self);
static void computer_reversi_hard_set_fixed_heuristic (ComputerReversiHard* self,
                                                gboolean value);
static GObject * computer_reversi_hard_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void computer_reversi_hard_finalize (GObject * obj);
static GType computer_reversi_hard_get_type_once (void);
static void _vala_computer_reversi_hard_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_computer_reversi_hard_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);
VALA_EXTERN void computer_player_complete_move (ComputerPlayer* self,
                                    PossibleMove* chosen_move);
VALA_EXTERN void computer_player_run_search (ComputerPlayer* self,
                                 PossibleMove* chosen_move);
static void computer_reversi_real_complete_move (ComputerPlayer* base,
                                          PossibleMove* chosen_move);
static Game* computer_reversi_get_game (ComputerReversi* self);
VALA_EXTERN gboolean game_place_tile (Game* self,
                          guint8 x,
                          guint8 y);
VALA_EXTERN gchar* game_to_string (Game* self);
static void computer_reversi_random_select (GameStateStruct* g,
                                     PossibleMove* random_move);
VALA_EXTERN GType game_state_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
VALA_EXTERN GameStateObject* game_get_current_state (Game* self);
VALA_EXTERN void game_state_object_get_game_state_struct (GameStateObject* self,
                                              GameStateStruct * result);
VALA_EXTERN void game_state_struct_get_possible_moves (GameStateStruct *self,
                                           GSList** moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static void computer_reversi_real_run_search (ComputerPlayer* base,
                                       PossibleMove* best_move);
VALA_EXTERN guint8 computer_reversi_get_move_randomly (ComputerReversi* self);
VALA_EXTERN gboolean game_get_reverse (Game* self);
VALA_EXTERN void game_get_possible_moves (Game* self,
                              GSList** moves);
VALA_EXTERN void game_state_struct_init_copy_and_move (GameStateStruct *self,
                                           GameStateStruct* game,
                                           PossibleMove* move);
static gint16 computer_reversi_search (ComputerReversi* self,
                                GameStateStruct* g,
                                guint8 depth,
                                gint16 a,
                                gint16 b);
static guint8 computer_reversi_get_initial_depth (ComputerReversi* self);
VALA_EXTERN gboolean computer_player_get_move_pending (ComputerPlayer* self);
VALA_EXTERN void game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                           GameStateStruct* game);
static gint16 computer_reversi_real_calculate_heuristic (ComputerReversi* self,
                                                  GameStateStruct* g);
static gint16 computer_reversi_real_end_of_game (ComputerReversi* self,
                                          GameStateStruct* g);
static void computer_reversi_real_sort_moves (ComputerReversi* self,
                                       GSList** moves);
VALA_EXTERN ComputerReversi* computer_reversi_construct (GType object_type);
VALA_EXTERN ComputerPlayer* computer_player_construct (GType object_type);
static void computer_reversi_set_game (ComputerReversi* self,
                                Game* value);
static void computer_reversi_set_initial_depth (ComputerReversi* self,
                                         guint8 value);
static void computer_reversi_set_size (ComputerReversi* self,
                                guint8 value);
static void computer_reversi_set_move_randomly (ComputerReversi* self,
                                         guint8 value);
static GObject * computer_reversi_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
VALA_EXTERN guint8 game_get_size (Game* self);
VALA_EXTERN guint8 game_get_initial_number_of_tiles (Game* self);
VALA_EXTERN guint8* game_copy_neighbor_tiles (Game* self,
                                  gint* result_length1,
                                  gint* result_length2);
static void computer_reversi_finalize (GObject * obj);
static GType computer_reversi_get_type_once (void);
static void _vala_computer_reversi_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_computer_reversi_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

const gint16 heuristic_8[8][8] = {{(gint16) 410, (gint16) 23, (gint16) 13, (gint16) 8, (gint16) 8, (gint16) 13, (gint16) 23, (gint16) 410}, {(gint16) 23, (gint16) -75, (gint16) -22, (gint16) -51, (gint16) -51, (gint16) -22, (gint16) -75, (gint16) 23}, {(gint16) 13, (gint16) -22, (gint16) 41, (gint16) 3, (gint16) 3, (gint16) 41, (gint16) -22, (gint16) 13}, {(gint16) 8, (gint16) -51, (gint16) 3, (gint16) -87, (gint16) -87, (gint16) 3, (gint16) -51, (gint16) 8}, {(gint16) 8, (gint16) -51, (gint16) 3, (gint16) -87, (gint16) -87, (gint16) 3, (gint16) -51, (gint16) 8}, {(gint16) 13, (gint16) -22, (gint16) 41, (gint16) 3, (gint16) 3, (gint16) 41, (gint16) -22, (gint16) 13}, {(gint16) 23, (gint16) -75, (gint16) -22, (gint16) -51, (gint16) -51, (gint16) -22, (gint16) -75, (gint16) 23}, {(gint16) 410, (gint16) 23, (gint16) 13, (gint16) 8, (gint16) 8, (gint16) 13, (gint16) 23, (gint16) 410}};

void
possible_move_init (PossibleMove *self,
                    guint8 x,
                    guint8 y)
{
#line 38 "../src/computer-reversi.vala"
	memset (self, 0, sizeof (PossibleMove));
#line 40 "../src/computer-reversi.vala"
	(*self).x = x;
#line 41 "../src/computer-reversi.vala"
	(*self).y = y;
#line 635 "computer-reversi.c"
}

PossibleMove*
possible_move_dup (const PossibleMove* self)
{
	PossibleMove* dup;
#line 23 "../src/computer-reversi.vala"
	dup = g_new0 (PossibleMove, 1);
#line 23 "../src/computer-reversi.vala"
	memcpy (dup, self, sizeof (PossibleMove));
#line 23 "../src/computer-reversi.vala"
	return dup;
#line 648 "computer-reversi.c"
}

void
possible_move_free (PossibleMove* self)
{
#line 23 "../src/computer-reversi.vala"
	g_free (self);
#line 656 "computer-reversi.c"
}

static GType
possible_move_get_type_once (void)
{
	GType possible_move_type_id;
	possible_move_type_id = g_boxed_type_register_static ("PossibleMove", (GBoxedCopyFunc) possible_move_dup, (GBoxedFreeFunc) possible_move_free);
	return possible_move_type_id;
}

GType
possible_move_get_type (void)
{
	static volatile gsize possible_move_type_id__once = 0;
	if (g_once_init_enter (&possible_move_type_id__once)) {
		GType possible_move_type_id;
		possible_move_type_id = possible_move_get_type_once ();
		g_once_init_leave (&possible_move_type_id__once, possible_move_type_id);
	}
	return possible_move_type_id__once;
}

ComputerReverseEasy*
computer_reverse_easy_construct (GType object_type,
                                 Game* game)
{
	ComputerReverseEasy * self = NULL;
#line 60 "../src/computer-reversi.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 62 "../src/computer-reversi.vala"
	self = (ComputerReverseEasy*) g_object_new (object_type, "game", game, "initial-depth", 2, NULL);
#line 60 "../src/computer-reversi.vala"
	return self;
#line 690 "computer-reversi.c"
}

ComputerReverseEasy*
computer_reverse_easy_new (Game* game)
{
#line 60 "../src/computer-reversi.vala"
	return computer_reverse_easy_construct (TYPE_COMPUTER_REVERSE_EASY, game);
#line 698 "computer-reversi.c"
}

static gint
_computer_reverse_easy_compare_move_gcompare_func (gconstpointer a,
                                                   gconstpointer b)
{
	gint result;
	result = computer_reverse_easy_compare_move ((PossibleMove*) a, (PossibleMove*) b);
#line 71 "../src/computer-reversi.vala"
	return result;
#line 709 "computer-reversi.c"
}

static void
computer_reverse_easy_real_sort_moves (ComputerReversi* base,
                                       GSList** moves)
{
	ComputerReverseEasy * self;
#line 69 "../src/computer-reversi.vala"
	self = (ComputerReverseEasy*) base;
#line 71 "../src/computer-reversi.vala"
	*moves = g_slist_sort (*moves, _computer_reverse_easy_compare_move_gcompare_func);
#line 721 "computer-reversi.c"
}

static inline gint
computer_reverse_easy_compare_move (PossibleMove* a,
                                    PossibleMove* b)
{
	gint _tmp0_ = 0;
	gint result;
#line 78 "../src/computer-reversi.vala"
	if (((PossibleMove) (*a)).n_tiles <= ((PossibleMove) (*b)).n_tiles) {
#line 78 "../src/computer-reversi.vala"
		_tmp0_ = -1;
#line 734 "computer-reversi.c"
	} else {
#line 78 "../src/computer-reversi.vala"
		_tmp0_ = 1;
#line 738 "computer-reversi.c"
	}
#line 78 "../src/computer-reversi.vala"
	result = _tmp0_;
#line 78 "../src/computer-reversi.vala"
	return result;
#line 744 "computer-reversi.c"
}

static gint16
computer_reverse_easy_real_end_of_game (ComputerReversi* base,
                                        GameStateStruct* g)
{
	ComputerReverseEasy * self;
	gint16 _tmp0_ = 0;
	GameStateStruct _tmp1_;
	GameStateStruct _tmp2_;
	gint16 result;
#line 85 "../src/computer-reversi.vala"
	self = (ComputerReverseEasy*) base;
#line 85 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 87 "../src/computer-reversi.vala"
	_tmp1_ = *g;
#line 87 "../src/computer-reversi.vala"
	_tmp2_ = *g;
#line 87 "../src/computer-reversi.vala"
	if (_tmp1_.n_current_tiles < _tmp2_.n_opponent_tiles) {
#line 766 "computer-reversi.c"
		GameStateStruct _tmp3_;
#line 87 "../src/computer-reversi.vala"
		_tmp3_ = *g;
#line 87 "../src/computer-reversi.vala"
		_tmp0_ = COMPUTER_REVERSI_POSITIVE_INFINITY - ((gint16) _tmp3_.n_current_tiles);
#line 772 "computer-reversi.c"
	} else {
		GameStateStruct _tmp4_;
#line 88 "../src/computer-reversi.vala"
		_tmp4_ = *g;
#line 88 "../src/computer-reversi.vala"
		_tmp0_ = COMPUTER_REVERSI_NEGATIVE_INFINITY + ((gint16) _tmp4_.n_opponent_tiles);
#line 779 "computer-reversi.c"
	}
#line 87 "../src/computer-reversi.vala"
	result = _tmp0_;
#line 87 "../src/computer-reversi.vala"
	return result;
#line 785 "computer-reversi.c"
}

static gint16
computer_reverse_easy_real_calculate_heuristic (ComputerReversi* base,
                                                GameStateStruct* g)
{
	ComputerReverseEasy * self;
	GameStateStruct _tmp0_;
	GameStateStruct _tmp1_;
	gint16 result;
#line 91 "../src/computer-reversi.vala"
	self = (ComputerReverseEasy*) base;
#line 91 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 94 "../src/computer-reversi.vala"
	_tmp0_ = *g;
#line 94 "../src/computer-reversi.vala"
	_tmp1_ = *g;
#line 94 "../src/computer-reversi.vala"
	result = ((gint16) _tmp0_.n_current_tiles) - ((gint16) _tmp1_.n_opponent_tiles);
#line 94 "../src/computer-reversi.vala"
	return result;
#line 808 "computer-reversi.c"
}

static void
computer_reverse_easy_class_init (ComputerReverseEasyClass * klass,
                                  gpointer klass_data)
{
#line 58 "../src/computer-reversi.vala"
	computer_reverse_easy_parent_class = g_type_class_peek_parent (klass);
#line 58 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->sort_moves = (void (*) (ComputerReversi*, GSList**)) computer_reverse_easy_real_sort_moves;
#line 58 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->end_of_game = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reverse_easy_real_end_of_game;
#line 58 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->calculate_heuristic = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reverse_easy_real_calculate_heuristic;
#line 823 "computer-reversi.c"
}

static void
computer_reverse_easy_instance_init (ComputerReverseEasy * self,
                                     gpointer klass)
{
}

static GType
computer_reverse_easy_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComputerReverseEasyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) computer_reverse_easy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComputerReverseEasy), 0, (GInstanceInitFunc) computer_reverse_easy_instance_init, NULL };
	GType computer_reverse_easy_type_id;
	computer_reverse_easy_type_id = g_type_register_static (TYPE_COMPUTER_REVERSI, "ComputerReverseEasy", &g_define_type_info, 0);
	return computer_reverse_easy_type_id;
}

GType
computer_reverse_easy_get_type (void)
{
	static volatile gsize computer_reverse_easy_type_id__once = 0;
	if (g_once_init_enter (&computer_reverse_easy_type_id__once)) {
		GType computer_reverse_easy_type_id;
		computer_reverse_easy_type_id = computer_reverse_easy_get_type_once ();
		g_once_init_leave (&computer_reverse_easy_type_id__once, computer_reverse_easy_type_id);
	}
	return computer_reverse_easy_type_id__once;
}

static inline gpointer
computer_reverse_hard_get_instance_private (ComputerReverseHard* self)
{
	return G_STRUCT_MEMBER_P (self, ComputerReverseHard_private_offset);
}

ComputerReverseHard*
computer_reverse_hard_construct (GType object_type,
                                 Game* game,
                                 guint8 initial_depth,
                                 gboolean fixed_heuristic)
{
	ComputerReverseHard * self = NULL;
#line 108 "../src/computer-reversi.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 110 "../src/computer-reversi.vala"
	self = (ComputerReverseHard*) g_object_new (object_type, "game", game, "even-depth", (initial_depth % 2) == 0, "initial-depth", initial_depth, "fixed-heuristic", fixed_heuristic, NULL);
#line 108 "../src/computer-reversi.vala"
	return self;
#line 872 "computer-reversi.c"
}

ComputerReverseHard*
computer_reverse_hard_new (Game* game,
                           guint8 initial_depth,
                           gboolean fixed_heuristic)
{
#line 108 "../src/computer-reversi.vala"
	return computer_reverse_hard_construct (TYPE_COMPUTER_REVERSE_HARD, game, initial_depth, fixed_heuristic);
#line 882 "computer-reversi.c"
}

static gint
_computer_reverse_hard_compare_move_gcompare_data_func (gconstpointer a,
                                                        gconstpointer b,
                                                        gpointer self)
{
	gint result;
	result = computer_reverse_hard_compare_move ((ComputerReverseHard*) self, (PossibleMove*) a, (PossibleMove*) b);
#line 122 "../src/computer-reversi.vala"
	return result;
#line 894 "computer-reversi.c"
}

static void
computer_reverse_hard_real_sort_moves (ComputerReversi* base,
                                       GSList** moves)
{
	ComputerReverseHard * self;
#line 120 "../src/computer-reversi.vala"
	self = (ComputerReverseHard*) base;
#line 122 "../src/computer-reversi.vala"
	*moves = g_slist_sort_with_data (*moves, _computer_reverse_hard_compare_move_gcompare_data_func, self);
#line 906 "computer-reversi.c"
}

static inline gint
computer_reverse_hard_compare_move (ComputerReverseHard* self,
                                    PossibleMove* a,
                                    PossibleMove* b)
{
	PossibleMove _tmp0_;
	PossibleMove _tmp1_;
	gint result;
#line 125 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 129 "../src/computer-reversi.vala"
	_tmp0_ = (PossibleMove) (*b);
#line 129 "../src/computer-reversi.vala"
	_tmp1_ = (PossibleMove) (*a);
#line 129 "../src/computer-reversi.vala"
	result = computer_reverse_hard_calculate_move_heuristic (self, &_tmp0_) - computer_reverse_hard_calculate_move_heuristic (self, &_tmp1_);
#line 129 "../src/computer-reversi.vala"
	return result;
#line 927 "computer-reversi.c"
}

static inline gint
computer_reverse_hard_calculate_move_heuristic (ComputerReverseHard* self,
                                                PossibleMove* move)
{
	gint comparator = 0;
	PossibleMove _tmp0_;
	PossibleMove _tmp1_;
	PossibleMove _tmp2_;
	PossibleMove _tmp3_;
	PossibleMove _tmp4_;
	PossibleMove _tmp5_;
	PossibleMove _tmp6_;
	PossibleMove _tmp7_;
	PossibleMove _tmp8_;
	PossibleMove _tmp9_;
	PossibleMove _tmp10_;
	PossibleMove _tmp11_;
	PossibleMove _tmp12_;
	PossibleMove _tmp13_;
	PossibleMove _tmp14_;
	PossibleMove _tmp15_;
	PossibleMove _tmp16_;
	PossibleMove _tmp17_;
	PossibleMove _tmp18_;
	PossibleMove _tmp19_;
	PossibleMove _tmp20_;
	PossibleMove _tmp21_;
	PossibleMove _tmp22_;
	PossibleMove _tmp23_;
	gint16* _tmp24_;
	gint _tmp24__length1;
	gint _tmp24__length2;
	PossibleMove _tmp25_;
	PossibleMove _tmp26_;
	gint16 _tmp27_;
	guint8* _tmp28_;
	gint _tmp28__length1;
	gint _tmp28__length2;
	PossibleMove _tmp29_;
	PossibleMove _tmp30_;
	guint8 _tmp31_;
	gint result;
#line 132 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 132 "../src/computer-reversi.vala"
	g_return_val_if_fail (move != NULL, 0);
#line 134 "../src/computer-reversi.vala"
	comparator = 0;
#line 135 "../src/computer-reversi.vala"
	_tmp0_ = *move;
#line 135 "../src/computer-reversi.vala"
	_tmp1_ = *move;
#line 135 "../src/computer-reversi.vala"
	_tmp2_ = *move;
#line 135 "../src/computer-reversi.vala"
	computer_reverse_hard_calculate_dir_heuristic (self, &comparator, _tmp0_.x, _tmp1_.y, (gint8) 0, (gint8) -1, _tmp2_.n_tiles_n);
#line 136 "../src/computer-reversi.vala"
	_tmp3_ = *move;
#line 136 "../src/computer-reversi.vala"
	_tmp4_ = *move;
#line 136 "../src/computer-reversi.vala"
	_tmp5_ = *move;
#line 136 "../src/computer-reversi.vala"
	computer_reverse_hard_calculate_dir_heuristic (self, &comparator, _tmp3_.x, _tmp4_.y, (gint8) 1, (gint8) -1, _tmp5_.n_tiles_ne);
#line 137 "../src/computer-reversi.vala"
	_tmp6_ = *move;
#line 137 "../src/computer-reversi.vala"
	_tmp7_ = *move;
#line 137 "../src/computer-reversi.vala"
	_tmp8_ = *move;
#line 137 "../src/computer-reversi.vala"
	computer_reverse_hard_calculate_dir_heuristic (self, &comparator, _tmp6_.x, _tmp7_.y, (gint8) 1, (gint8) 0, _tmp8_.n_tiles_e);
#line 138 "../src/computer-reversi.vala"
	_tmp9_ = *move;
#line 138 "../src/computer-reversi.vala"
	_tmp10_ = *move;
#line 138 "../src/computer-reversi.vala"
	_tmp11_ = *move;
#line 138 "../src/computer-reversi.vala"
	computer_reverse_hard_calculate_dir_heuristic (self, &comparator, _tmp9_.x, _tmp10_.y, (gint8) 1, (gint8) 1, _tmp11_.n_tiles_se);
#line 139 "../src/computer-reversi.vala"
	_tmp12_ = *move;
#line 139 "../src/computer-reversi.vala"
	_tmp13_ = *move;
#line 139 "../src/computer-reversi.vala"
	_tmp14_ = *move;
#line 139 "../src/computer-reversi.vala"
	computer_reverse_hard_calculate_dir_heuristic (self, &comparator, _tmp12_.x, _tmp13_.y, (gint8) 0, (gint8) 1, _tmp14_.n_tiles_s);
#line 140 "../src/computer-reversi.vala"
	_tmp15_ = *move;
#line 140 "../src/computer-reversi.vala"
	_tmp16_ = *move;
#line 140 "../src/computer-reversi.vala"
	_tmp17_ = *move;
#line 140 "../src/computer-reversi.vala"
	computer_reverse_hard_calculate_dir_heuristic (self, &comparator, _tmp15_.x, _tmp16_.y, (gint8) -1, (gint8) 1, _tmp17_.n_tiles_so);
#line 141 "../src/computer-reversi.vala"
	_tmp18_ = *move;
#line 141 "../src/computer-reversi.vala"
	_tmp19_ = *move;
#line 141 "../src/computer-reversi.vala"
	_tmp20_ = *move;
#line 141 "../src/computer-reversi.vala"
	computer_reverse_hard_calculate_dir_heuristic (self, &comparator, _tmp18_.x, _tmp19_.y, (gint8) -1, (gint8) 0, _tmp20_.n_tiles_o);
#line 142 "../src/computer-reversi.vala"
	_tmp21_ = *move;
#line 142 "../src/computer-reversi.vala"
	_tmp22_ = *move;
#line 142 "../src/computer-reversi.vala"
	_tmp23_ = *move;
#line 142 "../src/computer-reversi.vala"
	computer_reverse_hard_calculate_dir_heuristic (self, &comparator, _tmp21_.x, _tmp22_.y, (gint8) -1, (gint8) -1, _tmp23_.n_tiles_no);
#line 143 "../src/computer-reversi.vala"
	_tmp24_ = self->priv->heuristic;
#line 143 "../src/computer-reversi.vala"
	_tmp24__length1 = self->priv->heuristic_length1;
#line 143 "../src/computer-reversi.vala"
	_tmp24__length2 = self->priv->heuristic_length2;
#line 143 "../src/computer-reversi.vala"
	_tmp25_ = *move;
#line 143 "../src/computer-reversi.vala"
	_tmp26_ = *move;
#line 143 "../src/computer-reversi.vala"
	_tmp27_ = _tmp24_[(_tmp25_.x * _tmp24__length2) + _tmp26_.y];
#line 143 "../src/computer-reversi.vala"
	_tmp28_ = ((ComputerReversi*) self)->neighbor_tiles;
#line 143 "../src/computer-reversi.vala"
	_tmp28__length1 = ((ComputerReversi*) self)->neighbor_tiles_length1;
#line 143 "../src/computer-reversi.vala"
	_tmp28__length2 = ((ComputerReversi*) self)->neighbor_tiles_length2;
#line 143 "../src/computer-reversi.vala"
	_tmp29_ = *move;
#line 143 "../src/computer-reversi.vala"
	_tmp30_ = *move;
#line 143 "../src/computer-reversi.vala"
	_tmp31_ = _tmp28_[(_tmp29_.x * _tmp28__length2) + _tmp30_.y];
#line 143 "../src/computer-reversi.vala"
	result = ((2 * comparator) + ((gint) _tmp27_)) + (8 * ((gint) _tmp31_));
#line 143 "../src/computer-reversi.vala"
	return result;
#line 1070 "computer-reversi.c"
}

static inline void
computer_reverse_hard_calculate_dir_heuristic (ComputerReverseHard* self,
                                               gint* comparator,
                                               guint8 x,
                                               guint8 y,
                                               gint8 x_step,
                                               gint8 y_step,
                                               guint8 count)
{
#line 146 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 1084 "computer-reversi.c"
	{
		gboolean _tmp0_ = FALSE;
#line 148 "../src/computer-reversi.vala"
		_tmp0_ = TRUE;
#line 148 "../src/computer-reversi.vala"
		while (TRUE) {
#line 1091 "computer-reversi.c"
			gint16* _tmp2_;
			gint _tmp2__length1;
			gint _tmp2__length2;
			gint16 _tmp3_;
#line 148 "../src/computer-reversi.vala"
			if (!_tmp0_) {
#line 1098 "computer-reversi.c"
				guint8 _tmp1_;
#line 148 "../src/computer-reversi.vala"
				_tmp1_ = count;
#line 148 "../src/computer-reversi.vala"
				count = _tmp1_ - 1;
#line 1104 "computer-reversi.c"
			}
#line 148 "../src/computer-reversi.vala"
			_tmp0_ = FALSE;
#line 148 "../src/computer-reversi.vala"
			if (!(((gint) count) > 0)) {
#line 148 "../src/computer-reversi.vala"
				break;
#line 1112 "computer-reversi.c"
			}
#line 149 "../src/computer-reversi.vala"
			_tmp2_ = self->priv->heuristic;
#line 149 "../src/computer-reversi.vala"
			_tmp2__length1 = self->priv->heuristic_length1;
#line 149 "../src/computer-reversi.vala"
			_tmp2__length2 = self->priv->heuristic_length2;
#line 149 "../src/computer-reversi.vala"
			_tmp3_ = _tmp2_[((((gint8) x) + (((gint8) count) * x_step)) * _tmp2__length2) + (((gint8) y) + (((gint8) count) * y_step))];
#line 149 "../src/computer-reversi.vala"
			*comparator = (*comparator) + ((gint) _tmp3_);
#line 1124 "computer-reversi.c"
		}
	}
}

static gint16
computer_reverse_hard_real_end_of_game (ComputerReversi* base,
                                        GameStateStruct* g)
{
	ComputerReverseHard * self;
	gint16 _tmp0_ = 0;
	GameStateStruct _tmp1_;
	GameStateStruct _tmp2_;
	gint16 result;
#line 157 "../src/computer-reversi.vala"
	self = (ComputerReverseHard*) base;
#line 157 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 159 "../src/computer-reversi.vala"
	_tmp1_ = *g;
#line 159 "../src/computer-reversi.vala"
	_tmp2_ = *g;
#line 159 "../src/computer-reversi.vala"
	if (_tmp1_.n_current_tiles < _tmp2_.n_opponent_tiles) {
#line 1148 "computer-reversi.c"
		GameStateStruct _tmp3_;
#line 159 "../src/computer-reversi.vala"
		_tmp3_ = *g;
#line 159 "../src/computer-reversi.vala"
		_tmp0_ = COMPUTER_REVERSI_POSITIVE_INFINITY - ((gint16) _tmp3_.n_current_tiles);
#line 1154 "computer-reversi.c"
	} else {
		GameStateStruct _tmp4_;
#line 160 "../src/computer-reversi.vala"
		_tmp4_ = *g;
#line 160 "../src/computer-reversi.vala"
		_tmp0_ = COMPUTER_REVERSI_NEGATIVE_INFINITY + ((gint16) _tmp4_.n_opponent_tiles);
#line 1161 "computer-reversi.c"
	}
#line 159 "../src/computer-reversi.vala"
	result = _tmp0_;
#line 159 "../src/computer-reversi.vala"
	return result;
#line 1167 "computer-reversi.c"
}

static gint16
computer_reverse_hard_real_calculate_heuristic (ComputerReversi* base,
                                                GameStateStruct* g)
{
	ComputerReverseHard * self;
	GameStateStruct _tmp0_;
	gboolean _tmp1_;
	gint16 _tmp2_;
	gint16 result;
#line 163 "../src/computer-reversi.vala"
	self = (ComputerReverseHard*) base;
#line 163 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 165 "../src/computer-reversi.vala"
	_tmp0_ = *g;
#line 165 "../src/computer-reversi.vala"
	_tmp1_ = self->priv->_even_depth;
#line 165 "../src/computer-reversi.vala"
	_tmp2_ = computer_reverse_hard_eval_heuristic (&_tmp0_, &self->priv->heuristic, (gint*) (&self->priv->heuristic_length1), (gint*) (&self->priv->heuristic_length2), _tmp1_);
#line 165 "../src/computer-reversi.vala"
	result = _tmp2_;
#line 165 "../src/computer-reversi.vala"
	return result;
#line 1193 "computer-reversi.c"
}

static inline gint16
computer_reverse_hard_eval_heuristic (GameStateStruct* g,
                                      gint16** heuristic,
                                      gint* heuristic_length1,
                                      gint* heuristic_length2,
                                      gboolean even_depth)
{
	guint8 size = 0U;
	GameStateStruct _tmp0_;
	gint16 count = 0;
	GameStateStruct _tmp6_;
	GameStateStruct _tmp7_;
	GameStateStruct _tmp8_;
	GameStateStruct _tmp9_;
	GameStateStruct _tmp10_;
	GameStateStruct _tmp11_;
	gint16 result;
#line 168 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 170 "../src/computer-reversi.vala"
	_tmp0_ = *g;
#line 170 "../src/computer-reversi.vala"
	size = _tmp0_.size;
#line 171 "../src/computer-reversi.vala"
	count = (gint16) 0;
#line 1221 "computer-reversi.c"
	{
		guint8 x = 0U;
#line 173 "../src/computer-reversi.vala"
		x = (guint8) 0;
#line 1226 "computer-reversi.c"
		{
			gboolean _tmp1_ = FALSE;
#line 173 "../src/computer-reversi.vala"
			_tmp1_ = TRUE;
#line 173 "../src/computer-reversi.vala"
			while (TRUE) {
#line 173 "../src/computer-reversi.vala"
				if (!_tmp1_) {
#line 1235 "computer-reversi.c"
					guint8 _tmp2_;
#line 173 "../src/computer-reversi.vala"
					_tmp2_ = x;
#line 173 "../src/computer-reversi.vala"
					x = _tmp2_ + 1;
#line 1241 "computer-reversi.c"
				}
#line 173 "../src/computer-reversi.vala"
				_tmp1_ = FALSE;
#line 173 "../src/computer-reversi.vala"
				if (!(x < size)) {
#line 173 "../src/computer-reversi.vala"
					break;
#line 1249 "computer-reversi.c"
				}
				{
					guint8 y = 0U;
#line 174 "../src/computer-reversi.vala"
					y = (guint8) 0;
#line 1255 "computer-reversi.c"
					{
						gboolean _tmp3_ = FALSE;
#line 174 "../src/computer-reversi.vala"
						_tmp3_ = TRUE;
#line 174 "../src/computer-reversi.vala"
						while (TRUE) {
#line 1262 "computer-reversi.c"
							gint16 a = 0;
							gint16 tile_heuristic = 0;
							gint16 _tmp5_;
#line 174 "../src/computer-reversi.vala"
							if (!_tmp3_) {
#line 1268 "computer-reversi.c"
								guint8 _tmp4_;
#line 174 "../src/computer-reversi.vala"
								_tmp4_ = y;
#line 174 "../src/computer-reversi.vala"
								y = _tmp4_ + 1;
#line 1274 "computer-reversi.c"
							}
#line 174 "../src/computer-reversi.vala"
							_tmp3_ = FALSE;
#line 174 "../src/computer-reversi.vala"
							if (!(y < size)) {
#line 174 "../src/computer-reversi.vala"
								break;
#line 1282 "computer-reversi.c"
							}
#line 176 "../src/computer-reversi.vala"
							a = (gint16) game_state_struct_get_empty_neighbors (g, x, y);
#line 177 "../src/computer-reversi.vala"
							if (((gint) a) == 0) {
#line 178 "../src/computer-reversi.vala"
								a = (gint16) 6;
#line 1290 "computer-reversi.c"
							}
#line 180 "../src/computer-reversi.vala"
							_tmp5_ = (*heuristic)[(x * (*heuristic_length2)) + y];
#line 180 "../src/computer-reversi.vala"
							tile_heuristic = (gint16) (_tmp5_ + (8 * a));
#line 181 "../src/computer-reversi.vala"
							if (game_state_struct_is_empty_tile (g, x, y)) {
#line 183 "../src/computer-reversi.vala"
								if (even_depth) {
#line 184 "../src/computer-reversi.vala"
									count -= (gint16) (tile_heuristic / 2);
#line 1302 "computer-reversi.c"
								} else {
#line 186 "../src/computer-reversi.vala"
									count += (gint16) (tile_heuristic / 2);
#line 1306 "computer-reversi.c"
								}
							} else {
#line 188 "../src/computer-reversi.vala"
								if (game_state_struct_is_current_color (g, x, y)) {
#line 189 "../src/computer-reversi.vala"
									count += tile_heuristic;
#line 1313 "computer-reversi.c"
								} else {
#line 191 "../src/computer-reversi.vala"
									count -= tile_heuristic;
#line 1317 "computer-reversi.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 194 "../src/computer-reversi.vala"
	_tmp6_ = *g;
#line 194 "../src/computer-reversi.vala"
	computer_reverse_hard_mainline_penalty (&_tmp6_, COMPUTER_REVERSE_HARD_border_penalty, &count, MAIN_LINE_TOP);
#line 195 "../src/computer-reversi.vala"
	_tmp7_ = *g;
#line 195 "../src/computer-reversi.vala"
	computer_reverse_hard_mainline_penalty (&_tmp7_, COMPUTER_REVERSE_HARD_border_penalty, &count, MAIN_LINE_LEFT);
#line 196 "../src/computer-reversi.vala"
	_tmp8_ = *g;
#line 196 "../src/computer-reversi.vala"
	computer_reverse_hard_mainline_penalty (&_tmp8_, COMPUTER_REVERSE_HARD_border_penalty, &count, MAIN_LINE_RIGHT);
#line 197 "../src/computer-reversi.vala"
	_tmp9_ = *g;
#line 197 "../src/computer-reversi.vala"
	computer_reverse_hard_mainline_penalty (&_tmp9_, COMPUTER_REVERSE_HARD_border_penalty, &count, MAIN_LINE_BOTTOM);
#line 198 "../src/computer-reversi.vala"
	_tmp10_ = *g;
#line 198 "../src/computer-reversi.vala"
	computer_reverse_hard_mainline_penalty (&_tmp10_, COMPUTER_REVERSE_HARD_corner_penalty, &count, MAIN_LINE_TOPLEFT);
#line 199 "../src/computer-reversi.vala"
	_tmp11_ = *g;
#line 199 "../src/computer-reversi.vala"
	computer_reverse_hard_mainline_penalty (&_tmp11_, COMPUTER_REVERSE_HARD_corner_penalty, &count, MAIN_LINE_TOPRIGHT);
#line 201 "../src/computer-reversi.vala"
	result = count;
#line 201 "../src/computer-reversi.vala"
	return result;
#line 1354 "computer-reversi.c"
}

static void
computer_reverse_hard_mainline_penalty (GameStateStruct* g,
                                        gint16 penalty,
                                        gint16* count,
                                        MainLine mainline_id)
{
	Player* mainline = NULL;
	gint _tmp0_ = 0;
	Player* _tmp1_;
	gint mainline_length1;
	gint _mainline_size_;
	gboolean _tmp2_ = FALSE;
	Player* _tmp3_;
	gint _tmp3__length1;
	Player _tmp4_;
	GameStateStruct _tmp5_;
	gboolean _tmp18_ = FALSE;
	Player* _tmp19_;
	gint _tmp19__length1;
	GameStateStruct _tmp20_;
	Player _tmp21_;
	GameStateStruct _tmp22_;
#line 206 "../src/computer-reversi.vala"
	g_return_if_fail (g != NULL);
#line 208 "../src/computer-reversi.vala"
	_tmp1_ = game_state_struct_get_mainline (g, mainline_id, &_tmp0_);
#line 208 "../src/computer-reversi.vala"
	mainline = _tmp1_;
#line 208 "../src/computer-reversi.vala"
	mainline_length1 = _tmp0_;
#line 208 "../src/computer-reversi.vala"
	_mainline_size_ = mainline_length1;
#line 209 "../src/computer-reversi.vala"
	_tmp3_ = mainline;
#line 209 "../src/computer-reversi.vala"
	_tmp3__length1 = mainline_length1;
#line 209 "../src/computer-reversi.vala"
	_tmp4_ = _tmp3_[1];
#line 209 "../src/computer-reversi.vala"
	_tmp5_ = *g;
#line 209 "../src/computer-reversi.vala"
	if (_tmp4_ == _tmp5_.current_color) {
#line 1399 "computer-reversi.c"
		Player* _tmp6_;
		gint _tmp6__length1;
		Player _tmp7_;
#line 210 "../src/computer-reversi.vala"
		_tmp6_ = mainline;
#line 210 "../src/computer-reversi.vala"
		_tmp6__length1 = mainline_length1;
#line 210 "../src/computer-reversi.vala"
		_tmp7_ = _tmp6_[0];
#line 210 "../src/computer-reversi.vala"
		_tmp2_ = _tmp7_ == PLAYER_NONE;
#line 1411 "computer-reversi.c"
	} else {
#line 209 "../src/computer-reversi.vala"
		_tmp2_ = FALSE;
#line 1415 "computer-reversi.c"
	}
#line 209 "../src/computer-reversi.vala"
	if (_tmp2_) {
#line 1419 "computer-reversi.c"
		guint8 i = 0U;
		GameStateStruct _tmp14_;
#line 212 "../src/computer-reversi.vala"
		i = (guint8) 1;
#line 1424 "computer-reversi.c"
		{
			gboolean _tmp8_ = FALSE;
#line 213 "../src/computer-reversi.vala"
			_tmp8_ = TRUE;
#line 213 "../src/computer-reversi.vala"
			while (TRUE) {
#line 1431 "computer-reversi.c"
				guint8 _tmp12_;
				GameStateStruct _tmp13_;
#line 213 "../src/computer-reversi.vala"
				if (!_tmp8_) {
#line 1436 "computer-reversi.c"
					Player* _tmp9_;
					gint _tmp9__length1;
					Player _tmp10_;
					GameStateStruct _tmp11_;
#line 214 "../src/computer-reversi.vala"
					_tmp9_ = mainline;
#line 214 "../src/computer-reversi.vala"
					_tmp9__length1 = mainline_length1;
#line 214 "../src/computer-reversi.vala"
					_tmp10_ = _tmp9_[i];
#line 214 "../src/computer-reversi.vala"
					_tmp11_ = *g;
#line 214 "../src/computer-reversi.vala"
					if (!(_tmp10_ == _tmp11_.current_color)) {
#line 214 "../src/computer-reversi.vala"
						break;
#line 1453 "computer-reversi.c"
					}
				}
#line 213 "../src/computer-reversi.vala"
				_tmp8_ = FALSE;
#line 213 "../src/computer-reversi.vala"
				_tmp12_ = i;
#line 213 "../src/computer-reversi.vala"
				i = _tmp12_ + 1;
#line 213 "../src/computer-reversi.vala"
				_tmp13_ = *g;
#line 213 "../src/computer-reversi.vala"
				if (((gint) i) == (_tmp13_.size - 2)) {
#line 213 "../src/computer-reversi.vala"
					break;
#line 1468 "computer-reversi.c"
				}
			}
		}
#line 215 "../src/computer-reversi.vala"
		_tmp14_ = *g;
#line 215 "../src/computer-reversi.vala"
		if (((gint) i) != (_tmp14_.size - 2)) {
#line 1476 "computer-reversi.c"
			Player* _tmp15_;
			gint _tmp15__length1;
			Player _tmp16_;
			GameStateStruct _tmp17_;
#line 217 "../src/computer-reversi.vala"
			*count = (*count) + penalty;
#line 218 "../src/computer-reversi.vala"
			_tmp15_ = mainline;
#line 218 "../src/computer-reversi.vala"
			_tmp15__length1 = mainline_length1;
#line 218 "../src/computer-reversi.vala"
			_tmp16_ = _tmp15_[i + 1];
#line 218 "../src/computer-reversi.vala"
			_tmp17_ = *g;
#line 218 "../src/computer-reversi.vala"
			if (_tmp16_ == _tmp17_.current_color) {
#line 219 "../src/computer-reversi.vala"
				*count = (*count) + penalty;
#line 1495 "computer-reversi.c"
			}
		}
	}
#line 222 "../src/computer-reversi.vala"
	_tmp19_ = mainline;
#line 222 "../src/computer-reversi.vala"
	_tmp19__length1 = mainline_length1;
#line 222 "../src/computer-reversi.vala"
	_tmp20_ = *g;
#line 222 "../src/computer-reversi.vala"
	_tmp21_ = _tmp19_[_tmp20_.size - 2];
#line 222 "../src/computer-reversi.vala"
	_tmp22_ = *g;
#line 222 "../src/computer-reversi.vala"
	if (_tmp21_ == _tmp22_.current_color) {
#line 1511 "computer-reversi.c"
		Player* _tmp23_;
		gint _tmp23__length1;
		GameStateStruct _tmp24_;
		Player _tmp25_;
#line 223 "../src/computer-reversi.vala"
		_tmp23_ = mainline;
#line 223 "../src/computer-reversi.vala"
		_tmp23__length1 = mainline_length1;
#line 223 "../src/computer-reversi.vala"
		_tmp24_ = *g;
#line 223 "../src/computer-reversi.vala"
		_tmp25_ = _tmp23_[_tmp24_.size - 1];
#line 223 "../src/computer-reversi.vala"
		_tmp18_ = _tmp25_ == PLAYER_NONE;
#line 1526 "computer-reversi.c"
	} else {
#line 222 "../src/computer-reversi.vala"
		_tmp18_ = FALSE;
#line 1530 "computer-reversi.c"
	}
#line 222 "../src/computer-reversi.vala"
	if (_tmp18_) {
#line 1534 "computer-reversi.c"
		guint8 i = 0U;
		GameStateStruct _tmp33_;
#line 225 "../src/computer-reversi.vala"
		i = (guint8) 1;
#line 1539 "computer-reversi.c"
		{
			gboolean _tmp26_ = FALSE;
#line 226 "../src/computer-reversi.vala"
			_tmp26_ = TRUE;
#line 226 "../src/computer-reversi.vala"
			while (TRUE) {
#line 1546 "computer-reversi.c"
				guint8 _tmp31_;
				GameStateStruct _tmp32_;
#line 226 "../src/computer-reversi.vala"
				if (!_tmp26_) {
#line 1551 "computer-reversi.c"
					Player* _tmp27_;
					gint _tmp27__length1;
					GameStateStruct _tmp28_;
					Player _tmp29_;
					GameStateStruct _tmp30_;
#line 227 "../src/computer-reversi.vala"
					_tmp27_ = mainline;
#line 227 "../src/computer-reversi.vala"
					_tmp27__length1 = mainline_length1;
#line 227 "../src/computer-reversi.vala"
					_tmp28_ = *g;
#line 227 "../src/computer-reversi.vala"
					_tmp29_ = _tmp27_[(_tmp28_.size - 1) - i];
#line 227 "../src/computer-reversi.vala"
					_tmp30_ = *g;
#line 227 "../src/computer-reversi.vala"
					if (!(_tmp29_ == _tmp30_.current_color)) {
#line 227 "../src/computer-reversi.vala"
						break;
#line 1571 "computer-reversi.c"
					}
				}
#line 226 "../src/computer-reversi.vala"
				_tmp26_ = FALSE;
#line 226 "../src/computer-reversi.vala"
				_tmp31_ = i;
#line 226 "../src/computer-reversi.vala"
				i = _tmp31_ + 1;
#line 226 "../src/computer-reversi.vala"
				_tmp32_ = *g;
#line 226 "../src/computer-reversi.vala"
				if (((gint) i) == (_tmp32_.size - 2)) {
#line 226 "../src/computer-reversi.vala"
					break;
#line 1586 "computer-reversi.c"
				}
			}
		}
#line 228 "../src/computer-reversi.vala"
		_tmp33_ = *g;
#line 228 "../src/computer-reversi.vala"
		if (((gint) i) != (_tmp33_.size - 2)) {
#line 1594 "computer-reversi.c"
			Player* _tmp34_;
			gint _tmp34__length1;
			GameStateStruct _tmp35_;
			Player _tmp36_;
			GameStateStruct _tmp37_;
#line 230 "../src/computer-reversi.vala"
			*count = (*count) + penalty;
#line 231 "../src/computer-reversi.vala"
			_tmp34_ = mainline;
#line 231 "../src/computer-reversi.vala"
			_tmp34__length1 = mainline_length1;
#line 231 "../src/computer-reversi.vala"
			_tmp35_ = *g;
#line 231 "../src/computer-reversi.vala"
			_tmp36_ = _tmp34_[(_tmp35_.size - 2) - i];
#line 231 "../src/computer-reversi.vala"
			_tmp37_ = *g;
#line 231 "../src/computer-reversi.vala"
			if (_tmp36_ == _tmp37_.current_color) {
#line 232 "../src/computer-reversi.vala"
				*count = (*count) + penalty;
#line 1616 "computer-reversi.c"
			}
		}
	}
#line 206 "../src/computer-reversi.vala"
	mainline = (g_free (mainline), NULL);
#line 1622 "computer-reversi.c"
}

static gint16*
_vala_array_dup4 (gint16* self,
                  gssize length)
{
#line 249 "../src/computer-reversi.vala"
	if (length > 0) {
#line 249 "../src/computer-reversi.vala"
		return _vala_memdup2 (self, length * sizeof (gint16));
#line 1633 "computer-reversi.c"
	}
#line 249 "../src/computer-reversi.vala"
	return NULL;
#line 1637 "computer-reversi.c"
}

static void
computer_reverse_hard_init_heuristic (guint8 size,
                                      gboolean fixed_heuristic,
                                      gint16** heuristic,
                                      gint* heuristic_length1,
                                      gint* heuristic_length2)
{
	gint16* _vala_heuristic = NULL;
	gint _vala_heuristic_length1 = 0;
	gint _vala_heuristic_length2 = 0;
	gint16* _heuristic = NULL;
	gint _heuristic_length1 = 0;
	gint _heuristic_length2 = 0;
	gint16* _tmp4_;
#line 243 "../src/computer-reversi.vala"
	_vala_return_if_fail (((gint) size) >= 4, "size >= 4");
#line 248 "../src/computer-reversi.vala"
	if (((gint) size) == 8) {
#line 1658 "computer-reversi.c"
		gint16* _tmp0_;
		gint _tmp0__length1;
		gint _tmp0__length2;
#line 249 "../src/computer-reversi.vala"
		_tmp0_ = _vala_array_dup4 (heuristic_8, G_N_ELEMENTS (heuristic_8) * G_N_ELEMENTS (heuristic_8[0]));
#line 249 "../src/computer-reversi.vala"
		_tmp0__length1 = G_N_ELEMENTS (heuristic_8);
#line 249 "../src/computer-reversi.vala"
		_tmp0__length2 = G_N_ELEMENTS (heuristic_8[0]);
#line 249 "../src/computer-reversi.vala"
		_heuristic = (g_free (_heuristic), NULL);
#line 249 "../src/computer-reversi.vala"
		_heuristic = _tmp0_;
#line 249 "../src/computer-reversi.vala"
		_heuristic_length1 = _tmp0__length1;
#line 249 "../src/computer-reversi.vala"
		_heuristic_length2 = _tmp0__length2;
#line 1676 "computer-reversi.c"
	} else {
		gint16* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 251 "../src/computer-reversi.vala"
		computer_reverse_hard_create_heuristic (size, &_tmp1_, &_tmp2_, &_tmp3_);
#line 251 "../src/computer-reversi.vala"
		_heuristic = (g_free (_heuristic), NULL);
#line 251 "../src/computer-reversi.vala"
		_heuristic = _tmp1_;
#line 251 "../src/computer-reversi.vala"
		_heuristic_length1 = _tmp2_;
#line 251 "../src/computer-reversi.vala"
		_heuristic_length2 = _tmp3_;
#line 1691 "computer-reversi.c"
	}
#line 253 "../src/computer-reversi.vala"
	_tmp4_ = g_new0 (gint16, size * size);
#line 253 "../src/computer-reversi.vala"
	_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 253 "../src/computer-reversi.vala"
	_vala_heuristic = _tmp4_;
#line 253 "../src/computer-reversi.vala"
	_vala_heuristic_length1 = size;
#line 253 "../src/computer-reversi.vala"
	_vala_heuristic_length2 = size;
#line 1703 "computer-reversi.c"
	{
		guint8 i = 0U;
#line 254 "../src/computer-reversi.vala"
		i = (guint8) 0;
#line 1708 "computer-reversi.c"
		{
			gboolean _tmp5_ = FALSE;
#line 254 "../src/computer-reversi.vala"
			_tmp5_ = TRUE;
#line 254 "../src/computer-reversi.vala"
			while (TRUE) {
#line 254 "../src/computer-reversi.vala"
				if (!_tmp5_) {
#line 1717 "computer-reversi.c"
					guint8 _tmp6_;
#line 254 "../src/computer-reversi.vala"
					_tmp6_ = i;
#line 254 "../src/computer-reversi.vala"
					i = _tmp6_ + 1;
#line 1723 "computer-reversi.c"
				}
#line 254 "../src/computer-reversi.vala"
				_tmp5_ = FALSE;
#line 254 "../src/computer-reversi.vala"
				if (!(i < size)) {
#line 254 "../src/computer-reversi.vala"
					break;
#line 1731 "computer-reversi.c"
				}
				{
					guint8 j = 0U;
#line 255 "../src/computer-reversi.vala"
					j = (guint8) 0;
#line 1737 "computer-reversi.c"
					{
						gboolean _tmp7_ = FALSE;
#line 255 "../src/computer-reversi.vala"
						_tmp7_ = TRUE;
#line 255 "../src/computer-reversi.vala"
						while (TRUE) {
#line 1744 "computer-reversi.c"
							gint16* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gint16* _tmp10_;
							gint _tmp10__length1;
							gint _tmp10__length2;
							gint16 _tmp11_;
#line 255 "../src/computer-reversi.vala"
							if (!_tmp7_) {
#line 1754 "computer-reversi.c"
								guint8 _tmp8_;
#line 255 "../src/computer-reversi.vala"
								_tmp8_ = j;
#line 255 "../src/computer-reversi.vala"
								j = _tmp8_ + 1;
#line 1760 "computer-reversi.c"
							}
#line 255 "../src/computer-reversi.vala"
							_tmp7_ = FALSE;
#line 255 "../src/computer-reversi.vala"
							if (!(j < size)) {
#line 255 "../src/computer-reversi.vala"
								break;
#line 1768 "computer-reversi.c"
							}
#line 256 "../src/computer-reversi.vala"
							_tmp9_ = _vala_heuristic;
#line 256 "../src/computer-reversi.vala"
							_tmp9__length1 = _vala_heuristic_length1;
#line 256 "../src/computer-reversi.vala"
							_tmp9__length2 = _vala_heuristic_length2;
#line 256 "../src/computer-reversi.vala"
							_tmp10_ = _heuristic;
#line 256 "../src/computer-reversi.vala"
							_tmp10__length1 = _heuristic_length1;
#line 256 "../src/computer-reversi.vala"
							_tmp10__length2 = _heuristic_length2;
#line 256 "../src/computer-reversi.vala"
							_tmp11_ = _tmp10_[(i * _tmp10__length2) + j];
#line 256 "../src/computer-reversi.vala"
							_tmp9_[(i * _tmp9__length2) + j] = (gint16) ((-1.7) * (_tmp11_ + 112));
#line 1786 "computer-reversi.c"
						}
					}
				}
			}
		}
	}
#line 258 "../src/computer-reversi.vala"
	if (fixed_heuristic) {
#line 259 "../src/computer-reversi.vala"
		_heuristic = (g_free (_heuristic), NULL);
#line 259 "../src/computer-reversi.vala"
		if (heuristic) {
#line 259 "../src/computer-reversi.vala"
			*heuristic = _vala_heuristic;
#line 1801 "computer-reversi.c"
		} else {
#line 259 "../src/computer-reversi.vala"
			_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 1805 "computer-reversi.c"
		}
#line 259 "../src/computer-reversi.vala"
		if (heuristic_length1) {
#line 259 "../src/computer-reversi.vala"
			*heuristic_length1 = _vala_heuristic_length1;
#line 1811 "computer-reversi.c"
		}
#line 259 "../src/computer-reversi.vala"
		if (heuristic_length2) {
#line 259 "../src/computer-reversi.vala"
			*heuristic_length2 = _vala_heuristic_length2;
#line 1817 "computer-reversi.c"
		}
#line 259 "../src/computer-reversi.vala"
		return;
#line 1821 "computer-reversi.c"
	}
	{
		guint8 i = 0U;
#line 262 "../src/computer-reversi.vala"
		i = (guint8) 0;
#line 1827 "computer-reversi.c"
		{
			gboolean _tmp12_ = FALSE;
#line 262 "../src/computer-reversi.vala"
			_tmp12_ = TRUE;
#line 262 "../src/computer-reversi.vala"
			while (TRUE) {
#line 1834 "computer-reversi.c"
				gint _tmp14_ = 0;
				gint16* _tmp15_;
				gint _tmp15__length1;
				gint _tmp15__length2;
				guint8 x = 0U;
				guint8 y = 0U;
				gboolean minus = FALSE;
				gint _tmp16_ = 0;
				gint16* _tmp17_;
				gint _tmp17__length1;
				gint _tmp17__length2;
				gint _tmp18_ = 0;
				gint16* _tmp19_;
				gint _tmp19__length1;
				gint _tmp19__length2;
#line 262 "../src/computer-reversi.vala"
				if (!_tmp12_) {
#line 1852 "computer-reversi.c"
					guint8 _tmp13_;
#line 262 "../src/computer-reversi.vala"
					_tmp13_ = i;
#line 262 "../src/computer-reversi.vala"
					i = _tmp13_ + 1;
#line 1858 "computer-reversi.c"
				}
#line 262 "../src/computer-reversi.vala"
				_tmp12_ = FALSE;
#line 262 "../src/computer-reversi.vala"
				if (!(((gint) i) < 5)) {
#line 262 "../src/computer-reversi.vala"
					break;
#line 1866 "computer-reversi.c"
				}
#line 266 "../src/computer-reversi.vala"
				if (g_random_boolean ()) {
#line 266 "../src/computer-reversi.vala"
					_tmp14_ = -1;
#line 1872 "computer-reversi.c"
				} else {
#line 266 "../src/computer-reversi.vala"
					_tmp14_ = 1;
#line 1876 "computer-reversi.c"
				}
#line 264 "../src/computer-reversi.vala"
				_tmp15_ = _vala_heuristic;
#line 264 "../src/computer-reversi.vala"
				_tmp15__length1 = _vala_heuristic_length1;
#line 264 "../src/computer-reversi.vala"
				_tmp15__length2 = _vala_heuristic_length2;
#line 264 "../src/computer-reversi.vala"
				_tmp15_[(g_random_int_range ((gint32) 0, (gint32) size) * _tmp15__length2) + g_random_int_range ((gint32) 0, (gint32) size)] += (gint16) _tmp14_;
#line 268 "../src/computer-reversi.vala"
				x = (guint8) g_random_int_range ((gint32) 0, (gint32) size);
#line 269 "../src/computer-reversi.vala"
				y = (guint8) g_random_int_range ((gint32) 0, (gint32) size);
#line 270 "../src/computer-reversi.vala"
				minus = g_random_boolean ();
#line 271 "../src/computer-reversi.vala"
				if (minus) {
#line 271 "../src/computer-reversi.vala"
					_tmp16_ = -1;
#line 1896 "computer-reversi.c"
				} else {
#line 271 "../src/computer-reversi.vala"
					_tmp16_ = 1;
#line 1900 "computer-reversi.c"
				}
#line 271 "../src/computer-reversi.vala"
				_tmp17_ = _vala_heuristic;
#line 271 "../src/computer-reversi.vala"
				_tmp17__length1 = _vala_heuristic_length1;
#line 271 "../src/computer-reversi.vala"
				_tmp17__length2 = _vala_heuristic_length2;
#line 271 "../src/computer-reversi.vala"
				_tmp17_[(x * _tmp17__length2) + y] += (gint16) _tmp16_;
#line 272 "../src/computer-reversi.vala"
				if (minus) {
#line 272 "../src/computer-reversi.vala"
					_tmp18_ = -1;
#line 1914 "computer-reversi.c"
				} else {
#line 272 "../src/computer-reversi.vala"
					_tmp18_ = 1;
#line 1918 "computer-reversi.c"
				}
#line 272 "../src/computer-reversi.vala"
				_tmp19_ = _vala_heuristic;
#line 272 "../src/computer-reversi.vala"
				_tmp19__length1 = _vala_heuristic_length1;
#line 272 "../src/computer-reversi.vala"
				_tmp19__length2 = _vala_heuristic_length2;
#line 272 "../src/computer-reversi.vala"
				_tmp19_[(((size - 1) - x) * _tmp19__length2) + ((size - 1) - y)] += (gint16) _tmp18_;
#line 1928 "computer-reversi.c"
			}
		}
	}
#line 243 "../src/computer-reversi.vala"
	_heuristic = (g_free (_heuristic), NULL);
#line 243 "../src/computer-reversi.vala"
	if (heuristic) {
#line 243 "../src/computer-reversi.vala"
		*heuristic = _vala_heuristic;
#line 1938 "computer-reversi.c"
	} else {
#line 243 "../src/computer-reversi.vala"
		_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 1942 "computer-reversi.c"
	}
#line 243 "../src/computer-reversi.vala"
	if (heuristic_length1) {
#line 243 "../src/computer-reversi.vala"
		*heuristic_length1 = _vala_heuristic_length1;
#line 1948 "computer-reversi.c"
	}
#line 243 "../src/computer-reversi.vala"
	if (heuristic_length2) {
#line 243 "../src/computer-reversi.vala"
		*heuristic_length2 = _vala_heuristic_length2;
#line 1954 "computer-reversi.c"
	}
}

static void
computer_reverse_hard_create_heuristic (guint8 size,
                                        gint16** heuristic,
                                        gint* heuristic_length1,
                                        gint* heuristic_length2)
{
	gint16* _vala_heuristic = NULL;
	gint _vala_heuristic_length1 = 0;
	gint _vala_heuristic_length2 = 0;
	gint16* _tmp0_;
	guint8 tmp1 = 0U;
	gint16* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gint16* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gint16* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	gint16* _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
#line 276 "../src/computer-reversi.vala"
	_vala_return_if_fail (((gint) size) >= 4, "size >= 4");
#line 279 "../src/computer-reversi.vala"
	_tmp0_ = g_new0 (gint16, size * size);
#line 279 "../src/computer-reversi.vala"
	_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 279 "../src/computer-reversi.vala"
	_vala_heuristic = _tmp0_;
#line 279 "../src/computer-reversi.vala"
	_vala_heuristic_length1 = size;
#line 279 "../src/computer-reversi.vala"
	_vala_heuristic_length2 = size;
#line 1993 "computer-reversi.c"
	{
		guint8 x = 0U;
#line 280 "../src/computer-reversi.vala"
		x = (guint8) 0;
#line 1998 "computer-reversi.c"
		{
			gboolean _tmp1_ = FALSE;
#line 280 "../src/computer-reversi.vala"
			_tmp1_ = TRUE;
#line 280 "../src/computer-reversi.vala"
			while (TRUE) {
#line 280 "../src/computer-reversi.vala"
				if (!_tmp1_) {
#line 2007 "computer-reversi.c"
					guint8 _tmp2_;
#line 280 "../src/computer-reversi.vala"
					_tmp2_ = x;
#line 280 "../src/computer-reversi.vala"
					x = _tmp2_ + 1;
#line 2013 "computer-reversi.c"
				}
#line 280 "../src/computer-reversi.vala"
				_tmp1_ = FALSE;
#line 280 "../src/computer-reversi.vala"
				if (!(x < size)) {
#line 280 "../src/computer-reversi.vala"
					break;
#line 2021 "computer-reversi.c"
				}
				{
					guint8 y = 0U;
#line 281 "../src/computer-reversi.vala"
					y = (guint8) 0;
#line 2027 "computer-reversi.c"
					{
						gboolean _tmp3_ = FALSE;
#line 281 "../src/computer-reversi.vala"
						_tmp3_ = TRUE;
#line 281 "../src/computer-reversi.vala"
						while (TRUE) {
#line 2034 "computer-reversi.c"
							gint16* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 281 "../src/computer-reversi.vala"
							if (!_tmp3_) {
#line 2040 "computer-reversi.c"
								guint8 _tmp4_;
#line 281 "../src/computer-reversi.vala"
								_tmp4_ = y;
#line 281 "../src/computer-reversi.vala"
								y = _tmp4_ + 1;
#line 2046 "computer-reversi.c"
							}
#line 281 "../src/computer-reversi.vala"
							_tmp3_ = FALSE;
#line 281 "../src/computer-reversi.vala"
							if (!(y < size)) {
#line 281 "../src/computer-reversi.vala"
								break;
#line 2054 "computer-reversi.c"
							}
#line 282 "../src/computer-reversi.vala"
							_tmp5_ = _vala_heuristic;
#line 282 "../src/computer-reversi.vala"
							_tmp5__length1 = _vala_heuristic_length1;
#line 282 "../src/computer-reversi.vala"
							_tmp5__length2 = _vala_heuristic_length2;
#line 282 "../src/computer-reversi.vala"
							_tmp5_[(x * _tmp5__length2) + y] = (gint16) 0;
#line 2064 "computer-reversi.c"
						}
					}
				}
			}
		}
	}
#line 285 "../src/computer-reversi.vala"
	tmp1 = (guint8) (size - 1);
#line 286 "../src/computer-reversi.vala"
	_tmp6_ = _vala_heuristic;
#line 286 "../src/computer-reversi.vala"
	_tmp6__length1 = _vala_heuristic_length1;
#line 286 "../src/computer-reversi.vala"
	_tmp6__length2 = _vala_heuristic_length2;
#line 286 "../src/computer-reversi.vala"
	_tmp6_[(0 * _tmp6__length2) + 0] = (gint16) 110;
#line 287 "../src/computer-reversi.vala"
	_tmp7_ = _vala_heuristic;
#line 287 "../src/computer-reversi.vala"
	_tmp7__length1 = _vala_heuristic_length1;
#line 287 "../src/computer-reversi.vala"
	_tmp7__length2 = _vala_heuristic_length2;
#line 287 "../src/computer-reversi.vala"
	_tmp7_[(0 * _tmp7__length2) + tmp1] = (gint16) 110;
#line 288 "../src/computer-reversi.vala"
	_tmp8_ = _vala_heuristic;
#line 288 "../src/computer-reversi.vala"
	_tmp8__length1 = _vala_heuristic_length1;
#line 288 "../src/computer-reversi.vala"
	_tmp8__length2 = _vala_heuristic_length2;
#line 288 "../src/computer-reversi.vala"
	_tmp8_[(tmp1 * _tmp8__length2) + tmp1] = (gint16) 110;
#line 289 "../src/computer-reversi.vala"
	_tmp9_ = _vala_heuristic;
#line 289 "../src/computer-reversi.vala"
	_tmp9__length1 = _vala_heuristic_length1;
#line 289 "../src/computer-reversi.vala"
	_tmp9__length2 = _vala_heuristic_length2;
#line 289 "../src/computer-reversi.vala"
	_tmp9_[(tmp1 * _tmp9__length2) + 0] = (gint16) 110;
#line 291 "../src/computer-reversi.vala"
	if (((gint) size) >= 6) {
#line 2107 "computer-reversi.c"
		guint8 tmp2 = 0U;
		gint16* _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		gint16* _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		gint16* _tmp12_;
		gint _tmp12__length1;
		gint _tmp12__length2;
		gint16* _tmp13_;
		gint _tmp13__length1;
		gint _tmp13__length2;
		gint16* _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		gint16* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		gint16* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		gint16* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint16* _tmp18_;
		gint _tmp18__length1;
		gint _tmp18__length2;
		gint16* _tmp19_;
		gint _tmp19__length1;
		gint _tmp19__length2;
		gint16* _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		gint16* _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
#line 294 "../src/computer-reversi.vala"
		tmp2 = (guint8) (size - 2);
#line 295 "../src/computer-reversi.vala"
		_tmp10_ = _vala_heuristic;
#line 295 "../src/computer-reversi.vala"
		_tmp10__length1 = _vala_heuristic_length1;
#line 295 "../src/computer-reversi.vala"
		_tmp10__length2 = _vala_heuristic_length2;
#line 295 "../src/computer-reversi.vala"
		_tmp10_[(0 * _tmp10__length2) + 1] = (gint16) 35;
#line 296 "../src/computer-reversi.vala"
		_tmp11_ = _vala_heuristic;
#line 296 "../src/computer-reversi.vala"
		_tmp11__length1 = _vala_heuristic_length1;
#line 296 "../src/computer-reversi.vala"
		_tmp11__length2 = _vala_heuristic_length2;
#line 296 "../src/computer-reversi.vala"
		_tmp11_[(0 * _tmp11__length2) + tmp2] = (gint16) 35;
#line 297 "../src/computer-reversi.vala"
		_tmp12_ = _vala_heuristic;
#line 297 "../src/computer-reversi.vala"
		_tmp12__length1 = _vala_heuristic_length1;
#line 297 "../src/computer-reversi.vala"
		_tmp12__length2 = _vala_heuristic_length2;
#line 297 "../src/computer-reversi.vala"
		_tmp12_[(tmp1 * _tmp12__length2) + 1] = (gint16) 35;
#line 298 "../src/computer-reversi.vala"
		_tmp13_ = _vala_heuristic;
#line 298 "../src/computer-reversi.vala"
		_tmp13__length1 = _vala_heuristic_length1;
#line 298 "../src/computer-reversi.vala"
		_tmp13__length2 = _vala_heuristic_length2;
#line 298 "../src/computer-reversi.vala"
		_tmp13_[(tmp1 * _tmp13__length2) + tmp2] = (gint16) 35;
#line 299 "../src/computer-reversi.vala"
		_tmp14_ = _vala_heuristic;
#line 299 "../src/computer-reversi.vala"
		_tmp14__length1 = _vala_heuristic_length1;
#line 299 "../src/computer-reversi.vala"
		_tmp14__length2 = _vala_heuristic_length2;
#line 299 "../src/computer-reversi.vala"
		_tmp14_[(1 * _tmp14__length2) + 0] = (gint16) 35;
#line 300 "../src/computer-reversi.vala"
		_tmp15_ = _vala_heuristic;
#line 300 "../src/computer-reversi.vala"
		_tmp15__length1 = _vala_heuristic_length1;
#line 300 "../src/computer-reversi.vala"
		_tmp15__length2 = _vala_heuristic_length2;
#line 300 "../src/computer-reversi.vala"
		_tmp15_[(1 * _tmp15__length2) + tmp1] = (gint16) 35;
#line 301 "../src/computer-reversi.vala"
		_tmp16_ = _vala_heuristic;
#line 301 "../src/computer-reversi.vala"
		_tmp16__length1 = _vala_heuristic_length1;
#line 301 "../src/computer-reversi.vala"
		_tmp16__length2 = _vala_heuristic_length2;
#line 301 "../src/computer-reversi.vala"
		_tmp16_[(tmp2 * _tmp16__length2) + 0] = (gint16) 35;
#line 302 "../src/computer-reversi.vala"
		_tmp17_ = _vala_heuristic;
#line 302 "../src/computer-reversi.vala"
		_tmp17__length1 = _vala_heuristic_length1;
#line 302 "../src/computer-reversi.vala"
		_tmp17__length2 = _vala_heuristic_length2;
#line 302 "../src/computer-reversi.vala"
		_tmp17_[(tmp2 * _tmp17__length2) + tmp1] = (gint16) 35;
#line 305 "../src/computer-reversi.vala"
		_tmp18_ = _vala_heuristic;
#line 305 "../src/computer-reversi.vala"
		_tmp18__length1 = _vala_heuristic_length1;
#line 305 "../src/computer-reversi.vala"
		_tmp18__length2 = _vala_heuristic_length2;
#line 305 "../src/computer-reversi.vala"
		_tmp18_[(1 * _tmp18__length2) + 1] = (gint16) 15;
#line 306 "../src/computer-reversi.vala"
		_tmp19_ = _vala_heuristic;
#line 306 "../src/computer-reversi.vala"
		_tmp19__length1 = _vala_heuristic_length1;
#line 306 "../src/computer-reversi.vala"
		_tmp19__length2 = _vala_heuristic_length2;
#line 306 "../src/computer-reversi.vala"
		_tmp19_[(1 * _tmp19__length2) + tmp2] = (gint16) 15;
#line 307 "../src/computer-reversi.vala"
		_tmp20_ = _vala_heuristic;
#line 307 "../src/computer-reversi.vala"
		_tmp20__length1 = _vala_heuristic_length1;
#line 307 "../src/computer-reversi.vala"
		_tmp20__length2 = _vala_heuristic_length2;
#line 307 "../src/computer-reversi.vala"
		_tmp20_[(tmp2 * _tmp20__length2) + tmp2] = (gint16) 15;
#line 308 "../src/computer-reversi.vala"
		_tmp21_ = _vala_heuristic;
#line 308 "../src/computer-reversi.vala"
		_tmp21__length1 = _vala_heuristic_length1;
#line 308 "../src/computer-reversi.vala"
		_tmp21__length2 = _vala_heuristic_length2;
#line 308 "../src/computer-reversi.vala"
		_tmp21_[(tmp2 * _tmp21__length2) + 1] = (gint16) 15;
#line 2243 "computer-reversi.c"
	}
#line 276 "../src/computer-reversi.vala"
	if (heuristic) {
#line 276 "../src/computer-reversi.vala"
		*heuristic = _vala_heuristic;
#line 2249 "computer-reversi.c"
	} else {
#line 276 "../src/computer-reversi.vala"
		_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 2253 "computer-reversi.c"
	}
#line 276 "../src/computer-reversi.vala"
	if (heuristic_length1) {
#line 276 "../src/computer-reversi.vala"
		*heuristic_length1 = _vala_heuristic_length1;
#line 2259 "computer-reversi.c"
	}
#line 276 "../src/computer-reversi.vala"
	if (heuristic_length2) {
#line 276 "../src/computer-reversi.vala"
		*heuristic_length2 = _vala_heuristic_length2;
#line 2265 "computer-reversi.c"
	}
}

static gboolean
computer_reverse_hard_get_even_depth (ComputerReverseHard* self)
{
	gboolean result;
#line 100 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../src/computer-reversi.vala"
	result = self->priv->_even_depth;
#line 100 "../src/computer-reversi.vala"
	return result;
#line 2279 "computer-reversi.c"
}

static void
computer_reverse_hard_set_even_depth (ComputerReverseHard* self,
                                      gboolean value)
{
#line 100 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/computer-reversi.vala"
	self->priv->_even_depth = value;
#line 2290 "computer-reversi.c"
}

static gboolean
computer_reverse_hard_get_fixed_heuristic (ComputerReverseHard* self)
{
	gboolean result;
#line 101 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 101 "../src/computer-reversi.vala"
	result = self->priv->_fixed_heuristic;
#line 101 "../src/computer-reversi.vala"
	return result;
#line 2303 "computer-reversi.c"
}

static void
computer_reverse_hard_set_fixed_heuristic (ComputerReverseHard* self,
                                           gboolean value)
{
#line 101 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/computer-reversi.vala"
	self->priv->_fixed_heuristic = value;
#line 2314 "computer-reversi.c"
}

static GObject *
computer_reverse_hard_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ComputerReverseHard * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gboolean _tmp2_;
	gint16* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
#line 103 "../src/computer-reversi.vala"
	parent_class = G_OBJECT_CLASS (computer_reverse_hard_parent_class);
#line 103 "../src/computer-reversi.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 103 "../src/computer-reversi.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPUTER_REVERSE_HARD, ComputerReverseHard);
#line 105 "../src/computer-reversi.vala"
	_tmp0_ = computer_reversi_get_size ((ComputerReversi*) self);
#line 105 "../src/computer-reversi.vala"
	_tmp1_ = _tmp0_;
#line 105 "../src/computer-reversi.vala"
	_tmp2_ = self->priv->_fixed_heuristic;
#line 105 "../src/computer-reversi.vala"
	computer_reverse_hard_init_heuristic (_tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 105 "../src/computer-reversi.vala"
	self->priv->heuristic = (g_free (self->priv->heuristic), NULL);
#line 105 "../src/computer-reversi.vala"
	self->priv->heuristic = _tmp3_;
#line 105 "../src/computer-reversi.vala"
	self->priv->heuristic_length1 = _tmp4_;
#line 105 "../src/computer-reversi.vala"
	self->priv->heuristic_length2 = _tmp5_;
#line 103 "../src/computer-reversi.vala"
	return obj;
#line 2355 "computer-reversi.c"
}

static void
computer_reverse_hard_class_init (ComputerReverseHardClass * klass,
                                  gpointer klass_data)
{
#line 98 "../src/computer-reversi.vala"
	computer_reverse_hard_parent_class = g_type_class_peek_parent (klass);
#line 98 "../src/computer-reversi.vala"
	g_type_class_adjust_private_offset (klass, &ComputerReverseHard_private_offset);
#line 98 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->sort_moves = (void (*) (ComputerReversi*, GSList**)) computer_reverse_hard_real_sort_moves;
#line 98 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->end_of_game = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reverse_hard_real_end_of_game;
#line 98 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->calculate_heuristic = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reverse_hard_real_calculate_heuristic;
#line 98 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_computer_reverse_hard_get_property;
#line 98 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_computer_reverse_hard_set_property;
#line 98 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->constructor = computer_reverse_hard_constructor;
#line 98 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->finalize = computer_reverse_hard_finalize;
#line 98 "../src/computer-reversi.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPUTER_REVERSE_HARD_EVEN_DEPTH_PROPERTY, computer_reverse_hard_properties[COMPUTER_REVERSE_HARD_EVEN_DEPTH_PROPERTY] = g_param_spec_boolean ("even-depth", "even-depth", "even-depth", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 98 "../src/computer-reversi.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPUTER_REVERSE_HARD_FIXED_HEURISTIC_PROPERTY, computer_reverse_hard_properties[COMPUTER_REVERSE_HARD_FIXED_HEURISTIC_PROPERTY] = g_param_spec_boolean ("fixed-heuristic", "fixed-heuristic", "fixed-heuristic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 2384 "computer-reversi.c"
}

static void
computer_reverse_hard_instance_init (ComputerReverseHard * self,
                                     gpointer klass)
{
#line 98 "../src/computer-reversi.vala"
	self->priv = computer_reverse_hard_get_instance_private (self);
#line 2393 "computer-reversi.c"
}

static void
computer_reverse_hard_finalize (GObject * obj)
{
	ComputerReverseHard * self;
#line 98 "../src/computer-reversi.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPUTER_REVERSE_HARD, ComputerReverseHard);
#line 241 "../src/computer-reversi.vala"
	self->priv->heuristic = (g_free (self->priv->heuristic), NULL);
#line 98 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (computer_reverse_hard_parent_class)->finalize (obj);
#line 2406 "computer-reversi.c"
}

static GType
computer_reverse_hard_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComputerReverseHardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) computer_reverse_hard_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComputerReverseHard), 0, (GInstanceInitFunc) computer_reverse_hard_instance_init, NULL };
	GType computer_reverse_hard_type_id;
	computer_reverse_hard_type_id = g_type_register_static (TYPE_COMPUTER_REVERSI, "ComputerReverseHard", &g_define_type_info, 0);
	ComputerReverseHard_private_offset = g_type_add_instance_private (computer_reverse_hard_type_id, sizeof (ComputerReverseHardPrivate));
	return computer_reverse_hard_type_id;
}

GType
computer_reverse_hard_get_type (void)
{
	static volatile gsize computer_reverse_hard_type_id__once = 0;
	if (g_once_init_enter (&computer_reverse_hard_type_id__once)) {
		GType computer_reverse_hard_type_id;
		computer_reverse_hard_type_id = computer_reverse_hard_get_type_once ();
		g_once_init_leave (&computer_reverse_hard_type_id__once, computer_reverse_hard_type_id);
	}
	return computer_reverse_hard_type_id__once;
}

static void
_vala_computer_reverse_hard_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ComputerReverseHard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_REVERSE_HARD, ComputerReverseHard);
#line 98 "../src/computer-reversi.vala"
	switch (property_id) {
#line 98 "../src/computer-reversi.vala"
		case COMPUTER_REVERSE_HARD_EVEN_DEPTH_PROPERTY:
#line 98 "../src/computer-reversi.vala"
		g_value_set_boolean (value, computer_reverse_hard_get_even_depth (self));
#line 98 "../src/computer-reversi.vala"
		break;
#line 98 "../src/computer-reversi.vala"
		case COMPUTER_REVERSE_HARD_FIXED_HEURISTIC_PROPERTY:
#line 98 "../src/computer-reversi.vala"
		g_value_set_boolean (value, computer_reverse_hard_get_fixed_heuristic (self));
#line 98 "../src/computer-reversi.vala"
		break;
#line 2453 "computer-reversi.c"
		default:
#line 98 "../src/computer-reversi.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 98 "../src/computer-reversi.vala"
		break;
#line 2459 "computer-reversi.c"
	}
}

static void
_vala_computer_reverse_hard_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	ComputerReverseHard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_REVERSE_HARD, ComputerReverseHard);
#line 98 "../src/computer-reversi.vala"
	switch (property_id) {
#line 98 "../src/computer-reversi.vala"
		case COMPUTER_REVERSE_HARD_EVEN_DEPTH_PROPERTY:
#line 98 "../src/computer-reversi.vala"
		computer_reverse_hard_set_even_depth (self, g_value_get_boolean (value));
#line 98 "../src/computer-reversi.vala"
		break;
#line 98 "../src/computer-reversi.vala"
		case COMPUTER_REVERSE_HARD_FIXED_HEURISTIC_PROPERTY:
#line 98 "../src/computer-reversi.vala"
		computer_reverse_hard_set_fixed_heuristic (self, g_value_get_boolean (value));
#line 98 "../src/computer-reversi.vala"
		break;
#line 2485 "computer-reversi.c"
		default:
#line 98 "../src/computer-reversi.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 98 "../src/computer-reversi.vala"
		break;
#line 2491 "computer-reversi.c"
	}
}

ComputerReversiEasy*
computer_reversi_easy_construct (GType object_type,
                                 Game* game)
{
	ComputerReversiEasy * self = NULL;
#line 315 "../src/computer-reversi.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 317 "../src/computer-reversi.vala"
	self = (ComputerReversiEasy*) g_object_new (object_type, "game", game, "initial-depth", 2, NULL);
#line 315 "../src/computer-reversi.vala"
	return self;
#line 2506 "computer-reversi.c"
}

ComputerReversiEasy*
computer_reversi_easy_new (Game* game)
{
#line 315 "../src/computer-reversi.vala"
	return computer_reversi_easy_construct (TYPE_COMPUTER_REVERSI_EASY, game);
#line 2514 "computer-reversi.c"
}

static gint
_computer_reversi_easy_compare_move_gcompare_func (gconstpointer a,
                                                   gconstpointer b)
{
	gint result;
	result = computer_reversi_easy_compare_move ((PossibleMove*) a, (PossibleMove*) b);
#line 326 "../src/computer-reversi.vala"
	return result;
#line 2525 "computer-reversi.c"
}

static void
computer_reversi_easy_real_sort_moves (ComputerReversi* base,
                                       GSList** moves)
{
	ComputerReversiEasy * self;
#line 324 "../src/computer-reversi.vala"
	self = (ComputerReversiEasy*) base;
#line 326 "../src/computer-reversi.vala"
	*moves = g_slist_sort (*moves, _computer_reversi_easy_compare_move_gcompare_func);
#line 2537 "computer-reversi.c"
}

static inline gint
computer_reversi_easy_compare_move (PossibleMove* a,
                                    PossibleMove* b)
{
	gint _tmp0_ = 0;
	gint result;
#line 333 "../src/computer-reversi.vala"
	if (((PossibleMove) (*a)).n_tiles >= ((PossibleMove) (*b)).n_tiles) {
#line 333 "../src/computer-reversi.vala"
		_tmp0_ = -1;
#line 2550 "computer-reversi.c"
	} else {
#line 333 "../src/computer-reversi.vala"
		_tmp0_ = 1;
#line 2554 "computer-reversi.c"
	}
#line 333 "../src/computer-reversi.vala"
	result = _tmp0_;
#line 333 "../src/computer-reversi.vala"
	return result;
#line 2560 "computer-reversi.c"
}

static gint16
computer_reversi_easy_real_end_of_game (ComputerReversi* base,
                                        GameStateStruct* g)
{
	ComputerReversiEasy * self;
	gint16 _tmp0_ = 0;
	GameStateStruct _tmp1_;
	GameStateStruct _tmp2_;
	gint16 result;
#line 340 "../src/computer-reversi.vala"
	self = (ComputerReversiEasy*) base;
#line 340 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 342 "../src/computer-reversi.vala"
	_tmp1_ = *g;
#line 342 "../src/computer-reversi.vala"
	_tmp2_ = *g;
#line 342 "../src/computer-reversi.vala"
	if (_tmp1_.n_current_tiles > _tmp2_.n_opponent_tiles) {
#line 2582 "computer-reversi.c"
		GameStateStruct _tmp3_;
#line 342 "../src/computer-reversi.vala"
		_tmp3_ = *g;
#line 342 "../src/computer-reversi.vala"
		_tmp0_ = COMPUTER_REVERSI_POSITIVE_INFINITY - ((gint16) _tmp3_.n_opponent_tiles);
#line 2588 "computer-reversi.c"
	} else {
		GameStateStruct _tmp4_;
#line 343 "../src/computer-reversi.vala"
		_tmp4_ = *g;
#line 343 "../src/computer-reversi.vala"
		_tmp0_ = COMPUTER_REVERSI_NEGATIVE_INFINITY + ((gint16) _tmp4_.n_current_tiles);
#line 2595 "computer-reversi.c"
	}
#line 342 "../src/computer-reversi.vala"
	result = _tmp0_;
#line 342 "../src/computer-reversi.vala"
	return result;
#line 2601 "computer-reversi.c"
}

static gint16
computer_reversi_easy_real_calculate_heuristic (ComputerReversi* base,
                                                GameStateStruct* g)
{
	ComputerReversiEasy * self;
	GameStateStruct _tmp0_;
	GameStateStruct _tmp1_;
	gint16 result;
#line 346 "../src/computer-reversi.vala"
	self = (ComputerReversiEasy*) base;
#line 346 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 349 "../src/computer-reversi.vala"
	_tmp0_ = *g;
#line 349 "../src/computer-reversi.vala"
	_tmp1_ = *g;
#line 349 "../src/computer-reversi.vala"
	result = ((gint16) _tmp0_.n_opponent_tiles) - ((gint16) _tmp1_.n_current_tiles);
#line 349 "../src/computer-reversi.vala"
	return result;
#line 2624 "computer-reversi.c"
}

static void
computer_reversi_easy_class_init (ComputerReversiEasyClass * klass,
                                  gpointer klass_data)
{
#line 313 "../src/computer-reversi.vala"
	computer_reversi_easy_parent_class = g_type_class_peek_parent (klass);
#line 313 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->sort_moves = (void (*) (ComputerReversi*, GSList**)) computer_reversi_easy_real_sort_moves;
#line 313 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->end_of_game = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reversi_easy_real_end_of_game;
#line 313 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->calculate_heuristic = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reversi_easy_real_calculate_heuristic;
#line 2639 "computer-reversi.c"
}

static void
computer_reversi_easy_instance_init (ComputerReversiEasy * self,
                                     gpointer klass)
{
}

static GType
computer_reversi_easy_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComputerReversiEasyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) computer_reversi_easy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComputerReversiEasy), 0, (GInstanceInitFunc) computer_reversi_easy_instance_init, NULL };
	GType computer_reversi_easy_type_id;
	computer_reversi_easy_type_id = g_type_register_static (TYPE_COMPUTER_REVERSI, "ComputerReversiEasy", &g_define_type_info, 0);
	return computer_reversi_easy_type_id;
}

GType
computer_reversi_easy_get_type (void)
{
	static volatile gsize computer_reversi_easy_type_id__once = 0;
	if (g_once_init_enter (&computer_reversi_easy_type_id__once)) {
		GType computer_reversi_easy_type_id;
		computer_reversi_easy_type_id = computer_reversi_easy_get_type_once ();
		g_once_init_leave (&computer_reversi_easy_type_id__once, computer_reversi_easy_type_id);
	}
	return computer_reversi_easy_type_id__once;
}

static inline gpointer
computer_reversi_hard_get_instance_private (ComputerReversiHard* self)
{
	return G_STRUCT_MEMBER_P (self, ComputerReversiHard_private_offset);
}

ComputerReversiHard*
computer_reversi_hard_construct (GType object_type,
                                 Game* game,
                                 guint8 initial_depth,
                                 gboolean fixed_heuristic)
{
	ComputerReversiHard * self = NULL;
#line 363 "../src/computer-reversi.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 365 "../src/computer-reversi.vala"
	self = (ComputerReversiHard*) g_object_new (object_type, "game", game, "even-depth", (initial_depth % 2) == 0, "initial-depth", initial_depth, "fixed-heuristic", fixed_heuristic, NULL);
#line 363 "../src/computer-reversi.vala"
	return self;
#line 2688 "computer-reversi.c"
}

ComputerReversiHard*
computer_reversi_hard_new (Game* game,
                           guint8 initial_depth,
                           gboolean fixed_heuristic)
{
#line 363 "../src/computer-reversi.vala"
	return computer_reversi_hard_construct (TYPE_COMPUTER_REVERSI_HARD, game, initial_depth, fixed_heuristic);
#line 2698 "computer-reversi.c"
}

static gint
_computer_reversi_hard_compare_move_gcompare_data_func (gconstpointer a,
                                                        gconstpointer b,
                                                        gpointer self)
{
	gint result;
	result = computer_reversi_hard_compare_move ((ComputerReversiHard*) self, (PossibleMove*) a, (PossibleMove*) b);
#line 377 "../src/computer-reversi.vala"
	return result;
#line 2710 "computer-reversi.c"
}

static void
computer_reversi_hard_real_sort_moves (ComputerReversi* base,
                                       GSList** moves)
{
	ComputerReversiHard * self;
#line 375 "../src/computer-reversi.vala"
	self = (ComputerReversiHard*) base;
#line 377 "../src/computer-reversi.vala"
	*moves = g_slist_sort_with_data (*moves, _computer_reversi_hard_compare_move_gcompare_data_func, self);
#line 2722 "computer-reversi.c"
}

static inline gint
computer_reversi_hard_compare_move (ComputerReversiHard* self,
                                    PossibleMove* a,
                                    PossibleMove* b)
{
	PossibleMove _tmp0_;
	PossibleMove _tmp1_;
	gint result;
#line 380 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 384 "../src/computer-reversi.vala"
	_tmp0_ = (PossibleMove) (*b);
#line 384 "../src/computer-reversi.vala"
	_tmp1_ = (PossibleMove) (*a);
#line 384 "../src/computer-reversi.vala"
	result = computer_reversi_hard_calculate_move_heuristic (self, &_tmp0_) - computer_reversi_hard_calculate_move_heuristic (self, &_tmp1_);
#line 384 "../src/computer-reversi.vala"
	return result;
#line 2743 "computer-reversi.c"
}

static inline gint
computer_reversi_hard_calculate_move_heuristic (ComputerReversiHard* self,
                                                PossibleMove* move)
{
	gint comparator = 0;
	PossibleMove _tmp0_;
	PossibleMove _tmp1_;
	PossibleMove _tmp2_;
	PossibleMove _tmp3_;
	PossibleMove _tmp4_;
	PossibleMove _tmp5_;
	PossibleMove _tmp6_;
	PossibleMove _tmp7_;
	PossibleMove _tmp8_;
	PossibleMove _tmp9_;
	PossibleMove _tmp10_;
	PossibleMove _tmp11_;
	PossibleMove _tmp12_;
	PossibleMove _tmp13_;
	PossibleMove _tmp14_;
	PossibleMove _tmp15_;
	PossibleMove _tmp16_;
	PossibleMove _tmp17_;
	PossibleMove _tmp18_;
	PossibleMove _tmp19_;
	PossibleMove _tmp20_;
	PossibleMove _tmp21_;
	PossibleMove _tmp22_;
	PossibleMove _tmp23_;
	gint16* _tmp24_;
	gint _tmp24__length1;
	gint _tmp24__length2;
	PossibleMove _tmp25_;
	PossibleMove _tmp26_;
	gint16 _tmp27_;
	guint8* _tmp28_;
	gint _tmp28__length1;
	gint _tmp28__length2;
	PossibleMove _tmp29_;
	PossibleMove _tmp30_;
	guint8 _tmp31_;
	gint result;
#line 387 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 387 "../src/computer-reversi.vala"
	g_return_val_if_fail (move != NULL, 0);
#line 389 "../src/computer-reversi.vala"
	comparator = 0;
#line 390 "../src/computer-reversi.vala"
	_tmp0_ = *move;
#line 390 "../src/computer-reversi.vala"
	_tmp1_ = *move;
#line 390 "../src/computer-reversi.vala"
	_tmp2_ = *move;
#line 390 "../src/computer-reversi.vala"
	computer_reversi_hard_calculate_dir_heuristic (self, &comparator, _tmp0_.x, _tmp1_.y, (gint8) 0, (gint8) -1, _tmp2_.n_tiles_n);
#line 391 "../src/computer-reversi.vala"
	_tmp3_ = *move;
#line 391 "../src/computer-reversi.vala"
	_tmp4_ = *move;
#line 391 "../src/computer-reversi.vala"
	_tmp5_ = *move;
#line 391 "../src/computer-reversi.vala"
	computer_reversi_hard_calculate_dir_heuristic (self, &comparator, _tmp3_.x, _tmp4_.y, (gint8) 1, (gint8) -1, _tmp5_.n_tiles_ne);
#line 392 "../src/computer-reversi.vala"
	_tmp6_ = *move;
#line 392 "../src/computer-reversi.vala"
	_tmp7_ = *move;
#line 392 "../src/computer-reversi.vala"
	_tmp8_ = *move;
#line 392 "../src/computer-reversi.vala"
	computer_reversi_hard_calculate_dir_heuristic (self, &comparator, _tmp6_.x, _tmp7_.y, (gint8) 1, (gint8) 0, _tmp8_.n_tiles_e);
#line 393 "../src/computer-reversi.vala"
	_tmp9_ = *move;
#line 393 "../src/computer-reversi.vala"
	_tmp10_ = *move;
#line 393 "../src/computer-reversi.vala"
	_tmp11_ = *move;
#line 393 "../src/computer-reversi.vala"
	computer_reversi_hard_calculate_dir_heuristic (self, &comparator, _tmp9_.x, _tmp10_.y, (gint8) 1, (gint8) 1, _tmp11_.n_tiles_se);
#line 394 "../src/computer-reversi.vala"
	_tmp12_ = *move;
#line 394 "../src/computer-reversi.vala"
	_tmp13_ = *move;
#line 394 "../src/computer-reversi.vala"
	_tmp14_ = *move;
#line 394 "../src/computer-reversi.vala"
	computer_reversi_hard_calculate_dir_heuristic (self, &comparator, _tmp12_.x, _tmp13_.y, (gint8) 0, (gint8) 1, _tmp14_.n_tiles_s);
#line 395 "../src/computer-reversi.vala"
	_tmp15_ = *move;
#line 395 "../src/computer-reversi.vala"
	_tmp16_ = *move;
#line 395 "../src/computer-reversi.vala"
	_tmp17_ = *move;
#line 395 "../src/computer-reversi.vala"
	computer_reversi_hard_calculate_dir_heuristic (self, &comparator, _tmp15_.x, _tmp16_.y, (gint8) -1, (gint8) 1, _tmp17_.n_tiles_so);
#line 396 "../src/computer-reversi.vala"
	_tmp18_ = *move;
#line 396 "../src/computer-reversi.vala"
	_tmp19_ = *move;
#line 396 "../src/computer-reversi.vala"
	_tmp20_ = *move;
#line 396 "../src/computer-reversi.vala"
	computer_reversi_hard_calculate_dir_heuristic (self, &comparator, _tmp18_.x, _tmp19_.y, (gint8) -1, (gint8) 0, _tmp20_.n_tiles_o);
#line 397 "../src/computer-reversi.vala"
	_tmp21_ = *move;
#line 397 "../src/computer-reversi.vala"
	_tmp22_ = *move;
#line 397 "../src/computer-reversi.vala"
	_tmp23_ = *move;
#line 397 "../src/computer-reversi.vala"
	computer_reversi_hard_calculate_dir_heuristic (self, &comparator, _tmp21_.x, _tmp22_.y, (gint8) -1, (gint8) -1, _tmp23_.n_tiles_no);
#line 398 "../src/computer-reversi.vala"
	_tmp24_ = self->priv->heuristic;
#line 398 "../src/computer-reversi.vala"
	_tmp24__length1 = self->priv->heuristic_length1;
#line 398 "../src/computer-reversi.vala"
	_tmp24__length2 = self->priv->heuristic_length2;
#line 398 "../src/computer-reversi.vala"
	_tmp25_ = *move;
#line 398 "../src/computer-reversi.vala"
	_tmp26_ = *move;
#line 398 "../src/computer-reversi.vala"
	_tmp27_ = _tmp24_[(_tmp25_.x * _tmp24__length2) + _tmp26_.y];
#line 398 "../src/computer-reversi.vala"
	_tmp28_ = ((ComputerReversi*) self)->neighbor_tiles;
#line 398 "../src/computer-reversi.vala"
	_tmp28__length1 = ((ComputerReversi*) self)->neighbor_tiles_length1;
#line 398 "../src/computer-reversi.vala"
	_tmp28__length2 = ((ComputerReversi*) self)->neighbor_tiles_length2;
#line 398 "../src/computer-reversi.vala"
	_tmp29_ = *move;
#line 398 "../src/computer-reversi.vala"
	_tmp30_ = *move;
#line 398 "../src/computer-reversi.vala"
	_tmp31_ = _tmp28_[(_tmp29_.x * _tmp28__length2) + _tmp30_.y];
#line 398 "../src/computer-reversi.vala"
	result = ((2 * comparator) + ((gint) _tmp27_)) - (8 * ((gint) _tmp31_));
#line 398 "../src/computer-reversi.vala"
	return result;
#line 2886 "computer-reversi.c"
}

static inline void
computer_reversi_hard_calculate_dir_heuristic (ComputerReversiHard* self,
                                               gint* comparator,
                                               guint8 x,
                                               guint8 y,
                                               gint8 x_step,
                                               gint8 y_step,
                                               guint8 count)
{
#line 401 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 2900 "computer-reversi.c"
	{
		gboolean _tmp0_ = FALSE;
#line 403 "../src/computer-reversi.vala"
		_tmp0_ = TRUE;
#line 403 "../src/computer-reversi.vala"
		while (TRUE) {
#line 2907 "computer-reversi.c"
			gint16* _tmp2_;
			gint _tmp2__length1;
			gint _tmp2__length2;
			gint16 _tmp3_;
#line 403 "../src/computer-reversi.vala"
			if (!_tmp0_) {
#line 2914 "computer-reversi.c"
				guint8 _tmp1_;
#line 403 "../src/computer-reversi.vala"
				_tmp1_ = count;
#line 403 "../src/computer-reversi.vala"
				count = _tmp1_ - 1;
#line 2920 "computer-reversi.c"
			}
#line 403 "../src/computer-reversi.vala"
			_tmp0_ = FALSE;
#line 403 "../src/computer-reversi.vala"
			if (!(((gint) count) > 0)) {
#line 403 "../src/computer-reversi.vala"
				break;
#line 2928 "computer-reversi.c"
			}
#line 404 "../src/computer-reversi.vala"
			_tmp2_ = self->priv->heuristic;
#line 404 "../src/computer-reversi.vala"
			_tmp2__length1 = self->priv->heuristic_length1;
#line 404 "../src/computer-reversi.vala"
			_tmp2__length2 = self->priv->heuristic_length2;
#line 404 "../src/computer-reversi.vala"
			_tmp3_ = _tmp2_[((((gint8) x) + (((gint8) count) * x_step)) * _tmp2__length2) + (((gint8) y) + (((gint8) count) * y_step))];
#line 404 "../src/computer-reversi.vala"
			*comparator = (*comparator) + ((gint) _tmp3_);
#line 2940 "computer-reversi.c"
		}
	}
}

static gint16
computer_reversi_hard_real_end_of_game (ComputerReversi* base,
                                        GameStateStruct* g)
{
	ComputerReversiHard * self;
	gint16 _tmp0_ = 0;
	GameStateStruct _tmp1_;
	GameStateStruct _tmp2_;
	gint16 result;
#line 412 "../src/computer-reversi.vala"
	self = (ComputerReversiHard*) base;
#line 412 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 414 "../src/computer-reversi.vala"
	_tmp1_ = *g;
#line 414 "../src/computer-reversi.vala"
	_tmp2_ = *g;
#line 414 "../src/computer-reversi.vala"
	if (_tmp1_.n_current_tiles > _tmp2_.n_opponent_tiles) {
#line 2964 "computer-reversi.c"
		GameStateStruct _tmp3_;
#line 414 "../src/computer-reversi.vala"
		_tmp3_ = *g;
#line 414 "../src/computer-reversi.vala"
		_tmp0_ = COMPUTER_REVERSI_POSITIVE_INFINITY - ((gint16) _tmp3_.n_opponent_tiles);
#line 2970 "computer-reversi.c"
	} else {
		GameStateStruct _tmp4_;
#line 415 "../src/computer-reversi.vala"
		_tmp4_ = *g;
#line 415 "../src/computer-reversi.vala"
		_tmp0_ = COMPUTER_REVERSI_NEGATIVE_INFINITY + ((gint16) _tmp4_.n_current_tiles);
#line 2977 "computer-reversi.c"
	}
#line 414 "../src/computer-reversi.vala"
	result = _tmp0_;
#line 414 "../src/computer-reversi.vala"
	return result;
#line 2983 "computer-reversi.c"
}

static gint16
computer_reversi_hard_real_calculate_heuristic (ComputerReversi* base,
                                                GameStateStruct* g)
{
	ComputerReversiHard * self;
	GameStateStruct _tmp0_;
	gboolean _tmp1_;
	gint16 _tmp2_;
	gint16 result;
#line 418 "../src/computer-reversi.vala"
	self = (ComputerReversiHard*) base;
#line 418 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 420 "../src/computer-reversi.vala"
	_tmp0_ = *g;
#line 420 "../src/computer-reversi.vala"
	_tmp1_ = self->priv->_even_depth;
#line 420 "../src/computer-reversi.vala"
	_tmp2_ = computer_reversi_hard_eval_heuristic (&_tmp0_, &self->priv->heuristic, (gint*) (&self->priv->heuristic_length1), (gint*) (&self->priv->heuristic_length2), _tmp1_);
#line 420 "../src/computer-reversi.vala"
	result = _tmp2_;
#line 420 "../src/computer-reversi.vala"
	return result;
#line 3009 "computer-reversi.c"
}

static inline gint16
computer_reversi_hard_eval_heuristic (GameStateStruct* g,
                                      gint16** heuristic,
                                      gint* heuristic_length1,
                                      gint* heuristic_length2,
                                      gboolean even_depth)
{
	guint8 size = 0U;
	GameStateStruct _tmp0_;
	gint16 count = 0;
	GameStateStruct _tmp6_;
	GameStateStruct _tmp7_;
	GameStateStruct _tmp8_;
	GameStateStruct _tmp9_;
	GameStateStruct _tmp10_;
	GameStateStruct _tmp11_;
	gint16 result;
#line 423 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 425 "../src/computer-reversi.vala"
	_tmp0_ = *g;
#line 425 "../src/computer-reversi.vala"
	size = _tmp0_.size;
#line 426 "../src/computer-reversi.vala"
	count = (gint16) 0;
#line 3037 "computer-reversi.c"
	{
		guint8 x = 0U;
#line 428 "../src/computer-reversi.vala"
		x = (guint8) 0;
#line 3042 "computer-reversi.c"
		{
			gboolean _tmp1_ = FALSE;
#line 428 "../src/computer-reversi.vala"
			_tmp1_ = TRUE;
#line 428 "../src/computer-reversi.vala"
			while (TRUE) {
#line 428 "../src/computer-reversi.vala"
				if (!_tmp1_) {
#line 3051 "computer-reversi.c"
					guint8 _tmp2_;
#line 428 "../src/computer-reversi.vala"
					_tmp2_ = x;
#line 428 "../src/computer-reversi.vala"
					x = _tmp2_ + 1;
#line 3057 "computer-reversi.c"
				}
#line 428 "../src/computer-reversi.vala"
				_tmp1_ = FALSE;
#line 428 "../src/computer-reversi.vala"
				if (!(x < size)) {
#line 428 "../src/computer-reversi.vala"
					break;
#line 3065 "computer-reversi.c"
				}
				{
					guint8 y = 0U;
#line 429 "../src/computer-reversi.vala"
					y = (guint8) 0;
#line 3071 "computer-reversi.c"
					{
						gboolean _tmp3_ = FALSE;
#line 429 "../src/computer-reversi.vala"
						_tmp3_ = TRUE;
#line 429 "../src/computer-reversi.vala"
						while (TRUE) {
#line 3078 "computer-reversi.c"
							gint16 a = 0;
							gint16 tile_heuristic = 0;
							gint16 _tmp5_;
#line 429 "../src/computer-reversi.vala"
							if (!_tmp3_) {
#line 3084 "computer-reversi.c"
								guint8 _tmp4_;
#line 429 "../src/computer-reversi.vala"
								_tmp4_ = y;
#line 429 "../src/computer-reversi.vala"
								y = _tmp4_ + 1;
#line 3090 "computer-reversi.c"
							}
#line 429 "../src/computer-reversi.vala"
							_tmp3_ = FALSE;
#line 429 "../src/computer-reversi.vala"
							if (!(y < size)) {
#line 429 "../src/computer-reversi.vala"
								break;
#line 3098 "computer-reversi.c"
							}
#line 431 "../src/computer-reversi.vala"
							a = (gint16) game_state_struct_get_empty_neighbors (g, x, y);
#line 432 "../src/computer-reversi.vala"
							if (((gint) a) == 0) {
#line 433 "../src/computer-reversi.vala"
								a = (gint16) -6;
#line 3106 "computer-reversi.c"
							}
#line 435 "../src/computer-reversi.vala"
							_tmp5_ = (*heuristic)[(x * (*heuristic_length2)) + y];
#line 435 "../src/computer-reversi.vala"
							tile_heuristic = (gint16) (_tmp5_ - (8 * a));
#line 436 "../src/computer-reversi.vala"
							if (game_state_struct_is_empty_tile (g, x, y)) {
#line 438 "../src/computer-reversi.vala"
								if (even_depth) {
#line 439 "../src/computer-reversi.vala"
									count -= (gint16) (tile_heuristic / 2);
#line 3118 "computer-reversi.c"
								} else {
#line 441 "../src/computer-reversi.vala"
									count += (gint16) (tile_heuristic / 2);
#line 3122 "computer-reversi.c"
								}
							} else {
#line 443 "../src/computer-reversi.vala"
								if (game_state_struct_is_current_color (g, x, y)) {
#line 444 "../src/computer-reversi.vala"
									count += tile_heuristic;
#line 3129 "computer-reversi.c"
								} else {
#line 446 "../src/computer-reversi.vala"
									count -= tile_heuristic;
#line 3133 "computer-reversi.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 449 "../src/computer-reversi.vala"
	_tmp6_ = *g;
#line 449 "../src/computer-reversi.vala"
	computer_reversi_hard_mainline_penalty (&_tmp6_, COMPUTER_REVERSI_HARD_border_penalty, &count, MAIN_LINE_TOP);
#line 450 "../src/computer-reversi.vala"
	_tmp7_ = *g;
#line 450 "../src/computer-reversi.vala"
	computer_reversi_hard_mainline_penalty (&_tmp7_, COMPUTER_REVERSI_HARD_border_penalty, &count, MAIN_LINE_LEFT);
#line 451 "../src/computer-reversi.vala"
	_tmp8_ = *g;
#line 451 "../src/computer-reversi.vala"
	computer_reversi_hard_mainline_penalty (&_tmp8_, COMPUTER_REVERSI_HARD_border_penalty, &count, MAIN_LINE_RIGHT);
#line 452 "../src/computer-reversi.vala"
	_tmp9_ = *g;
#line 452 "../src/computer-reversi.vala"
	computer_reversi_hard_mainline_penalty (&_tmp9_, COMPUTER_REVERSI_HARD_border_penalty, &count, MAIN_LINE_BOTTOM);
#line 453 "../src/computer-reversi.vala"
	_tmp10_ = *g;
#line 453 "../src/computer-reversi.vala"
	computer_reversi_hard_mainline_penalty (&_tmp10_, COMPUTER_REVERSI_HARD_corner_penalty, &count, MAIN_LINE_TOPLEFT);
#line 454 "../src/computer-reversi.vala"
	_tmp11_ = *g;
#line 454 "../src/computer-reversi.vala"
	computer_reversi_hard_mainline_penalty (&_tmp11_, COMPUTER_REVERSI_HARD_corner_penalty, &count, MAIN_LINE_TOPRIGHT);
#line 456 "../src/computer-reversi.vala"
	result = count;
#line 456 "../src/computer-reversi.vala"
	return result;
#line 3170 "computer-reversi.c"
}

static void
computer_reversi_hard_mainline_penalty (GameStateStruct* g,
                                        gint16 penalty,
                                        gint16* count,
                                        MainLine mainline_id)
{
	Player* mainline = NULL;
	gint _tmp0_ = 0;
	Player* _tmp1_;
	gint mainline_length1;
	gint _mainline_size_;
	gboolean _tmp2_ = FALSE;
	Player* _tmp3_;
	gint _tmp3__length1;
	Player _tmp4_;
	GameStateStruct _tmp5_;
	gboolean _tmp34_ = FALSE;
	Player* _tmp35_;
	gint _tmp35__length1;
	GameStateStruct _tmp36_;
	Player _tmp37_;
	GameStateStruct _tmp38_;
#line 461 "../src/computer-reversi.vala"
	g_return_if_fail (g != NULL);
#line 463 "../src/computer-reversi.vala"
	_tmp1_ = game_state_struct_get_mainline (g, mainline_id, &_tmp0_);
#line 463 "../src/computer-reversi.vala"
	mainline = _tmp1_;
#line 463 "../src/computer-reversi.vala"
	mainline_length1 = _tmp0_;
#line 463 "../src/computer-reversi.vala"
	_mainline_size_ = mainline_length1;
#line 464 "../src/computer-reversi.vala"
	_tmp3_ = mainline;
#line 464 "../src/computer-reversi.vala"
	_tmp3__length1 = mainline_length1;
#line 464 "../src/computer-reversi.vala"
	_tmp4_ = _tmp3_[1];
#line 464 "../src/computer-reversi.vala"
	_tmp5_ = *g;
#line 464 "../src/computer-reversi.vala"
	if (_tmp4_ == _tmp5_.current_color) {
#line 3215 "computer-reversi.c"
		Player* _tmp6_;
		gint _tmp6__length1;
		Player _tmp7_;
#line 465 "../src/computer-reversi.vala"
		_tmp6_ = mainline;
#line 465 "../src/computer-reversi.vala"
		_tmp6__length1 = mainline_length1;
#line 465 "../src/computer-reversi.vala"
		_tmp7_ = _tmp6_[0];
#line 465 "../src/computer-reversi.vala"
		_tmp2_ = _tmp7_ == PLAYER_NONE;
#line 3227 "computer-reversi.c"
	} else {
#line 464 "../src/computer-reversi.vala"
		_tmp2_ = FALSE;
#line 3231 "computer-reversi.c"
	}
#line 464 "../src/computer-reversi.vala"
	if (_tmp2_) {
#line 3235 "computer-reversi.c"
		guint8 i = 0U;
		GameStateStruct _tmp14_;
#line 467 "../src/computer-reversi.vala"
		i = (guint8) 1;
#line 3240 "computer-reversi.c"
		{
			gboolean _tmp8_ = FALSE;
#line 468 "../src/computer-reversi.vala"
			_tmp8_ = TRUE;
#line 468 "../src/computer-reversi.vala"
			while (TRUE) {
#line 3247 "computer-reversi.c"
				guint8 _tmp12_;
				GameStateStruct _tmp13_;
#line 468 "../src/computer-reversi.vala"
				if (!_tmp8_) {
#line 3252 "computer-reversi.c"
					Player* _tmp9_;
					gint _tmp9__length1;
					Player _tmp10_;
					GameStateStruct _tmp11_;
#line 469 "../src/computer-reversi.vala"
					_tmp9_ = mainline;
#line 469 "../src/computer-reversi.vala"
					_tmp9__length1 = mainline_length1;
#line 469 "../src/computer-reversi.vala"
					_tmp10_ = _tmp9_[i];
#line 469 "../src/computer-reversi.vala"
					_tmp11_ = *g;
#line 469 "../src/computer-reversi.vala"
					if (!(_tmp10_ == _tmp11_.current_color)) {
#line 469 "../src/computer-reversi.vala"
						break;
#line 3269 "computer-reversi.c"
					}
				}
#line 468 "../src/computer-reversi.vala"
				_tmp8_ = FALSE;
#line 468 "../src/computer-reversi.vala"
				_tmp12_ = i;
#line 468 "../src/computer-reversi.vala"
				i = _tmp12_ + 1;
#line 468 "../src/computer-reversi.vala"
				_tmp13_ = *g;
#line 468 "../src/computer-reversi.vala"
				if (((gint) i) == (_tmp13_.size - 2)) {
#line 468 "../src/computer-reversi.vala"
					break;
#line 3284 "computer-reversi.c"
				}
			}
		}
#line 470 "../src/computer-reversi.vala"
		_tmp14_ = *g;
#line 470 "../src/computer-reversi.vala"
		if (((gint) i) != (_tmp14_.size - 2)) {
#line 3292 "computer-reversi.c"
			Player* _tmp15_;
			gint _tmp15__length1;
			Player _tmp16_;
			GameStateStruct _tmp17_;
#line 472 "../src/computer-reversi.vala"
			*count = (*count) - penalty;
#line 473 "../src/computer-reversi.vala"
			_tmp15_ = mainline;
#line 473 "../src/computer-reversi.vala"
			_tmp15__length1 = mainline_length1;
#line 473 "../src/computer-reversi.vala"
			_tmp16_ = _tmp15_[i + 1];
#line 473 "../src/computer-reversi.vala"
			_tmp17_ = *g;
#line 473 "../src/computer-reversi.vala"
			if (_tmp16_ == _tmp17_.current_color) {
#line 474 "../src/computer-reversi.vala"
				*count = (*count) - penalty;
#line 3311 "computer-reversi.c"
			}
		}
	} else {
		gboolean _tmp18_ = FALSE;
		Player* _tmp19_;
		gint _tmp19__length1;
		Player _tmp20_;
		GameStateStruct _tmp21_;
#line 477 "../src/computer-reversi.vala"
		_tmp19_ = mainline;
#line 477 "../src/computer-reversi.vala"
		_tmp19__length1 = mainline_length1;
#line 477 "../src/computer-reversi.vala"
		_tmp20_ = _tmp19_[1];
#line 477 "../src/computer-reversi.vala"
		_tmp21_ = *g;
#line 477 "../src/computer-reversi.vala"
		if (_tmp20_ == _tmp21_.opponent_color) {
#line 3330 "computer-reversi.c"
			Player* _tmp22_;
			gint _tmp22__length1;
			Player _tmp23_;
#line 478 "../src/computer-reversi.vala"
			_tmp22_ = mainline;
#line 478 "../src/computer-reversi.vala"
			_tmp22__length1 = mainline_length1;
#line 478 "../src/computer-reversi.vala"
			_tmp23_ = _tmp22_[0];
#line 478 "../src/computer-reversi.vala"
			_tmp18_ = _tmp23_ == PLAYER_NONE;
#line 3342 "computer-reversi.c"
		} else {
#line 477 "../src/computer-reversi.vala"
			_tmp18_ = FALSE;
#line 3346 "computer-reversi.c"
		}
#line 477 "../src/computer-reversi.vala"
		if (_tmp18_) {
#line 3350 "computer-reversi.c"
			guint8 i = 0U;
			GameStateStruct _tmp30_;
#line 480 "../src/computer-reversi.vala"
			i = (guint8) 1;
#line 3355 "computer-reversi.c"
			{
				gboolean _tmp24_ = FALSE;
#line 481 "../src/computer-reversi.vala"
				_tmp24_ = TRUE;
#line 481 "../src/computer-reversi.vala"
				while (TRUE) {
#line 3362 "computer-reversi.c"
					guint8 _tmp28_;
					GameStateStruct _tmp29_;
#line 481 "../src/computer-reversi.vala"
					if (!_tmp24_) {
#line 3367 "computer-reversi.c"
						Player* _tmp25_;
						gint _tmp25__length1;
						Player _tmp26_;
						GameStateStruct _tmp27_;
#line 482 "../src/computer-reversi.vala"
						_tmp25_ = mainline;
#line 482 "../src/computer-reversi.vala"
						_tmp25__length1 = mainline_length1;
#line 482 "../src/computer-reversi.vala"
						_tmp26_ = _tmp25_[i];
#line 482 "../src/computer-reversi.vala"
						_tmp27_ = *g;
#line 482 "../src/computer-reversi.vala"
						if (!(_tmp26_ == _tmp27_.opponent_color)) {
#line 482 "../src/computer-reversi.vala"
							break;
#line 3384 "computer-reversi.c"
						}
					}
#line 481 "../src/computer-reversi.vala"
					_tmp24_ = FALSE;
#line 481 "../src/computer-reversi.vala"
					_tmp28_ = i;
#line 481 "../src/computer-reversi.vala"
					i = _tmp28_ + 1;
#line 481 "../src/computer-reversi.vala"
					_tmp29_ = *g;
#line 481 "../src/computer-reversi.vala"
					if (((gint) i) == (_tmp29_.size - 2)) {
#line 481 "../src/computer-reversi.vala"
						break;
#line 3399 "computer-reversi.c"
					}
				}
			}
#line 483 "../src/computer-reversi.vala"
			_tmp30_ = *g;
#line 483 "../src/computer-reversi.vala"
			if (((gint) i) != (_tmp30_.size - 2)) {
#line 3407 "computer-reversi.c"
				Player* _tmp31_;
				gint _tmp31__length1;
				Player _tmp32_;
				GameStateStruct _tmp33_;
#line 485 "../src/computer-reversi.vala"
				*count = (*count) + penalty;
#line 486 "../src/computer-reversi.vala"
				_tmp31_ = mainline;
#line 486 "../src/computer-reversi.vala"
				_tmp31__length1 = mainline_length1;
#line 486 "../src/computer-reversi.vala"
				_tmp32_ = _tmp31_[i + 1];
#line 486 "../src/computer-reversi.vala"
				_tmp33_ = *g;
#line 486 "../src/computer-reversi.vala"
				if (_tmp32_ == _tmp33_.opponent_color) {
#line 487 "../src/computer-reversi.vala"
					*count = (*count) + penalty;
#line 3426 "computer-reversi.c"
				}
			}
		}
	}
#line 490 "../src/computer-reversi.vala"
	_tmp35_ = mainline;
#line 490 "../src/computer-reversi.vala"
	_tmp35__length1 = mainline_length1;
#line 490 "../src/computer-reversi.vala"
	_tmp36_ = *g;
#line 490 "../src/computer-reversi.vala"
	_tmp37_ = _tmp35_[_tmp36_.size - 2];
#line 490 "../src/computer-reversi.vala"
	_tmp38_ = *g;
#line 490 "../src/computer-reversi.vala"
	if (_tmp37_ == _tmp38_.current_color) {
#line 3443 "computer-reversi.c"
		Player* _tmp39_;
		gint _tmp39__length1;
		GameStateStruct _tmp40_;
		Player _tmp41_;
#line 491 "../src/computer-reversi.vala"
		_tmp39_ = mainline;
#line 491 "../src/computer-reversi.vala"
		_tmp39__length1 = mainline_length1;
#line 491 "../src/computer-reversi.vala"
		_tmp40_ = *g;
#line 491 "../src/computer-reversi.vala"
		_tmp41_ = _tmp39_[_tmp40_.size - 1];
#line 491 "../src/computer-reversi.vala"
		_tmp34_ = _tmp41_ == PLAYER_NONE;
#line 3458 "computer-reversi.c"
	} else {
#line 490 "../src/computer-reversi.vala"
		_tmp34_ = FALSE;
#line 3462 "computer-reversi.c"
	}
#line 490 "../src/computer-reversi.vala"
	if (_tmp34_) {
#line 3466 "computer-reversi.c"
		guint8 i = 0U;
		GameStateStruct _tmp49_;
#line 493 "../src/computer-reversi.vala"
		i = (guint8) 1;
#line 3471 "computer-reversi.c"
		{
			gboolean _tmp42_ = FALSE;
#line 494 "../src/computer-reversi.vala"
			_tmp42_ = TRUE;
#line 494 "../src/computer-reversi.vala"
			while (TRUE) {
#line 3478 "computer-reversi.c"
				guint8 _tmp47_;
				GameStateStruct _tmp48_;
#line 494 "../src/computer-reversi.vala"
				if (!_tmp42_) {
#line 3483 "computer-reversi.c"
					Player* _tmp43_;
					gint _tmp43__length1;
					GameStateStruct _tmp44_;
					Player _tmp45_;
					GameStateStruct _tmp46_;
#line 495 "../src/computer-reversi.vala"
					_tmp43_ = mainline;
#line 495 "../src/computer-reversi.vala"
					_tmp43__length1 = mainline_length1;
#line 495 "../src/computer-reversi.vala"
					_tmp44_ = *g;
#line 495 "../src/computer-reversi.vala"
					_tmp45_ = _tmp43_[(_tmp44_.size - 1) - i];
#line 495 "../src/computer-reversi.vala"
					_tmp46_ = *g;
#line 495 "../src/computer-reversi.vala"
					if (!(_tmp45_ == _tmp46_.current_color)) {
#line 495 "../src/computer-reversi.vala"
						break;
#line 3503 "computer-reversi.c"
					}
				}
#line 494 "../src/computer-reversi.vala"
				_tmp42_ = FALSE;
#line 494 "../src/computer-reversi.vala"
				_tmp47_ = i;
#line 494 "../src/computer-reversi.vala"
				i = _tmp47_ + 1;
#line 494 "../src/computer-reversi.vala"
				_tmp48_ = *g;
#line 494 "../src/computer-reversi.vala"
				if (((gint) i) == (_tmp48_.size - 2)) {
#line 494 "../src/computer-reversi.vala"
					break;
#line 3518 "computer-reversi.c"
				}
			}
		}
#line 496 "../src/computer-reversi.vala"
		_tmp49_ = *g;
#line 496 "../src/computer-reversi.vala"
		if (((gint) i) != (_tmp49_.size - 2)) {
#line 3526 "computer-reversi.c"
			Player* _tmp50_;
			gint _tmp50__length1;
			GameStateStruct _tmp51_;
			Player _tmp52_;
			GameStateStruct _tmp53_;
#line 498 "../src/computer-reversi.vala"
			*count = (*count) - penalty;
#line 499 "../src/computer-reversi.vala"
			_tmp50_ = mainline;
#line 499 "../src/computer-reversi.vala"
			_tmp50__length1 = mainline_length1;
#line 499 "../src/computer-reversi.vala"
			_tmp51_ = *g;
#line 499 "../src/computer-reversi.vala"
			_tmp52_ = _tmp50_[(_tmp51_.size - 2) - i];
#line 499 "../src/computer-reversi.vala"
			_tmp53_ = *g;
#line 499 "../src/computer-reversi.vala"
			if (_tmp52_ == _tmp53_.current_color) {
#line 500 "../src/computer-reversi.vala"
				*count = (*count) - penalty;
#line 3548 "computer-reversi.c"
			}
		}
	} else {
		gboolean _tmp54_ = FALSE;
		Player* _tmp55_;
		gint _tmp55__length1;
		GameStateStruct _tmp56_;
		Player _tmp57_;
		GameStateStruct _tmp58_;
#line 503 "../src/computer-reversi.vala"
		_tmp55_ = mainline;
#line 503 "../src/computer-reversi.vala"
		_tmp55__length1 = mainline_length1;
#line 503 "../src/computer-reversi.vala"
		_tmp56_ = *g;
#line 503 "../src/computer-reversi.vala"
		_tmp57_ = _tmp55_[_tmp56_.size - 2];
#line 503 "../src/computer-reversi.vala"
		_tmp58_ = *g;
#line 503 "../src/computer-reversi.vala"
		if (_tmp57_ == _tmp58_.opponent_color) {
#line 3570 "computer-reversi.c"
			Player* _tmp59_;
			gint _tmp59__length1;
			GameStateStruct _tmp60_;
			Player _tmp61_;
#line 504 "../src/computer-reversi.vala"
			_tmp59_ = mainline;
#line 504 "../src/computer-reversi.vala"
			_tmp59__length1 = mainline_length1;
#line 504 "../src/computer-reversi.vala"
			_tmp60_ = *g;
#line 504 "../src/computer-reversi.vala"
			_tmp61_ = _tmp59_[_tmp60_.size - 1];
#line 504 "../src/computer-reversi.vala"
			_tmp54_ = _tmp61_ == PLAYER_NONE;
#line 3585 "computer-reversi.c"
		} else {
#line 503 "../src/computer-reversi.vala"
			_tmp54_ = FALSE;
#line 3589 "computer-reversi.c"
		}
#line 503 "../src/computer-reversi.vala"
		if (_tmp54_) {
#line 3593 "computer-reversi.c"
			guint8 i = 0U;
			GameStateStruct _tmp69_;
#line 506 "../src/computer-reversi.vala"
			i = (guint8) 1;
#line 3598 "computer-reversi.c"
			{
				gboolean _tmp62_ = FALSE;
#line 507 "../src/computer-reversi.vala"
				_tmp62_ = TRUE;
#line 507 "../src/computer-reversi.vala"
				while (TRUE) {
#line 3605 "computer-reversi.c"
					guint8 _tmp67_;
					GameStateStruct _tmp68_;
#line 507 "../src/computer-reversi.vala"
					if (!_tmp62_) {
#line 3610 "computer-reversi.c"
						Player* _tmp63_;
						gint _tmp63__length1;
						GameStateStruct _tmp64_;
						Player _tmp65_;
						GameStateStruct _tmp66_;
#line 508 "../src/computer-reversi.vala"
						_tmp63_ = mainline;
#line 508 "../src/computer-reversi.vala"
						_tmp63__length1 = mainline_length1;
#line 508 "../src/computer-reversi.vala"
						_tmp64_ = *g;
#line 508 "../src/computer-reversi.vala"
						_tmp65_ = _tmp63_[(_tmp64_.size - 1) - i];
#line 508 "../src/computer-reversi.vala"
						_tmp66_ = *g;
#line 508 "../src/computer-reversi.vala"
						if (!(_tmp65_ == _tmp66_.opponent_color)) {
#line 508 "../src/computer-reversi.vala"
							break;
#line 3630 "computer-reversi.c"
						}
					}
#line 507 "../src/computer-reversi.vala"
					_tmp62_ = FALSE;
#line 507 "../src/computer-reversi.vala"
					_tmp67_ = i;
#line 507 "../src/computer-reversi.vala"
					i = _tmp67_ + 1;
#line 507 "../src/computer-reversi.vala"
					_tmp68_ = *g;
#line 507 "../src/computer-reversi.vala"
					if (((gint) i) == (_tmp68_.size - 2)) {
#line 507 "../src/computer-reversi.vala"
						break;
#line 3645 "computer-reversi.c"
					}
				}
			}
#line 509 "../src/computer-reversi.vala"
			_tmp69_ = *g;
#line 509 "../src/computer-reversi.vala"
			if (((gint) i) != (_tmp69_.size - 2)) {
#line 3653 "computer-reversi.c"
				Player* _tmp70_;
				gint _tmp70__length1;
				GameStateStruct _tmp71_;
				Player _tmp72_;
				GameStateStruct _tmp73_;
#line 511 "../src/computer-reversi.vala"
				*count = (*count) + penalty;
#line 512 "../src/computer-reversi.vala"
				_tmp70_ = mainline;
#line 512 "../src/computer-reversi.vala"
				_tmp70__length1 = mainline_length1;
#line 512 "../src/computer-reversi.vala"
				_tmp71_ = *g;
#line 512 "../src/computer-reversi.vala"
				_tmp72_ = _tmp70_[(_tmp71_.size - 2) - i];
#line 512 "../src/computer-reversi.vala"
				_tmp73_ = *g;
#line 512 "../src/computer-reversi.vala"
				if (_tmp72_ == _tmp73_.opponent_color) {
#line 513 "../src/computer-reversi.vala"
					*count = (*count) + penalty;
#line 3675 "computer-reversi.c"
				}
			}
		}
	}
#line 461 "../src/computer-reversi.vala"
	mainline = (g_free (mainline), NULL);
#line 3682 "computer-reversi.c"
}

static gint16*
_vala_array_dup5 (gint16* self,
                  gssize length)
{
#line 528 "../src/computer-reversi.vala"
	if (length > 0) {
#line 528 "../src/computer-reversi.vala"
		return _vala_memdup2 (self, length * sizeof (gint16));
#line 3693 "computer-reversi.c"
	}
#line 528 "../src/computer-reversi.vala"
	return NULL;
#line 3697 "computer-reversi.c"
}

static inline void
computer_reversi_hard_init_heuristic (guint8 size,
                                      gboolean fixed_heuristic,
                                      gint16** heuristic,
                                      gint* heuristic_length1,
                                      gint* heuristic_length2)
{
	gint16* _vala_heuristic = NULL;
	gint _vala_heuristic_length1 = 0;
	gint _vala_heuristic_length2 = 0;
#line 524 "../src/computer-reversi.vala"
	_vala_return_if_fail (((gint) size) >= 4, "size >= 4");
#line 527 "../src/computer-reversi.vala"
	if (((gint) size) == 8) {
#line 3714 "computer-reversi.c"
		gint16* _tmp0_;
		gint _tmp0__length1;
		gint _tmp0__length2;
#line 528 "../src/computer-reversi.vala"
		_tmp0_ = _vala_array_dup5 (heuristic_8, G_N_ELEMENTS (heuristic_8) * G_N_ELEMENTS (heuristic_8[0]));
#line 528 "../src/computer-reversi.vala"
		_tmp0__length1 = G_N_ELEMENTS (heuristic_8);
#line 528 "../src/computer-reversi.vala"
		_tmp0__length2 = G_N_ELEMENTS (heuristic_8[0]);
#line 528 "../src/computer-reversi.vala"
		_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 528 "../src/computer-reversi.vala"
		_vala_heuristic = _tmp0_;
#line 528 "../src/computer-reversi.vala"
		_vala_heuristic_length1 = _tmp0__length1;
#line 528 "../src/computer-reversi.vala"
		_vala_heuristic_length2 = _tmp0__length2;
#line 3732 "computer-reversi.c"
	} else {
		gint16* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
#line 530 "../src/computer-reversi.vala"
		computer_reversi_hard_create_heuristic (size, &_tmp1_, &_tmp2_, &_tmp3_);
#line 530 "../src/computer-reversi.vala"
		_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 530 "../src/computer-reversi.vala"
		_vala_heuristic = _tmp1_;
#line 530 "../src/computer-reversi.vala"
		_vala_heuristic_length1 = _tmp2_;
#line 530 "../src/computer-reversi.vala"
		_vala_heuristic_length2 = _tmp3_;
#line 3747 "computer-reversi.c"
	}
#line 532 "../src/computer-reversi.vala"
	if (fixed_heuristic) {
#line 533 "../src/computer-reversi.vala"
		if (heuristic) {
#line 533 "../src/computer-reversi.vala"
			*heuristic = _vala_heuristic;
#line 3755 "computer-reversi.c"
		} else {
#line 533 "../src/computer-reversi.vala"
			_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 3759 "computer-reversi.c"
		}
#line 533 "../src/computer-reversi.vala"
		if (heuristic_length1) {
#line 533 "../src/computer-reversi.vala"
			*heuristic_length1 = _vala_heuristic_length1;
#line 3765 "computer-reversi.c"
		}
#line 533 "../src/computer-reversi.vala"
		if (heuristic_length2) {
#line 533 "../src/computer-reversi.vala"
			*heuristic_length2 = _vala_heuristic_length2;
#line 3771 "computer-reversi.c"
		}
#line 533 "../src/computer-reversi.vala"
		return;
#line 3775 "computer-reversi.c"
	}
	{
		guint8 i = 0U;
#line 536 "../src/computer-reversi.vala"
		i = (guint8) 0;
#line 3781 "computer-reversi.c"
		{
			gboolean _tmp4_ = FALSE;
#line 536 "../src/computer-reversi.vala"
			_tmp4_ = TRUE;
#line 536 "../src/computer-reversi.vala"
			while (TRUE) {
#line 3788 "computer-reversi.c"
				gint _tmp6_ = 0;
				gint16* _tmp7_;
				gint _tmp7__length1;
				gint _tmp7__length2;
				guint8 x = 0U;
				guint8 y = 0U;
				gboolean minus = FALSE;
				gint _tmp8_ = 0;
				gint16* _tmp9_;
				gint _tmp9__length1;
				gint _tmp9__length2;
				gint _tmp10_ = 0;
				gint16* _tmp11_;
				gint _tmp11__length1;
				gint _tmp11__length2;
#line 536 "../src/computer-reversi.vala"
				if (!_tmp4_) {
#line 3806 "computer-reversi.c"
					guint8 _tmp5_;
#line 536 "../src/computer-reversi.vala"
					_tmp5_ = i;
#line 536 "../src/computer-reversi.vala"
					i = _tmp5_ + 1;
#line 3812 "computer-reversi.c"
				}
#line 536 "../src/computer-reversi.vala"
				_tmp4_ = FALSE;
#line 536 "../src/computer-reversi.vala"
				if (!(((gint) i) < 5)) {
#line 536 "../src/computer-reversi.vala"
					break;
#line 3820 "computer-reversi.c"
				}
#line 540 "../src/computer-reversi.vala"
				if (g_random_boolean ()) {
#line 540 "../src/computer-reversi.vala"
					_tmp6_ = -1;
#line 3826 "computer-reversi.c"
				} else {
#line 540 "../src/computer-reversi.vala"
					_tmp6_ = 1;
#line 3830 "computer-reversi.c"
				}
#line 538 "../src/computer-reversi.vala"
				_tmp7_ = _vala_heuristic;
#line 538 "../src/computer-reversi.vala"
				_tmp7__length1 = _vala_heuristic_length1;
#line 538 "../src/computer-reversi.vala"
				_tmp7__length2 = _vala_heuristic_length2;
#line 538 "../src/computer-reversi.vala"
				_tmp7_[(g_random_int_range ((gint32) 0, (gint32) size) * _tmp7__length2) + g_random_int_range ((gint32) 0, (gint32) size)] += (gint16) _tmp6_;
#line 542 "../src/computer-reversi.vala"
				x = (guint8) g_random_int_range ((gint32) 0, (gint32) size);
#line 543 "../src/computer-reversi.vala"
				y = (guint8) g_random_int_range ((gint32) 0, (gint32) size);
#line 544 "../src/computer-reversi.vala"
				minus = g_random_boolean ();
#line 545 "../src/computer-reversi.vala"
				if (minus) {
#line 545 "../src/computer-reversi.vala"
					_tmp8_ = -1;
#line 3850 "computer-reversi.c"
				} else {
#line 545 "../src/computer-reversi.vala"
					_tmp8_ = 1;
#line 3854 "computer-reversi.c"
				}
#line 545 "../src/computer-reversi.vala"
				_tmp9_ = _vala_heuristic;
#line 545 "../src/computer-reversi.vala"
				_tmp9__length1 = _vala_heuristic_length1;
#line 545 "../src/computer-reversi.vala"
				_tmp9__length2 = _vala_heuristic_length2;
#line 545 "../src/computer-reversi.vala"
				_tmp9_[(x * _tmp9__length2) + y] += (gint16) _tmp8_;
#line 546 "../src/computer-reversi.vala"
				if (minus) {
#line 546 "../src/computer-reversi.vala"
					_tmp10_ = -1;
#line 3868 "computer-reversi.c"
				} else {
#line 546 "../src/computer-reversi.vala"
					_tmp10_ = 1;
#line 3872 "computer-reversi.c"
				}
#line 546 "../src/computer-reversi.vala"
				_tmp11_ = _vala_heuristic;
#line 546 "../src/computer-reversi.vala"
				_tmp11__length1 = _vala_heuristic_length1;
#line 546 "../src/computer-reversi.vala"
				_tmp11__length2 = _vala_heuristic_length2;
#line 546 "../src/computer-reversi.vala"
				_tmp11_[(((size - 1) - x) * _tmp11__length2) + ((size - 1) - y)] += (gint16) _tmp10_;
#line 3882 "computer-reversi.c"
			}
		}
	}
#line 524 "../src/computer-reversi.vala"
	if (heuristic) {
#line 524 "../src/computer-reversi.vala"
		*heuristic = _vala_heuristic;
#line 3890 "computer-reversi.c"
	} else {
#line 524 "../src/computer-reversi.vala"
		_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 3894 "computer-reversi.c"
	}
#line 524 "../src/computer-reversi.vala"
	if (heuristic_length1) {
#line 524 "../src/computer-reversi.vala"
		*heuristic_length1 = _vala_heuristic_length1;
#line 3900 "computer-reversi.c"
	}
#line 524 "../src/computer-reversi.vala"
	if (heuristic_length2) {
#line 524 "../src/computer-reversi.vala"
		*heuristic_length2 = _vala_heuristic_length2;
#line 3906 "computer-reversi.c"
	}
}

static void
computer_reversi_hard_create_heuristic (guint8 size,
                                        gint16** heuristic,
                                        gint* heuristic_length1,
                                        gint* heuristic_length2)
{
	gint16* _vala_heuristic = NULL;
	gint _vala_heuristic_length1 = 0;
	gint _vala_heuristic_length2 = 0;
	gint16* _tmp0_;
	guint8 tmp1 = 0U;
	gint16* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gint16* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gint16* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	gint16* _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
#line 550 "../src/computer-reversi.vala"
	_vala_return_if_fail (((gint) size) >= 4, "size >= 4");
#line 553 "../src/computer-reversi.vala"
	_tmp0_ = g_new0 (gint16, size * size);
#line 553 "../src/computer-reversi.vala"
	_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 553 "../src/computer-reversi.vala"
	_vala_heuristic = _tmp0_;
#line 553 "../src/computer-reversi.vala"
	_vala_heuristic_length1 = size;
#line 553 "../src/computer-reversi.vala"
	_vala_heuristic_length2 = size;
#line 3945 "computer-reversi.c"
	{
		guint8 x = 0U;
#line 554 "../src/computer-reversi.vala"
		x = (guint8) 0;
#line 3950 "computer-reversi.c"
		{
			gboolean _tmp1_ = FALSE;
#line 554 "../src/computer-reversi.vala"
			_tmp1_ = TRUE;
#line 554 "../src/computer-reversi.vala"
			while (TRUE) {
#line 554 "../src/computer-reversi.vala"
				if (!_tmp1_) {
#line 3959 "computer-reversi.c"
					guint8 _tmp2_;
#line 554 "../src/computer-reversi.vala"
					_tmp2_ = x;
#line 554 "../src/computer-reversi.vala"
					x = _tmp2_ + 1;
#line 3965 "computer-reversi.c"
				}
#line 554 "../src/computer-reversi.vala"
				_tmp1_ = FALSE;
#line 554 "../src/computer-reversi.vala"
				if (!(x < size)) {
#line 554 "../src/computer-reversi.vala"
					break;
#line 3973 "computer-reversi.c"
				}
				{
					guint8 y = 0U;
#line 555 "../src/computer-reversi.vala"
					y = (guint8) 0;
#line 3979 "computer-reversi.c"
					{
						gboolean _tmp3_ = FALSE;
#line 555 "../src/computer-reversi.vala"
						_tmp3_ = TRUE;
#line 555 "../src/computer-reversi.vala"
						while (TRUE) {
#line 3986 "computer-reversi.c"
							gint16* _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
#line 555 "../src/computer-reversi.vala"
							if (!_tmp3_) {
#line 3992 "computer-reversi.c"
								guint8 _tmp4_;
#line 555 "../src/computer-reversi.vala"
								_tmp4_ = y;
#line 555 "../src/computer-reversi.vala"
								y = _tmp4_ + 1;
#line 3998 "computer-reversi.c"
							}
#line 555 "../src/computer-reversi.vala"
							_tmp3_ = FALSE;
#line 555 "../src/computer-reversi.vala"
							if (!(y < size)) {
#line 555 "../src/computer-reversi.vala"
								break;
#line 4006 "computer-reversi.c"
							}
#line 556 "../src/computer-reversi.vala"
							_tmp5_ = _vala_heuristic;
#line 556 "../src/computer-reversi.vala"
							_tmp5__length1 = _vala_heuristic_length1;
#line 556 "../src/computer-reversi.vala"
							_tmp5__length2 = _vala_heuristic_length2;
#line 556 "../src/computer-reversi.vala"
							_tmp5_[(x * _tmp5__length2) + y] = (gint16) 0;
#line 4016 "computer-reversi.c"
						}
					}
				}
			}
		}
	}
#line 559 "../src/computer-reversi.vala"
	tmp1 = (guint8) (size - 1);
#line 560 "../src/computer-reversi.vala"
	_tmp6_ = _vala_heuristic;
#line 560 "../src/computer-reversi.vala"
	_tmp6__length1 = _vala_heuristic_length1;
#line 560 "../src/computer-reversi.vala"
	_tmp6__length2 = _vala_heuristic_length2;
#line 560 "../src/computer-reversi.vala"
	_tmp6_[(0 * _tmp6__length2) + 0] = (gint16) 110;
#line 561 "../src/computer-reversi.vala"
	_tmp7_ = _vala_heuristic;
#line 561 "../src/computer-reversi.vala"
	_tmp7__length1 = _vala_heuristic_length1;
#line 561 "../src/computer-reversi.vala"
	_tmp7__length2 = _vala_heuristic_length2;
#line 561 "../src/computer-reversi.vala"
	_tmp7_[(0 * _tmp7__length2) + tmp1] = (gint16) 110;
#line 562 "../src/computer-reversi.vala"
	_tmp8_ = _vala_heuristic;
#line 562 "../src/computer-reversi.vala"
	_tmp8__length1 = _vala_heuristic_length1;
#line 562 "../src/computer-reversi.vala"
	_tmp8__length2 = _vala_heuristic_length2;
#line 562 "../src/computer-reversi.vala"
	_tmp8_[(tmp1 * _tmp8__length2) + tmp1] = (gint16) 110;
#line 563 "../src/computer-reversi.vala"
	_tmp9_ = _vala_heuristic;
#line 563 "../src/computer-reversi.vala"
	_tmp9__length1 = _vala_heuristic_length1;
#line 563 "../src/computer-reversi.vala"
	_tmp9__length2 = _vala_heuristic_length2;
#line 563 "../src/computer-reversi.vala"
	_tmp9_[(tmp1 * _tmp9__length2) + 0] = (gint16) 110;
#line 565 "../src/computer-reversi.vala"
	if (((gint) size) >= 6) {
#line 4059 "computer-reversi.c"
		guint8 tmp2 = 0U;
		gint16* _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		gint16* _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		gint16* _tmp12_;
		gint _tmp12__length1;
		gint _tmp12__length2;
		gint16* _tmp13_;
		gint _tmp13__length1;
		gint _tmp13__length2;
		gint16* _tmp14_;
		gint _tmp14__length1;
		gint _tmp14__length2;
		gint16* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		gint16* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		gint16* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint16* _tmp18_;
		gint _tmp18__length1;
		gint _tmp18__length2;
		gint16* _tmp19_;
		gint _tmp19__length1;
		gint _tmp19__length2;
		gint16* _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		gint16* _tmp21_;
		gint _tmp21__length1;
		gint _tmp21__length2;
#line 568 "../src/computer-reversi.vala"
		tmp2 = (guint8) (size - 2);
#line 569 "../src/computer-reversi.vala"
		_tmp10_ = _vala_heuristic;
#line 569 "../src/computer-reversi.vala"
		_tmp10__length1 = _vala_heuristic_length1;
#line 569 "../src/computer-reversi.vala"
		_tmp10__length2 = _vala_heuristic_length2;
#line 569 "../src/computer-reversi.vala"
		_tmp10_[(0 * _tmp10__length2) + 1] = (gint16) 35;
#line 570 "../src/computer-reversi.vala"
		_tmp11_ = _vala_heuristic;
#line 570 "../src/computer-reversi.vala"
		_tmp11__length1 = _vala_heuristic_length1;
#line 570 "../src/computer-reversi.vala"
		_tmp11__length2 = _vala_heuristic_length2;
#line 570 "../src/computer-reversi.vala"
		_tmp11_[(0 * _tmp11__length2) + tmp2] = (gint16) 35;
#line 571 "../src/computer-reversi.vala"
		_tmp12_ = _vala_heuristic;
#line 571 "../src/computer-reversi.vala"
		_tmp12__length1 = _vala_heuristic_length1;
#line 571 "../src/computer-reversi.vala"
		_tmp12__length2 = _vala_heuristic_length2;
#line 571 "../src/computer-reversi.vala"
		_tmp12_[(tmp1 * _tmp12__length2) + 1] = (gint16) 35;
#line 572 "../src/computer-reversi.vala"
		_tmp13_ = _vala_heuristic;
#line 572 "../src/computer-reversi.vala"
		_tmp13__length1 = _vala_heuristic_length1;
#line 572 "../src/computer-reversi.vala"
		_tmp13__length2 = _vala_heuristic_length2;
#line 572 "../src/computer-reversi.vala"
		_tmp13_[(tmp1 * _tmp13__length2) + tmp2] = (gint16) 35;
#line 573 "../src/computer-reversi.vala"
		_tmp14_ = _vala_heuristic;
#line 573 "../src/computer-reversi.vala"
		_tmp14__length1 = _vala_heuristic_length1;
#line 573 "../src/computer-reversi.vala"
		_tmp14__length2 = _vala_heuristic_length2;
#line 573 "../src/computer-reversi.vala"
		_tmp14_[(1 * _tmp14__length2) + 0] = (gint16) 35;
#line 574 "../src/computer-reversi.vala"
		_tmp15_ = _vala_heuristic;
#line 574 "../src/computer-reversi.vala"
		_tmp15__length1 = _vala_heuristic_length1;
#line 574 "../src/computer-reversi.vala"
		_tmp15__length2 = _vala_heuristic_length2;
#line 574 "../src/computer-reversi.vala"
		_tmp15_[(1 * _tmp15__length2) + tmp1] = (gint16) 35;
#line 575 "../src/computer-reversi.vala"
		_tmp16_ = _vala_heuristic;
#line 575 "../src/computer-reversi.vala"
		_tmp16__length1 = _vala_heuristic_length1;
#line 575 "../src/computer-reversi.vala"
		_tmp16__length2 = _vala_heuristic_length2;
#line 575 "../src/computer-reversi.vala"
		_tmp16_[(tmp2 * _tmp16__length2) + 0] = (gint16) 35;
#line 576 "../src/computer-reversi.vala"
		_tmp17_ = _vala_heuristic;
#line 576 "../src/computer-reversi.vala"
		_tmp17__length1 = _vala_heuristic_length1;
#line 576 "../src/computer-reversi.vala"
		_tmp17__length2 = _vala_heuristic_length2;
#line 576 "../src/computer-reversi.vala"
		_tmp17_[(tmp2 * _tmp17__length2) + tmp1] = (gint16) 35;
#line 579 "../src/computer-reversi.vala"
		_tmp18_ = _vala_heuristic;
#line 579 "../src/computer-reversi.vala"
		_tmp18__length1 = _vala_heuristic_length1;
#line 579 "../src/computer-reversi.vala"
		_tmp18__length2 = _vala_heuristic_length2;
#line 579 "../src/computer-reversi.vala"
		_tmp18_[(1 * _tmp18__length2) + 1] = (gint16) 15;
#line 580 "../src/computer-reversi.vala"
		_tmp19_ = _vala_heuristic;
#line 580 "../src/computer-reversi.vala"
		_tmp19__length1 = _vala_heuristic_length1;
#line 580 "../src/computer-reversi.vala"
		_tmp19__length2 = _vala_heuristic_length2;
#line 580 "../src/computer-reversi.vala"
		_tmp19_[(1 * _tmp19__length2) + tmp2] = (gint16) 15;
#line 581 "../src/computer-reversi.vala"
		_tmp20_ = _vala_heuristic;
#line 581 "../src/computer-reversi.vala"
		_tmp20__length1 = _vala_heuristic_length1;
#line 581 "../src/computer-reversi.vala"
		_tmp20__length2 = _vala_heuristic_length2;
#line 581 "../src/computer-reversi.vala"
		_tmp20_[(tmp2 * _tmp20__length2) + tmp2] = (gint16) 15;
#line 582 "../src/computer-reversi.vala"
		_tmp21_ = _vala_heuristic;
#line 582 "../src/computer-reversi.vala"
		_tmp21__length1 = _vala_heuristic_length1;
#line 582 "../src/computer-reversi.vala"
		_tmp21__length2 = _vala_heuristic_length2;
#line 582 "../src/computer-reversi.vala"
		_tmp21_[(tmp2 * _tmp21__length2) + 1] = (gint16) 15;
#line 4195 "computer-reversi.c"
	}
#line 550 "../src/computer-reversi.vala"
	if (heuristic) {
#line 550 "../src/computer-reversi.vala"
		*heuristic = _vala_heuristic;
#line 4201 "computer-reversi.c"
	} else {
#line 550 "../src/computer-reversi.vala"
		_vala_heuristic = (g_free (_vala_heuristic), NULL);
#line 4205 "computer-reversi.c"
	}
#line 550 "../src/computer-reversi.vala"
	if (heuristic_length1) {
#line 550 "../src/computer-reversi.vala"
		*heuristic_length1 = _vala_heuristic_length1;
#line 4211 "computer-reversi.c"
	}
#line 550 "../src/computer-reversi.vala"
	if (heuristic_length2) {
#line 550 "../src/computer-reversi.vala"
		*heuristic_length2 = _vala_heuristic_length2;
#line 4217 "computer-reversi.c"
	}
}

static gboolean
computer_reversi_hard_get_even_depth (ComputerReversiHard* self)
{
	gboolean result;
#line 355 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 355 "../src/computer-reversi.vala"
	result = self->priv->_even_depth;
#line 355 "../src/computer-reversi.vala"
	return result;
#line 4231 "computer-reversi.c"
}

static void
computer_reversi_hard_set_even_depth (ComputerReversiHard* self,
                                      gboolean value)
{
#line 355 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 355 "../src/computer-reversi.vala"
	self->priv->_even_depth = value;
#line 4242 "computer-reversi.c"
}

static gboolean
computer_reversi_hard_get_fixed_heuristic (ComputerReversiHard* self)
{
	gboolean result;
#line 356 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 356 "../src/computer-reversi.vala"
	result = self->priv->_fixed_heuristic;
#line 356 "../src/computer-reversi.vala"
	return result;
#line 4255 "computer-reversi.c"
}

static void
computer_reversi_hard_set_fixed_heuristic (ComputerReversiHard* self,
                                           gboolean value)
{
#line 356 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/computer-reversi.vala"
	self->priv->_fixed_heuristic = value;
#line 4266 "computer-reversi.c"
}

static GObject *
computer_reversi_hard_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ComputerReversiHard * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gboolean _tmp2_;
	gint16* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
#line 358 "../src/computer-reversi.vala"
	parent_class = G_OBJECT_CLASS (computer_reversi_hard_parent_class);
#line 358 "../src/computer-reversi.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 358 "../src/computer-reversi.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPUTER_REVERSI_HARD, ComputerReversiHard);
#line 360 "../src/computer-reversi.vala"
	_tmp0_ = computer_reversi_get_size ((ComputerReversi*) self);
#line 360 "../src/computer-reversi.vala"
	_tmp1_ = _tmp0_;
#line 360 "../src/computer-reversi.vala"
	_tmp2_ = self->priv->_fixed_heuristic;
#line 360 "../src/computer-reversi.vala"
	computer_reversi_hard_init_heuristic (_tmp1_, _tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 360 "../src/computer-reversi.vala"
	self->priv->heuristic = (g_free (self->priv->heuristic), NULL);
#line 360 "../src/computer-reversi.vala"
	self->priv->heuristic = _tmp3_;
#line 360 "../src/computer-reversi.vala"
	self->priv->heuristic_length1 = _tmp4_;
#line 360 "../src/computer-reversi.vala"
	self->priv->heuristic_length2 = _tmp5_;
#line 358 "../src/computer-reversi.vala"
	return obj;
#line 4307 "computer-reversi.c"
}

static void
computer_reversi_hard_class_init (ComputerReversiHardClass * klass,
                                  gpointer klass_data)
{
#line 353 "../src/computer-reversi.vala"
	computer_reversi_hard_parent_class = g_type_class_peek_parent (klass);
#line 353 "../src/computer-reversi.vala"
	g_type_class_adjust_private_offset (klass, &ComputerReversiHard_private_offset);
#line 353 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->sort_moves = (void (*) (ComputerReversi*, GSList**)) computer_reversi_hard_real_sort_moves;
#line 353 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->end_of_game = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reversi_hard_real_end_of_game;
#line 353 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->calculate_heuristic = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reversi_hard_real_calculate_heuristic;
#line 353 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_computer_reversi_hard_get_property;
#line 353 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_computer_reversi_hard_set_property;
#line 353 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->constructor = computer_reversi_hard_constructor;
#line 353 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->finalize = computer_reversi_hard_finalize;
#line 353 "../src/computer-reversi.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPUTER_REVERSI_HARD_EVEN_DEPTH_PROPERTY, computer_reversi_hard_properties[COMPUTER_REVERSI_HARD_EVEN_DEPTH_PROPERTY] = g_param_spec_boolean ("even-depth", "even-depth", "even-depth", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 353 "../src/computer-reversi.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPUTER_REVERSI_HARD_FIXED_HEURISTIC_PROPERTY, computer_reversi_hard_properties[COMPUTER_REVERSI_HARD_FIXED_HEURISTIC_PROPERTY] = g_param_spec_boolean ("fixed-heuristic", "fixed-heuristic", "fixed-heuristic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 4336 "computer-reversi.c"
}

static void
computer_reversi_hard_instance_init (ComputerReversiHard * self,
                                     gpointer klass)
{
#line 353 "../src/computer-reversi.vala"
	self->priv = computer_reversi_hard_get_instance_private (self);
#line 4345 "computer-reversi.c"
}

static void
computer_reversi_hard_finalize (GObject * obj)
{
	ComputerReversiHard * self;
#line 353 "../src/computer-reversi.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPUTER_REVERSI_HARD, ComputerReversiHard);
#line 522 "../src/computer-reversi.vala"
	self->priv->heuristic = (g_free (self->priv->heuristic), NULL);
#line 353 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (computer_reversi_hard_parent_class)->finalize (obj);
#line 4358 "computer-reversi.c"
}

static GType
computer_reversi_hard_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComputerReversiHardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) computer_reversi_hard_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComputerReversiHard), 0, (GInstanceInitFunc) computer_reversi_hard_instance_init, NULL };
	GType computer_reversi_hard_type_id;
	computer_reversi_hard_type_id = g_type_register_static (TYPE_COMPUTER_REVERSI, "ComputerReversiHard", &g_define_type_info, 0);
	ComputerReversiHard_private_offset = g_type_add_instance_private (computer_reversi_hard_type_id, sizeof (ComputerReversiHardPrivate));
	return computer_reversi_hard_type_id;
}

GType
computer_reversi_hard_get_type (void)
{
	static volatile gsize computer_reversi_hard_type_id__once = 0;
	if (g_once_init_enter (&computer_reversi_hard_type_id__once)) {
		GType computer_reversi_hard_type_id;
		computer_reversi_hard_type_id = computer_reversi_hard_get_type_once ();
		g_once_init_leave (&computer_reversi_hard_type_id__once, computer_reversi_hard_type_id);
	}
	return computer_reversi_hard_type_id__once;
}

static void
_vala_computer_reversi_hard_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	ComputerReversiHard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_REVERSI_HARD, ComputerReversiHard);
#line 353 "../src/computer-reversi.vala"
	switch (property_id) {
#line 353 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_HARD_EVEN_DEPTH_PROPERTY:
#line 353 "../src/computer-reversi.vala"
		g_value_set_boolean (value, computer_reversi_hard_get_even_depth (self));
#line 353 "../src/computer-reversi.vala"
		break;
#line 353 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_HARD_FIXED_HEURISTIC_PROPERTY:
#line 353 "../src/computer-reversi.vala"
		g_value_set_boolean (value, computer_reversi_hard_get_fixed_heuristic (self));
#line 353 "../src/computer-reversi.vala"
		break;
#line 4405 "computer-reversi.c"
		default:
#line 353 "../src/computer-reversi.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 353 "../src/computer-reversi.vala"
		break;
#line 4411 "computer-reversi.c"
	}
}

static void
_vala_computer_reversi_hard_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	ComputerReversiHard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_REVERSI_HARD, ComputerReversiHard);
#line 353 "../src/computer-reversi.vala"
	switch (property_id) {
#line 353 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_HARD_EVEN_DEPTH_PROPERTY:
#line 353 "../src/computer-reversi.vala"
		computer_reversi_hard_set_even_depth (self, g_value_get_boolean (value));
#line 353 "../src/computer-reversi.vala"
		break;
#line 353 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_HARD_FIXED_HEURISTIC_PROPERTY:
#line 353 "../src/computer-reversi.vala"
		computer_reversi_hard_set_fixed_heuristic (self, g_value_get_boolean (value));
#line 353 "../src/computer-reversi.vala"
		break;
#line 4437 "computer-reversi.c"
		default:
#line 353 "../src/computer-reversi.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 353 "../src/computer-reversi.vala"
		break;
#line 4443 "computer-reversi.c"
	}
}

static inline gpointer
computer_reversi_get_instance_private (ComputerReversi* self)
{
	return G_STRUCT_MEMBER_P (self, ComputerReversi_private_offset);
}

static void
computer_reversi_real_complete_move (ComputerPlayer* base,
                                     PossibleMove* chosen_move)
{
	ComputerReversi * self;
	Game* _tmp0_;
	PossibleMove _tmp1_;
	PossibleMove _tmp2_;
#line 613 "../src/computer-reversi.vala"
	self = (ComputerReversi*) base;
#line 613 "../src/computer-reversi.vala"
	g_return_if_fail (chosen_move != NULL);
#line 615 "../src/computer-reversi.vala"
	_tmp0_ = self->priv->_game;
#line 615 "../src/computer-reversi.vala"
	_tmp1_ = *chosen_move;
#line 615 "../src/computer-reversi.vala"
	_tmp2_ = *chosen_move;
#line 615 "../src/computer-reversi.vala"
	if (!game_place_tile (_tmp0_, _tmp1_.x, _tmp2_.y)) {
#line 4473 "computer-reversi.c"
		PossibleMove _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		PossibleMove _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		Game* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		PossibleMove random_move = {0};
		Game* _tmp14_;
		GameStateObject* _tmp15_;
		GameStateObject* _tmp16_;
		GameStateStruct _tmp17_ = {0};
		GameStateStruct _tmp18_;
		PossibleMove _tmp19_ = {0};
		Game* _tmp20_;
		PossibleMove _tmp21_;
		PossibleMove _tmp22_;
#line 617 "../src/computer-reversi.vala"
		_tmp3_ = *chosen_move;
#line 617 "../src/computer-reversi.vala"
		_tmp4_ = g_strdup_printf ("%hhu", _tmp3_.x);
#line 617 "../src/computer-reversi.vala"
		_tmp5_ = _tmp4_;
#line 617 "../src/computer-reversi.vala"
		_tmp6_ = *chosen_move;
#line 617 "../src/computer-reversi.vala"
		_tmp7_ = g_strdup_printf ("%hhu", _tmp6_.y);
#line 617 "../src/computer-reversi.vala"
		_tmp8_ = _tmp7_;
#line 617 "../src/computer-reversi.vala"
		_tmp9_ = self->priv->_game;
#line 617 "../src/computer-reversi.vala"
		_tmp10_ = game_to_string (_tmp9_);
#line 617 "../src/computer-reversi.vala"
		_tmp11_ = _tmp10_;
#line 617 "../src/computer-reversi.vala"
		_tmp12_ = g_strconcat ("Computer chose an invalid move: ", _tmp5_, ",", _tmp8_, "\n", _tmp11_, NULL);
#line 617 "../src/computer-reversi.vala"
		_tmp13_ = _tmp12_;
#line 617 "../src/computer-reversi.vala"
		g_critical ("computer-reversi.vala:617: %s", _tmp13_);
#line 617 "../src/computer-reversi.vala"
		_g_free0 (_tmp13_);
#line 617 "../src/computer-reversi.vala"
		_g_free0 (_tmp11_);
#line 617 "../src/computer-reversi.vala"
		_g_free0 (_tmp8_);
#line 617 "../src/computer-reversi.vala"
		_g_free0 (_tmp5_);
#line 621 "../src/computer-reversi.vala"
		_tmp14_ = self->priv->_game;
#line 621 "../src/computer-reversi.vala"
		_tmp15_ = game_get_current_state (_tmp14_);
#line 621 "../src/computer-reversi.vala"
		_tmp16_ = _tmp15_;
#line 621 "../src/computer-reversi.vala"
		game_state_object_get_game_state_struct (_tmp16_, &_tmp17_);
#line 621 "../src/computer-reversi.vala"
		_tmp18_ = _tmp17_;
#line 621 "../src/computer-reversi.vala"
		computer_reversi_random_select (&_tmp18_, &_tmp19_);
#line 621 "../src/computer-reversi.vala"
		random_move = _tmp19_;
#line 622 "../src/computer-reversi.vala"
		_tmp20_ = self->priv->_game;
#line 622 "../src/computer-reversi.vala"
		_tmp21_ = random_move;
#line 622 "../src/computer-reversi.vala"
		_tmp22_ = random_move;
#line 622 "../src/computer-reversi.vala"
		if (!game_place_tile (_tmp20_, _tmp21_.x, _tmp22_.y)) {
#line 4549 "computer-reversi.c"
			PossibleMove _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			PossibleMove _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			Game* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
#line 624 "../src/computer-reversi.vala"
			_tmp23_ = random_move;
#line 624 "../src/computer-reversi.vala"
			_tmp24_ = g_strdup_printf ("%hhu", _tmp23_.x);
#line 624 "../src/computer-reversi.vala"
			_tmp25_ = _tmp24_;
#line 624 "../src/computer-reversi.vala"
			_tmp26_ = random_move;
#line 624 "../src/computer-reversi.vala"
			_tmp27_ = g_strdup_printf ("%hhu", _tmp26_.y);
#line 624 "../src/computer-reversi.vala"
			_tmp28_ = _tmp27_;
#line 624 "../src/computer-reversi.vala"
			_tmp29_ = self->priv->_game;
#line 624 "../src/computer-reversi.vala"
			_tmp30_ = game_to_string (_tmp29_);
#line 624 "../src/computer-reversi.vala"
			_tmp31_ = _tmp30_;
#line 624 "../src/computer-reversi.vala"
			_tmp32_ = g_strconcat ("Computer chose an invalid move for the second time: ", _tmp25_, ",", _tmp28_, "\n", _tmp31_, NULL);
#line 624 "../src/computer-reversi.vala"
			_tmp33_ = _tmp32_;
#line 624 "../src/computer-reversi.vala"
			g_critical ("computer-reversi.vala:624: %s", _tmp33_);
#line 624 "../src/computer-reversi.vala"
			_g_free0 (_tmp33_);
#line 624 "../src/computer-reversi.vala"
			_g_free0 (_tmp31_);
#line 624 "../src/computer-reversi.vala"
			_g_free0 (_tmp28_);
#line 624 "../src/computer-reversi.vala"
			_g_free0 (_tmp25_);
#line 625 "../src/computer-reversi.vala"
			g_assert_not_reached ();
#line 4595 "computer-reversi.c"
		}
	}
}

static void
_possible_move_free0_ (gpointer var)
{
#line 633 "../src/computer-reversi.vala"
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
#line 4605 "computer-reversi.c"
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
#line 633 "../src/computer-reversi.vala"
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
#line 4613 "computer-reversi.c"
}

static void
computer_reversi_random_select (GameStateStruct* g,
                                PossibleMove* random_move)
{
	PossibleMove _vala_random_move = {0};
	GSList* moves = NULL;
	GSList* _tmp0_ = NULL;
	gconstpointer _tmp1_;
#line 630 "../src/computer-reversi.vala"
	g_return_if_fail (g != NULL);
#line 633 "../src/computer-reversi.vala"
	game_state_struct_get_possible_moves (g, &_tmp0_);
#line 633 "../src/computer-reversi.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 633 "../src/computer-reversi.vala"
	moves = _tmp0_;
#line 646 "../src/computer-reversi.vala"
	_tmp1_ = g_slist_nth_data (moves, (guint) g_random_int_range ((gint32) 0, (gint32) g_slist_length (moves)));
#line 646 "../src/computer-reversi.vala"
	_vala_random_move = (PossibleMove) (*((PossibleMove*) _tmp1_));
#line 630 "../src/computer-reversi.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 630 "../src/computer-reversi.vala"
	if (random_move) {
#line 630 "../src/computer-reversi.vala"
		*random_move = _vala_random_move;
#line 4642 "computer-reversi.c"
	}
}

static void
computer_reversi_real_run_search (ComputerPlayer* base,
                                  PossibleMove* best_move)
{
	ComputerReversi * self;
	PossibleMove _vala_best_move = {0};
	GameStateStruct g = {0};
	Game* _tmp0_;
	GameStateObject* _tmp1_;
	GameStateObject* _tmp2_;
	GameStateStruct _tmp3_ = {0};
	GameStateStruct _tmp4_;
	GameStateStruct _tmp5_;
	GameStateStruct _tmp6_ = {0};
	GameStateStruct _tmp7_;
	guint8 _tmp8_;
	gint16 a = 0;
	GSList* moves = NULL;
	Game* _tmp26_;
	GSList* _tmp27_ = NULL;
	GSList* _tmp28_;
#line 653 "../src/computer-reversi.vala"
	self = (ComputerReversi*) base;
#line 659 "../src/computer-reversi.vala"
	_tmp0_ = self->priv->_game;
#line 659 "../src/computer-reversi.vala"
	_tmp1_ = game_get_current_state (_tmp0_);
#line 659 "../src/computer-reversi.vala"
	_tmp2_ = _tmp1_;
#line 659 "../src/computer-reversi.vala"
	game_state_object_get_game_state_struct (_tmp2_, &_tmp3_);
#line 659 "../src/computer-reversi.vala"
	_tmp4_ = _tmp3_;
#line 659 "../src/computer-reversi.vala"
	_tmp5_ = _tmp4_;
#line 659 "../src/computer-reversi.vala"
	game_state_struct_copy (&_tmp5_, &_tmp6_);
#line 659 "../src/computer-reversi.vala"
	g = _tmp6_;
#line 662 "../src/computer-reversi.vala"
	_tmp7_ = g;
#line 662 "../src/computer-reversi.vala"
	_tmp8_ = self->priv->_move_randomly;
#line 662 "../src/computer-reversi.vala"
	if (_tmp7_.n_tiles < _tmp8_) {
#line 4691 "computer-reversi.c"
		gboolean _tmp9_ = FALSE;
		guint8 _tmp10_;
#line 664 "../src/computer-reversi.vala"
		_tmp10_ = self->priv->_size;
#line 664 "../src/computer-reversi.vala"
		if (((gint) _tmp10_) != 8) {
#line 664 "../src/computer-reversi.vala"
			_tmp9_ = TRUE;
#line 4700 "computer-reversi.c"
		} else {
			Game* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 664 "../src/computer-reversi.vala"
			_tmp11_ = self->priv->_game;
#line 664 "../src/computer-reversi.vala"
			_tmp12_ = game_get_reverse (_tmp11_);
#line 664 "../src/computer-reversi.vala"
			_tmp13_ = _tmp12_;
#line 664 "../src/computer-reversi.vala"
			_tmp9_ = _tmp13_;
#line 4713 "computer-reversi.c"
		}
#line 664 "../src/computer-reversi.vala"
		if (_tmp9_) {
#line 4717 "computer-reversi.c"
			GameStateStruct _tmp14_;
			PossibleMove _tmp15_ = {0};
#line 665 "../src/computer-reversi.vala"
			_tmp14_ = g;
#line 665 "../src/computer-reversi.vala"
			computer_reversi_random_select (&_tmp14_, &_tmp15_);
#line 665 "../src/computer-reversi.vala"
			_vala_best_move = _tmp15_;
#line 4726 "computer-reversi.c"
		} else {
			{
				gboolean _tmp16_ = FALSE;
#line 668 "../src/computer-reversi.vala"
				_tmp16_ = TRUE;
#line 668 "../src/computer-reversi.vala"
				while (TRUE) {
#line 4734 "computer-reversi.c"
					GameStateStruct _tmp24_;
					PossibleMove _tmp25_ = {0};
#line 668 "../src/computer-reversi.vala"
					if (!_tmp16_) {
#line 4739 "computer-reversi.c"
						gboolean _tmp17_ = FALSE;
						gboolean _tmp18_ = FALSE;
						PossibleMove _tmp19_;
#line 672 "../src/computer-reversi.vala"
						_tmp19_ = _vala_best_move;
#line 672 "../src/computer-reversi.vala"
						if (((gint) _tmp19_.x) == 1) {
#line 672 "../src/computer-reversi.vala"
							_tmp18_ = TRUE;
#line 4749 "computer-reversi.c"
						} else {
							PossibleMove _tmp20_;
#line 672 "../src/computer-reversi.vala"
							_tmp20_ = _vala_best_move;
#line 672 "../src/computer-reversi.vala"
							_tmp18_ = ((gint) _tmp20_.x) == 6;
#line 4756 "computer-reversi.c"
						}
#line 672 "../src/computer-reversi.vala"
						if (_tmp18_) {
#line 4760 "computer-reversi.c"
							gboolean _tmp21_ = FALSE;
							PossibleMove _tmp22_;
#line 673 "../src/computer-reversi.vala"
							_tmp22_ = _vala_best_move;
#line 673 "../src/computer-reversi.vala"
							if (((gint) _tmp22_.y) == 1) {
#line 673 "../src/computer-reversi.vala"
								_tmp21_ = TRUE;
#line 4769 "computer-reversi.c"
							} else {
								PossibleMove _tmp23_;
#line 673 "../src/computer-reversi.vala"
								_tmp23_ = _vala_best_move;
#line 673 "../src/computer-reversi.vala"
								_tmp21_ = ((gint) _tmp23_.y) == 6;
#line 4776 "computer-reversi.c"
							}
#line 673 "../src/computer-reversi.vala"
							_tmp17_ = _tmp21_;
#line 4780 "computer-reversi.c"
						} else {
#line 672 "../src/computer-reversi.vala"
							_tmp17_ = FALSE;
#line 4784 "computer-reversi.c"
						}
#line 672 "../src/computer-reversi.vala"
						if (!_tmp17_) {
#line 672 "../src/computer-reversi.vala"
							break;
#line 4790 "computer-reversi.c"
						}
					}
#line 668 "../src/computer-reversi.vala"
					_tmp16_ = FALSE;
#line 670 "../src/computer-reversi.vala"
					_tmp24_ = g;
#line 670 "../src/computer-reversi.vala"
					computer_reversi_random_select (&_tmp24_, &_tmp25_);
#line 670 "../src/computer-reversi.vala"
					_vala_best_move = _tmp25_;
#line 4801 "computer-reversi.c"
				}
			}
		}
#line 675 "../src/computer-reversi.vala"
		game_state_struct_destroy (&g);
#line 675 "../src/computer-reversi.vala"
		if (best_move) {
#line 675 "../src/computer-reversi.vala"
			*best_move = _vala_best_move;
#line 4811 "computer-reversi.c"
		}
#line 675 "../src/computer-reversi.vala"
		return;
#line 4815 "computer-reversi.c"
	}
#line 678 "../src/computer-reversi.vala"
	possible_move_init (&_vala_best_move, (guint8) 0, (guint8) 0);
#line 681 "../src/computer-reversi.vala"
	a = COMPUTER_REVERSI_LESS_THAN_NEGATIVE_INFINITY;
#line 684 "../src/computer-reversi.vala"
	_tmp26_ = self->priv->_game;
#line 684 "../src/computer-reversi.vala"
	game_get_possible_moves (_tmp26_, &_tmp27_);
#line 684 "../src/computer-reversi.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 684 "../src/computer-reversi.vala"
	moves = _tmp27_;
#line 685 "../src/computer-reversi.vala"
	computer_reversi_sort_moves (self, &moves);
#line 688 "../src/computer-reversi.vala"
	_tmp28_ = moves;
#line 4833 "computer-reversi.c"
	{
		GSList* move_collection = NULL;
		GSList* move_it = NULL;
#line 688 "../src/computer-reversi.vala"
		move_collection = _tmp28_;
#line 688 "../src/computer-reversi.vala"
		for (move_it = move_collection; move_it != NULL; move_it = move_it->next) {
#line 4841 "computer-reversi.c"
			PossibleMove* move = NULL;
#line 688 "../src/computer-reversi.vala"
			move = (PossibleMove*) move_it->data;
#line 4845 "computer-reversi.c"
			{
				GameStateStruct _g = {0};
				GameStateStruct _tmp29_;
				PossibleMove* _tmp30_;
				PossibleMove _tmp31_;
				gint16 a_new = 0;
				GameStateStruct _tmp32_;
				guint8 _tmp33_;
				gboolean _tmp35_;
				gboolean _tmp36_;
#line 693 "../src/computer-reversi.vala"
				_tmp29_ = g;
#line 693 "../src/computer-reversi.vala"
				_tmp30_ = move;
#line 693 "../src/computer-reversi.vala"
				_tmp31_ = (PossibleMove) (*_tmp30_);
#line 693 "../src/computer-reversi.vala"
				game_state_struct_init_copy_and_move (&_g, &_tmp29_, &_tmp31_);
#line 695 "../src/computer-reversi.vala"
				_tmp32_ = _g;
#line 695 "../src/computer-reversi.vala"
				_tmp33_ = self->priv->_initial_depth;
#line 695 "../src/computer-reversi.vala"
				a_new = (gint16) (-1 * computer_reversi_search (self, &_tmp32_, _tmp33_, COMPUTER_REVERSI_NEGATIVE_INFINITY, -a));
#line 696 "../src/computer-reversi.vala"
				if (a_new > a) {
#line 4872 "computer-reversi.c"
					PossibleMove* _tmp34_;
#line 698 "../src/computer-reversi.vala"
					a = a_new;
#line 699 "../src/computer-reversi.vala"
					_tmp34_ = move;
#line 699 "../src/computer-reversi.vala"
					_vala_best_move = (PossibleMove) (*_tmp34_);
#line 4880 "computer-reversi.c"
				}
#line 704 "../src/computer-reversi.vala"
				_tmp35_ = computer_player_get_move_pending ((ComputerPlayer*) self);
#line 704 "../src/computer-reversi.vala"
				_tmp36_ = _tmp35_;
#line 704 "../src/computer-reversi.vala"
				if (!_tmp36_) {
#line 705 "../src/computer-reversi.vala"
					game_state_struct_destroy (&_g);
#line 705 "../src/computer-reversi.vala"
					(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 705 "../src/computer-reversi.vala"
					game_state_struct_destroy (&g);
#line 705 "../src/computer-reversi.vala"
					if (best_move) {
#line 705 "../src/computer-reversi.vala"
						*best_move = _vala_best_move;
#line 4898 "computer-reversi.c"
					}
#line 705 "../src/computer-reversi.vala"
					return;
#line 4902 "computer-reversi.c"
				}
#line 688 "../src/computer-reversi.vala"
				game_state_struct_destroy (&_g);
#line 4906 "computer-reversi.c"
			}
		}
	}
#line 653 "../src/computer-reversi.vala"
	(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 653 "../src/computer-reversi.vala"
	game_state_struct_destroy (&g);
#line 653 "../src/computer-reversi.vala"
	if (best_move) {
#line 653 "../src/computer-reversi.vala"
		*best_move = _vala_best_move;
#line 4918 "computer-reversi.c"
	}
}

static gint16
computer_reversi_search (ComputerReversi* self,
                         GameStateStruct* g,
                         guint8 depth,
                         gint16 a,
                         gint16 b)
{
	GameStateStruct _tmp0_;
	GameStateStruct _tmp3_;
	gint16 result;
#line 709 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 709 "../src/computer-reversi.vala"
	g_return_val_if_fail (g != NULL, 0);
#line 713 "../src/computer-reversi.vala"
	_tmp0_ = *g;
#line 713 "../src/computer-reversi.vala"
	if (_tmp0_.is_complete) {
#line 4940 "computer-reversi.c"
		GameStateStruct _tmp1_;
#line 714 "../src/computer-reversi.vala"
		_tmp1_ = *g;
#line 714 "../src/computer-reversi.vala"
		result = computer_reversi_end_of_game (self, &_tmp1_);
#line 714 "../src/computer-reversi.vala"
		return result;
#line 4948 "computer-reversi.c"
	}
#line 717 "../src/computer-reversi.vala"
	if (((gint) depth) == 0) {
#line 4952 "computer-reversi.c"
		GameStateStruct _tmp2_;
#line 718 "../src/computer-reversi.vala"
		_tmp2_ = *g;
#line 718 "../src/computer-reversi.vala"
		result = computer_reversi_calculate_heuristic (self, &_tmp2_);
#line 718 "../src/computer-reversi.vala"
		return result;
#line 4960 "computer-reversi.c"
	}
#line 720 "../src/computer-reversi.vala"
	_tmp3_ = *g;
#line 720 "../src/computer-reversi.vala"
	if (_tmp3_.current_player_can_move) {
#line 4966 "computer-reversi.c"
		GSList* moves = NULL;
		GSList* _tmp4_ = NULL;
		GSList* _tmp5_;
#line 723 "../src/computer-reversi.vala"
		game_state_struct_get_possible_moves (g, &_tmp4_);
#line 723 "../src/computer-reversi.vala"
		(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 723 "../src/computer-reversi.vala"
		moves = _tmp4_;
#line 724 "../src/computer-reversi.vala"
		computer_reversi_sort_moves (self, &moves);
#line 727 "../src/computer-reversi.vala"
		_tmp5_ = moves;
#line 4980 "computer-reversi.c"
		{
			GSList* move_collection = NULL;
			GSList* move_it = NULL;
#line 727 "../src/computer-reversi.vala"
			move_collection = _tmp5_;
#line 727 "../src/computer-reversi.vala"
			for (move_it = move_collection; move_it != NULL; move_it = move_it->next) {
#line 4988 "computer-reversi.c"
				PossibleMove* move = NULL;
#line 727 "../src/computer-reversi.vala"
				move = (PossibleMove*) move_it->data;
#line 4992 "computer-reversi.c"
				{
					GameStateStruct _g = {0};
					GameStateStruct _tmp6_;
					PossibleMove* _tmp7_;
					PossibleMove _tmp8_;
					gint16 a_new = 0;
					GameStateStruct _tmp9_;
#line 732 "../src/computer-reversi.vala"
					_tmp6_ = *g;
#line 732 "../src/computer-reversi.vala"
					_tmp7_ = move;
#line 732 "../src/computer-reversi.vala"
					_tmp8_ = (PossibleMove) (*_tmp7_);
#line 732 "../src/computer-reversi.vala"
					game_state_struct_init_copy_and_move (&_g, &_tmp6_, &_tmp8_);
#line 734 "../src/computer-reversi.vala"
					_tmp9_ = _g;
#line 734 "../src/computer-reversi.vala"
					a_new = (gint16) (-1 * computer_reversi_search (self, &_tmp9_, (guint8) (depth - 1), -b, -a));
#line 735 "../src/computer-reversi.vala"
					if (a_new > a) {
#line 736 "../src/computer-reversi.vala"
						a = a_new;
#line 5016 "computer-reversi.c"
					}
#line 739 "../src/computer-reversi.vala"
					if (b <= a) {
#line 740 "../src/computer-reversi.vala"
						game_state_struct_destroy (&_g);
#line 740 "../src/computer-reversi.vala"
						break;
#line 5024 "computer-reversi.c"
					}
#line 727 "../src/computer-reversi.vala"
					game_state_struct_destroy (&_g);
#line 5028 "computer-reversi.c"
				}
			}
		}
#line 720 "../src/computer-reversi.vala"
		(moves == NULL) ? NULL : (moves = (_g_slist_free__possible_move_free0_ (moves), NULL));
#line 5034 "computer-reversi.c"
	} else {
		GameStateStruct _g = {0};
		GameStateStruct _tmp10_;
		gint16 a_new = 0;
		GameStateStruct _tmp11_;
#line 745 "../src/computer-reversi.vala"
		_tmp10_ = *g;
#line 745 "../src/computer-reversi.vala"
		game_state_struct_init_copy_and_pass (&_g, &_tmp10_);
#line 747 "../src/computer-reversi.vala"
		_tmp11_ = _g;
#line 747 "../src/computer-reversi.vala"
		a_new = (gint16) (-1 * computer_reversi_search (self, &_tmp11_, (guint8) (depth - 1), -b, -a));
#line 748 "../src/computer-reversi.vala"
		if (a_new > a) {
#line 749 "../src/computer-reversi.vala"
			a = a_new;
#line 5052 "computer-reversi.c"
		}
#line 720 "../src/computer-reversi.vala"
		game_state_struct_destroy (&_g);
#line 5056 "computer-reversi.c"
	}
#line 752 "../src/computer-reversi.vala"
	result = a;
#line 752 "../src/computer-reversi.vala"
	return result;
#line 5062 "computer-reversi.c"
}

static gint16
computer_reversi_real_calculate_heuristic (ComputerReversi* self,
                                           GameStateStruct* g)
{
	gint16 _tmp0_ = 0;
#line 755 "../src/computer-reversi.vala"
	g_critical ("Type `%s' does not implement abstract method `computer_reversi_calculate_heuristic'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 755 "../src/computer-reversi.vala"
	return _tmp0_;
#line 5074 "computer-reversi.c"
}

gint16
computer_reversi_calculate_heuristic (ComputerReversi* self,
                                      GameStateStruct* g)
{
	ComputerReversiClass* _klass_;
#line 755 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 755 "../src/computer-reversi.vala"
	_klass_ = COMPUTER_REVERSI_GET_CLASS (self);
#line 755 "../src/computer-reversi.vala"
	if (_klass_->calculate_heuristic) {
#line 755 "../src/computer-reversi.vala"
		return _klass_->calculate_heuristic (self, g);
#line 5090 "computer-reversi.c"
	}
#line 755 "../src/computer-reversi.vala"
	return -1;
#line 5094 "computer-reversi.c"
}

static gint16
computer_reversi_real_end_of_game (ComputerReversi* self,
                                   GameStateStruct* g)
{
	gint16 _tmp0_ = 0;
#line 756 "../src/computer-reversi.vala"
	g_critical ("Type `%s' does not implement abstract method `computer_reversi_end_of_game'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 756 "../src/computer-reversi.vala"
	return _tmp0_;
#line 5106 "computer-reversi.c"
}

gint16
computer_reversi_end_of_game (ComputerReversi* self,
                              GameStateStruct* g)
{
	ComputerReversiClass* _klass_;
#line 756 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 756 "../src/computer-reversi.vala"
	_klass_ = COMPUTER_REVERSI_GET_CLASS (self);
#line 756 "../src/computer-reversi.vala"
	if (_klass_->end_of_game) {
#line 756 "../src/computer-reversi.vala"
		return _klass_->end_of_game (self, g);
#line 5122 "computer-reversi.c"
	}
#line 756 "../src/computer-reversi.vala"
	return -1;
#line 5126 "computer-reversi.c"
}

static void
computer_reversi_real_sort_moves (ComputerReversi* self,
                                  GSList** moves)
{
#line 757 "../src/computer-reversi.vala"
	g_critical ("Type `%s' does not implement abstract method `computer_reversi_sort_moves'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 757 "../src/computer-reversi.vala"
	return;
#line 5137 "computer-reversi.c"
}

void
computer_reversi_sort_moves (ComputerReversi* self,
                             GSList** moves)
{
	ComputerReversiClass* _klass_;
#line 757 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 757 "../src/computer-reversi.vala"
	_klass_ = COMPUTER_REVERSI_GET_CLASS (self);
#line 757 "../src/computer-reversi.vala"
	if (_klass_->sort_moves) {
#line 757 "../src/computer-reversi.vala"
		_klass_->sort_moves (self, moves);
#line 5153 "computer-reversi.c"
	}
}

ComputerReversi*
computer_reversi_construct (GType object_type)
{
	ComputerReversi * self = NULL;
#line 587 "../src/computer-reversi.vala"
	self = (ComputerReversi*) computer_player_construct (object_type);
#line 587 "../src/computer-reversi.vala"
	return self;
#line 5165 "computer-reversi.c"
}

static Game*
computer_reversi_get_game (ComputerReversi* self)
{
	Game* result;
	Game* _tmp0_;
#line 589 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 589 "../src/computer-reversi.vala"
	_tmp0_ = self->priv->_game;
#line 589 "../src/computer-reversi.vala"
	result = _tmp0_;
#line 589 "../src/computer-reversi.vala"
	return result;
#line 5181 "computer-reversi.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 589 "../src/computer-reversi.vala"
	return self ? g_object_ref (self) : NULL;
#line 5189 "computer-reversi.c"
}

static void
computer_reversi_set_game (ComputerReversi* self,
                           Game* value)
{
	Game* _tmp0_;
#line 589 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 589 "../src/computer-reversi.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 589 "../src/computer-reversi.vala"
	_g_object_unref0 (self->priv->_game);
#line 589 "../src/computer-reversi.vala"
	self->priv->_game = _tmp0_;
#line 5205 "computer-reversi.c"
}

static guint8
computer_reversi_get_initial_depth (ComputerReversi* self)
{
	guint8 result;
#line 590 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 590 "../src/computer-reversi.vala"
	result = self->priv->_initial_depth;
#line 590 "../src/computer-reversi.vala"
	return result;
#line 5218 "computer-reversi.c"
}

static void
computer_reversi_set_initial_depth (ComputerReversi* self,
                                    guint8 value)
{
#line 590 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 590 "../src/computer-reversi.vala"
	self->priv->_initial_depth = value;
#line 5229 "computer-reversi.c"
}

guint8
computer_reversi_get_size (ComputerReversi* self)
{
	guint8 result;
#line 592 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 592 "../src/computer-reversi.vala"
	result = self->priv->_size;
#line 592 "../src/computer-reversi.vala"
	return result;
#line 5242 "computer-reversi.c"
}

static void
computer_reversi_set_size (ComputerReversi* self,
                           guint8 value)
{
#line 592 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 592 "../src/computer-reversi.vala"
	self->priv->_size = value;
#line 5253 "computer-reversi.c"
}

guint8
computer_reversi_get_move_randomly (ComputerReversi* self)
{
	guint8 result;
#line 593 "../src/computer-reversi.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 593 "../src/computer-reversi.vala"
	result = self->priv->_move_randomly;
#line 593 "../src/computer-reversi.vala"
	return result;
#line 5266 "computer-reversi.c"
}

static void
computer_reversi_set_move_randomly (ComputerReversi* self,
                                    guint8 value)
{
#line 593 "../src/computer-reversi.vala"
	g_return_if_fail (self != NULL);
#line 593 "../src/computer-reversi.vala"
	self->priv->_move_randomly = value;
#line 5277 "computer-reversi.c"
}

static GObject *
computer_reversi_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ComputerReversi * self;
	Game* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	gint _tmp3_ = 0;
	guint8 _tmp4_;
	Game* _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
	Game* _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	guint8* _tmp11_;
#line 602 "../src/computer-reversi.vala"
	parent_class = G_OBJECT_CLASS (computer_reversi_parent_class);
#line 602 "../src/computer-reversi.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 602 "../src/computer-reversi.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPUTER_REVERSI, ComputerReversi);
#line 604 "../src/computer-reversi.vala"
	_tmp0_ = self->priv->_game;
#line 604 "../src/computer-reversi.vala"
	_tmp1_ = game_get_size (_tmp0_);
#line 604 "../src/computer-reversi.vala"
	_tmp2_ = _tmp1_;
#line 604 "../src/computer-reversi.vala"
	computer_reversi_set_size (self, _tmp2_);
#line 605 "../src/computer-reversi.vala"
	_tmp4_ = self->priv->_size;
#line 605 "../src/computer-reversi.vala"
	if (((gint) _tmp4_) < 6) {
#line 605 "../src/computer-reversi.vala"
		_tmp3_ = 2;
#line 5320 "computer-reversi.c"
	} else {
#line 605 "../src/computer-reversi.vala"
		_tmp3_ = 4;
#line 5324 "computer-reversi.c"
	}
#line 605 "../src/computer-reversi.vala"
	_tmp5_ = self->priv->_game;
#line 605 "../src/computer-reversi.vala"
	_tmp6_ = game_get_initial_number_of_tiles (_tmp5_);
#line 605 "../src/computer-reversi.vala"
	_tmp7_ = _tmp6_;
#line 605 "../src/computer-reversi.vala"
	computer_reversi_set_move_randomly (self, (guint8) (_tmp7_ + _tmp3_));
#line 606 "../src/computer-reversi.vala"
	_tmp8_ = self->priv->_game;
#line 606 "../src/computer-reversi.vala"
	_tmp11_ = game_copy_neighbor_tiles (_tmp8_, &_tmp9_, &_tmp10_);
#line 606 "../src/computer-reversi.vala"
	self->neighbor_tiles = (g_free (self->neighbor_tiles), NULL);
#line 606 "../src/computer-reversi.vala"
	self->neighbor_tiles = _tmp11_;
#line 606 "../src/computer-reversi.vala"
	self->neighbor_tiles_length1 = _tmp9_;
#line 606 "../src/computer-reversi.vala"
	self->neighbor_tiles_length2 = _tmp10_;
#line 602 "../src/computer-reversi.vala"
	return obj;
#line 5348 "computer-reversi.c"
}

static void
computer_reversi_class_init (ComputerReversiClass * klass,
                             gpointer klass_data)
{
#line 587 "../src/computer-reversi.vala"
	computer_reversi_parent_class = g_type_class_peek_parent (klass);
#line 587 "../src/computer-reversi.vala"
	g_type_class_adjust_private_offset (klass, &ComputerReversi_private_offset);
#line 587 "../src/computer-reversi.vala"
	((ComputerPlayerClass *) klass)->complete_move = (void (*) (ComputerPlayer*, PossibleMove*)) computer_reversi_real_complete_move;
#line 587 "../src/computer-reversi.vala"
	((ComputerPlayerClass *) klass)->run_search = (void (*) (ComputerPlayer*, PossibleMove*)) computer_reversi_real_run_search;
#line 587 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->calculate_heuristic = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reversi_real_calculate_heuristic;
#line 587 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->end_of_game = (gint16 (*) (ComputerReversi*, GameStateStruct*)) computer_reversi_real_end_of_game;
#line 587 "../src/computer-reversi.vala"
	((ComputerReversiClass *) klass)->sort_moves = (void (*) (ComputerReversi*, GSList**)) computer_reversi_real_sort_moves;
#line 587 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_computer_reversi_get_property;
#line 587 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_computer_reversi_set_property;
#line 587 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->constructor = computer_reversi_constructor;
#line 587 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (klass)->finalize = computer_reversi_finalize;
#line 587 "../src/computer-reversi.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPUTER_REVERSI_GAME_PROPERTY, computer_reversi_properties[COMPUTER_REVERSI_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 587 "../src/computer-reversi.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPUTER_REVERSI_INITIAL_DEPTH_PROPERTY, computer_reversi_properties[COMPUTER_REVERSI_INITIAL_DEPTH_PROPERTY] = g_param_spec_uchar ("initial-depth", "initial-depth", "initial-depth", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 587 "../src/computer-reversi.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPUTER_REVERSI_SIZE_PROPERTY, computer_reversi_properties[COMPUTER_REVERSI_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 587 "../src/computer-reversi.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMPUTER_REVERSI_MOVE_RANDOMLY_PROPERTY, computer_reversi_properties[COMPUTER_REVERSI_MOVE_RANDOMLY_PROPERTY] = g_param_spec_uchar ("move-randomly", "move-randomly", "move-randomly", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 5385 "computer-reversi.c"
}

static void
computer_reversi_instance_init (ComputerReversi * self,
                                gpointer klass)
{
#line 587 "../src/computer-reversi.vala"
	self->priv = computer_reversi_get_instance_private (self);
#line 5394 "computer-reversi.c"
}

static void
computer_reversi_finalize (GObject * obj)
{
	ComputerReversi * self;
#line 587 "../src/computer-reversi.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPUTER_REVERSI, ComputerReversi);
#line 589 "../src/computer-reversi.vala"
	_g_object_unref0 (self->priv->_game);
#line 600 "../src/computer-reversi.vala"
	self->neighbor_tiles = (g_free (self->neighbor_tiles), NULL);
#line 587 "../src/computer-reversi.vala"
	G_OBJECT_CLASS (computer_reversi_parent_class)->finalize (obj);
#line 5409 "computer-reversi.c"
}

static GType
computer_reversi_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ComputerReversiClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) computer_reversi_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ComputerReversi), 0, (GInstanceInitFunc) computer_reversi_instance_init, NULL };
	GType computer_reversi_type_id;
	computer_reversi_type_id = g_type_register_static (TYPE_COMPUTER_PLAYER, "ComputerReversi", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	ComputerReversi_private_offset = g_type_add_instance_private (computer_reversi_type_id, sizeof (ComputerReversiPrivate));
	return computer_reversi_type_id;
}

GType
computer_reversi_get_type (void)
{
	static volatile gsize computer_reversi_type_id__once = 0;
	if (g_once_init_enter (&computer_reversi_type_id__once)) {
		GType computer_reversi_type_id;
		computer_reversi_type_id = computer_reversi_get_type_once ();
		g_once_init_leave (&computer_reversi_type_id__once, computer_reversi_type_id);
	}
	return computer_reversi_type_id__once;
}

static void
_vala_computer_reversi_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	ComputerReversi * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_REVERSI, ComputerReversi);
#line 587 "../src/computer-reversi.vala"
	switch (property_id) {
#line 587 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_GAME_PROPERTY:
#line 587 "../src/computer-reversi.vala"
		g_value_set_object (value, computer_reversi_get_game (self));
#line 587 "../src/computer-reversi.vala"
		break;
#line 587 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_INITIAL_DEPTH_PROPERTY:
#line 587 "../src/computer-reversi.vala"
		g_value_set_uchar (value, computer_reversi_get_initial_depth (self));
#line 587 "../src/computer-reversi.vala"
		break;
#line 587 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_SIZE_PROPERTY:
#line 587 "../src/computer-reversi.vala"
		g_value_set_uchar (value, computer_reversi_get_size (self));
#line 587 "../src/computer-reversi.vala"
		break;
#line 587 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_MOVE_RANDOMLY_PROPERTY:
#line 587 "../src/computer-reversi.vala"
		g_value_set_uchar (value, computer_reversi_get_move_randomly (self));
#line 587 "../src/computer-reversi.vala"
		break;
#line 5468 "computer-reversi.c"
		default:
#line 587 "../src/computer-reversi.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 587 "../src/computer-reversi.vala"
		break;
#line 5474 "computer-reversi.c"
	}
}

static void
_vala_computer_reversi_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	ComputerReversi * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMPUTER_REVERSI, ComputerReversi);
#line 587 "../src/computer-reversi.vala"
	switch (property_id) {
#line 587 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_GAME_PROPERTY:
#line 587 "../src/computer-reversi.vala"
		computer_reversi_set_game (self, g_value_get_object (value));
#line 587 "../src/computer-reversi.vala"
		break;
#line 587 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_INITIAL_DEPTH_PROPERTY:
#line 587 "../src/computer-reversi.vala"
		computer_reversi_set_initial_depth (self, g_value_get_uchar (value));
#line 587 "../src/computer-reversi.vala"
		break;
#line 587 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_SIZE_PROPERTY:
#line 587 "../src/computer-reversi.vala"
		computer_reversi_set_size (self, g_value_get_uchar (value));
#line 587 "../src/computer-reversi.vala"
		break;
#line 587 "../src/computer-reversi.vala"
		case COMPUTER_REVERSI_MOVE_RANDOMLY_PROPERTY:
#line 587 "../src/computer-reversi.vala"
		computer_reversi_set_move_randomly (self, g_value_get_uchar (value));
#line 587 "../src/computer-reversi.vala"
		break;
#line 5512 "computer-reversi.c"
		default:
#line 587 "../src/computer-reversi.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 587 "../src/computer-reversi.vala"
		break;
#line 5518 "computer-reversi.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

