/* game.c generated by valac 0.56.18, the Vala compiler
 * generated from game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Reversi, also known as Iagno.

   Copyright 2010-2013 Robert Ancell
   Copyright 2013-2014 Michael Catanzaro
   Copyright 2014-2019 Arnaud Bonatti

   GNOME Reversi is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Reversi is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNOME Reversi.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	MAIN_LINE_TOP,
	MAIN_LINE_LEFT,
	MAIN_LINE_RIGHT,
	MAIN_LINE_BOTTOM,
	MAIN_LINE_TOPLEFT,
	MAIN_LINE_TOPRIGHT
} MainLine;

#define TYPE_MAIN_LINE (main_line_get_type ())

#define TYPE_GAME_STATE_STRUCT (game_state_struct_get_type ())
typedef struct _GameStateStruct GameStateStruct;
typedef enum  {
	PLAYER_NONE,
	PLAYER_DARK,
	PLAYER_LIGHT
} Player;

#define TYPE_PLAYER (player_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_POSSIBLE_MOVE (possible_move_get_type ())
typedef struct _PossibleMove PossibleMove;

#define TYPE_GAME_STATE_OBJECT (game_state_object_get_type ())
#define GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_STATE_OBJECT, GameStateObject))
#define GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))
#define IS_GAME_STATE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_STATE_OBJECT))
#define IS_GAME_STATE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_STATE_OBJECT))
#define GAME_STATE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_STATE_OBJECT, GameStateObjectClass))

typedef struct _GameStateObject GameStateObject;
typedef struct _GameStateObjectClass GameStateObjectClass;
typedef struct _GameStateObjectPrivate GameStateObjectPrivate;
enum  {
	GAME_STATE_OBJECT_0_PROPERTY,
	GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY,
	GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY,
	GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY,
	GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY,
	GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY,
	GAME_STATE_OBJECT_NUM_PROPERTIES
};
static GParamSpec* game_state_object_properties[GAME_STATE_OBJECT_NUM_PROPERTIES];

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
typedef enum  {
	OPENING_HUMANS,
	OPENING_REVERSI,
	OPENING_INVERTED,
	OPENING_ALTER_TOP,
	OPENING_ALTER_LEFT,
	OPENING_ALTER_RIGHT,
	OPENING_ALTER_BOTTOM
} Opening;

#define TYPE_OPENING (opening_get_type ())
enum  {
	GAME_0_PROPERTY,
	GAME_NUMBER_OF_MOVES_PROPERTY,
	GAME_SIZE_PROPERTY,
	GAME_REVERSE_PROPERTY,
	GAME_OPENING_PROPERTY,
	GAME_CURRENT_STATE_PROPERTY,
	GAME_INITIAL_NUMBER_OF_TILES_PROPERTY,
	GAME_PRINT_LOGS_PROPERTY,
	GAME_IS_COMPLETE_PROPERTY,
	GAME_N_LIGHT_TILES_PROPERTY,
	GAME_N_DARK_TILES_PROPERTY,
	GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY,
	GAME_CURRENT_COLOR_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GAME_TURN_ENDED_SIGNAL,
	GAME_COMPLETENESS_UPDATED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GameStateStruct {
	Player current_color;
	Player opponent_color;
	guint8 size;
	guint8 n_current_tiles;
	guint8 n_opponent_tiles;
	guint8 n_tiles;
	gboolean current_player_can_move;
	gboolean is_complete;
	Player* tiles;
	gint tiles_length1;
	gint tiles_length2;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	guint8 x_saved;
	guint8 y_saved;
	guint8* empty_neighbors;
	gint empty_neighbors_length1;
	gint empty_neighbors_length2;
};

struct _PossibleMove {
	guint8 x;
	guint8 y;
	guint8 n_tiles;
	guint8 n_tiles_n;
	guint8 n_tiles_ne;
	guint8 n_tiles_e;
	guint8 n_tiles_se;
	guint8 n_tiles_s;
	guint8 n_tiles_so;
	guint8 n_tiles_o;
	guint8 n_tiles_no;
};

struct _GameStateObject {
	GObject parent_instance;
	GameStateObjectPrivate * priv;
};

struct _GameStateObjectClass {
	GObjectClass parent_class;
};

struct _GameStateObjectPrivate {
	GameStateStruct _game_state_struct;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	GListStore* undo_stack;
	guint8 _size;
	gboolean _reverse;
	Opening _opening;
	GameStateObject* _current_state;
	guint8 _initial_number_of_tiles;
	gboolean _print_logs;
	guint8* neighbor_tiles;
	gint neighbor_tiles_length1;
	gint neighbor_tiles_length2;
	GSList* possible_moves;
};

static gint GameStateObject_private_offset;
static gpointer game_state_object_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

VALA_EXTERN GType main_line_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType game_state_struct_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GameStateStruct* game_state_struct_dup (const GameStateStruct* self);
VALA_EXTERN void game_state_struct_free (GameStateStruct* self);
VALA_EXTERN void game_state_struct_copy (const GameStateStruct* self,
                             GameStateStruct* dest);
VALA_EXTERN void game_state_struct_destroy (GameStateStruct* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (GameStateStruct, game_state_struct_destroy)
VALA_EXTERN gchar* game_state_struct_to_string (GameStateStruct *self);
VALA_EXTERN gchar* player_to_string (Player self);
VALA_EXTERN void game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                           GameStateStruct* game);
VALA_EXTERN Player player_flip_color (Player p);
static Player* _vala_array_dup6 (Player* self,
                          gssize length);
static guint8* _vala_array_dup7 (guint8* self,
                          gssize length);
VALA_EXTERN GType possible_move_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PossibleMove* possible_move_dup (const PossibleMove* self);
VALA_EXTERN void possible_move_free (PossibleMove* self);
VALA_EXTERN void game_state_struct_init_copy_and_move (GameStateStruct *self,
                                           GameStateStruct* game,
                                           PossibleMove* move);
static Player* _vala_array_dup8 (Player* self,
                          gssize length);
static inline void game_state_struct_flip_tiles (Player** tiles,
                                   gint* tiles_length1,
                                   gint* tiles_length2,
                                   guint8 x,
                                   guint8 y,
                                   Player color,
                                   gint8 x_step,
                                   gint8 y_step,
                                   guint8 count);
static guint8* _vala_array_dup9 (guint8* self,
                          gssize length);
static inline void game_state_struct_update_empty_neighbors (GameStateStruct *self,
                                               guint8 x,
                                               guint8 y);
static void game_state_struct_update_who_can_move (GameStateStruct *self);
VALA_EXTERN void game_state_struct_init_from_grid (GameStateStruct *self,
                                       guint8 _size,
                                       Player* _tiles,
                                       gint _tiles_length1,
                                       gint _tiles_length2,
                                       Player color,
                                       guint8* _neighbor_tiles,
                                       gint _neighbor_tiles_length1,
                                       gint _neighbor_tiles_length2,
                                       gboolean humans_opening);
static Player* _vala_array_dup10 (Player* self,
                           gssize length);
static inline void game_state_struct_add_tile_of_color (GameStateStruct *self,
                                          Player color);
static inline void game_state_struct_init_empty_neighbors (GameStateStruct *self);
VALA_EXTERN void game_state_struct_init_empty (GameStateStruct *self,
                                   guint8 _size,
                                   guint8* _neighbor_tiles,
                                   gint _neighbor_tiles_length1,
                                   gint _neighbor_tiles_length2);
VALA_EXTERN void game_state_struct_init_copy_and_add (GameStateStruct *self,
                                          GameStateStruct* game,
                                          guint8 x,
                                          guint8 y);
static Player* _vala_array_dup11 (Player* self,
                           gssize length);
VALA_EXTERN void game_state_struct_init_copy_and_add_two (GameStateStruct *self,
                                              GameStateStruct* game,
                                              guint8 x1,
                                              guint8 y1,
                                              guint8 x2,
                                              guint8 y2);
static Player* _vala_array_dup12 (Player* self,
                           gssize length);
VALA_EXTERN gboolean game_state_struct_is_current_color (GameStateStruct *self,
                                             guint8 x,
                                             guint8 y);
VALA_EXTERN gboolean game_state_struct_is_empty_tile (GameStateStruct *self,
                                          guint8 x,
                                          guint8 y);
static inline gboolean game_state_struct_is_valid_location_signed (GameStateStruct *self,
                                                     gint8 x,
                                                     gint8 y);
static inline gboolean game_state_struct_is_unplayable_basic (GameStateStruct *self,
                                                guint8 x,
                                                guint8 y);
static inline gboolean game_state_struct_can_place (GameStateStruct *self,
                                      guint8 x,
                                      guint8 y,
                                      Player color);
VALA_EXTERN void game_state_struct_get_possible_moves (GameStateStruct *self,
                                           GSList** moves);
static void _possible_move_free0_ (gpointer var);
static inline void _g_slist_free__possible_move_free0_ (GSList* self);
static inline gboolean game_state_struct_place_tile (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y,
                                       Player color,
                                       PossibleMove* move);
VALA_EXTERN gboolean game_state_struct_test_placing_tile (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y,
                                              PossibleMove* move);
VALA_EXTERN void possible_move_init (PossibleMove *self,
                         guint8 x,
                         guint8 y);
static inline guint8 game_state_struct_can_flip_tiles (GameStateStruct *self,
                                         guint8 x,
                                         guint8 y,
                                         Player color,
                                         gint8 x_step,
                                         gint8 y_step);
VALA_EXTERN guint8 game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                              guint8 x,
                                              guint8 y);
static inline guint8 game_state_struct_is_empty (GameStateStruct *self,
                                   gint8 x,
                                   gint8 y);
VALA_EXTERN Player* game_state_struct_get_mainline (GameStateStruct *self,
                                        MainLine mainline_id,
                                        gint* result_length1);
static Player* _vala_array_dup13 (Player* self,
                           gssize length);
static guint8* _vala_array_dup14 (guint8* self,
                           gssize length);
VALA_EXTERN GType game_state_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameStateObject, g_object_unref)
VALA_EXTERN gchar* game_state_object_to_string (GameStateObject* self);
VALA_EXTERN void game_state_object_get_game_state_struct (GameStateObject* self,
                                              GameStateStruct * result);
VALA_EXTERN GameStateObject* game_state_object_new_copy_and_pass (GameStateObject* game);
VALA_EXTERN GameStateObject* game_state_object_construct_copy_and_pass (GType object_type,
                                                            GameStateObject* game);
VALA_EXTERN GameStateObject* game_state_object_new_copy_and_move (GameStateObject* game,
                                                      PossibleMove* move);
VALA_EXTERN GameStateObject* game_state_object_construct_copy_and_move (GType object_type,
                                                            GameStateObject* game,
                                                            PossibleMove* move);
VALA_EXTERN GameStateObject* game_state_object_new_from_grid (guint8 size,
                                                  Player* tiles,
                                                  gint tiles_length1,
                                                  gint tiles_length2,
                                                  Player color,
                                                  guint8* neighbor_tiles,
                                                  gint neighbor_tiles_length1,
                                                  gint neighbor_tiles_length2,
                                                  gboolean humans_opening);
VALA_EXTERN GameStateObject* game_state_object_construct_from_grid (GType object_type,
                                                        guint8 size,
                                                        Player* tiles,
                                                        gint tiles_length1,
                                                        gint tiles_length2,
                                                        Player color,
                                                        guint8* neighbor_tiles,
                                                        gint neighbor_tiles_length1,
                                                        gint neighbor_tiles_length2,
                                                        gboolean humans_opening);
VALA_EXTERN GameStateObject* game_state_object_new_empty (guint8 size,
                                              guint8* neighbor_tiles,
                                              gint neighbor_tiles_length1,
                                              gint neighbor_tiles_length2);
VALA_EXTERN GameStateObject* game_state_object_construct_empty (GType object_type,
                                                    guint8 size,
                                                    guint8* neighbor_tiles,
                                                    gint neighbor_tiles_length1,
                                                    gint neighbor_tiles_length2);
VALA_EXTERN GameStateObject* game_state_object_new_copy_and_add (GameStateObject* game,
                                                     guint8 x,
                                                     guint8 y);
VALA_EXTERN GameStateObject* game_state_object_construct_copy_and_add (GType object_type,
                                                           GameStateObject* game,
                                                           guint8 x,
                                                           guint8 y);
VALA_EXTERN GameStateObject* game_state_object_new_copy_and_add_two (GameStateObject* game,
                                                         guint8 x,
                                                         guint8 y,
                                                         guint8 x2,
                                                         guint8 y2);
VALA_EXTERN GameStateObject* game_state_object_construct_copy_and_add_two (GType object_type,
                                                               GameStateObject* game,
                                                               guint8 x,
                                                               guint8 y,
                                                               guint8 x2,
                                                               guint8 y2);
VALA_EXTERN Player game_state_object_get_owner (GameStateObject* self,
                                    guint8 x,
                                    guint8 y);
VALA_EXTERN void game_state_object_get_possible_moves (GameStateObject* self,
                                           GSList** moves);
VALA_EXTERN gboolean game_state_object_test_placing_tile (GameStateObject* self,
                                              guint8 x,
                                              guint8 y,
                                              PossibleMove* move);
VALA_EXTERN GameStateObject* game_state_object_new (void);
VALA_EXTERN GameStateObject* game_state_object_construct (GType object_type);
VALA_EXTERN Player game_state_object_get_current_color (GameStateObject* self);
VALA_EXTERN guint8 game_state_object_get_n_light_tiles (GameStateObject* self);
VALA_EXTERN guint8 game_state_object_get_n_dark_tiles (GameStateObject* self);
VALA_EXTERN gboolean game_state_object_get_current_player_can_move (GameStateObject* self);
VALA_EXTERN gboolean game_state_object_get_is_complete (GameStateObject* self);
static void game_state_object_finalize (GObject * obj);
static GType game_state_object_get_type_once (void);
static void _vala_game_state_object_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
VALA_EXTERN GType game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
VALA_EXTERN GType opening_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Game* game_new (gboolean _reverse,
                Opening _opening,
                guint8 _size,
                gboolean _print_logs);
VALA_EXTERN Game* game_construct (GType object_type,
                      gboolean _reverse,
                      Opening _opening,
                      guint8 _size,
                      gboolean _print_logs);
static void game_init_neighbor_tiles (guint8 size,
                               guint8** neighbor_tiles,
                               gint* neighbor_tiles_length1,
                               gint* neighbor_tiles_length2);
static inline void game_setup_even_board (guint8 size,
                            Opening opening,
                            Player** tiles,
                            gint* tiles_length1,
                            gint* tiles_length2,
                            guint8* initial_number_of_tiles);
static inline void game_setup_odd_board (guint8 size,
                           Opening opening,
                           Player** tiles,
                           gint* tiles_length1,
                           gint* tiles_length2,
                           guint8* initial_number_of_tiles);
VALA_EXTERN Game* game_new_from_strings (gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             gboolean _reverse,
                             guint8 _size,
                             gboolean _print_logs);
VALA_EXTERN Game* game_construct_from_strings (GType object_type,
                                   gchar** setup,
                                   gint setup_length1,
                                   Player to_move,
                                   gboolean _reverse,
                                   guint8 _size,
                                   gboolean _print_logs);
VALA_EXTERN Player player_from_char (gchar c);
VALA_EXTERN gchar* game_to_string (Game* self);
VALA_EXTERN Player game_get_owner (Game* self,
                       guint8 x,
                       guint8 y);
VALA_EXTERN GameStateObject* game_get_current_state (Game* self);
VALA_EXTERN gboolean game_place_tile (Game* self,
                          guint8 x,
                          guint8 y);
VALA_EXTERN Opening game_get_opening (Game* self);
static inline gboolean game_humans_opening_place_tile (Game* self,
                                         guint8 x,
                                         guint8 y);
VALA_EXTERN gboolean game_get_print_logs (Game* self);
VALA_EXTERN Player game_get_current_color (Game* self);
VALA_EXTERN void game_set_current_state (Game* self,
                             GameStateObject* value);
static void game_end_of_turn (Game* self,
                       gboolean undoing,
                       gboolean no_draw);
VALA_EXTERN gboolean game_pass (Game* self);
VALA_EXTERN gboolean game_get_current_player_can_move (Game* self);
static inline void game_update_possible_moves (Game* self);
VALA_EXTERN void game_undo (Game* self,
                guint8 count);
VALA_EXTERN guint8 game_get_number_of_moves (Game* self);
VALA_EXTERN guint8* game_copy_neighbor_tiles (Game* self,
                                  gint* result_length1,
                                  gint* result_length2);
static guint8* _vala_array_dup15 (guint8* self,
                           gssize length);
VALA_EXTERN gboolean game_test_placing_tile (Game* self,
                                 guint8 x,
                                 guint8 y,
                                 PossibleMove* move);
static gboolean game_humans_opening_test_placing_tile (Game* self,
                                                guint8 x,
                                                guint8 y);
VALA_EXTERN void game_get_possible_moves (Game* self,
                              GSList** moves);
static PossibleMove* __lambda15_ (Game* self,
                           PossibleMove* a);
static gpointer ___lambda15__gcopy_func (gconstpointer src,
                                  gpointer self);
static inline void game_humans_opening_update_possible_moves (Game* self);
VALA_EXTERN guint8 game_get_size (Game* self);
static inline void game_humans_opening_update_opening_even (Game* self);
VALA_EXTERN guint8 game_get_n_light_tiles (Game* self);
static inline void game_humans_opening_update_opening_odd (Game* self,
                                             guint8 x,
                                             guint8 y);
VALA_EXTERN void game_set_opening (Game* self,
                       Opening value);
static inline gboolean game_humans_opening_test_placing_tile_even (Game* self,
                                                     guint8 x,
                                                     guint8 y);
static inline gboolean game_humans_opening_test_placing_tile_odd (Game* self,
                                                    guint8 x,
                                                    guint8 y);
static inline void game_humans_opening_update_possible_moves_even (Game* self);
static inline void game_humans_opening_update_possible_moves_odd (Game* self);
static void game_set_size (Game* self,
                    guint8 value);
VALA_EXTERN gboolean game_get_reverse (Game* self);
static void game_set_reverse (Game* self,
                       gboolean value);
VALA_EXTERN guint8 game_get_initial_number_of_tiles (Game* self);
static void game_set_initial_number_of_tiles (Game* self,
                                       guint8 value);
static void game_set_print_logs (Game* self,
                          gboolean value);
VALA_EXTERN gboolean game_get_is_complete (Game* self);
VALA_EXTERN guint8 game_get_n_dark_tiles (Game* self);
static void g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static GObject * game_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
VALA_EXTERN gchar* opening_to_string (Opening self);
static void game_finalize (GObject * obj);
static GType game_get_type_once (void);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
main_line_get_type_once (void)
{
	static const GEnumValue values[] = {{MAIN_LINE_TOP, "MAIN_LINE_TOP", "top"}, {MAIN_LINE_LEFT, "MAIN_LINE_LEFT", "left"}, {MAIN_LINE_RIGHT, "MAIN_LINE_RIGHT", "right"}, {MAIN_LINE_BOTTOM, "MAIN_LINE_BOTTOM", "bottom"}, {MAIN_LINE_TOPLEFT, "MAIN_LINE_TOPLEFT", "topleft"}, {MAIN_LINE_TOPRIGHT, "MAIN_LINE_TOPRIGHT", "topright"}, {0, NULL, NULL}};
	GType main_line_type_id;
	main_line_type_id = g_enum_register_static ("MainLine", values);
	return main_line_type_id;
}

GType
main_line_get_type (void)
{
	static volatile gsize main_line_type_id__once = 0;
	if (g_once_init_enter (&main_line_type_id__once)) {
		GType main_line_type_id;
		main_line_type_id = main_line_get_type_once ();
		g_once_init_leave (&main_line_type_id__once, main_line_type_id);
	}
	return main_line_type_id__once;
}

gchar*
game_state_struct_to_string (GameStateStruct *self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 51 "../src/game.vala"
	_tmp0_ = g_strdup ("\n");
#line 51 "../src/game.vala"
	s = _tmp0_;
#line 600 "game.c"
	{
		guint8 y = 0U;
#line 53 "../src/game.vala"
		y = (guint8) 0;
#line 605 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 53 "../src/game.vala"
			_tmp1_ = TRUE;
#line 53 "../src/game.vala"
			while (TRUE) {
#line 612 "game.c"
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 53 "../src/game.vala"
				if (!_tmp1_) {
#line 617 "game.c"
					guint8 _tmp2_;
#line 53 "../src/game.vala"
					_tmp2_ = y;
#line 53 "../src/game.vala"
					y = _tmp2_ + 1;
#line 623 "game.c"
				}
#line 53 "../src/game.vala"
				_tmp1_ = FALSE;
#line 53 "../src/game.vala"
				if (!(y < (*self).size)) {
#line 53 "../src/game.vala"
					break;
#line 631 "game.c"
				}
				{
					guint8 x = 0U;
#line 55 "../src/game.vala"
					x = (guint8) 0;
#line 637 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 55 "../src/game.vala"
						_tmp3_ = TRUE;
#line 55 "../src/game.vala"
						while (TRUE) {
#line 644 "game.c"
							const gchar* _tmp5_;
							Player* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							Player _tmp7_;
							gchar* _tmp8_;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
							gchar* _tmp12_;
#line 55 "../src/game.vala"
							if (!_tmp3_) {
#line 657 "game.c"
								guint8 _tmp4_;
#line 55 "../src/game.vala"
								_tmp4_ = x;
#line 55 "../src/game.vala"
								x = _tmp4_ + 1;
#line 663 "game.c"
							}
#line 55 "../src/game.vala"
							_tmp3_ = FALSE;
#line 55 "../src/game.vala"
							if (!(x < (*self).size)) {
#line 55 "../src/game.vala"
								break;
#line 671 "game.c"
							}
#line 56 "../src/game.vala"
							_tmp5_ = s;
#line 56 "../src/game.vala"
							_tmp6_ = (*self).tiles;
#line 56 "../src/game.vala"
							_tmp6__length1 = (*self).tiles_length1;
#line 56 "../src/game.vala"
							_tmp6__length2 = (*self).tiles_length2;
#line 56 "../src/game.vala"
							_tmp7_ = _tmp6_[(x * _tmp6__length2) + y];
#line 56 "../src/game.vala"
							_tmp8_ = player_to_string (_tmp7_);
#line 56 "../src/game.vala"
							_tmp9_ = _tmp8_;
#line 56 "../src/game.vala"
							_tmp10_ = g_strconcat (" ", _tmp9_, NULL);
#line 56 "../src/game.vala"
							_tmp11_ = _tmp10_;
#line 56 "../src/game.vala"
							_tmp12_ = g_strconcat (_tmp5_, _tmp11_, NULL);
#line 56 "../src/game.vala"
							_g_free0 (s);
#line 56 "../src/game.vala"
							s = _tmp12_;
#line 56 "../src/game.vala"
							_g_free0 (_tmp11_);
#line 56 "../src/game.vala"
							_g_free0 (_tmp9_);
#line 701 "game.c"
						}
					}
				}
#line 57 "../src/game.vala"
				_tmp13_ = s;
#line 57 "../src/game.vala"
				_tmp14_ = g_strconcat (_tmp13_, "\n", NULL);
#line 57 "../src/game.vala"
				_g_free0 (s);
#line 57 "../src/game.vala"
				s = _tmp14_;
#line 713 "game.c"
			}
		}
	}
#line 60 "../src/game.vala"
	result = s;
#line 60 "../src/game.vala"
	return result;
#line 721 "game.c"
}

static Player*
_vala_array_dup6 (Player* self,
                  gssize length)
{
#line 76 "../src/game.vala"
	if (length > 0) {
#line 76 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (Player));
#line 732 "game.c"
	}
#line 76 "../src/game.vala"
	return NULL;
#line 736 "game.c"
}

static guint8*
_vala_array_dup7 (guint8* self,
                  gssize length)
{
#line 84 "../src/game.vala"
	if (length > 0) {
#line 84 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 747 "game.c"
	}
#line 84 "../src/game.vala"
	return NULL;
#line 751 "game.c"
}

void
game_state_struct_init_copy_and_pass (GameStateStruct *self,
                                      GameStateStruct* game)
{
	GameStateStruct _tmp0_;
	GameStateStruct _tmp1_;
	GameStateStruct _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	GameStateStruct _tmp4_;
	Player* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	Player* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	GameStateStruct _tmp7_;
	GameStateStruct _tmp8_;
	GameStateStruct _tmp9_;
	guint8* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
#line 63 "../src/game.vala"
	g_return_if_fail (game != NULL);
#line 63 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 68 "../src/game.vala"
	_tmp0_ = *game;
#line 68 "../src/game.vala"
	(*self).opponent_color = _tmp0_.current_color;
#line 69 "../src/game.vala"
	(*self).current_color = player_flip_color ((*self).opponent_color);
#line 72 "../src/game.vala"
	_tmp1_ = *game;
#line 72 "../src/game.vala"
	(*self).size = _tmp1_.size;
#line 73 "../src/game.vala"
	_tmp2_ = *game;
#line 73 "../src/game.vala"
	_tmp3_ = _tmp2_.neighbor_tiles;
#line 73 "../src/game.vala"
	_tmp3__length1 = _tmp2_.neighbor_tiles_length1;
#line 73 "../src/game.vala"
	_tmp3__length2 = _tmp2_.neighbor_tiles_length2;
#line 73 "../src/game.vala"
	(*self).neighbor_tiles = _tmp3_;
#line 73 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _tmp3__length1;
#line 73 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _tmp3__length2;
#line 76 "../src/game.vala"
	_tmp4_ = *game;
#line 76 "../src/game.vala"
	_tmp5_ = _tmp4_.tiles;
#line 76 "../src/game.vala"
	_tmp5__length1 = _tmp4_.tiles_length1;
#line 76 "../src/game.vala"
	_tmp5__length2 = _tmp4_.tiles_length2;
#line 76 "../src/game.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup6 (_tmp5_, _tmp5__length1 * _tmp5__length2) : _tmp5_;
#line 76 "../src/game.vala"
	_tmp6__length1 = _tmp5__length1;
#line 76 "../src/game.vala"
	_tmp6__length2 = _tmp5__length2;
#line 76 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 76 "../src/game.vala"
	(*self).tiles = _tmp6_;
#line 76 "../src/game.vala"
	(*self).tiles_length1 = _tmp6__length1;
#line 76 "../src/game.vala"
	(*self).tiles_length2 = _tmp6__length2;
#line 79 "../src/game.vala"
	_tmp7_ = *game;
#line 79 "../src/game.vala"
	(*self).n_current_tiles = _tmp7_.n_opponent_tiles;
#line 80 "../src/game.vala"
	_tmp8_ = *game;
#line 80 "../src/game.vala"
	(*self).n_opponent_tiles = _tmp8_.n_current_tiles;
#line 81 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 84 "../src/game.vala"
	_tmp9_ = *game;
#line 84 "../src/game.vala"
	_tmp10_ = _tmp9_.empty_neighbors;
#line 84 "../src/game.vala"
	_tmp10__length1 = _tmp9_.empty_neighbors_length1;
#line 84 "../src/game.vala"
	_tmp10__length2 = _tmp9_.empty_neighbors_length2;
#line 84 "../src/game.vala"
	_tmp11_ = (_tmp10_ != NULL) ? _vala_array_dup7 (_tmp10_, _tmp10__length1 * _tmp10__length2) : _tmp10_;
#line 84 "../src/game.vala"
	_tmp11__length1 = _tmp10__length1;
#line 84 "../src/game.vala"
	_tmp11__length2 = _tmp10__length2;
#line 84 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 84 "../src/game.vala"
	(*self).empty_neighbors = _tmp11_;
#line 84 "../src/game.vala"
	(*self).empty_neighbors_length1 = _tmp11__length1;
#line 84 "../src/game.vala"
	(*self).empty_neighbors_length2 = _tmp11__length2;
#line 87 "../src/game.vala"
	(*self).current_player_can_move = TRUE;
#line 88 "../src/game.vala"
	(*self).is_complete = FALSE;
#line 89 "../src/game.vala"
	(*self).x_saved = (guint8) 0;
#line 90 "../src/game.vala"
	(*self).y_saved = (guint8) 0;
#line 870 "game.c"
}

static Player*
_vala_array_dup8 (Player* self,
                  gssize length)
{
#line 104 "../src/game.vala"
	if (length > 0) {
#line 104 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (Player));
#line 881 "game.c"
	}
#line 104 "../src/game.vala"
	return NULL;
#line 885 "game.c"
}

static guint8*
_vala_array_dup9 (guint8* self,
                  gssize length)
{
#line 121 "../src/game.vala"
	if (length > 0) {
#line 121 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 896 "game.c"
	}
#line 121 "../src/game.vala"
	return NULL;
#line 900 "game.c"
}

void
game_state_struct_init_copy_and_move (GameStateStruct *self,
                                      GameStateStruct* game,
                                      PossibleMove* move)
{
	GameStateStruct _tmp0_;
	GameStateStruct _tmp1_;
	GameStateStruct _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	GameStateStruct _tmp4_;
	Player* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	Player* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	PossibleMove _tmp7_;
	PossibleMove _tmp8_;
	PossibleMove _tmp9_;
	PossibleMove _tmp10_;
	PossibleMove _tmp11_;
	PossibleMove _tmp12_;
	PossibleMove _tmp13_;
	PossibleMove _tmp14_;
	PossibleMove _tmp15_;
	PossibleMove _tmp16_;
	PossibleMove _tmp17_;
	PossibleMove _tmp18_;
	PossibleMove _tmp19_;
	PossibleMove _tmp20_;
	PossibleMove _tmp21_;
	PossibleMove _tmp22_;
	PossibleMove _tmp23_;
	PossibleMove _tmp24_;
	PossibleMove _tmp25_;
	PossibleMove _tmp26_;
	PossibleMove _tmp27_;
	PossibleMove _tmp28_;
	PossibleMove _tmp29_;
	PossibleMove _tmp30_;
	PossibleMove _tmp31_;
	PossibleMove _tmp32_;
	GameStateStruct _tmp33_;
	PossibleMove _tmp34_;
	GameStateStruct _tmp35_;
	PossibleMove _tmp36_;
	GameStateStruct _tmp37_;
	guint8* _tmp38_;
	gint _tmp38__length1;
	gint _tmp38__length2;
	guint8* _tmp39_;
	gint _tmp39__length1;
	gint _tmp39__length2;
	PossibleMove _tmp40_;
	PossibleMove _tmp41_;
#line 93 "../src/game.vala"
	g_return_if_fail (game != NULL);
#line 93 "../src/game.vala"
	g_return_if_fail (move != NULL);
#line 93 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 96 "../src/game.vala"
	_tmp0_ = *game;
#line 96 "../src/game.vala"
	(*self).opponent_color = _tmp0_.current_color;
#line 97 "../src/game.vala"
	(*self).current_color = player_flip_color ((*self).opponent_color);
#line 100 "../src/game.vala"
	_tmp1_ = *game;
#line 100 "../src/game.vala"
	(*self).size = _tmp1_.size;
#line 101 "../src/game.vala"
	_tmp2_ = *game;
#line 101 "../src/game.vala"
	_tmp3_ = _tmp2_.neighbor_tiles;
#line 101 "../src/game.vala"
	_tmp3__length1 = _tmp2_.neighbor_tiles_length1;
#line 101 "../src/game.vala"
	_tmp3__length2 = _tmp2_.neighbor_tiles_length2;
#line 101 "../src/game.vala"
	(*self).neighbor_tiles = _tmp3_;
#line 101 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _tmp3__length1;
#line 101 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _tmp3__length2;
#line 104 "../src/game.vala"
	_tmp4_ = *game;
#line 104 "../src/game.vala"
	_tmp5_ = _tmp4_.tiles;
#line 104 "../src/game.vala"
	_tmp5__length1 = _tmp4_.tiles_length1;
#line 104 "../src/game.vala"
	_tmp5__length2 = _tmp4_.tiles_length2;
#line 104 "../src/game.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup8 (_tmp5_, _tmp5__length1 * _tmp5__length2) : _tmp5_;
#line 104 "../src/game.vala"
	_tmp6__length1 = _tmp5__length1;
#line 104 "../src/game.vala"
	_tmp6__length2 = _tmp5__length2;
#line 104 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 104 "../src/game.vala"
	(*self).tiles = _tmp6_;
#line 104 "../src/game.vala"
	(*self).tiles_length1 = _tmp6__length1;
#line 104 "../src/game.vala"
	(*self).tiles_length2 = _tmp6__length2;
#line 105 "../src/game.vala"
	_tmp7_ = *move;
#line 105 "../src/game.vala"
	_tmp8_ = *move;
#line 105 "../src/game.vala"
	_tmp9_ = *move;
#line 105 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp7_.x, _tmp8_.y, (*self).opponent_color, (gint8) 0, (gint8) -1, _tmp9_.n_tiles_n);
#line 106 "../src/game.vala"
	_tmp10_ = *move;
#line 106 "../src/game.vala"
	_tmp11_ = *move;
#line 106 "../src/game.vala"
	_tmp12_ = *move;
#line 106 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp10_.x, _tmp11_.y, (*self).opponent_color, (gint8) 1, (gint8) -1, _tmp12_.n_tiles_ne);
#line 107 "../src/game.vala"
	_tmp13_ = *move;
#line 107 "../src/game.vala"
	_tmp14_ = *move;
#line 107 "../src/game.vala"
	_tmp15_ = *move;
#line 107 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp13_.x, _tmp14_.y, (*self).opponent_color, (gint8) 1, (gint8) 0, _tmp15_.n_tiles_e);
#line 108 "../src/game.vala"
	_tmp16_ = *move;
#line 108 "../src/game.vala"
	_tmp17_ = *move;
#line 108 "../src/game.vala"
	_tmp18_ = *move;
#line 108 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp16_.x, _tmp17_.y, (*self).opponent_color, (gint8) 1, (gint8) 1, _tmp18_.n_tiles_se);
#line 109 "../src/game.vala"
	_tmp19_ = *move;
#line 109 "../src/game.vala"
	_tmp20_ = *move;
#line 109 "../src/game.vala"
	_tmp21_ = *move;
#line 109 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp19_.x, _tmp20_.y, (*self).opponent_color, (gint8) 0, (gint8) 1, _tmp21_.n_tiles_s);
#line 110 "../src/game.vala"
	_tmp22_ = *move;
#line 110 "../src/game.vala"
	_tmp23_ = *move;
#line 110 "../src/game.vala"
	_tmp24_ = *move;
#line 110 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp22_.x, _tmp23_.y, (*self).opponent_color, (gint8) -1, (gint8) 1, _tmp24_.n_tiles_so);
#line 111 "../src/game.vala"
	_tmp25_ = *move;
#line 111 "../src/game.vala"
	_tmp26_ = *move;
#line 111 "../src/game.vala"
	_tmp27_ = *move;
#line 111 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp25_.x, _tmp26_.y, (*self).opponent_color, (gint8) -1, (gint8) 0, _tmp27_.n_tiles_o);
#line 112 "../src/game.vala"
	_tmp28_ = *move;
#line 112 "../src/game.vala"
	_tmp29_ = *move;
#line 112 "../src/game.vala"
	_tmp30_ = *move;
#line 112 "../src/game.vala"
	game_state_struct_flip_tiles (&(*self).tiles, (gint*) (&(*self).tiles_length1), (gint*) (&(*self).tiles_length2), _tmp28_.x, _tmp29_.y, (*self).opponent_color, (gint8) -1, (gint8) -1, _tmp30_.n_tiles_no);
#line 113 "../src/game.vala"
	_tmp31_ = *move;
#line 113 "../src/game.vala"
	_tmp32_ = *move;
#line 113 "../src/game.vala"
	(*self).tiles[(_tmp31_.x * (*self).tiles_length2) + _tmp32_.y] = (*self).opponent_color;
#line 116 "../src/game.vala"
	_tmp33_ = *game;
#line 116 "../src/game.vala"
	_tmp34_ = *move;
#line 116 "../src/game.vala"
	(*self).n_current_tiles = _tmp33_.n_opponent_tiles - _tmp34_.n_tiles;
#line 117 "../src/game.vala"
	_tmp35_ = *game;
#line 117 "../src/game.vala"
	_tmp36_ = *move;
#line 117 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) ((_tmp35_.n_current_tiles + _tmp36_.n_tiles) + 1);
#line 118 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 121 "../src/game.vala"
	_tmp37_ = *game;
#line 121 "../src/game.vala"
	_tmp38_ = _tmp37_.empty_neighbors;
#line 121 "../src/game.vala"
	_tmp38__length1 = _tmp37_.empty_neighbors_length1;
#line 121 "../src/game.vala"
	_tmp38__length2 = _tmp37_.empty_neighbors_length2;
#line 121 "../src/game.vala"
	_tmp39_ = (_tmp38_ != NULL) ? _vala_array_dup9 (_tmp38_, _tmp38__length1 * _tmp38__length2) : _tmp38_;
#line 121 "../src/game.vala"
	_tmp39__length1 = _tmp38__length1;
#line 121 "../src/game.vala"
	_tmp39__length2 = _tmp38__length2;
#line 121 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 121 "../src/game.vala"
	(*self).empty_neighbors = _tmp39_;
#line 121 "../src/game.vala"
	(*self).empty_neighbors_length1 = _tmp39__length1;
#line 121 "../src/game.vala"
	(*self).empty_neighbors_length2 = _tmp39__length2;
#line 122 "../src/game.vala"
	_tmp40_ = *move;
#line 122 "../src/game.vala"
	_tmp41_ = *move;
#line 122 "../src/game.vala"
	game_state_struct_update_empty_neighbors (&(*self), _tmp40_.x, _tmp41_.y);
#line 125 "../src/game.vala"
	game_state_struct_update_who_can_move (&(*self));
#line 1126 "game.c"
}

static inline void
game_state_struct_flip_tiles (Player** tiles,
                              gint* tiles_length1,
                              gint* tiles_length2,
                              guint8 x,
                              guint8 y,
                              Player color,
                              gint8 x_step,
                              gint8 y_step,
                              guint8 count)
{
	{
		gboolean _tmp0_ = FALSE;
#line 129 "../src/game.vala"
		_tmp0_ = TRUE;
#line 129 "../src/game.vala"
		while (TRUE) {
#line 129 "../src/game.vala"
			if (!_tmp0_) {
#line 1148 "game.c"
				guint8 _tmp1_;
#line 129 "../src/game.vala"
				_tmp1_ = count;
#line 129 "../src/game.vala"
				count = _tmp1_ - 1;
#line 1154 "game.c"
			}
#line 129 "../src/game.vala"
			_tmp0_ = FALSE;
#line 129 "../src/game.vala"
			if (!(((gint) count) > 0)) {
#line 129 "../src/game.vala"
				break;
#line 1162 "game.c"
			}
#line 131 "../src/game.vala"
			(*tiles)[((((gint8) x) + (((gint8) count) * x_step)) * (*tiles_length2)) + (((gint8) y) + (((gint8) count) * y_step))] = color;
#line 1166 "game.c"
		}
	}
}

static Player*
_vala_array_dup10 (Player* self,
                   gssize length)
{
#line 147 "../src/game.vala"
	if (length > 0) {
#line 147 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (Player));
#line 1179 "game.c"
	}
#line 147 "../src/game.vala"
	return NULL;
#line 1183 "game.c"
}

void
game_state_struct_init_from_grid (GameStateStruct *self,
                                  guint8 _size,
                                  Player* _tiles,
                                  gint _tiles_length1,
                                  gint _tiles_length2,
                                  Player color,
                                  guint8* _neighbor_tiles,
                                  gint _neighbor_tiles_length1,
                                  gint _neighbor_tiles_length2,
                                  gboolean humans_opening)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 136 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 139 "../src/game.vala"
	(*self).current_color = color;
#line 140 "../src/game.vala"
	(*self).opponent_color = player_flip_color (color);
#line 143 "../src/game.vala"
	(*self).size = _size;
#line 144 "../src/game.vala"
	(*self).neighbor_tiles = _neighbor_tiles;
#line 144 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _neighbor_tiles_length1;
#line 144 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _neighbor_tiles_length2;
#line 147 "../src/game.vala"
	_tmp0_ = (_tiles != NULL) ? _vala_array_dup10 (_tiles, _tiles_length1 * _tiles_length2) : _tiles;
#line 147 "../src/game.vala"
	_tmp0__length1 = _tiles_length1;
#line 147 "../src/game.vala"
	_tmp0__length2 = _tiles_length2;
#line 147 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 147 "../src/game.vala"
	(*self).tiles = _tmp0_;
#line 147 "../src/game.vala"
	(*self).tiles_length1 = _tmp0__length1;
#line 147 "../src/game.vala"
	(*self).tiles_length2 = _tmp0__length2;
#line 150 "../src/game.vala"
	(*self).n_current_tiles = (guint8) 0;
#line 151 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) 0;
#line 1233 "game.c"
	{
		guint8 x = 0U;
#line 152 "../src/game.vala"
		x = (guint8) 0;
#line 1238 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 152 "../src/game.vala"
			_tmp1_ = TRUE;
#line 152 "../src/game.vala"
			while (TRUE) {
#line 152 "../src/game.vala"
				if (!_tmp1_) {
#line 1247 "game.c"
					guint8 _tmp2_;
#line 152 "../src/game.vala"
					_tmp2_ = x;
#line 152 "../src/game.vala"
					x = _tmp2_ + 1;
#line 1253 "game.c"
				}
#line 152 "../src/game.vala"
				_tmp1_ = FALSE;
#line 152 "../src/game.vala"
				if (!(x < _size)) {
#line 152 "../src/game.vala"
					break;
#line 1261 "game.c"
				}
				{
					guint8 y = 0U;
#line 153 "../src/game.vala"
					y = (guint8) 0;
#line 1267 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 153 "../src/game.vala"
						_tmp3_ = TRUE;
#line 153 "../src/game.vala"
						while (TRUE) {
#line 1274 "game.c"
							Player _tmp5_;
#line 153 "../src/game.vala"
							if (!_tmp3_) {
#line 1278 "game.c"
								guint8 _tmp4_;
#line 153 "../src/game.vala"
								_tmp4_ = y;
#line 153 "../src/game.vala"
								y = _tmp4_ + 1;
#line 1284 "game.c"
							}
#line 153 "../src/game.vala"
							_tmp3_ = FALSE;
#line 153 "../src/game.vala"
							if (!(y < _size)) {
#line 153 "../src/game.vala"
								break;
#line 1292 "game.c"
							}
#line 154 "../src/game.vala"
							_tmp5_ = _tiles[(x * _tiles_length2) + y];
#line 154 "../src/game.vala"
							game_state_struct_add_tile_of_color (&(*self), _tmp5_);
#line 1298 "game.c"
						}
					}
				}
			}
		}
	}
#line 155 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 158 "../src/game.vala"
	game_state_struct_init_empty_neighbors (&(*self));
#line 161 "../src/game.vala"
	if (humans_opening) {
#line 163 "../src/game.vala"
		(*self).current_player_can_move = TRUE;
#line 164 "../src/game.vala"
		(*self).is_complete = FALSE;
#line 1315 "game.c"
	} else {
#line 167 "../src/game.vala"
		game_state_struct_update_who_can_move (&(*self));
#line 1319 "game.c"
	}
}

static inline void
game_state_struct_add_tile_of_color (GameStateStruct *self,
                                     Player color)
{
#line 171 "../src/game.vala"
	if (color == (*self).current_color) {
#line 1329 "game.c"
		guint8 _tmp0_;
#line 172 "../src/game.vala"
		_tmp0_ = (*self).n_current_tiles;
#line 172 "../src/game.vala"
		(*self).n_current_tiles = _tmp0_ + 1;
#line 1335 "game.c"
	} else {
#line 173 "../src/game.vala"
		if (color != PLAYER_NONE) {
#line 1339 "game.c"
			guint8 _tmp1_;
#line 174 "../src/game.vala"
			_tmp1_ = (*self).n_opponent_tiles;
#line 174 "../src/game.vala"
			(*self).n_opponent_tiles = _tmp1_ + 1;
#line 1345 "game.c"
		}
	}
}

void
game_state_struct_init_empty (GameStateStruct *self,
                              guint8 _size,
                              guint8* _neighbor_tiles,
                              gint _neighbor_tiles_length1,
                              gint _neighbor_tiles_length2)
{
	Player* _tmp0_;
#line 177 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 180 "../src/game.vala"
	(*self).current_color = PLAYER_DARK;
#line 181 "../src/game.vala"
	(*self).opponent_color = PLAYER_LIGHT;
#line 184 "../src/game.vala"
	(*self).size = _size;
#line 185 "../src/game.vala"
	(*self).neighbor_tiles = _neighbor_tiles;
#line 185 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _neighbor_tiles_length1;
#line 185 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _neighbor_tiles_length2;
#line 188 "../src/game.vala"
	_tmp0_ = g_new0 (Player, _size * _size);
#line 188 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 188 "../src/game.vala"
	(*self).tiles = _tmp0_;
#line 188 "../src/game.vala"
	(*self).tiles_length1 = _size;
#line 188 "../src/game.vala"
	(*self).tiles_length2 = _size;
#line 1382 "game.c"
	{
		guint8 x = 0U;
#line 189 "../src/game.vala"
		x = (guint8) 0;
#line 1387 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 189 "../src/game.vala"
			_tmp1_ = TRUE;
#line 189 "../src/game.vala"
			while (TRUE) {
#line 189 "../src/game.vala"
				if (!_tmp1_) {
#line 1396 "game.c"
					guint8 _tmp2_;
#line 189 "../src/game.vala"
					_tmp2_ = x;
#line 189 "../src/game.vala"
					x = _tmp2_ + 1;
#line 1402 "game.c"
				}
#line 189 "../src/game.vala"
				_tmp1_ = FALSE;
#line 189 "../src/game.vala"
				if (!(x < _size)) {
#line 189 "../src/game.vala"
					break;
#line 1410 "game.c"
				}
				{
					guint8 y = 0U;
#line 190 "../src/game.vala"
					y = (guint8) 0;
#line 1416 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 190 "../src/game.vala"
						_tmp3_ = TRUE;
#line 190 "../src/game.vala"
						while (TRUE) {
#line 190 "../src/game.vala"
							if (!_tmp3_) {
#line 1425 "game.c"
								guint8 _tmp4_;
#line 190 "../src/game.vala"
								_tmp4_ = y;
#line 190 "../src/game.vala"
								y = _tmp4_ + 1;
#line 1431 "game.c"
							}
#line 190 "../src/game.vala"
							_tmp3_ = FALSE;
#line 190 "../src/game.vala"
							if (!(y < _size)) {
#line 190 "../src/game.vala"
								break;
#line 1439 "game.c"
							}
#line 191 "../src/game.vala"
							(*self).tiles[(x * (*self).tiles_length2) + y] = PLAYER_NONE;
#line 1443 "game.c"
						}
					}
				}
			}
		}
	}
#line 194 "../src/game.vala"
	(*self).n_current_tiles = (guint8) 0;
#line 195 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) 0;
#line 196 "../src/game.vala"
	(*self).n_tiles = (guint8) 0;
#line 199 "../src/game.vala"
	game_state_struct_init_empty_neighbors (&(*self));
#line 202 "../src/game.vala"
	(*self).current_player_can_move = TRUE;
#line 203 "../src/game.vala"
	(*self).is_complete = FALSE;
#line 204 "../src/game.vala"
	(*self).x_saved = (guint8) (((*self).size / 2) - 2);
#line 205 "../src/game.vala"
	(*self).y_saved = (guint8) (((*self).size / 2) - 2);
#line 1466 "game.c"
}

static Player*
_vala_array_dup11 (Player* self,
                   gssize length)
{
#line 219 "../src/game.vala"
	if (length > 0) {
#line 219 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (Player));
#line 1477 "game.c"
	}
#line 219 "../src/game.vala"
	return NULL;
#line 1481 "game.c"
}

void
game_state_struct_init_copy_and_add (GameStateStruct *self,
                                     GameStateStruct* game,
                                     guint8 x,
                                     guint8 y)
{
	GameStateStruct _tmp0_;
	GameStateStruct _tmp1_;
	GameStateStruct _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	GameStateStruct _tmp4_;
	Player* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	Player* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	Player* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Player _tmp8_;
	GameStateStruct _tmp9_;
	GameStateStruct _tmp10_;
#line 208 "../src/game.vala"
	g_return_if_fail (game != NULL);
#line 208 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 211 "../src/game.vala"
	_tmp0_ = *game;
#line 211 "../src/game.vala"
	(*self).opponent_color = _tmp0_.current_color;
#line 212 "../src/game.vala"
	(*self).current_color = player_flip_color ((*self).opponent_color);
#line 215 "../src/game.vala"
	_tmp1_ = *game;
#line 215 "../src/game.vala"
	(*self).size = _tmp1_.size;
#line 216 "../src/game.vala"
	_tmp2_ = *game;
#line 216 "../src/game.vala"
	_tmp3_ = _tmp2_.neighbor_tiles;
#line 216 "../src/game.vala"
	_tmp3__length1 = _tmp2_.neighbor_tiles_length1;
#line 216 "../src/game.vala"
	_tmp3__length2 = _tmp2_.neighbor_tiles_length2;
#line 216 "../src/game.vala"
	(*self).neighbor_tiles = _tmp3_;
#line 216 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _tmp3__length1;
#line 216 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _tmp3__length2;
#line 219 "../src/game.vala"
	_tmp4_ = *game;
#line 219 "../src/game.vala"
	_tmp5_ = _tmp4_.tiles;
#line 219 "../src/game.vala"
	_tmp5__length1 = _tmp4_.tiles_length1;
#line 219 "../src/game.vala"
	_tmp5__length2 = _tmp4_.tiles_length2;
#line 219 "../src/game.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup11 (_tmp5_, _tmp5__length1 * _tmp5__length2) : _tmp5_;
#line 219 "../src/game.vala"
	_tmp6__length1 = _tmp5__length1;
#line 219 "../src/game.vala"
	_tmp6__length2 = _tmp5__length2;
#line 219 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 219 "../src/game.vala"
	(*self).tiles = _tmp6_;
#line 219 "../src/game.vala"
	(*self).tiles_length1 = _tmp6__length1;
#line 219 "../src/game.vala"
	(*self).tiles_length2 = _tmp6__length2;
#line 220 "../src/game.vala"
	_tmp7_ = (*self).tiles;
#line 220 "../src/game.vala"
	_tmp7__length1 = (*self).tiles_length1;
#line 220 "../src/game.vala"
	_tmp7__length2 = (*self).tiles_length2;
#line 220 "../src/game.vala"
	_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
#line 220 "../src/game.vala"
	if (_tmp8_ != PLAYER_NONE) {
#line 221 "../src/game.vala"
		g_assert_not_reached ();
#line 1571 "game.c"
	}
#line 222 "../src/game.vala"
	(*self).tiles[(x * (*self).tiles_length2) + y] = (*self).opponent_color;
#line 225 "../src/game.vala"
	_tmp9_ = *game;
#line 225 "../src/game.vala"
	(*self).n_current_tiles = _tmp9_.n_opponent_tiles;
#line 226 "../src/game.vala"
	_tmp10_ = *game;
#line 226 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) (_tmp10_.n_current_tiles + 1);
#line 227 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 230 "../src/game.vala"
	game_state_struct_init_empty_neighbors (&(*self));
#line 233 "../src/game.vala"
	(*self).current_player_can_move = TRUE;
#line 234 "../src/game.vala"
	(*self).is_complete = FALSE;
#line 235 "../src/game.vala"
	(*self).x_saved = (guint8) (((*self).size / 2) - 2);
#line 236 "../src/game.vala"
	(*self).y_saved = (guint8) (((*self).size / 2) - 2);
#line 1595 "game.c"
}

static Player*
_vala_array_dup12 (Player* self,
                   gssize length)
{
#line 250 "../src/game.vala"
	if (length > 0) {
#line 250 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (Player));
#line 1606 "game.c"
	}
#line 250 "../src/game.vala"
	return NULL;
#line 1610 "game.c"
}

void
game_state_struct_init_copy_and_add_two (GameStateStruct *self,
                                         GameStateStruct* game,
                                         guint8 x1,
                                         guint8 y1,
                                         guint8 x2,
                                         guint8 y2)
{
	GameStateStruct _tmp0_;
	GameStateStruct _tmp1_;
	GameStateStruct _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	GameStateStruct _tmp4_;
	Player* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	Player* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean _tmp7_ = FALSE;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	Player _tmp9_;
	GameStateStruct _tmp12_;
	GameStateStruct _tmp13_;
#line 239 "../src/game.vala"
	g_return_if_fail (game != NULL);
#line 239 "../src/game.vala"
	memset (self, 0, sizeof (GameStateStruct));
#line 242 "../src/game.vala"
	_tmp0_ = *game;
#line 242 "../src/game.vala"
	(*self).opponent_color = _tmp0_.current_color;
#line 243 "../src/game.vala"
	(*self).current_color = player_flip_color ((*self).opponent_color);
#line 246 "../src/game.vala"
	_tmp1_ = *game;
#line 246 "../src/game.vala"
	(*self).size = _tmp1_.size;
#line 247 "../src/game.vala"
	_tmp2_ = *game;
#line 247 "../src/game.vala"
	_tmp3_ = _tmp2_.neighbor_tiles;
#line 247 "../src/game.vala"
	_tmp3__length1 = _tmp2_.neighbor_tiles_length1;
#line 247 "../src/game.vala"
	_tmp3__length2 = _tmp2_.neighbor_tiles_length2;
#line 247 "../src/game.vala"
	(*self).neighbor_tiles = _tmp3_;
#line 247 "../src/game.vala"
	(*self).neighbor_tiles_length1 = _tmp3__length1;
#line 247 "../src/game.vala"
	(*self).neighbor_tiles_length2 = _tmp3__length2;
#line 250 "../src/game.vala"
	_tmp4_ = *game;
#line 250 "../src/game.vala"
	_tmp5_ = _tmp4_.tiles;
#line 250 "../src/game.vala"
	_tmp5__length1 = _tmp4_.tiles_length1;
#line 250 "../src/game.vala"
	_tmp5__length2 = _tmp4_.tiles_length2;
#line 250 "../src/game.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup12 (_tmp5_, _tmp5__length1 * _tmp5__length2) : _tmp5_;
#line 250 "../src/game.vala"
	_tmp6__length1 = _tmp5__length1;
#line 250 "../src/game.vala"
	_tmp6__length2 = _tmp5__length2;
#line 250 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 250 "../src/game.vala"
	(*self).tiles = _tmp6_;
#line 250 "../src/game.vala"
	(*self).tiles_length1 = _tmp6__length1;
#line 250 "../src/game.vala"
	(*self).tiles_length2 = _tmp6__length2;
#line 251 "../src/game.vala"
	_tmp8_ = (*self).tiles;
#line 251 "../src/game.vala"
	_tmp8__length1 = (*self).tiles_length1;
#line 251 "../src/game.vala"
	_tmp8__length2 = (*self).tiles_length2;
#line 251 "../src/game.vala"
	_tmp9_ = _tmp8_[(x1 * _tmp8__length2) + y1];
#line 251 "../src/game.vala"
	if (_tmp9_ != PLAYER_NONE) {
#line 251 "../src/game.vala"
		_tmp7_ = TRUE;
#line 1703 "game.c"
	} else {
		Player* _tmp10_;
		gint _tmp10__length1;
		gint _tmp10__length2;
		Player _tmp11_;
#line 252 "../src/game.vala"
		_tmp10_ = (*self).tiles;
#line 252 "../src/game.vala"
		_tmp10__length1 = (*self).tiles_length1;
#line 252 "../src/game.vala"
		_tmp10__length2 = (*self).tiles_length2;
#line 252 "../src/game.vala"
		_tmp11_ = _tmp10_[(x2 * _tmp10__length2) + y2];
#line 252 "../src/game.vala"
		_tmp7_ = _tmp11_ != PLAYER_NONE;
#line 1719 "game.c"
	}
#line 251 "../src/game.vala"
	if (_tmp7_) {
#line 253 "../src/game.vala"
		g_assert_not_reached ();
#line 1725 "game.c"
	}
#line 254 "../src/game.vala"
	(*self).tiles[(x1 * (*self).tiles_length2) + y1] = (*self).opponent_color;
#line 255 "../src/game.vala"
	(*self).tiles[(x2 * (*self).tiles_length2) + y2] = (*self).opponent_color;
#line 258 "../src/game.vala"
	_tmp12_ = *game;
#line 258 "../src/game.vala"
	(*self).n_current_tiles = _tmp12_.n_opponent_tiles;
#line 259 "../src/game.vala"
	_tmp13_ = *game;
#line 259 "../src/game.vala"
	(*self).n_opponent_tiles = (guint8) (_tmp13_.n_current_tiles + 2);
#line 260 "../src/game.vala"
	(*self).n_tiles = (*self).n_current_tiles + (*self).n_opponent_tiles;
#line 263 "../src/game.vala"
	game_state_struct_init_empty_neighbors (&(*self));
#line 266 "../src/game.vala"
	(*self).current_player_can_move = TRUE;
#line 267 "../src/game.vala"
	(*self).is_complete = FALSE;
#line 268 "../src/game.vala"
	(*self).x_saved = (guint8) (((*self).size / 2) - 2);
#line 269 "../src/game.vala"
	(*self).y_saved = (guint8) (((*self).size / 2) - 2);
#line 1751 "game.c"
}

inline gboolean
game_state_struct_is_current_color (GameStateStruct *self,
                                    guint8 x,
                                    guint8 y)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	gboolean result;
#line 279 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 279 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 279 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 279 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 279 "../src/game.vala"
	result = _tmp1_ == (*self).current_color;
#line 279 "../src/game.vala"
	return result;
#line 1776 "game.c"
}

inline gboolean
game_state_struct_is_empty_tile (GameStateStruct *self,
                                 guint8 x,
                                 guint8 y)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	gboolean result;
#line 285 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 285 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 285 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 285 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 285 "../src/game.vala"
	result = _tmp1_ == PLAYER_NONE;
#line 285 "../src/game.vala"
	return result;
#line 1801 "game.c"
}

static inline gboolean
game_state_struct_is_valid_location_signed (GameStateStruct *self,
                                            gint8 x,
                                            gint8 y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 290 "../src/game.vala"
	if (((gint) x) >= 0) {
#line 290 "../src/game.vala"
		_tmp2_ = ((guint8) x) < (*self).size;
#line 1817 "game.c"
	} else {
#line 290 "../src/game.vala"
		_tmp2_ = FALSE;
#line 1821 "game.c"
	}
#line 290 "../src/game.vala"
	if (_tmp2_) {
#line 291 "../src/game.vala"
		_tmp1_ = ((gint) y) >= 0;
#line 1827 "game.c"
	} else {
#line 290 "../src/game.vala"
		_tmp1_ = FALSE;
#line 1831 "game.c"
	}
#line 290 "../src/game.vala"
	if (_tmp1_) {
#line 291 "../src/game.vala"
		_tmp0_ = ((guint8) y) < (*self).size;
#line 1837 "game.c"
	} else {
#line 290 "../src/game.vala"
		_tmp0_ = FALSE;
#line 1841 "game.c"
	}
#line 290 "../src/game.vala"
	result = _tmp0_;
#line 290 "../src/game.vala"
	return result;
#line 1847 "game.c"
}

static void
game_state_struct_update_who_can_move (GameStateStruct *self)
{
	Player enemy = 0;
	gboolean opponent_can_move = FALSE;
#line 308 "../src/game.vala"
	enemy = player_flip_color ((*self).current_color);
#line 309 "../src/game.vala"
	opponent_can_move = FALSE;
#line 1859 "game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 310 "../src/game.vala"
		(*self).x_saved = (guint8) 0;
#line 310 "../src/game.vala"
		_tmp0_ = TRUE;
#line 310 "../src/game.vala"
		while (TRUE) {
#line 310 "../src/game.vala"
			if (!_tmp0_) {
#line 1870 "game.c"
				guint8 _tmp1_;
#line 310 "../src/game.vala"
				_tmp1_ = (*self).x_saved;
#line 310 "../src/game.vala"
				(*self).x_saved = _tmp1_ + 1;
#line 1876 "game.c"
			}
#line 310 "../src/game.vala"
			_tmp0_ = FALSE;
#line 310 "../src/game.vala"
			if (!((*self).x_saved < (*self).size)) {
#line 310 "../src/game.vala"
				break;
#line 1884 "game.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 312 "../src/game.vala"
				(*self).y_saved = (guint8) 0;
#line 312 "../src/game.vala"
				_tmp2_ = TRUE;
#line 312 "../src/game.vala"
				while (TRUE) {
#line 312 "../src/game.vala"
					if (!_tmp2_) {
#line 1896 "game.c"
						guint8 _tmp3_;
#line 312 "../src/game.vala"
						_tmp3_ = (*self).y_saved;
#line 312 "../src/game.vala"
						(*self).y_saved = _tmp3_ + 1;
#line 1902 "game.c"
					}
#line 312 "../src/game.vala"
					_tmp2_ = FALSE;
#line 312 "../src/game.vala"
					if (!((*self).y_saved < (*self).size)) {
#line 312 "../src/game.vala"
						break;
#line 1910 "game.c"
					}
#line 314 "../src/game.vala"
					if (game_state_struct_is_unplayable_basic (&(*self), (*self).x_saved, (*self).y_saved)) {
#line 315 "../src/game.vala"
						continue;
#line 1916 "game.c"
					}
#line 316 "../src/game.vala"
					if (game_state_struct_can_place (&(*self), (*self).x_saved, (*self).y_saved, (*self).current_color)) {
#line 318 "../src/game.vala"
						(*self).current_player_can_move = TRUE;
#line 319 "../src/game.vala"
						(*self).is_complete = FALSE;
#line 320 "../src/game.vala"
						return;
#line 1926 "game.c"
					}
#line 322 "../src/game.vala"
					if (opponent_can_move) {
#line 323 "../src/game.vala"
						continue;
#line 1932 "game.c"
					}
#line 324 "../src/game.vala"
					if (game_state_struct_can_place (&(*self), (*self).x_saved, (*self).y_saved, enemy)) {
#line 326 "../src/game.vala"
						opponent_can_move = TRUE;
#line 327 "../src/game.vala"
						(*self).is_complete = FALSE;
#line 1940 "game.c"
					}
				}
			}
		}
	}
#line 331 "../src/game.vala"
	(*self).current_player_can_move = FALSE;
#line 332 "../src/game.vala"
	if (!opponent_can_move) {
#line 333 "../src/game.vala"
		(*self).is_complete = TRUE;
#line 1952 "game.c"
	}
}

static void
_possible_move_free0_ (gpointer var)
{
#line 338 "../src/game.vala"
	(var == NULL) ? NULL : (var = (possible_move_free (var), NULL));
#line 1961 "game.c"
}

static inline void
_g_slist_free__possible_move_free0_ (GSList* self)
{
#line 338 "../src/game.vala"
	g_slist_free_full (self, (GDestroyNotify) _possible_move_free0_);
#line 1969 "game.c"
}

static gpointer
_possible_move_dup0 (gpointer self)
{
#line 349 "../src/game.vala"
	return self ? possible_move_dup (self) : NULL;
#line 1977 "game.c"
}

void
game_state_struct_get_possible_moves (GameStateStruct *self,
                                      GSList** moves)
{
	GSList* _vala_moves = NULL;
	guint8 x = 0U;
	guint8 y = 0U;
#line 338 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 338 "../src/game.vala"
	_vala_moves = NULL;
#line 341 "../src/game.vala"
	x = (*self).x_saved;
#line 342 "../src/game.vala"
	y = (*self).y_saved;
#line 1995 "game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 343 "../src/game.vala"
		_tmp0_ = TRUE;
#line 343 "../src/game.vala"
		while (TRUE) {
#line 343 "../src/game.vala"
			if (!_tmp0_) {
#line 2004 "game.c"
				guint8 _tmp1_;
#line 343 "../src/game.vala"
				_tmp1_ = x;
#line 343 "../src/game.vala"
				x = _tmp1_ + 1;
#line 2010 "game.c"
			}
#line 343 "../src/game.vala"
			_tmp0_ = FALSE;
#line 343 "../src/game.vala"
			if (!(x < (*self).size)) {
#line 343 "../src/game.vala"
				break;
#line 2018 "game.c"
			}
			{
				gboolean _tmp2_ = FALSE;
#line 345 "../src/game.vala"
				_tmp2_ = TRUE;
#line 345 "../src/game.vala"
				while (TRUE) {
#line 2026 "game.c"
					PossibleMove move = {0};
					PossibleMove _tmp4_ = {0};
					gboolean _tmp5_;
#line 345 "../src/game.vala"
					if (!_tmp2_) {
#line 2032 "game.c"
						guint8 _tmp3_;
#line 345 "../src/game.vala"
						_tmp3_ = y;
#line 345 "../src/game.vala"
						y = _tmp3_ + 1;
#line 2038 "game.c"
					}
#line 345 "../src/game.vala"
					_tmp2_ = FALSE;
#line 345 "../src/game.vala"
					if (!(y < (*self).size)) {
#line 345 "../src/game.vala"
						break;
#line 2046 "game.c"
					}
#line 348 "../src/game.vala"
					_tmp5_ = game_state_struct_place_tile (&(*self), x, y, (*self).current_color, &_tmp4_);
#line 348 "../src/game.vala"
					move = _tmp4_;
#line 348 "../src/game.vala"
					if (_tmp5_) {
#line 2054 "game.c"
						PossibleMove _tmp6_;
						PossibleMove* _tmp7_;
#line 349 "../src/game.vala"
						_tmp6_ = move;
#line 349 "../src/game.vala"
						_tmp7_ = _possible_move_dup0 (&_tmp6_);
#line 349 "../src/game.vala"
						_vala_moves = g_slist_prepend (_vala_moves, _tmp7_);
#line 2063 "game.c"
					}
				}
			}
#line 351 "../src/game.vala"
			y = (guint8) 0;
#line 2069 "game.c"
		}
	}
#line 336 "../src/game.vala"
	if (moves) {
#line 336 "../src/game.vala"
		*moves = _vala_moves;
#line 2076 "game.c"
	} else {
#line 336 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 2080 "game.c"
	}
}

inline gboolean
game_state_struct_test_placing_tile (GameStateStruct *self,
                                     guint8 x,
                                     guint8 y,
                                     PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	PossibleMove _tmp0_ = {0};
	gboolean _tmp1_;
	gboolean result;
#line 361 "../src/game.vala"
	_tmp1_ = game_state_struct_place_tile (&(*self), x, y, (*self).current_color, &_tmp0_);
#line 361 "../src/game.vala"
	_vala_move = _tmp0_;
#line 361 "../src/game.vala"
	result = _tmp1_;
#line 361 "../src/game.vala"
	if (move) {
#line 361 "../src/game.vala"
		*move = _vala_move;
#line 2104 "game.c"
	}
#line 361 "../src/game.vala"
	return result;
#line 2108 "game.c"
}

static inline gboolean
game_state_struct_is_unplayable_basic (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8 _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	guint8 _tmp3_;
	Player* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	Player _tmp5_;
	gboolean result;
#line 366 "../src/game.vala"
	_tmp0_ = (*self).empty_neighbors;
#line 366 "../src/game.vala"
	_tmp0__length1 = (*self).empty_neighbors_length1;
#line 366 "../src/game.vala"
	_tmp0__length2 = (*self).empty_neighbors_length2;
#line 366 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 366 "../src/game.vala"
	_tmp2_ = (*self).neighbor_tiles;
#line 366 "../src/game.vala"
	_tmp2__length1 = (*self).neighbor_tiles_length1;
#line 366 "../src/game.vala"
	_tmp2__length2 = (*self).neighbor_tiles_length2;
#line 366 "../src/game.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 366 "../src/game.vala"
	if (_tmp1_ == _tmp3_) {
#line 367 "../src/game.vala"
		result = TRUE;
#line 367 "../src/game.vala"
		return result;
#line 2151 "game.c"
	}
#line 368 "../src/game.vala"
	_tmp4_ = (*self).tiles;
#line 368 "../src/game.vala"
	_tmp4__length1 = (*self).tiles_length1;
#line 368 "../src/game.vala"
	_tmp4__length2 = (*self).tiles_length2;
#line 368 "../src/game.vala"
	_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
#line 368 "../src/game.vala"
	if (_tmp5_ != PLAYER_NONE) {
#line 369 "../src/game.vala"
		result = TRUE;
#line 369 "../src/game.vala"
		return result;
#line 2167 "game.c"
	}
#line 370 "../src/game.vala"
	result = FALSE;
#line 370 "../src/game.vala"
	return result;
#line 2173 "game.c"
}

static inline gboolean
game_state_struct_place_tile (GameStateStruct *self,
                              guint8 x,
                              guint8 y,
                              Player color,
                              PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	PossibleMove _tmp0_;
	PossibleMove _tmp1_;
	PossibleMove _tmp2_;
	PossibleMove _tmp3_;
	PossibleMove _tmp4_;
	PossibleMove _tmp5_;
	PossibleMove _tmp6_;
	PossibleMove _tmp7_;
	PossibleMove _tmp8_;
	gboolean result;
#line 376 "../src/game.vala"
	possible_move_init (&_vala_move, x, y);
#line 378 "../src/game.vala"
	if (game_state_struct_is_unplayable_basic (&(*self), x, y)) {
#line 379 "../src/game.vala"
		result = FALSE;
#line 379 "../src/game.vala"
		if (move) {
#line 379 "../src/game.vala"
			*move = _vala_move;
#line 2204 "game.c"
		}
#line 379 "../src/game.vala"
		return result;
#line 2208 "game.c"
	}
#line 381 "../src/game.vala"
	_vala_move.n_tiles_n = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) -1);
#line 382 "../src/game.vala"
	_vala_move.n_tiles_ne = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) -1);
#line 383 "../src/game.vala"
	_vala_move.n_tiles_e = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 0);
#line 384 "../src/game.vala"
	_vala_move.n_tiles_se = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 1);
#line 385 "../src/game.vala"
	_vala_move.n_tiles_s = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) 1);
#line 386 "../src/game.vala"
	_vala_move.n_tiles_so = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 1);
#line 387 "../src/game.vala"
	_vala_move.n_tiles_o = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 0);
#line 388 "../src/game.vala"
	_vala_move.n_tiles_no = game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) -1);
#line 390 "../src/game.vala"
	_tmp0_ = _vala_move;
#line 390 "../src/game.vala"
	_tmp1_ = _vala_move;
#line 390 "../src/game.vala"
	_tmp2_ = _vala_move;
#line 390 "../src/game.vala"
	_tmp3_ = _vala_move;
#line 390 "../src/game.vala"
	_tmp4_ = _vala_move;
#line 390 "../src/game.vala"
	_tmp5_ = _vala_move;
#line 390 "../src/game.vala"
	_tmp6_ = _vala_move;
#line 390 "../src/game.vala"
	_tmp7_ = _vala_move;
#line 390 "../src/game.vala"
	_vala_move.n_tiles = ((((((_tmp0_.n_tiles_n + _tmp1_.n_tiles_ne) + _tmp2_.n_tiles_e) + _tmp3_.n_tiles_se) + _tmp4_.n_tiles_s) + _tmp5_.n_tiles_so) + _tmp6_.n_tiles_o) + _tmp7_.n_tiles_no;
#line 394 "../src/game.vala"
	_tmp8_ = _vala_move;
#line 394 "../src/game.vala"
	result = ((gint) _tmp8_.n_tiles) != 0;
#line 394 "../src/game.vala"
	if (move) {
#line 394 "../src/game.vala"
		*move = _vala_move;
#line 2252 "game.c"
	}
#line 394 "../src/game.vala"
	return result;
#line 2256 "game.c"
}

/**
     * can_place:
     * @x: the x coordinate of the tile to test
     * @y: the y coordinate of the tile to test
     * @color: the player color to test
     *
     * You should test is_unplayable_basic() before launching this.
     *
     * This method is faster than place_tile(), as it returns early
     * when some turnable tiles are found in one of the directions.
     *
     * Returns: %true if the given @color can be play there
     */
static inline gboolean
game_state_struct_can_place (GameStateStruct *self,
                             guint8 x,
                             guint8 y,
                             Player color)
{
	gboolean result;
#line 413 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) -1)) > 0) {
#line 413 "../src/game.vala"
		result = TRUE;
#line 413 "../src/game.vala"
		return result;
#line 2285 "game.c"
	}
#line 414 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 1)) > 0) {
#line 414 "../src/game.vala"
		result = TRUE;
#line 414 "../src/game.vala"
		return result;
#line 2293 "game.c"
	}
#line 415 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 1)) > 0) {
#line 415 "../src/game.vala"
		result = TRUE;
#line 415 "../src/game.vala"
		return result;
#line 2301 "game.c"
	}
#line 416 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) -1)) > 0) {
#line 416 "../src/game.vala"
		result = TRUE;
#line 416 "../src/game.vala"
		return result;
#line 2309 "game.c"
	}
#line 417 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 1, (gint8) 0)) > 0) {
#line 417 "../src/game.vala"
		result = TRUE;
#line 417 "../src/game.vala"
		return result;
#line 2317 "game.c"
	}
#line 418 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) -1, (gint8) 0)) > 0) {
#line 418 "../src/game.vala"
		result = TRUE;
#line 418 "../src/game.vala"
		return result;
#line 2325 "game.c"
	}
#line 419 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) 1)) > 0) {
#line 419 "../src/game.vala"
		result = TRUE;
#line 419 "../src/game.vala"
		return result;
#line 2333 "game.c"
	}
#line 420 "../src/game.vala"
	if (((gint) game_state_struct_can_flip_tiles (&(*self), x, y, color, (gint8) 0, (gint8) -1)) > 0) {
#line 420 "../src/game.vala"
		result = TRUE;
#line 420 "../src/game.vala"
		return result;
#line 2341 "game.c"
	}
#line 421 "../src/game.vala"
	result = FALSE;
#line 421 "../src/game.vala"
	return result;
#line 2347 "game.c"
}

/**
     * can_flip_tiles:
     * @x: the x coordinate to start with
     * @y: the y coordinate to start with
     * @color: the player color to test
     * @x_step: the step on the x direction, %1, %0 or %-1
     * @y_step: the step on the y direction, %1, %0 or %-1
     *
     * Returns: the number of turnable tiles in the given direction
     */
static inline guint8
game_state_struct_can_flip_tiles (GameStateStruct *self,
                                  guint8 x,
                                  guint8 y,
                                  Player color,
                                  gint8 x_step,
                                  gint8 y_step)
{
	Player enemy = 0;
	gint8 enemy_count = 0;
	gboolean is_valid_location = FALSE;
	gint8 xt = 0;
	gint8 yt = 0;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	guint8 result;
#line 436 "../src/game.vala"
	enemy = player_flip_color (color);
#line 439 "../src/game.vala"
	enemy_count = (gint8) -1;
#line 440 "../src/game.vala"
	is_valid_location = FALSE;
#line 441 "../src/game.vala"
	xt = (gint8) x;
#line 442 "../src/game.vala"
	yt = (gint8) y;
#line 2386 "game.c"
	{
		gboolean _tmp0_ = FALSE;
#line 443 "../src/game.vala"
		_tmp0_ = TRUE;
#line 443 "../src/game.vala"
		while (TRUE) {
#line 2393 "game.c"
			gint8 _tmp4_;
#line 443 "../src/game.vala"
			if (!_tmp0_) {
#line 2397 "game.c"
				gboolean _tmp1_ = FALSE;
#line 449 "../src/game.vala"
				if (is_valid_location) {
#line 2401 "game.c"
					Player* _tmp2_;
					gint _tmp2__length1;
					gint _tmp2__length2;
					Player _tmp3_;
#line 449 "../src/game.vala"
					_tmp2_ = (*self).tiles;
#line 449 "../src/game.vala"
					_tmp2__length1 = (*self).tiles_length1;
#line 449 "../src/game.vala"
					_tmp2__length2 = (*self).tiles_length2;
#line 449 "../src/game.vala"
					_tmp3_ = _tmp2_[(xt * _tmp2__length2) + yt];
#line 449 "../src/game.vala"
					_tmp1_ = _tmp3_ == enemy;
#line 2416 "game.c"
				} else {
#line 449 "../src/game.vala"
					_tmp1_ = FALSE;
#line 2420 "game.c"
				}
#line 449 "../src/game.vala"
				if (!_tmp1_) {
#line 449 "../src/game.vala"
					break;
#line 2426 "game.c"
				}
			}
#line 443 "../src/game.vala"
			_tmp0_ = FALSE;
#line 444 "../src/game.vala"
			_tmp4_ = enemy_count;
#line 444 "../src/game.vala"
			enemy_count = _tmp4_ + 1;
#line 445 "../src/game.vala"
			xt += x_step;
#line 446 "../src/game.vala"
			yt += y_step;
#line 447 "../src/game.vala"
			is_valid_location = game_state_struct_is_valid_location_signed (&(*self), xt, yt);
#line 2441 "game.c"
		}
	}
#line 452 "../src/game.vala"
	if (((gint) enemy_count) <= 0) {
#line 452 "../src/game.vala"
		_tmp6_ = TRUE;
#line 2448 "game.c"
	} else {
#line 452 "../src/game.vala"
		_tmp6_ = !is_valid_location;
#line 2452 "game.c"
	}
#line 452 "../src/game.vala"
	if (_tmp6_) {
#line 452 "../src/game.vala"
		_tmp5_ = TRUE;
#line 2458 "game.c"
	} else {
		Player* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		Player _tmp8_;
#line 452 "../src/game.vala"
		_tmp7_ = (*self).tiles;
#line 452 "../src/game.vala"
		_tmp7__length1 = (*self).tiles_length1;
#line 452 "../src/game.vala"
		_tmp7__length2 = (*self).tiles_length2;
#line 452 "../src/game.vala"
		_tmp8_ = _tmp7_[(xt * _tmp7__length2) + yt];
#line 452 "../src/game.vala"
		_tmp5_ = _tmp8_ != color;
#line 2474 "game.c"
	}
#line 452 "../src/game.vala"
	if (_tmp5_) {
#line 453 "../src/game.vala"
		result = (guint8) 0;
#line 453 "../src/game.vala"
		return result;
#line 2482 "game.c"
	}
#line 455 "../src/game.vala"
	result = (guint8) enemy_count;
#line 455 "../src/game.vala"
	return result;
#line 2488 "game.c"
}

guint8
game_state_struct_get_empty_neighbors (GameStateStruct *self,
                                       guint8 x,
                                       guint8 y)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8 _tmp1_;
	guint8 result;
#line 466 "../src/game.vala"
	_tmp0_ = (*self).empty_neighbors;
#line 466 "../src/game.vala"
	_tmp0__length1 = (*self).empty_neighbors_length1;
#line 466 "../src/game.vala"
	_tmp0__length2 = (*self).empty_neighbors_length2;
#line 466 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 466 "../src/game.vala"
	result = _tmp1_;
#line 466 "../src/game.vala"
	return result;
#line 2513 "game.c"
}

static inline void
game_state_struct_init_empty_neighbors (GameStateStruct *self)
{
	guint8* _tmp0_;
	gint8 _size = 0;
	gint8 xmm = 0;
	gint8 ymm = 0;
	gint8 xpp = 0;
	gint8 ypp = 0;
	gboolean xmm_is_valid = FALSE;
	gboolean xpp_is_valid = FALSE;
#line 471 "../src/game.vala"
	_tmp0_ = g_new0 (guint8, (*self).size * (*self).size);
#line 471 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 471 "../src/game.vala"
	(*self).empty_neighbors = _tmp0_;
#line 471 "../src/game.vala"
	(*self).empty_neighbors_length1 = (*self).size;
#line 471 "../src/game.vala"
	(*self).empty_neighbors_length2 = (*self).size;
#line 472 "../src/game.vala"
	_size = (gint8) (*self).size;
#line 2539 "game.c"
	{
		gint8 x = 0;
#line 478 "../src/game.vala"
		x = (gint8) 0;
#line 2544 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 478 "../src/game.vala"
			_tmp1_ = TRUE;
#line 478 "../src/game.vala"
			while (TRUE) {
#line 478 "../src/game.vala"
				if (!_tmp1_) {
#line 2553 "game.c"
					gint8 _tmp2_;
#line 478 "../src/game.vala"
					_tmp2_ = x;
#line 478 "../src/game.vala"
					x = _tmp2_ + 1;
#line 2559 "game.c"
				}
#line 478 "../src/game.vala"
				_tmp1_ = FALSE;
#line 478 "../src/game.vala"
				if (!(x < _size)) {
#line 478 "../src/game.vala"
					break;
#line 2567 "game.c"
				}
#line 480 "../src/game.vala"
				xmm = (gint8) (x - 1);
#line 481 "../src/game.vala"
				xpp = (gint8) (x + 1);
#line 482 "../src/game.vala"
				xmm_is_valid = ((gint) xmm) >= 0;
#line 483 "../src/game.vala"
				xpp_is_valid = ((guint8) xpp) < (*self).size;
#line 2577 "game.c"
				{
					gint8 y = 0;
#line 485 "../src/game.vala"
					y = (gint8) 0;
#line 2582 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 485 "../src/game.vala"
						_tmp3_ = TRUE;
#line 485 "../src/game.vala"
						while (TRUE) {
#line 2589 "game.c"
							guint8 empty_neighbors_x_y = 0U;
#line 485 "../src/game.vala"
							if (!_tmp3_) {
#line 2593 "game.c"
								gint8 _tmp4_;
#line 485 "../src/game.vala"
								_tmp4_ = y;
#line 485 "../src/game.vala"
								y = _tmp4_ + 1;
#line 2599 "game.c"
							}
#line 485 "../src/game.vala"
							_tmp3_ = FALSE;
#line 485 "../src/game.vala"
							if (!(y < _size)) {
#line 485 "../src/game.vala"
								break;
#line 2607 "game.c"
							}
#line 487 "../src/game.vala"
							ymm = (gint8) (y - 1);
#line 488 "../src/game.vala"
							ypp = (gint8) (y + 1);
#line 490 "../src/game.vala"
							empty_neighbors_x_y = game_state_struct_is_empty (&(*self), x, ymm) + game_state_struct_is_empty (&(*self), x, ypp);
#line 492 "../src/game.vala"
							if (xmm_is_valid) {
#line 493 "../src/game.vala"
								empty_neighbors_x_y += (game_state_struct_is_empty (&(*self), xmm, y) + game_state_struct_is_empty (&(*self), xmm, ymm)) + game_state_struct_is_empty (&(*self), xmm, ypp);
#line 2619 "game.c"
							}
#line 496 "../src/game.vala"
							if (xpp_is_valid) {
#line 497 "../src/game.vala"
								empty_neighbors_x_y += (game_state_struct_is_empty (&(*self), xpp, y) + game_state_struct_is_empty (&(*self), xpp, ymm)) + game_state_struct_is_empty (&(*self), xpp, ypp);
#line 2625 "game.c"
							}
#line 501 "../src/game.vala"
							(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + y] = empty_neighbors_x_y;
#line 2629 "game.c"
						}
					}
				}
			}
		}
	}
}

static inline guint8
game_state_struct_is_empty (GameStateStruct *self,
                            gint8 x,
                            gint8 y)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player _tmp1_;
	guint8 result;
#line 508 "../src/game.vala"
	if (!game_state_struct_is_valid_location_signed (&(*self), x, y)) {
#line 509 "../src/game.vala"
		result = (guint8) 0;
#line 509 "../src/game.vala"
		return result;
#line 2654 "game.c"
	}
#line 510 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 510 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 510 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 510 "../src/game.vala"
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
#line 510 "../src/game.vala"
	if (_tmp1_ != PLAYER_NONE) {
#line 511 "../src/game.vala"
		result = (guint8) 0;
#line 511 "../src/game.vala"
		return result;
#line 2670 "game.c"
	}
#line 513 "../src/game.vala"
	result = (guint8) 1;
#line 513 "../src/game.vala"
	return result;
#line 2676 "game.c"
}

static inline void
game_state_struct_update_empty_neighbors (GameStateStruct *self,
                                          guint8 x,
                                          guint8 y)
{
	gint8 xmm = 0;
	gint8 ymm = 0;
	gint8 xpp = 0;
	gint8 ypp = 0;
	gboolean ymm_is_valid = FALSE;
	gboolean ypp_is_valid = FALSE;
#line 518 "../src/game.vala"
	xmm = (gint8) (((gint8) x) - 1);
#line 519 "../src/game.vala"
	ymm = (gint8) (((gint8) y) - 1);
#line 520 "../src/game.vala"
	xpp = (gint8) (xmm + 2);
#line 521 "../src/game.vala"
	ypp = (gint8) (ymm + 2);
#line 523 "../src/game.vala"
	ymm_is_valid = ((gint) ymm) >= 0;
#line 524 "../src/game.vala"
	ypp_is_valid = ((guint8) ypp) < (*self).size;
#line 526 "../src/game.vala"
	if (((gint) xmm) >= 0) {
#line 528 "../src/game.vala"
		(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + y] -= (guint8) 1;
#line 529 "../src/game.vala"
		if (ymm_is_valid) {
#line 529 "../src/game.vala"
			(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2710 "game.c"
		}
#line 530 "../src/game.vala"
		if (ypp_is_valid) {
#line 530 "../src/game.vala"
			(*self).empty_neighbors[(xmm * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2716 "game.c"
		}
	}
#line 532 "../src/game.vala"
	if (ymm_is_valid) {
#line 532 "../src/game.vala"
		(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2723 "game.c"
	}
#line 533 "../src/game.vala"
	if (ypp_is_valid) {
#line 533 "../src/game.vala"
		(*self).empty_neighbors[(x * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2729 "game.c"
	}
#line 534 "../src/game.vala"
	if (((guint8) xpp) < (*self).size) {
#line 536 "../src/game.vala"
		(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + y] -= (guint8) 1;
#line 537 "../src/game.vala"
		if (ymm_is_valid) {
#line 537 "../src/game.vala"
			(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + ymm] -= (guint8) 1;
#line 2739 "game.c"
		}
#line 538 "../src/game.vala"
		if (ypp_is_valid) {
#line 538 "../src/game.vala"
			(*self).empty_neighbors[(xpp * (*self).empty_neighbors_length2) + ypp] -= (guint8) 1;
#line 2745 "game.c"
		}
	}
}

Player*
game_state_struct_get_mainline (GameStateStruct *self,
                                MainLine mainline_id,
                                gint* result_length1)
{
	Player* mainline = NULL;
	Player* _tmp0_;
	gint mainline_length1;
	gint _mainline_size_;
	Player* _tmp31_;
	gint _tmp31__length1;
	Player* result;
#line 548 "../src/game.vala"
	_tmp0_ = g_new0 (Player, (*self).size);
#line 548 "../src/game.vala"
	mainline = _tmp0_;
#line 548 "../src/game.vala"
	mainline_length1 = (*self).size;
#line 548 "../src/game.vala"
	_mainline_size_ = mainline_length1;
#line 549 "../src/game.vala"
	switch (mainline_id) {
#line 549 "../src/game.vala"
		case MAIN_LINE_TOP:
#line 2774 "game.c"
		{
			{
				guint8 i = 0U;
#line 551 "../src/game.vala"
				i = (guint8) 0;
#line 2780 "game.c"
				{
					gboolean _tmp1_ = FALSE;
#line 551 "../src/game.vala"
					_tmp1_ = TRUE;
#line 551 "../src/game.vala"
					while (TRUE) {
#line 2787 "game.c"
						Player* _tmp3_;
						gint _tmp3__length1;
						Player* _tmp4_;
						gint _tmp4__length1;
						gint _tmp4__length2;
						Player _tmp5_;
#line 551 "../src/game.vala"
						if (!_tmp1_) {
#line 2796 "game.c"
							guint8 _tmp2_;
#line 551 "../src/game.vala"
							_tmp2_ = i;
#line 551 "../src/game.vala"
							i = _tmp2_ + 1;
#line 2802 "game.c"
						}
#line 551 "../src/game.vala"
						_tmp1_ = FALSE;
#line 551 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 551 "../src/game.vala"
							break;
#line 2810 "game.c"
						}
#line 551 "../src/game.vala"
						_tmp3_ = mainline;
#line 551 "../src/game.vala"
						_tmp3__length1 = mainline_length1;
#line 551 "../src/game.vala"
						_tmp4_ = (*self).tiles;
#line 551 "../src/game.vala"
						_tmp4__length1 = (*self).tiles_length1;
#line 551 "../src/game.vala"
						_tmp4__length2 = (*self).tiles_length2;
#line 551 "../src/game.vala"
						_tmp5_ = _tmp4_[(i * _tmp4__length2) + 0];
#line 551 "../src/game.vala"
						_tmp3_[i] = _tmp5_;
#line 2826 "game.c"
					}
				}
			}
#line 551 "../src/game.vala"
			break;
#line 2832 "game.c"
		}
#line 549 "../src/game.vala"
		case MAIN_LINE_LEFT:
#line 2836 "game.c"
		{
			{
				guint8 i = 0U;
#line 552 "../src/game.vala"
				i = (guint8) 0;
#line 2842 "game.c"
				{
					gboolean _tmp6_ = FALSE;
#line 552 "../src/game.vala"
					_tmp6_ = TRUE;
#line 552 "../src/game.vala"
					while (TRUE) {
#line 2849 "game.c"
						Player* _tmp8_;
						gint _tmp8__length1;
						Player* _tmp9_;
						gint _tmp9__length1;
						gint _tmp9__length2;
						Player _tmp10_;
#line 552 "../src/game.vala"
						if (!_tmp6_) {
#line 2858 "game.c"
							guint8 _tmp7_;
#line 552 "../src/game.vala"
							_tmp7_ = i;
#line 552 "../src/game.vala"
							i = _tmp7_ + 1;
#line 2864 "game.c"
						}
#line 552 "../src/game.vala"
						_tmp6_ = FALSE;
#line 552 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 552 "../src/game.vala"
							break;
#line 2872 "game.c"
						}
#line 552 "../src/game.vala"
						_tmp8_ = mainline;
#line 552 "../src/game.vala"
						_tmp8__length1 = mainline_length1;
#line 552 "../src/game.vala"
						_tmp9_ = (*self).tiles;
#line 552 "../src/game.vala"
						_tmp9__length1 = (*self).tiles_length1;
#line 552 "../src/game.vala"
						_tmp9__length2 = (*self).tiles_length2;
#line 552 "../src/game.vala"
						_tmp10_ = _tmp9_[(0 * _tmp9__length2) + i];
#line 552 "../src/game.vala"
						_tmp8_[i] = _tmp10_;
#line 2888 "game.c"
					}
				}
			}
#line 552 "../src/game.vala"
			break;
#line 2894 "game.c"
		}
#line 549 "../src/game.vala"
		case MAIN_LINE_RIGHT:
#line 2898 "game.c"
		{
			{
				guint8 i = 0U;
#line 553 "../src/game.vala"
				i = (guint8) 0;
#line 2904 "game.c"
				{
					gboolean _tmp11_ = FALSE;
#line 553 "../src/game.vala"
					_tmp11_ = TRUE;
#line 553 "../src/game.vala"
					while (TRUE) {
#line 2911 "game.c"
						Player* _tmp13_;
						gint _tmp13__length1;
						Player* _tmp14_;
						gint _tmp14__length1;
						gint _tmp14__length2;
						Player _tmp15_;
#line 553 "../src/game.vala"
						if (!_tmp11_) {
#line 2920 "game.c"
							guint8 _tmp12_;
#line 553 "../src/game.vala"
							_tmp12_ = i;
#line 553 "../src/game.vala"
							i = _tmp12_ + 1;
#line 2926 "game.c"
						}
#line 553 "../src/game.vala"
						_tmp11_ = FALSE;
#line 553 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 553 "../src/game.vala"
							break;
#line 2934 "game.c"
						}
#line 553 "../src/game.vala"
						_tmp13_ = mainline;
#line 553 "../src/game.vala"
						_tmp13__length1 = mainline_length1;
#line 553 "../src/game.vala"
						_tmp14_ = (*self).tiles;
#line 553 "../src/game.vala"
						_tmp14__length1 = (*self).tiles_length1;
#line 553 "../src/game.vala"
						_tmp14__length2 = (*self).tiles_length2;
#line 553 "../src/game.vala"
						_tmp15_ = _tmp14_[(((*self).size - 1) * _tmp14__length2) + i];
#line 553 "../src/game.vala"
						_tmp13_[i] = _tmp15_;
#line 2950 "game.c"
					}
				}
			}
#line 553 "../src/game.vala"
			break;
#line 2956 "game.c"
		}
#line 549 "../src/game.vala"
		case MAIN_LINE_BOTTOM:
#line 2960 "game.c"
		{
			{
				guint8 i = 0U;
#line 554 "../src/game.vala"
				i = (guint8) 0;
#line 2966 "game.c"
				{
					gboolean _tmp16_ = FALSE;
#line 554 "../src/game.vala"
					_tmp16_ = TRUE;
#line 554 "../src/game.vala"
					while (TRUE) {
#line 2973 "game.c"
						Player* _tmp18_;
						gint _tmp18__length1;
						Player* _tmp19_;
						gint _tmp19__length1;
						gint _tmp19__length2;
						Player _tmp20_;
#line 554 "../src/game.vala"
						if (!_tmp16_) {
#line 2982 "game.c"
							guint8 _tmp17_;
#line 554 "../src/game.vala"
							_tmp17_ = i;
#line 554 "../src/game.vala"
							i = _tmp17_ + 1;
#line 2988 "game.c"
						}
#line 554 "../src/game.vala"
						_tmp16_ = FALSE;
#line 554 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 554 "../src/game.vala"
							break;
#line 2996 "game.c"
						}
#line 554 "../src/game.vala"
						_tmp18_ = mainline;
#line 554 "../src/game.vala"
						_tmp18__length1 = mainline_length1;
#line 554 "../src/game.vala"
						_tmp19_ = (*self).tiles;
#line 554 "../src/game.vala"
						_tmp19__length1 = (*self).tiles_length1;
#line 554 "../src/game.vala"
						_tmp19__length2 = (*self).tiles_length2;
#line 554 "../src/game.vala"
						_tmp20_ = _tmp19_[(i * _tmp19__length2) + ((*self).size - 1)];
#line 554 "../src/game.vala"
						_tmp18_[i] = _tmp20_;
#line 3012 "game.c"
					}
				}
			}
#line 554 "../src/game.vala"
			break;
#line 3018 "game.c"
		}
#line 549 "../src/game.vala"
		case MAIN_LINE_TOPLEFT:
#line 3022 "game.c"
		{
			{
				guint8 i = 0U;
#line 555 "../src/game.vala"
				i = (guint8) 0;
#line 3028 "game.c"
				{
					gboolean _tmp21_ = FALSE;
#line 555 "../src/game.vala"
					_tmp21_ = TRUE;
#line 555 "../src/game.vala"
					while (TRUE) {
#line 3035 "game.c"
						Player* _tmp23_;
						gint _tmp23__length1;
						Player* _tmp24_;
						gint _tmp24__length1;
						gint _tmp24__length2;
						Player _tmp25_;
#line 555 "../src/game.vala"
						if (!_tmp21_) {
#line 3044 "game.c"
							guint8 _tmp22_;
#line 555 "../src/game.vala"
							_tmp22_ = i;
#line 555 "../src/game.vala"
							i = _tmp22_ + 1;
#line 3050 "game.c"
						}
#line 555 "../src/game.vala"
						_tmp21_ = FALSE;
#line 555 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 555 "../src/game.vala"
							break;
#line 3058 "game.c"
						}
#line 555 "../src/game.vala"
						_tmp23_ = mainline;
#line 555 "../src/game.vala"
						_tmp23__length1 = mainline_length1;
#line 555 "../src/game.vala"
						_tmp24_ = (*self).tiles;
#line 555 "../src/game.vala"
						_tmp24__length1 = (*self).tiles_length1;
#line 555 "../src/game.vala"
						_tmp24__length2 = (*self).tiles_length2;
#line 555 "../src/game.vala"
						_tmp25_ = _tmp24_[(i * _tmp24__length2) + i];
#line 555 "../src/game.vala"
						_tmp23_[i] = _tmp25_;
#line 3074 "game.c"
					}
				}
			}
#line 555 "../src/game.vala"
			break;
#line 3080 "game.c"
		}
#line 549 "../src/game.vala"
		case MAIN_LINE_TOPRIGHT:
#line 3084 "game.c"
		{
			{
				guint8 i = 0U;
#line 556 "../src/game.vala"
				i = (guint8) 0;
#line 3090 "game.c"
				{
					gboolean _tmp26_ = FALSE;
#line 556 "../src/game.vala"
					_tmp26_ = TRUE;
#line 556 "../src/game.vala"
					while (TRUE) {
#line 3097 "game.c"
						Player* _tmp28_;
						gint _tmp28__length1;
						Player* _tmp29_;
						gint _tmp29__length1;
						gint _tmp29__length2;
						Player _tmp30_;
#line 556 "../src/game.vala"
						if (!_tmp26_) {
#line 3106 "game.c"
							guint8 _tmp27_;
#line 556 "../src/game.vala"
							_tmp27_ = i;
#line 556 "../src/game.vala"
							i = _tmp27_ + 1;
#line 3112 "game.c"
						}
#line 556 "../src/game.vala"
						_tmp26_ = FALSE;
#line 556 "../src/game.vala"
						if (!(i < (*self).size)) {
#line 556 "../src/game.vala"
							break;
#line 3120 "game.c"
						}
#line 556 "../src/game.vala"
						_tmp28_ = mainline;
#line 556 "../src/game.vala"
						_tmp28__length1 = mainline_length1;
#line 556 "../src/game.vala"
						_tmp29_ = (*self).tiles;
#line 556 "../src/game.vala"
						_tmp29__length1 = (*self).tiles_length1;
#line 556 "../src/game.vala"
						_tmp29__length2 = (*self).tiles_length2;
#line 556 "../src/game.vala"
						_tmp30_ = _tmp29_[((((*self).size - 1) - i) * _tmp29__length2) + i];
#line 556 "../src/game.vala"
						_tmp28_[i] = _tmp30_;
#line 3136 "game.c"
					}
				}
			}
#line 556 "../src/game.vala"
			break;
#line 3142 "game.c"
		}
		default:
		{
#line 557 "../src/game.vala"
			g_assert_not_reached ();
#line 3148 "game.c"
		}
	}
#line 559 "../src/game.vala"
	_tmp31_ = mainline;
#line 559 "../src/game.vala"
	_tmp31__length1 = mainline_length1;
#line 559 "../src/game.vala"
	if (result_length1) {
#line 559 "../src/game.vala"
		*result_length1 = _tmp31__length1;
#line 3159 "game.c"
	}
#line 559 "../src/game.vala"
	result = _tmp31_;
#line 559 "../src/game.vala"
	return result;
#line 3165 "game.c"
}

static Player*
_vala_array_dup13 (Player* self,
                   gssize length)
{
#line 33 "../src/game.vala"
	if (length > 0) {
#line 33 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (Player));
#line 3176 "game.c"
	}
#line 33 "../src/game.vala"
	return NULL;
#line 3180 "game.c"
}

static guint8*
_vala_array_dup14 (guint8* self,
                   gssize length)
{
#line 33 "../src/game.vala"
	if (length > 0) {
#line 33 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 3191 "game.c"
	}
#line 33 "../src/game.vala"
	return NULL;
#line 3195 "game.c"
}

void
game_state_struct_copy (const GameStateStruct* self,
                        GameStateStruct* dest)
{
	Player* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Player* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	guint8* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
#line 33 "../src/game.vala"
	(*dest).current_color = (*self).current_color;
#line 33 "../src/game.vala"
	(*dest).opponent_color = (*self).opponent_color;
#line 33 "../src/game.vala"
	(*dest).size = (*self).size;
#line 33 "../src/game.vala"
	(*dest).n_current_tiles = (*self).n_current_tiles;
#line 33 "../src/game.vala"
	(*dest).n_opponent_tiles = (*self).n_opponent_tiles;
#line 33 "../src/game.vala"
	(*dest).n_tiles = (*self).n_tiles;
#line 33 "../src/game.vala"
	(*dest).current_player_can_move = (*self).current_player_can_move;
#line 33 "../src/game.vala"
	(*dest).is_complete = (*self).is_complete;
#line 33 "../src/game.vala"
	_tmp0_ = (*self).tiles;
#line 33 "../src/game.vala"
	_tmp0__length1 = (*self).tiles_length1;
#line 33 "../src/game.vala"
	_tmp0__length2 = (*self).tiles_length2;
#line 33 "../src/game.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup13 (_tmp0_, _tmp0__length1 * _tmp0__length2) : _tmp0_;
#line 33 "../src/game.vala"
	_tmp1__length1 = _tmp0__length1;
#line 33 "../src/game.vala"
	_tmp1__length2 = _tmp0__length2;
#line 33 "../src/game.vala"
	(*dest).tiles = (g_free ((*dest).tiles), NULL);
#line 33 "../src/game.vala"
	(*dest).tiles = _tmp1_;
#line 33 "../src/game.vala"
	(*dest).tiles_length1 = _tmp1__length1;
#line 33 "../src/game.vala"
	(*dest).tiles_length2 = _tmp1__length2;
#line 33 "../src/game.vala"
	_tmp2_ = (*self).neighbor_tiles;
#line 33 "../src/game.vala"
	_tmp2__length1 = (*self).neighbor_tiles_length1;
#line 33 "../src/game.vala"
	_tmp2__length2 = (*self).neighbor_tiles_length2;
#line 33 "../src/game.vala"
	(*dest).neighbor_tiles = _tmp2_;
#line 33 "../src/game.vala"
	(*dest).neighbor_tiles_length1 = _tmp2__length1;
#line 33 "../src/game.vala"
	(*dest).neighbor_tiles_length2 = _tmp2__length2;
#line 33 "../src/game.vala"
	(*dest).x_saved = (*self).x_saved;
#line 33 "../src/game.vala"
	(*dest).y_saved = (*self).y_saved;
#line 33 "../src/game.vala"
	_tmp3_ = (*self).empty_neighbors;
#line 33 "../src/game.vala"
	_tmp3__length1 = (*self).empty_neighbors_length1;
#line 33 "../src/game.vala"
	_tmp3__length2 = (*self).empty_neighbors_length2;
#line 33 "../src/game.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup14 (_tmp3_, _tmp3__length1 * _tmp3__length2) : _tmp3_;
#line 33 "../src/game.vala"
	_tmp4__length1 = _tmp3__length1;
#line 33 "../src/game.vala"
	_tmp4__length2 = _tmp3__length2;
#line 33 "../src/game.vala"
	(*dest).empty_neighbors = (g_free ((*dest).empty_neighbors), NULL);
#line 33 "../src/game.vala"
	(*dest).empty_neighbors = _tmp4_;
#line 33 "../src/game.vala"
	(*dest).empty_neighbors_length1 = _tmp4__length1;
#line 33 "../src/game.vala"
	(*dest).empty_neighbors_length2 = _tmp4__length2;
#line 3289 "game.c"
}

void
game_state_struct_destroy (GameStateStruct* self)
{
#line 46 "../src/game.vala"
	(*self).tiles = (g_free ((*self).tiles), NULL);
#line 462 "../src/game.vala"
	(*self).empty_neighbors = (g_free ((*self).empty_neighbors), NULL);
#line 3299 "game.c"
}

GameStateStruct*
game_state_struct_dup (const GameStateStruct* self)
{
	GameStateStruct* dup;
#line 33 "../src/game.vala"
	dup = g_new0 (GameStateStruct, 1);
#line 33 "../src/game.vala"
	game_state_struct_copy (self, dup);
#line 33 "../src/game.vala"
	return dup;
#line 3312 "game.c"
}

void
game_state_struct_free (GameStateStruct* self)
{
#line 33 "../src/game.vala"
	game_state_struct_destroy (self);
#line 33 "../src/game.vala"
	g_free (self);
#line 3322 "game.c"
}

static GType
game_state_struct_get_type_once (void)
{
	GType game_state_struct_type_id;
	game_state_struct_type_id = g_boxed_type_register_static ("GameStateStruct", (GBoxedCopyFunc) game_state_struct_dup, (GBoxedFreeFunc) game_state_struct_free);
	return game_state_struct_type_id;
}

GType
game_state_struct_get_type (void)
{
	static volatile gsize game_state_struct_type_id__once = 0;
	if (g_once_init_enter (&game_state_struct_type_id__once)) {
		GType game_state_struct_type_id;
		game_state_struct_type_id = game_state_struct_get_type_once ();
		g_once_init_leave (&game_state_struct_type_id__once, game_state_struct_type_id);
	}
	return game_state_struct_type_id__once;
}

static inline gpointer
game_state_object_get_instance_private (GameStateObject* self)
{
	return G_STRUCT_MEMBER_P (self, GameStateObject_private_offset);
}

gchar*
game_state_object_to_string (GameStateObject* self)
{
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 588 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 590 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 590 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 590 "../src/game.vala"
	_tmp2_ = game_state_struct_to_string (&_tmp1_);
#line 590 "../src/game.vala"
	result = _tmp2_;
#line 590 "../src/game.vala"
	return result;
#line 3370 "game.c"
}

GameStateObject*
game_state_object_construct_copy_and_pass (GType object_type,
                                           GameStateObject* game)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 597 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 597 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 599 "../src/game.vala"
	game_state_object_get_game_state_struct (game, &_tmp0_);
#line 599 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 599 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 599 "../src/game.vala"
	game_state_struct_init_copy_and_pass (&self->priv->_game_state_struct, &_tmp1_);
#line 597 "../src/game.vala"
	return self;
#line 3394 "game.c"
}

GameStateObject*
game_state_object_new_copy_and_pass (GameStateObject* game)
{
#line 597 "../src/game.vala"
	return game_state_object_construct_copy_and_pass (TYPE_GAME_STATE_OBJECT, game);
#line 3402 "game.c"
}

GameStateObject*
game_state_object_construct_copy_and_move (GType object_type,
                                           GameStateObject* game,
                                           PossibleMove* move)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	PossibleMove _tmp2_;
#line 602 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 602 "../src/game.vala"
	g_return_val_if_fail (move != NULL, NULL);
#line 602 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 604 "../src/game.vala"
	game_state_object_get_game_state_struct (game, &_tmp0_);
#line 604 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 604 "../src/game.vala"
	_tmp2_ = *move;
#line 604 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 604 "../src/game.vala"
	game_state_struct_init_copy_and_move (&self->priv->_game_state_struct, &_tmp1_, &_tmp2_);
#line 602 "../src/game.vala"
	return self;
#line 3432 "game.c"
}

GameStateObject*
game_state_object_new_copy_and_move (GameStateObject* game,
                                     PossibleMove* move)
{
#line 602 "../src/game.vala"
	return game_state_object_construct_copy_and_move (TYPE_GAME_STATE_OBJECT, game, move);
#line 3441 "game.c"
}

GameStateObject*
game_state_object_construct_from_grid (GType object_type,
                                       guint8 size,
                                       Player* tiles,
                                       gint tiles_length1,
                                       gint tiles_length2,
                                       Player color,
                                       guint8* neighbor_tiles,
                                       gint neighbor_tiles_length1,
                                       gint neighbor_tiles_length2,
                                       gboolean humans_opening)
{
	GameStateObject * self = NULL;
#line 607 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 609 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 609 "../src/game.vala"
	game_state_struct_init_from_grid (&self->priv->_game_state_struct, size, tiles, tiles_length1, tiles_length2, color, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2, humans_opening);
#line 607 "../src/game.vala"
	return self;
#line 3465 "game.c"
}

GameStateObject*
game_state_object_new_from_grid (guint8 size,
                                 Player* tiles,
                                 gint tiles_length1,
                                 gint tiles_length2,
                                 Player color,
                                 guint8* neighbor_tiles,
                                 gint neighbor_tiles_length1,
                                 gint neighbor_tiles_length2,
                                 gboolean humans_opening)
{
#line 607 "../src/game.vala"
	return game_state_object_construct_from_grid (TYPE_GAME_STATE_OBJECT, size, tiles, tiles_length1, tiles_length2, color, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2, humans_opening);
#line 3481 "game.c"
}

GameStateObject*
game_state_object_construct_empty (GType object_type,
                                   guint8 size,
                                   guint8* neighbor_tiles,
                                   gint neighbor_tiles_length1,
                                   gint neighbor_tiles_length2)
{
	GameStateObject * self = NULL;
#line 612 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 614 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 614 "../src/game.vala"
	game_state_struct_init_empty (&self->priv->_game_state_struct, size, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2);
#line 612 "../src/game.vala"
	return self;
#line 3500 "game.c"
}

GameStateObject*
game_state_object_new_empty (guint8 size,
                             guint8* neighbor_tiles,
                             gint neighbor_tiles_length1,
                             gint neighbor_tiles_length2)
{
#line 612 "../src/game.vala"
	return game_state_object_construct_empty (TYPE_GAME_STATE_OBJECT, size, neighbor_tiles, neighbor_tiles_length1, neighbor_tiles_length2);
#line 3511 "game.c"
}

GameStateObject*
game_state_object_construct_copy_and_add (GType object_type,
                                          GameStateObject* game,
                                          guint8 x,
                                          guint8 y)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 617 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 617 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 619 "../src/game.vala"
	game_state_object_get_game_state_struct (game, &_tmp0_);
#line 619 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 619 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 619 "../src/game.vala"
	game_state_struct_init_copy_and_add (&self->priv->_game_state_struct, &_tmp1_, x, y);
#line 617 "../src/game.vala"
	return self;
#line 3537 "game.c"
}

GameStateObject*
game_state_object_new_copy_and_add (GameStateObject* game,
                                    guint8 x,
                                    guint8 y)
{
#line 617 "../src/game.vala"
	return game_state_object_construct_copy_and_add (TYPE_GAME_STATE_OBJECT, game, x, y);
#line 3547 "game.c"
}

GameStateObject*
game_state_object_construct_copy_and_add_two (GType object_type,
                                              GameStateObject* game,
                                              guint8 x,
                                              guint8 y,
                                              guint8 x2,
                                              guint8 y2)
{
	GameStateObject * self = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 622 "../src/game.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 622 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 624 "../src/game.vala"
	game_state_object_get_game_state_struct (game, &_tmp0_);
#line 624 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 624 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 624 "../src/game.vala"
	game_state_struct_init_copy_and_add_two (&self->priv->_game_state_struct, &_tmp1_, x, y, x2, y2);
#line 622 "../src/game.vala"
	return self;
#line 3575 "game.c"
}

GameStateObject*
game_state_object_new_copy_and_add_two (GameStateObject* game,
                                        guint8 x,
                                        guint8 y,
                                        guint8 x2,
                                        guint8 y2)
{
#line 622 "../src/game.vala"
	return game_state_object_construct_copy_and_add_two (TYPE_GAME_STATE_OBJECT, game, x, y, x2, y2);
#line 3587 "game.c"
}

Player
game_state_object_get_owner (GameStateObject* self,
                             guint8 x,
                             guint8 y)
{
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	Player* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	Player _tmp3_;
	Player result;
#line 631 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 634 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 634 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 634 "../src/game.vala"
	_tmp2_ = _tmp1_.tiles;
#line 634 "../src/game.vala"
	_tmp2__length1 = _tmp1_.tiles_length1;
#line 634 "../src/game.vala"
	_tmp2__length2 = _tmp1_.tiles_length2;
#line 634 "../src/game.vala"
	_tmp3_ = _tmp2_[(x * _tmp2__length2) + y];
#line 634 "../src/game.vala"
	result = _tmp3_;
#line 634 "../src/game.vala"
	return result;
#line 3620 "game.c"
}

void
game_state_object_get_possible_moves (GameStateObject* self,
                                      GSList** moves)
{
	GSList* _vala_moves = NULL;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	GSList* _tmp2_ = NULL;
#line 641 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 643 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 643 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 643 "../src/game.vala"
	game_state_struct_get_possible_moves (&_tmp1_, &_tmp2_);
#line 643 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 643 "../src/game.vala"
	_vala_moves = _tmp2_;
#line 641 "../src/game.vala"
	if (moves) {
#line 641 "../src/game.vala"
		*moves = _vala_moves;
#line 3647 "game.c"
	} else {
#line 641 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 3651 "game.c"
	}
}

gboolean
game_state_object_test_placing_tile (GameStateObject* self,
                                     guint8 x,
                                     guint8 y,
                                     PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
	gboolean result;
#line 646 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 648 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 648 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 648 "../src/game.vala"
	_tmp3_ = game_state_struct_test_placing_tile (&_tmp1_, x, y, &_tmp2_);
#line 648 "../src/game.vala"
	_vala_move = _tmp2_;
#line 648 "../src/game.vala"
	result = _tmp3_;
#line 648 "../src/game.vala"
	if (move) {
#line 648 "../src/game.vala"
		*move = _vala_move;
#line 3683 "game.c"
	}
#line 648 "../src/game.vala"
	return result;
#line 3687 "game.c"
}

GameStateObject*
game_state_object_construct (GType object_type)
{
	GameStateObject * self = NULL;
#line 563 "../src/game.vala"
	self = (GameStateObject*) g_object_new (object_type, NULL);
#line 563 "../src/game.vala"
	return self;
#line 3698 "game.c"
}

GameStateObject*
game_state_object_new (void)
{
#line 563 "../src/game.vala"
	return game_state_object_construct (TYPE_GAME_STATE_OBJECT);
#line 3706 "game.c"
}

void
game_state_object_get_game_state_struct (GameStateObject* self,
                                         GameStateStruct * result)
{
	GameStateStruct _tmp0_;
#line 566 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 566 "../src/game.vala"
	_tmp0_ = self->priv->_game_state_struct;
#line 566 "../src/game.vala"
	*result = _tmp0_;
#line 566 "../src/game.vala"
	return;
#line 3722 "game.c"
}

Player
game_state_object_get_current_color (GameStateObject* self)
{
	Player result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 568 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 568 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 568 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 568 "../src/game.vala"
	result = _tmp1_.current_color;
#line 568 "../src/game.vala"
	return result;
#line 3741 "game.c"
}

guint8
game_state_object_get_n_light_tiles (GameStateObject* self)
{
	guint8 result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	GameStateStruct _tmp4_ = {0};
	GameStateStruct _tmp5_;
#line 570 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 571 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 571 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 571 "../src/game.vala"
	if (_tmp1_.current_color == PLAYER_LIGHT) {
#line 3760 "game.c"
		GameStateStruct _tmp2_ = {0};
		GameStateStruct _tmp3_;
#line 572 "../src/game.vala"
		game_state_object_get_game_state_struct (self, &_tmp2_);
#line 572 "../src/game.vala"
		_tmp3_ = _tmp2_;
#line 572 "../src/game.vala"
		result = _tmp3_.n_current_tiles;
#line 572 "../src/game.vala"
		return result;
#line 3771 "game.c"
	}
#line 574 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp4_);
#line 574 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 574 "../src/game.vala"
	result = _tmp5_.n_opponent_tiles;
#line 574 "../src/game.vala"
	return result;
#line 3781 "game.c"
}

guint8
game_state_object_get_n_dark_tiles (GameStateObject* self)
{
	guint8 result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
	GameStateStruct _tmp4_ = {0};
	GameStateStruct _tmp5_;
#line 577 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 578 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 578 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 578 "../src/game.vala"
	if (_tmp1_.current_color == PLAYER_DARK) {
#line 3800 "game.c"
		GameStateStruct _tmp2_ = {0};
		GameStateStruct _tmp3_;
#line 579 "../src/game.vala"
		game_state_object_get_game_state_struct (self, &_tmp2_);
#line 579 "../src/game.vala"
		_tmp3_ = _tmp2_;
#line 579 "../src/game.vala"
		result = _tmp3_.n_current_tiles;
#line 579 "../src/game.vala"
		return result;
#line 3811 "game.c"
	}
#line 581 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp4_);
#line 581 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 581 "../src/game.vala"
	result = _tmp5_.n_opponent_tiles;
#line 581 "../src/game.vala"
	return result;
#line 3821 "game.c"
}

gboolean
game_state_object_get_current_player_can_move (GameStateObject* self)
{
	gboolean result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 585 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 585 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 585 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 585 "../src/game.vala"
	result = _tmp1_.current_player_can_move;
#line 585 "../src/game.vala"
	return result;
#line 3840 "game.c"
}

gboolean
game_state_object_get_is_complete (GameStateObject* self)
{
	gboolean result;
	GameStateStruct _tmp0_ = {0};
	GameStateStruct _tmp1_;
#line 586 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 586 "../src/game.vala"
	game_state_object_get_game_state_struct (self, &_tmp0_);
#line 586 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 586 "../src/game.vala"
	result = _tmp1_.is_complete;
#line 586 "../src/game.vala"
	return result;
#line 3859 "game.c"
}

static void
game_state_object_class_init (GameStateObjectClass * klass,
                              gpointer klass_data)
{
#line 563 "../src/game.vala"
	game_state_object_parent_class = g_type_class_peek_parent (klass);
#line 563 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &GameStateObject_private_offset);
#line 563 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_state_object_get_property;
#line 563 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_state_object_finalize;
#line 563 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY] = g_param_spec_boxed ("game-state-struct", "game-state-struct", "game-state-struct", TYPE_GAME_STATE_STRUCT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 563 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 563 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 563 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 563 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 563 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY, game_state_object_properties[GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 3886 "game.c"
}

static void
game_state_object_instance_init (GameStateObject * self,
                                 gpointer klass)
{
#line 563 "../src/game.vala"
	self->priv = game_state_object_get_instance_private (self);
#line 3895 "game.c"
}

static void
game_state_object_finalize (GObject * obj)
{
	GameStateObject * self;
#line 563 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_STATE_OBJECT, GameStateObject);
#line 565 "../src/game.vala"
	game_state_struct_destroy (&self->priv->_game_state_struct);
#line 563 "../src/game.vala"
	G_OBJECT_CLASS (game_state_object_parent_class)->finalize (obj);
#line 3908 "game.c"
}

static GType
game_state_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameStateObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_state_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameStateObject), 0, (GInstanceInitFunc) game_state_object_instance_init, NULL };
	GType game_state_object_type_id;
	game_state_object_type_id = g_type_register_static (G_TYPE_OBJECT, "GameStateObject", &g_define_type_info, 0);
	GameStateObject_private_offset = g_type_add_instance_private (game_state_object_type_id, sizeof (GameStateObjectPrivate));
	return game_state_object_type_id;
}

GType
game_state_object_get_type (void)
{
	static volatile gsize game_state_object_type_id__once = 0;
	if (g_once_init_enter (&game_state_object_type_id__once)) {
		GType game_state_object_type_id;
		game_state_object_type_id = game_state_object_get_type_once ();
		g_once_init_leave (&game_state_object_type_id__once, game_state_object_type_id);
	}
	return game_state_object_type_id__once;
}

static void
_vala_game_state_object_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	GameStateObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_STATE_OBJECT, GameStateObject);
#line 563 "../src/game.vala"
	switch (property_id) {
#line 563 "../src/game.vala"
		case GAME_STATE_OBJECT_GAME_STATE_STRUCT_PROPERTY:
#line 3945 "game.c"
		{
			GameStateStruct boxed;
#line 563 "../src/game.vala"
			game_state_object_get_game_state_struct (self, &boxed);
#line 563 "../src/game.vala"
			g_value_set_boxed (value, &boxed);
#line 3952 "game.c"
		}
#line 563 "../src/game.vala"
		break;
#line 563 "../src/game.vala"
		case GAME_STATE_OBJECT_CURRENT_COLOR_PROPERTY:
#line 563 "../src/game.vala"
		g_value_set_enum (value, game_state_object_get_current_color (self));
#line 563 "../src/game.vala"
		break;
#line 563 "../src/game.vala"
		case GAME_STATE_OBJECT_N_LIGHT_TILES_PROPERTY:
#line 563 "../src/game.vala"
		g_value_set_uchar (value, game_state_object_get_n_light_tiles (self));
#line 563 "../src/game.vala"
		break;
#line 563 "../src/game.vala"
		case GAME_STATE_OBJECT_N_DARK_TILES_PROPERTY:
#line 563 "../src/game.vala"
		g_value_set_uchar (value, game_state_object_get_n_dark_tiles (self));
#line 563 "../src/game.vala"
		break;
#line 563 "../src/game.vala"
		case GAME_STATE_OBJECT_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
#line 563 "../src/game.vala"
		g_value_set_boolean (value, game_state_object_get_current_player_can_move (self));
#line 563 "../src/game.vala"
		break;
#line 563 "../src/game.vala"
		case GAME_STATE_OBJECT_IS_COMPLETE_PROPERTY:
#line 563 "../src/game.vala"
		g_value_set_boolean (value, game_state_object_get_is_complete (self));
#line 563 "../src/game.vala"
		break;
#line 3986 "game.c"
		default:
#line 563 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 563 "../src/game.vala"
		break;
#line 3992 "game.c"
	}
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gboolean _reverse,
                Opening _opening,
                guint8 _size,
                gboolean _print_logs)
{
	Game * self = NULL;
	guint8* _neighbor_tiles = NULL;
	gint _neighbor_tiles_length1 = 0;
	gint _neighbor_tiles_length2 = 0;
	guint8* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GameStateObject* _current_state = NULL;
	guint8 _initial_number_of_tiles = 0U;
	gboolean even_board = FALSE;
	gboolean humans_opening = FALSE;
	gboolean _tmp3_ = FALSE;
	GameStateObject* _tmp18_;
	guint8* _tmp19_;
	gint _tmp19__length1;
	gint _tmp19__length2;
#line 695 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
#line 695 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
#line 700 "../src/game.vala"
	game_init_neighbor_tiles (_size, &_tmp0_, &_tmp1_, &_tmp2_);
#line 700 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 700 "../src/game.vala"
	_neighbor_tiles = _tmp0_;
#line 700 "../src/game.vala"
	_neighbor_tiles_length1 = _tmp1_;
#line 700 "../src/game.vala"
	_neighbor_tiles_length2 = _tmp2_;
#line 704 "../src/game.vala"
	even_board = (_size % 2) == 0;
#line 705 "../src/game.vala"
	humans_opening = _opening == OPENING_HUMANS;
#line 706 "../src/game.vala"
	if (even_board) {
#line 706 "../src/game.vala"
		_tmp3_ = humans_opening;
#line 4047 "game.c"
	} else {
#line 706 "../src/game.vala"
		_tmp3_ = FALSE;
#line 4051 "game.c"
	}
#line 706 "../src/game.vala"
	if (_tmp3_) {
#line 4055 "game.c"
		guint8* _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		GameStateObject* _tmp5_;
#line 708 "../src/game.vala"
		_initial_number_of_tiles = (guint8) 0;
#line 710 "../src/game.vala"
		_tmp4_ = _neighbor_tiles;
#line 710 "../src/game.vala"
		_tmp4__length1 = _neighbor_tiles_length1;
#line 710 "../src/game.vala"
		_tmp4__length2 = _neighbor_tiles_length2;
#line 710 "../src/game.vala"
		_tmp5_ = game_state_object_new_empty (_size, _tmp4_, _tmp4__length1, _tmp4__length2);
#line 710 "../src/game.vala"
		_g_object_unref0 (_current_state);
#line 710 "../src/game.vala"
		_current_state = _tmp5_;
#line 4074 "game.c"
	} else {
		Player* tiles = NULL;
		Player* _tmp6_;
		gint tiles_length1;
		gint tiles_length2;
		Player _tmp14_ = 0;
		Player first_player = 0;
		Player* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		guint8* _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		GameStateObject* _tmp17_;
#line 714 "../src/game.vala"
		_tmp6_ = g_new0 (Player, _size * _size);
#line 714 "../src/game.vala"
		tiles = _tmp6_;
#line 714 "../src/game.vala"
		tiles_length1 = _size;
#line 714 "../src/game.vala"
		tiles_length2 = _size;
#line 4097 "game.c"
		{
			guint8 x = 0U;
#line 716 "../src/game.vala"
			x = (guint8) 0;
#line 4102 "game.c"
			{
				gboolean _tmp7_ = FALSE;
#line 716 "../src/game.vala"
				_tmp7_ = TRUE;
#line 716 "../src/game.vala"
				while (TRUE) {
#line 716 "../src/game.vala"
					if (!_tmp7_) {
#line 4111 "game.c"
						guint8 _tmp8_;
#line 716 "../src/game.vala"
						_tmp8_ = x;
#line 716 "../src/game.vala"
						x = _tmp8_ + 1;
#line 4117 "game.c"
					}
#line 716 "../src/game.vala"
					_tmp7_ = FALSE;
#line 716 "../src/game.vala"
					if (!(x < _size)) {
#line 716 "../src/game.vala"
						break;
#line 4125 "game.c"
					}
					{
						guint8 y = 0U;
#line 717 "../src/game.vala"
						y = (guint8) 0;
#line 4131 "game.c"
						{
							gboolean _tmp9_ = FALSE;
#line 717 "../src/game.vala"
							_tmp9_ = TRUE;
#line 717 "../src/game.vala"
							while (TRUE) {
#line 4138 "game.c"
								Player* _tmp11_;
								gint _tmp11__length1;
								gint _tmp11__length2;
#line 717 "../src/game.vala"
								if (!_tmp9_) {
#line 4144 "game.c"
									guint8 _tmp10_;
#line 717 "../src/game.vala"
									_tmp10_ = y;
#line 717 "../src/game.vala"
									y = _tmp10_ + 1;
#line 4150 "game.c"
								}
#line 717 "../src/game.vala"
								_tmp9_ = FALSE;
#line 717 "../src/game.vala"
								if (!(y < _size)) {
#line 717 "../src/game.vala"
									break;
#line 4158 "game.c"
								}
#line 718 "../src/game.vala"
								_tmp11_ = tiles;
#line 718 "../src/game.vala"
								_tmp11__length1 = tiles_length1;
#line 718 "../src/game.vala"
								_tmp11__length2 = tiles_length2;
#line 718 "../src/game.vala"
								_tmp11_[(x * _tmp11__length2) + y] = PLAYER_NONE;
#line 4168 "game.c"
							}
						}
					}
				}
			}
		}
#line 720 "../src/game.vala"
		if (even_board) {
#line 4177 "game.c"
			guint8 _tmp12_ = 0U;
#line 721 "../src/game.vala"
			game_setup_even_board (_size, _opening, &tiles, (gint*) (&tiles_length1), (gint*) (&tiles_length2), &_tmp12_);
#line 721 "../src/game.vala"
			_initial_number_of_tiles = _tmp12_;
#line 4183 "game.c"
		} else {
			guint8 _tmp13_ = 0U;
#line 723 "../src/game.vala"
			game_setup_odd_board (_size, _opening, &tiles, (gint*) (&tiles_length1), (gint*) (&tiles_length2), &_tmp13_);
#line 723 "../src/game.vala"
			_initial_number_of_tiles = _tmp13_;
#line 4190 "game.c"
		}
#line 725 "../src/game.vala"
		if (humans_opening) {
#line 725 "../src/game.vala"
			_tmp14_ = PLAYER_LIGHT;
#line 4196 "game.c"
		} else {
#line 725 "../src/game.vala"
			_tmp14_ = PLAYER_DARK;
#line 4200 "game.c"
		}
#line 725 "../src/game.vala"
		first_player = _tmp14_;
#line 726 "../src/game.vala"
		_tmp15_ = tiles;
#line 726 "../src/game.vala"
		_tmp15__length1 = tiles_length1;
#line 726 "../src/game.vala"
		_tmp15__length2 = tiles_length2;
#line 726 "../src/game.vala"
		_tmp16_ = _neighbor_tiles;
#line 726 "../src/game.vala"
		_tmp16__length1 = _neighbor_tiles_length1;
#line 726 "../src/game.vala"
		_tmp16__length2 = _neighbor_tiles_length2;
#line 726 "../src/game.vala"
		_tmp17_ = game_state_object_new_from_grid (_size, _tmp15_, _tmp15__length1, _tmp15__length2, first_player, _tmp16_, _tmp16__length1, _tmp16__length2, humans_opening);
#line 726 "../src/game.vala"
		_g_object_unref0 (_current_state);
#line 726 "../src/game.vala"
		_current_state = _tmp17_;
#line 706 "../src/game.vala"
		tiles = (g_free (tiles), NULL);
#line 4224 "game.c"
	}
#line 729 "../src/game.vala"
	_tmp18_ = _current_state;
#line 729 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "size", _size, "reverse", _reverse, "opening", _opening, "current-state", _tmp18_, "initial-number-of-tiles", _initial_number_of_tiles, "print-logs", _print_logs, NULL);
#line 735 "../src/game.vala"
	_tmp19_ = _neighbor_tiles;
#line 735 "../src/game.vala"
	_tmp19__length1 = _neighbor_tiles_length1;
#line 735 "../src/game.vala"
	_tmp19__length2 = _neighbor_tiles_length2;
#line 735 "../src/game.vala"
	_neighbor_tiles = NULL;
#line 735 "../src/game.vala"
	_neighbor_tiles_length1 = 0;
#line 735 "../src/game.vala"
	_neighbor_tiles_length2 = 0;
#line 735 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 735 "../src/game.vala"
	self->priv->neighbor_tiles = _tmp19_;
#line 735 "../src/game.vala"
	self->priv->neighbor_tiles_length1 = _tmp19__length1;
#line 735 "../src/game.vala"
	self->priv->neighbor_tiles_length2 = _tmp19__length2;
#line 695 "../src/game.vala"
	_g_object_unref0 (_current_state);
#line 695 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 695 "../src/game.vala"
	return self;
#line 4256 "game.c"
}

Game*
game_new (gboolean _reverse,
          Opening _opening,
          guint8 _size,
          gboolean _print_logs)
{
#line 695 "../src/game.vala"
	return game_construct (TYPE_GAME, _reverse, _opening, _size, _print_logs);
#line 4267 "game.c"
}

static inline void
game_setup_even_board (guint8 size,
                       Opening opening,
                       Player** tiles,
                       gint* tiles_length1,
                       gint* tiles_length2,
                       guint8* initial_number_of_tiles)
{
	guint8 _vala_initial_number_of_tiles = 0U;
	guint8 half_size = 0U;
	Player* start_position = NULL;
	gint start_position_length1 = 0;
	gint start_position_length2 = 0;
	Player* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	Player _tmp7_;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	Player _tmp9_;
	Player* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	Player _tmp11_;
	Player* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	Player _tmp13_;
#line 740 "../src/game.vala"
	half_size = (guint8) (size / 2);
#line 741 "../src/game.vala"
	_vala_initial_number_of_tiles = (guint8) 4;
#line 743 "../src/game.vala"
	switch (opening) {
#line 743 "../src/game.vala"
		case OPENING_REVERSI:
#line 4307 "game.c"
		{
			Player* _tmp0_;
#line 745 "../src/game.vala"
			_tmp0_ = g_new0 (Player, 2 * 2);
#line 745 "../src/game.vala"
			_tmp0_[0] = PLAYER_LIGHT;
#line 745 "../src/game.vala"
			_tmp0_[1] = PLAYER_DARK;
#line 745 "../src/game.vala"
			_tmp0_[2] = PLAYER_DARK;
#line 745 "../src/game.vala"
			_tmp0_[3] = PLAYER_LIGHT;
#line 745 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 745 "../src/game.vala"
			start_position = _tmp0_;
#line 745 "../src/game.vala"
			start_position_length1 = 2;
#line 745 "../src/game.vala"
			start_position_length2 = 2;
#line 745 "../src/game.vala"
			break;
#line 4330 "game.c"
		}
#line 743 "../src/game.vala"
		case OPENING_INVERTED:
#line 4334 "game.c"
		{
			Player* _tmp1_;
#line 746 "../src/game.vala"
			_tmp1_ = g_new0 (Player, 2 * 2);
#line 746 "../src/game.vala"
			_tmp1_[0] = PLAYER_DARK;
#line 746 "../src/game.vala"
			_tmp1_[1] = PLAYER_LIGHT;
#line 746 "../src/game.vala"
			_tmp1_[2] = PLAYER_LIGHT;
#line 746 "../src/game.vala"
			_tmp1_[3] = PLAYER_DARK;
#line 746 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 746 "../src/game.vala"
			start_position = _tmp1_;
#line 746 "../src/game.vala"
			start_position_length1 = 2;
#line 746 "../src/game.vala"
			start_position_length2 = 2;
#line 746 "../src/game.vala"
			break;
#line 4357 "game.c"
		}
#line 743 "../src/game.vala"
		case OPENING_ALTER_TOP:
#line 4361 "game.c"
		{
			Player* _tmp2_;
#line 747 "../src/game.vala"
			_tmp2_ = g_new0 (Player, 2 * 2);
#line 747 "../src/game.vala"
			_tmp2_[0] = PLAYER_DARK;
#line 747 "../src/game.vala"
			_tmp2_[1] = PLAYER_DARK;
#line 747 "../src/game.vala"
			_tmp2_[2] = PLAYER_LIGHT;
#line 747 "../src/game.vala"
			_tmp2_[3] = PLAYER_LIGHT;
#line 747 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 747 "../src/game.vala"
			start_position = _tmp2_;
#line 747 "../src/game.vala"
			start_position_length1 = 2;
#line 747 "../src/game.vala"
			start_position_length2 = 2;
#line 747 "../src/game.vala"
			break;
#line 4384 "game.c"
		}
#line 743 "../src/game.vala"
		case OPENING_ALTER_LEFT:
#line 4388 "game.c"
		{
			Player* _tmp3_;
#line 748 "../src/game.vala"
			_tmp3_ = g_new0 (Player, 2 * 2);
#line 748 "../src/game.vala"
			_tmp3_[0] = PLAYER_DARK;
#line 748 "../src/game.vala"
			_tmp3_[1] = PLAYER_LIGHT;
#line 748 "../src/game.vala"
			_tmp3_[2] = PLAYER_DARK;
#line 748 "../src/game.vala"
			_tmp3_[3] = PLAYER_LIGHT;
#line 748 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 748 "../src/game.vala"
			start_position = _tmp3_;
#line 748 "../src/game.vala"
			start_position_length1 = 2;
#line 748 "../src/game.vala"
			start_position_length2 = 2;
#line 748 "../src/game.vala"
			break;
#line 4411 "game.c"
		}
#line 743 "../src/game.vala"
		case OPENING_ALTER_RIGHT:
#line 4415 "game.c"
		{
			Player* _tmp4_;
#line 749 "../src/game.vala"
			_tmp4_ = g_new0 (Player, 2 * 2);
#line 749 "../src/game.vala"
			_tmp4_[0] = PLAYER_LIGHT;
#line 749 "../src/game.vala"
			_tmp4_[1] = PLAYER_DARK;
#line 749 "../src/game.vala"
			_tmp4_[2] = PLAYER_LIGHT;
#line 749 "../src/game.vala"
			_tmp4_[3] = PLAYER_DARK;
#line 749 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 749 "../src/game.vala"
			start_position = _tmp4_;
#line 749 "../src/game.vala"
			start_position_length1 = 2;
#line 749 "../src/game.vala"
			start_position_length2 = 2;
#line 749 "../src/game.vala"
			break;
#line 4438 "game.c"
		}
#line 743 "../src/game.vala"
		case OPENING_ALTER_BOTTOM:
#line 4442 "game.c"
		{
			Player* _tmp5_;
#line 750 "../src/game.vala"
			_tmp5_ = g_new0 (Player, 2 * 2);
#line 750 "../src/game.vala"
			_tmp5_[0] = PLAYER_LIGHT;
#line 750 "../src/game.vala"
			_tmp5_[1] = PLAYER_LIGHT;
#line 750 "../src/game.vala"
			_tmp5_[2] = PLAYER_DARK;
#line 750 "../src/game.vala"
			_tmp5_[3] = PLAYER_DARK;
#line 750 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 750 "../src/game.vala"
			start_position = _tmp5_;
#line 750 "../src/game.vala"
			start_position_length1 = 2;
#line 750 "../src/game.vala"
			start_position_length2 = 2;
#line 750 "../src/game.vala"
			break;
#line 4465 "game.c"
		}
		default:
		{
#line 751 "../src/game.vala"
			g_assert_not_reached ();
#line 4471 "game.c"
		}
	}
#line 753 "../src/game.vala"
	_tmp6_ = start_position;
#line 753 "../src/game.vala"
	_tmp6__length1 = start_position_length1;
#line 753 "../src/game.vala"
	_tmp6__length2 = start_position_length2;
#line 753 "../src/game.vala"
	_tmp7_ = _tmp6_[(0 * _tmp6__length2) + 0];
#line 753 "../src/game.vala"
	(*tiles)[((half_size - 1) * (*tiles_length2)) + (half_size - 1)] = _tmp7_;
#line 754 "../src/game.vala"
	_tmp8_ = start_position;
#line 754 "../src/game.vala"
	_tmp8__length1 = start_position_length1;
#line 754 "../src/game.vala"
	_tmp8__length2 = start_position_length2;
#line 754 "../src/game.vala"
	_tmp9_ = _tmp8_[(0 * _tmp8__length2) + 1];
#line 754 "../src/game.vala"
	(*tiles)[(half_size * (*tiles_length2)) + (half_size - 1)] = _tmp9_;
#line 755 "../src/game.vala"
	_tmp10_ = start_position;
#line 755 "../src/game.vala"
	_tmp10__length1 = start_position_length1;
#line 755 "../src/game.vala"
	_tmp10__length2 = start_position_length2;
#line 755 "../src/game.vala"
	_tmp11_ = _tmp10_[(1 * _tmp10__length2) + 0];
#line 755 "../src/game.vala"
	(*tiles)[((half_size - 1) * (*tiles_length2)) + half_size] = _tmp11_;
#line 756 "../src/game.vala"
	_tmp12_ = start_position;
#line 756 "../src/game.vala"
	_tmp12__length1 = start_position_length1;
#line 756 "../src/game.vala"
	_tmp12__length2 = start_position_length2;
#line 756 "../src/game.vala"
	_tmp13_ = _tmp12_[(1 * _tmp12__length2) + 1];
#line 756 "../src/game.vala"
	(*tiles)[(half_size * (*tiles_length2)) + half_size] = _tmp13_;
#line 737 "../src/game.vala"
	start_position = (g_free (start_position), NULL);
#line 737 "../src/game.vala"
	if (initial_number_of_tiles) {
#line 737 "../src/game.vala"
		*initial_number_of_tiles = _vala_initial_number_of_tiles;
#line 4520 "game.c"
	}
}

static inline void
game_setup_odd_board (guint8 size,
                      Opening opening,
                      Player** tiles,
                      gint* tiles_length1,
                      gint* tiles_length2,
                      guint8* initial_number_of_tiles)
{
	guint8 _vala_initial_number_of_tiles = 0U;
	guint8 mid_board = 0U;
	gint _tmp0_ = 0;
	Player* start_position = NULL;
	gint start_position_length1 = 0;
	gint start_position_length2 = 0;
	Player* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	Player _tmp9_;
	Player* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	Player _tmp11_;
	Player* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	Player _tmp13_;
	Player* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	Player _tmp15_;
	Player* _tmp16_;
	gint _tmp16__length1;
	gint _tmp16__length2;
	Player _tmp17_;
	Player* _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	Player _tmp19_;
	Player* _tmp20_;
	gint _tmp20__length1;
	gint _tmp20__length2;
	Player _tmp21_;
	Player* _tmp22_;
	gint _tmp22__length1;
	gint _tmp22__length2;
	Player _tmp23_;
#line 761 "../src/game.vala"
	mid_board = (guint8) ((size - 1) / 2);
#line 762 "../src/game.vala"
	if (opening == OPENING_HUMANS) {
#line 762 "../src/game.vala"
		_tmp0_ = 1;
#line 4576 "game.c"
	} else {
#line 762 "../src/game.vala"
		_tmp0_ = 7;
#line 4580 "game.c"
	}
#line 762 "../src/game.vala"
	_vala_initial_number_of_tiles = (guint8) _tmp0_;
#line 764 "../src/game.vala"
	switch (opening) {
#line 764 "../src/game.vala"
		case OPENING_HUMANS:
#line 4588 "game.c"
		{
			Player* _tmp1_;
#line 766 "../src/game.vala"
			_tmp1_ = g_new0 (Player, 3 * 3);
#line 766 "../src/game.vala"
			_tmp1_[0] = PLAYER_NONE;
#line 766 "../src/game.vala"
			_tmp1_[1] = PLAYER_NONE;
#line 766 "../src/game.vala"
			_tmp1_[2] = PLAYER_NONE;
#line 766 "../src/game.vala"
			_tmp1_[3] = PLAYER_NONE;
#line 766 "../src/game.vala"
			_tmp1_[4] = PLAYER_DARK;
#line 766 "../src/game.vala"
			_tmp1_[5] = PLAYER_NONE;
#line 766 "../src/game.vala"
			_tmp1_[6] = PLAYER_NONE;
#line 766 "../src/game.vala"
			_tmp1_[7] = PLAYER_NONE;
#line 766 "../src/game.vala"
			_tmp1_[8] = PLAYER_NONE;
#line 766 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 766 "../src/game.vala"
			start_position = _tmp1_;
#line 766 "../src/game.vala"
			start_position_length1 = 3;
#line 766 "../src/game.vala"
			start_position_length2 = 3;
#line 768 "../src/game.vala"
			break;
#line 4621 "game.c"
		}
#line 764 "../src/game.vala"
		case OPENING_REVERSI:
#line 4625 "game.c"
		{
			Player* _tmp2_;
#line 769 "../src/game.vala"
			_tmp2_ = g_new0 (Player, 3 * 3);
#line 769 "../src/game.vala"
			_tmp2_[0] = PLAYER_NONE;
#line 769 "../src/game.vala"
			_tmp2_[1] = PLAYER_LIGHT;
#line 769 "../src/game.vala"
			_tmp2_[2] = PLAYER_DARK;
#line 769 "../src/game.vala"
			_tmp2_[3] = PLAYER_LIGHT;
#line 769 "../src/game.vala"
			_tmp2_[4] = PLAYER_DARK;
#line 769 "../src/game.vala"
			_tmp2_[5] = PLAYER_LIGHT;
#line 769 "../src/game.vala"
			_tmp2_[6] = PLAYER_DARK;
#line 769 "../src/game.vala"
			_tmp2_[7] = PLAYER_LIGHT;
#line 769 "../src/game.vala"
			_tmp2_[8] = PLAYER_NONE;
#line 769 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 769 "../src/game.vala"
			start_position = _tmp2_;
#line 769 "../src/game.vala"
			start_position_length1 = 3;
#line 769 "../src/game.vala"
			start_position_length2 = 3;
#line 771 "../src/game.vala"
			break;
#line 4658 "game.c"
		}
#line 764 "../src/game.vala"
		case OPENING_INVERTED:
#line 4662 "game.c"
		{
			Player* _tmp3_;
#line 772 "../src/game.vala"
			_tmp3_ = g_new0 (Player, 3 * 3);
#line 772 "../src/game.vala"
			_tmp3_[0] = PLAYER_DARK;
#line 772 "../src/game.vala"
			_tmp3_[1] = PLAYER_LIGHT;
#line 772 "../src/game.vala"
			_tmp3_[2] = PLAYER_NONE;
#line 772 "../src/game.vala"
			_tmp3_[3] = PLAYER_LIGHT;
#line 772 "../src/game.vala"
			_tmp3_[4] = PLAYER_DARK;
#line 772 "../src/game.vala"
			_tmp3_[5] = PLAYER_LIGHT;
#line 772 "../src/game.vala"
			_tmp3_[6] = PLAYER_NONE;
#line 772 "../src/game.vala"
			_tmp3_[7] = PLAYER_LIGHT;
#line 772 "../src/game.vala"
			_tmp3_[8] = PLAYER_DARK;
#line 772 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 772 "../src/game.vala"
			start_position = _tmp3_;
#line 772 "../src/game.vala"
			start_position_length1 = 3;
#line 772 "../src/game.vala"
			start_position_length2 = 3;
#line 774 "../src/game.vala"
			break;
#line 4695 "game.c"
		}
#line 764 "../src/game.vala"
		case OPENING_ALTER_TOP:
#line 4699 "game.c"
		{
			Player* _tmp4_;
#line 775 "../src/game.vala"
			_tmp4_ = g_new0 (Player, 3 * 3);
#line 775 "../src/game.vala"
			_tmp4_[0] = PLAYER_NONE;
#line 775 "../src/game.vala"
			_tmp4_[1] = PLAYER_DARK;
#line 775 "../src/game.vala"
			_tmp4_[2] = PLAYER_LIGHT;
#line 775 "../src/game.vala"
			_tmp4_[3] = PLAYER_LIGHT;
#line 775 "../src/game.vala"
			_tmp4_[4] = PLAYER_DARK;
#line 775 "../src/game.vala"
			_tmp4_[5] = PLAYER_LIGHT;
#line 775 "../src/game.vala"
			_tmp4_[6] = PLAYER_LIGHT;
#line 775 "../src/game.vala"
			_tmp4_[7] = PLAYER_DARK;
#line 775 "../src/game.vala"
			_tmp4_[8] = PLAYER_NONE;
#line 775 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 775 "../src/game.vala"
			start_position = _tmp4_;
#line 775 "../src/game.vala"
			start_position_length1 = 3;
#line 775 "../src/game.vala"
			start_position_length2 = 3;
#line 777 "../src/game.vala"
			break;
#line 4732 "game.c"
		}
#line 764 "../src/game.vala"
		case OPENING_ALTER_LEFT:
#line 4736 "game.c"
		{
			Player* _tmp5_;
#line 778 "../src/game.vala"
			_tmp5_ = g_new0 (Player, 3 * 3);
#line 778 "../src/game.vala"
			_tmp5_[0] = PLAYER_LIGHT;
#line 778 "../src/game.vala"
			_tmp5_[1] = PLAYER_LIGHT;
#line 778 "../src/game.vala"
			_tmp5_[2] = PLAYER_NONE;
#line 778 "../src/game.vala"
			_tmp5_[3] = PLAYER_DARK;
#line 778 "../src/game.vala"
			_tmp5_[4] = PLAYER_DARK;
#line 778 "../src/game.vala"
			_tmp5_[5] = PLAYER_DARK;
#line 778 "../src/game.vala"
			_tmp5_[6] = PLAYER_NONE;
#line 778 "../src/game.vala"
			_tmp5_[7] = PLAYER_LIGHT;
#line 778 "../src/game.vala"
			_tmp5_[8] = PLAYER_LIGHT;
#line 778 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 778 "../src/game.vala"
			start_position = _tmp5_;
#line 778 "../src/game.vala"
			start_position_length1 = 3;
#line 778 "../src/game.vala"
			start_position_length2 = 3;
#line 780 "../src/game.vala"
			break;
#line 4769 "game.c"
		}
#line 764 "../src/game.vala"
		case OPENING_ALTER_RIGHT:
#line 4773 "game.c"
		{
			Player* _tmp6_;
#line 781 "../src/game.vala"
			_tmp6_ = g_new0 (Player, 3 * 3);
#line 781 "../src/game.vala"
			_tmp6_[0] = PLAYER_NONE;
#line 781 "../src/game.vala"
			_tmp6_[1] = PLAYER_LIGHT;
#line 781 "../src/game.vala"
			_tmp6_[2] = PLAYER_LIGHT;
#line 781 "../src/game.vala"
			_tmp6_[3] = PLAYER_DARK;
#line 781 "../src/game.vala"
			_tmp6_[4] = PLAYER_DARK;
#line 781 "../src/game.vala"
			_tmp6_[5] = PLAYER_DARK;
#line 781 "../src/game.vala"
			_tmp6_[6] = PLAYER_LIGHT;
#line 781 "../src/game.vala"
			_tmp6_[7] = PLAYER_LIGHT;
#line 781 "../src/game.vala"
			_tmp6_[8] = PLAYER_NONE;
#line 781 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 781 "../src/game.vala"
			start_position = _tmp6_;
#line 781 "../src/game.vala"
			start_position_length1 = 3;
#line 781 "../src/game.vala"
			start_position_length2 = 3;
#line 783 "../src/game.vala"
			break;
#line 4806 "game.c"
		}
#line 764 "../src/game.vala"
		case OPENING_ALTER_BOTTOM:
#line 4810 "game.c"
		{
			Player* _tmp7_;
#line 784 "../src/game.vala"
			_tmp7_ = g_new0 (Player, 3 * 3);
#line 784 "../src/game.vala"
			_tmp7_[0] = PLAYER_LIGHT;
#line 784 "../src/game.vala"
			_tmp7_[1] = PLAYER_DARK;
#line 784 "../src/game.vala"
			_tmp7_[2] = PLAYER_NONE;
#line 784 "../src/game.vala"
			_tmp7_[3] = PLAYER_LIGHT;
#line 784 "../src/game.vala"
			_tmp7_[4] = PLAYER_DARK;
#line 784 "../src/game.vala"
			_tmp7_[5] = PLAYER_LIGHT;
#line 784 "../src/game.vala"
			_tmp7_[6] = PLAYER_NONE;
#line 784 "../src/game.vala"
			_tmp7_[7] = PLAYER_DARK;
#line 784 "../src/game.vala"
			_tmp7_[8] = PLAYER_LIGHT;
#line 784 "../src/game.vala"
			start_position = (g_free (start_position), NULL);
#line 784 "../src/game.vala"
			start_position = _tmp7_;
#line 784 "../src/game.vala"
			start_position_length1 = 3;
#line 784 "../src/game.vala"
			start_position_length2 = 3;
#line 786 "../src/game.vala"
			break;
#line 4843 "game.c"
		}
		default:
		{
#line 787 "../src/game.vala"
			g_assert_not_reached ();
#line 4849 "game.c"
		}
	}
#line 789 "../src/game.vala"
	_tmp8_ = start_position;
#line 789 "../src/game.vala"
	_tmp8__length1 = start_position_length1;
#line 789 "../src/game.vala"
	_tmp8__length2 = start_position_length2;
#line 789 "../src/game.vala"
	_tmp9_ = _tmp8_[(0 * _tmp8__length2) + 0];
#line 789 "../src/game.vala"
	(*tiles)[((mid_board - 1) * (*tiles_length2)) + (mid_board - 1)] = _tmp9_;
#line 790 "../src/game.vala"
	_tmp10_ = start_position;
#line 790 "../src/game.vala"
	_tmp10__length1 = start_position_length1;
#line 790 "../src/game.vala"
	_tmp10__length2 = start_position_length2;
#line 790 "../src/game.vala"
	_tmp11_ = _tmp10_[(0 * _tmp10__length2) + 1];
#line 790 "../src/game.vala"
	(*tiles)[(mid_board * (*tiles_length2)) + (mid_board - 1)] = _tmp11_;
#line 791 "../src/game.vala"
	_tmp12_ = start_position;
#line 791 "../src/game.vala"
	_tmp12__length1 = start_position_length1;
#line 791 "../src/game.vala"
	_tmp12__length2 = start_position_length2;
#line 791 "../src/game.vala"
	_tmp13_ = _tmp12_[(0 * _tmp12__length2) + 2];
#line 791 "../src/game.vala"
	(*tiles)[((mid_board + 1) * (*tiles_length2)) + (mid_board - 1)] = _tmp13_;
#line 792 "../src/game.vala"
	_tmp14_ = start_position;
#line 792 "../src/game.vala"
	_tmp14__length1 = start_position_length1;
#line 792 "../src/game.vala"
	_tmp14__length2 = start_position_length2;
#line 792 "../src/game.vala"
	_tmp15_ = _tmp14_[(1 * _tmp14__length2) + 0];
#line 792 "../src/game.vala"
	(*tiles)[((mid_board - 1) * (*tiles_length2)) + mid_board] = _tmp15_;
#line 793 "../src/game.vala"
	(*tiles)[(mid_board * (*tiles_length2)) + mid_board] = PLAYER_DARK;
#line 794 "../src/game.vala"
	_tmp16_ = start_position;
#line 794 "../src/game.vala"
	_tmp16__length1 = start_position_length1;
#line 794 "../src/game.vala"
	_tmp16__length2 = start_position_length2;
#line 794 "../src/game.vala"
	_tmp17_ = _tmp16_[(1 * _tmp16__length2) + 2];
#line 794 "../src/game.vala"
	(*tiles)[((mid_board + 1) * (*tiles_length2)) + mid_board] = _tmp17_;
#line 795 "../src/game.vala"
	_tmp18_ = start_position;
#line 795 "../src/game.vala"
	_tmp18__length1 = start_position_length1;
#line 795 "../src/game.vala"
	_tmp18__length2 = start_position_length2;
#line 795 "../src/game.vala"
	_tmp19_ = _tmp18_[(2 * _tmp18__length2) + 0];
#line 795 "../src/game.vala"
	(*tiles)[((mid_board - 1) * (*tiles_length2)) + (mid_board + 1)] = _tmp19_;
#line 796 "../src/game.vala"
	_tmp20_ = start_position;
#line 796 "../src/game.vala"
	_tmp20__length1 = start_position_length1;
#line 796 "../src/game.vala"
	_tmp20__length2 = start_position_length2;
#line 796 "../src/game.vala"
	_tmp21_ = _tmp20_[(2 * _tmp20__length2) + 1];
#line 796 "../src/game.vala"
	(*tiles)[(mid_board * (*tiles_length2)) + (mid_board + 1)] = _tmp21_;
#line 797 "../src/game.vala"
	_tmp22_ = start_position;
#line 797 "../src/game.vala"
	_tmp22__length1 = start_position_length1;
#line 797 "../src/game.vala"
	_tmp22__length2 = start_position_length2;
#line 797 "../src/game.vala"
	_tmp23_ = _tmp22_[(2 * _tmp22__length2) + 2];
#line 797 "../src/game.vala"
	(*tiles)[((mid_board + 1) * (*tiles_length2)) + (mid_board + 1)] = _tmp23_;
#line 758 "../src/game.vala"
	start_position = (g_free (start_position), NULL);
#line 758 "../src/game.vala"
	if (initial_number_of_tiles) {
#line 758 "../src/game.vala"
		*initial_number_of_tiles = _vala_initial_number_of_tiles;
#line 4940 "game.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 4958 "game.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 4972 "game.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 4976 "game.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 4982 "game.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 4987 "game.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 4993 "game.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 4997 "game.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 5001 "game.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 5005 "game.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 5009 "game.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 5013 "game.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 5028 "game.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 5037 "game.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 5044 "game.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 5050 "game.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 5058 "game.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 5062 "game.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 5068 "game.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 5073 "game.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 5079 "game.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 5083 "game.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 5087 "game.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 5093 "game.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 5099 "game.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 5111 "game.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 5115 "game.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 5119 "game.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 5124 "game.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 5132 "game.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 5150 "game.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 5156 "game.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 5160 "game.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 5168 "game.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 5177 "game.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 5186 "game.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 5192 "game.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 5200 "game.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 5212 "game.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 5218 "game.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 5222 "game.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 5230 "game.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 5241 "game.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 5250 "game.c"
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 5272 "game.c"
}

Game*
game_construct_from_strings (GType object_type,
                             gchar** setup,
                             gint setup_length1,
                             Player to_move,
                             gboolean _reverse,
                             guint8 _size,
                             gboolean _print_logs)
{
	Game * self = NULL;
	guint8* _neighbor_tiles = NULL;
	gint _neighbor_tiles_length1 = 0;
	gint _neighbor_tiles_length2 = 0;
	guint8* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	Player* tiles = NULL;
	Player* _tmp3_;
	gint tiles_length1;
	gint tiles_length2;
	GameStateObject* _current_state = NULL;
	Player* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	guint8* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	GameStateObject* _tmp15_;
	gint _tmp16_ = 0;
	GameStateObject* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
#line 800 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) >= 4, "_size >= 4", NULL);
#line 800 "../src/game.vala"
	_vala_return_val_if_fail (((gint) _size) <= 16, "_size <= 16", NULL);
#line 800 "../src/game.vala"
	_vala_return_val_if_fail (to_move != PLAYER_NONE, "to_move != Player.NONE", NULL);
#line 800 "../src/game.vala"
	_vala_return_val_if_fail (setup_length1 == ((gint) _size), "setup.length == _size", NULL);
#line 807 "../src/game.vala"
	game_init_neighbor_tiles (_size, &_tmp0_, &_tmp1_, &_tmp2_);
#line 807 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 807 "../src/game.vala"
	_neighbor_tiles = _tmp0_;
#line 807 "../src/game.vala"
	_neighbor_tiles_length1 = _tmp1_;
#line 807 "../src/game.vala"
	_neighbor_tiles_length2 = _tmp2_;
#line 809 "../src/game.vala"
	_tmp3_ = g_new0 (Player, _size * _size);
#line 809 "../src/game.vala"
	tiles = _tmp3_;
#line 809 "../src/game.vala"
	tiles_length1 = _size;
#line 809 "../src/game.vala"
	tiles_length2 = _size;
#line 5342 "game.c"
	{
		guint8 y = 0U;
#line 811 "../src/game.vala"
		y = (guint8) 0;
#line 5347 "game.c"
		{
			gboolean _tmp4_ = FALSE;
#line 811 "../src/game.vala"
			_tmp4_ = TRUE;
#line 811 "../src/game.vala"
			while (TRUE) {
#line 5354 "game.c"
				const gchar* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 811 "../src/game.vala"
				if (!_tmp4_) {
#line 5360 "game.c"
					guint8 _tmp5_;
#line 811 "../src/game.vala"
					_tmp5_ = y;
#line 811 "../src/game.vala"
					y = _tmp5_ + 1;
#line 5366 "game.c"
				}
#line 811 "../src/game.vala"
				_tmp4_ = FALSE;
#line 811 "../src/game.vala"
				if (!(y < _size)) {
#line 811 "../src/game.vala"
					break;
#line 5374 "game.c"
				}
#line 813 "../src/game.vala"
				_tmp6_ = setup[y];
#line 813 "../src/game.vala"
				_tmp7_ = strlen (_tmp6_);
#line 813 "../src/game.vala"
				_tmp8_ = _tmp7_;
#line 813 "../src/game.vala"
				if (_tmp8_ != (_size * 2)) {
#line 814 "../src/game.vala"
					g_warn_if_reached ();
#line 5386 "game.c"
				}
				{
					guint8 x = 0U;
#line 815 "../src/game.vala"
					x = (guint8) 0;
#line 5392 "game.c"
					{
						gboolean _tmp9_ = FALSE;
#line 815 "../src/game.vala"
						_tmp9_ = TRUE;
#line 815 "../src/game.vala"
						while (TRUE) {
#line 5399 "game.c"
							Player* _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							const gchar* _tmp12_;
#line 815 "../src/game.vala"
							if (!_tmp9_) {
#line 5406 "game.c"
								guint8 _tmp10_;
#line 815 "../src/game.vala"
								_tmp10_ = x;
#line 815 "../src/game.vala"
								x = _tmp10_ + 1;
#line 5412 "game.c"
							}
#line 815 "../src/game.vala"
							_tmp9_ = FALSE;
#line 815 "../src/game.vala"
							if (!(x < _size)) {
#line 815 "../src/game.vala"
								break;
#line 5420 "game.c"
							}
#line 816 "../src/game.vala"
							_tmp11_ = tiles;
#line 816 "../src/game.vala"
							_tmp11__length1 = tiles_length1;
#line 816 "../src/game.vala"
							_tmp11__length2 = tiles_length2;
#line 816 "../src/game.vala"
							_tmp12_ = setup[y];
#line 816 "../src/game.vala"
							_tmp11_[(x * _tmp11__length2) + y] = player_from_char (string_get (_tmp12_, (glong) ((x * 2) + 1)));
#line 5432 "game.c"
						}
					}
				}
			}
		}
	}
#line 819 "../src/game.vala"
	_tmp13_ = tiles;
#line 819 "../src/game.vala"
	_tmp13__length1 = tiles_length1;
#line 819 "../src/game.vala"
	_tmp13__length2 = tiles_length2;
#line 819 "../src/game.vala"
	_tmp14_ = _neighbor_tiles;
#line 819 "../src/game.vala"
	_tmp14__length1 = _neighbor_tiles_length1;
#line 819 "../src/game.vala"
	_tmp14__length2 = _neighbor_tiles_length2;
#line 819 "../src/game.vala"
	_tmp15_ = game_state_object_new_from_grid (_size, _tmp13_, _tmp13__length1, _tmp13__length2, to_move, _tmp14_, _tmp14__length1, _tmp14__length2, FALSE);
#line 819 "../src/game.vala"
	_current_state = _tmp15_;
#line 825 "../src/game.vala"
	if ((_size % 2) == 0) {
#line 825 "../src/game.vala"
		_tmp16_ = 4;
#line 5459 "game.c"
	} else {
#line 825 "../src/game.vala"
		_tmp16_ = 7;
#line 5463 "game.c"
	}
#line 821 "../src/game.vala"
	_tmp17_ = _current_state;
#line 821 "../src/game.vala"
	self = (Game*) g_object_new (object_type, "size", _size, "reverse", _reverse, "opening", OPENING_REVERSI, "current-state", _tmp17_, "initial-number-of-tiles", _tmp16_, "print-logs", _print_logs, NULL);
#line 827 "../src/game.vala"
	_tmp18_ = _neighbor_tiles;
#line 827 "../src/game.vala"
	_tmp18__length1 = _neighbor_tiles_length1;
#line 827 "../src/game.vala"
	_tmp18__length2 = _neighbor_tiles_length2;
#line 827 "../src/game.vala"
	_neighbor_tiles = NULL;
#line 827 "../src/game.vala"
	_neighbor_tiles_length1 = 0;
#line 827 "../src/game.vala"
	_neighbor_tiles_length2 = 0;
#line 827 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 827 "../src/game.vala"
	self->priv->neighbor_tiles = _tmp18_;
#line 827 "../src/game.vala"
	self->priv->neighbor_tiles_length1 = _tmp18__length1;
#line 827 "../src/game.vala"
	self->priv->neighbor_tiles_length2 = _tmp18__length2;
#line 829 "../src/game.vala"
	_tmp19_ = _vala_g_strjoinv ("\n", (gchar**) setup, (gint) ((setup_length1 * sizeof (gchar*)) / sizeof (gchar*)));
#line 829 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 829 "../src/game.vala"
	_tmp21_ = string_strip (_tmp20_);
#line 829 "../src/game.vala"
	_tmp22_ = _tmp21_;
#line 829 "../src/game.vala"
	_tmp23_ = game_to_string (self);
#line 829 "../src/game.vala"
	_tmp24_ = _tmp23_;
#line 829 "../src/game.vala"
	_tmp25_ = string_strip (_tmp24_);
#line 829 "../src/game.vala"
	_tmp26_ = _tmp25_;
#line 829 "../src/game.vala"
	g_warn_if_fail (g_strcmp0 (_tmp22_, _tmp26_) == 0);
#line 829 "../src/game.vala"
	_g_free0 (_tmp26_);
#line 829 "../src/game.vala"
	_g_free0 (_tmp24_);
#line 829 "../src/game.vala"
	_g_free0 (_tmp22_);
#line 829 "../src/game.vala"
	_g_free0 (_tmp20_);
#line 800 "../src/game.vala"
	_g_object_unref0 (_current_state);
#line 800 "../src/game.vala"
	tiles = (g_free (tiles), NULL);
#line 800 "../src/game.vala"
	_neighbor_tiles = (g_free (_neighbor_tiles), NULL);
#line 800 "../src/game.vala"
	return self;
#line 5523 "game.c"
}

Game*
game_new_from_strings (gchar** setup,
                       gint setup_length1,
                       Player to_move,
                       gboolean _reverse,
                       guint8 _size,
                       gboolean _print_logs)
{
#line 800 "../src/game.vala"
	return game_construct_from_strings (TYPE_GAME, setup, setup_length1, to_move, _reverse, _size, _print_logs);
#line 5536 "game.c"
}

Player
game_get_owner (Game* self,
                guint8 x,
                guint8 y)
{
	GameStateObject* _tmp0_;
	Player result;
#line 836 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 838 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 838 "../src/game.vala"
	result = game_state_object_get_owner (_tmp0_, x, y);
#line 838 "../src/game.vala"
	return result;
#line 5554 "game.c"
}

gchar*
game_to_string (Game* self)
{
	GameStateObject* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 849 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 851 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 851 "../src/game.vala"
	_tmp1_ = game_state_object_to_string (_tmp0_);
#line 851 "../src/game.vala"
	result = _tmp1_;
#line 851 "../src/game.vala"
	return result;
#line 5573 "game.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 5586 "game.c"
}

gboolean
game_place_tile (Game* self,
                 guint8 x,
                 guint8 y)
{
	Opening _tmp0_;
	PossibleMove move = {0};
	GameStateObject* _tmp1_;
	PossibleMove _tmp2_ = {0};
	gboolean _tmp3_;
	gboolean _tmp4_;
	GameStateObject* _tmp17_;
	PossibleMove _tmp18_;
	GameStateObject* _tmp19_;
	GameStateObject* _tmp20_;
	GListStore* _tmp21_;
	GameStateObject* _tmp22_;
	gboolean result;
#line 858 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 860 "../src/game.vala"
	_tmp0_ = self->priv->_opening;
#line 860 "../src/game.vala"
	if (_tmp0_ == OPENING_HUMANS) {
#line 861 "../src/game.vala"
		result = game_humans_opening_place_tile (self, x, y);
#line 861 "../src/game.vala"
		return result;
#line 5617 "game.c"
	}
#line 864 "../src/game.vala"
	_tmp1_ = self->priv->_current_state;
#line 864 "../src/game.vala"
	_tmp3_ = game_state_object_test_placing_tile (_tmp1_, x, y, &_tmp2_);
#line 864 "../src/game.vala"
	move = _tmp2_;
#line 864 "../src/game.vala"
	if (!_tmp3_) {
#line 865 "../src/game.vala"
		result = FALSE;
#line 865 "../src/game.vala"
		return result;
#line 5631 "game.c"
	}
#line 867 "../src/game.vala"
	_tmp4_ = self->priv->_print_logs;
#line 867 "../src/game.vala"
	if (_tmp4_) {
#line 5637 "game.c"
		const gchar* _tmp5_ = NULL;
		Player _tmp6_;
		Player _tmp7_;
		gchar* current_color_string = NULL;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 869 "../src/game.vala"
		_tmp6_ = game_get_current_color (self);
#line 869 "../src/game.vala"
		_tmp7_ = _tmp6_;
#line 869 "../src/game.vala"
		if (_tmp7_ == PLAYER_DARK) {
#line 869 "../src/game.vala"
			_tmp5_ = "dark :";
#line 5659 "game.c"
		} else {
#line 869 "../src/game.vala"
			_tmp5_ = "light:";
#line 5663 "game.c"
		}
#line 869 "../src/game.vala"
		_tmp8_ = g_strdup (_tmp5_);
#line 869 "../src/game.vala"
		current_color_string = _tmp8_;
#line 870 "../src/game.vala"
		_tmp9_ = current_color_string;
#line 870 "../src/game.vala"
		_tmp10_ = string_to_string (_tmp9_);
#line 870 "../src/game.vala"
		_tmp11_ = g_strdup_printf ("%hhu", x);
#line 870 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 870 "../src/game.vala"
		_tmp13_ = g_strdup_printf ("%hhu", y);
#line 870 "../src/game.vala"
		_tmp14_ = _tmp13_;
#line 870 "../src/game.vala"
		_tmp15_ = g_strconcat (_tmp10_, " (", _tmp12_, ", ", _tmp14_, ")\n", NULL);
#line 870 "../src/game.vala"
		_tmp16_ = _tmp15_;
#line 870 "../src/game.vala"
		g_print ("%s", _tmp16_);
#line 870 "../src/game.vala"
		_g_free0 (_tmp16_);
#line 870 "../src/game.vala"
		_g_free0 (_tmp14_);
#line 870 "../src/game.vala"
		_g_free0 (_tmp12_);
#line 867 "../src/game.vala"
		_g_free0 (current_color_string);
#line 5695 "game.c"
	}
#line 873 "../src/game.vala"
	_tmp17_ = self->priv->_current_state;
#line 873 "../src/game.vala"
	_tmp18_ = move;
#line 873 "../src/game.vala"
	_tmp19_ = game_state_object_new_copy_and_move (_tmp17_, &_tmp18_);
#line 873 "../src/game.vala"
	_tmp20_ = _tmp19_;
#line 873 "../src/game.vala"
	game_set_current_state (self, _tmp20_);
#line 873 "../src/game.vala"
	_g_object_unref0 (_tmp20_);
#line 874 "../src/game.vala"
	_tmp21_ = self->priv->undo_stack;
#line 874 "../src/game.vala"
	_tmp22_ = self->priv->_current_state;
#line 874 "../src/game.vala"
	g_list_store_append (_tmp21_, (GObject*) _tmp22_);
#line 875 "../src/game.vala"
	game_end_of_turn (self, FALSE, FALSE);
#line 876 "../src/game.vala"
	result = TRUE;
#line 876 "../src/game.vala"
	return result;
#line 5721 "game.c"
}

gboolean
game_pass (Game* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GameStateObject* _tmp5_;
	GameStateObject* _tmp6_;
	GameStateObject* _tmp7_;
	GListStore* _tmp8_;
	GameStateObject* _tmp9_;
	gboolean result;
#line 879 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 881 "../src/game.vala"
	_tmp0_ = game_get_current_player_can_move (self);
#line 881 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 881 "../src/game.vala"
	if (_tmp1_) {
#line 882 "../src/game.vala"
		result = FALSE;
#line 882 "../src/game.vala"
		return result;
#line 5748 "game.c"
	}
#line 884 "../src/game.vala"
	_tmp2_ = self->priv->_print_logs;
#line 884 "../src/game.vala"
	if (_tmp2_) {
#line 5754 "game.c"
		Player _tmp3_;
		Player _tmp4_;
#line 886 "../src/game.vala"
		_tmp3_ = game_get_current_color (self);
#line 886 "../src/game.vala"
		_tmp4_ = _tmp3_;
#line 886 "../src/game.vala"
		if (_tmp4_ == PLAYER_DARK) {
#line 887 "../src/game.vala"
			g_print ("dark : pass\n");
#line 5765 "game.c"
		} else {
#line 889 "../src/game.vala"
			g_print ("light: pass\n");
#line 5769 "game.c"
		}
	}
#line 892 "../src/game.vala"
	_tmp5_ = self->priv->_current_state;
#line 892 "../src/game.vala"
	_tmp6_ = game_state_object_new_copy_and_pass (_tmp5_);
#line 892 "../src/game.vala"
	_tmp7_ = _tmp6_;
#line 892 "../src/game.vala"
	game_set_current_state (self, _tmp7_);
#line 892 "../src/game.vala"
	_g_object_unref0 (_tmp7_);
#line 893 "../src/game.vala"
	_tmp8_ = self->priv->undo_stack;
#line 893 "../src/game.vala"
	_tmp9_ = self->priv->_current_state;
#line 893 "../src/game.vala"
	g_list_store_append (_tmp8_, (GObject*) _tmp9_);
#line 894 "../src/game.vala"
	game_end_of_turn (self, FALSE, TRUE);
#line 895 "../src/game.vala"
	result = TRUE;
#line 895 "../src/game.vala"
	return result;
#line 5794 "game.c"
}

static void
game_end_of_turn (Game* self,
                  gboolean undoing,
                  gboolean no_draw)
{
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 898 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 900 "../src/game.vala"
	game_update_possible_moves (self);
#line 901 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 901 "../src/game.vala"
	_tmp1_ = game_state_object_get_is_complete (_tmp0_);
#line 901 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 901 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_COMPLETENESS_UPDATED_SIGNAL], 0, _tmp2_);
#line 902 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_TURN_ENDED_SIGNAL], 0, undoing, no_draw);
#line 5819 "game.c"
}

void
game_undo (Game* self,
           guint8 count)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint undo_stack_n_items = 0U;
	GListStore* _tmp2_;
	GObject* tmp_current_state = NULL;
	GListStore* _tmp3_;
	GObject* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GObject* _tmp6_;
	GObject* _tmp8_;
	GListStore* _tmp9_;
	gboolean _tmp10_ = FALSE;
#line 909 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 909 "../src/game.vala"
	_vala_return_if_fail ((((gint) count) == 1) || (((gint) count) == 2), "count == 1 || count == 2");
#line 909 "../src/game.vala"
	_tmp0_ = game_get_number_of_moves (self);
#line 909 "../src/game.vala"
	_tmp1_ = _tmp0_;
#line 909 "../src/game.vala"
	_vala_return_if_fail (_tmp1_ >= count, "number_of_moves >= count");
#line 913 "../src/game.vala"
	_tmp2_ = self->priv->undo_stack;
#line 913 "../src/game.vala"
	undo_stack_n_items = g_list_model_get_n_items ((GListModel*) _tmp2_);
#line 914 "../src/game.vala"
	_tmp3_ = self->priv->undo_stack;
#line 914 "../src/game.vala"
	_tmp4_ = g_list_model_get_object ((GListModel*) _tmp3_, undo_stack_n_items - 2);
#line 914 "../src/game.vala"
	tmp_current_state = _tmp4_;
#line 915 "../src/game.vala"
	_tmp6_ = tmp_current_state;
#line 915 "../src/game.vala"
	if (_tmp6_ == NULL) {
#line 915 "../src/game.vala"
		_tmp5_ = TRUE;
#line 5864 "game.c"
	} else {
		GObject* _tmp7_;
#line 915 "../src/game.vala"
		_tmp7_ = tmp_current_state;
#line 915 "../src/game.vala"
		_tmp5_ = !IS_GAME_STATE_OBJECT (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, G_TYPE_OBJECT, GObject));
#line 5871 "game.c"
	}
#line 915 "../src/game.vala"
	if (_tmp5_) {
#line 916 "../src/game.vala"
		g_assert_not_reached ();
#line 5877 "game.c"
	}
#line 917 "../src/game.vala"
	_tmp8_ = tmp_current_state;
#line 917 "../src/game.vala"
	game_set_current_state (self, G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, G_TYPE_OBJECT, GObject), TYPE_GAME_STATE_OBJECT, GameStateObject));
#line 921 "../src/game.vala"
	_tmp9_ = self->priv->undo_stack;
#line 921 "../src/game.vala"
	g_list_store_remove (_tmp9_, undo_stack_n_items - 1);
#line 923 "../src/game.vala"
	if (((gint) count) == 1) {
#line 5889 "game.c"
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 923 "../src/game.vala"
		_tmp11_ = game_get_current_player_can_move (self);
#line 923 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 923 "../src/game.vala"
		_tmp10_ = _tmp12_;
#line 5898 "game.c"
	} else {
#line 923 "../src/game.vala"
		_tmp10_ = FALSE;
#line 5902 "game.c"
	}
#line 923 "../src/game.vala"
	if (_tmp10_) {
#line 924 "../src/game.vala"
		game_end_of_turn (self, TRUE, FALSE);
#line 5908 "game.c"
	} else {
#line 925 "../src/game.vala"
		if (((gint) count) == 2) {
#line 927 "../src/game.vala"
			game_end_of_turn (self, TRUE, TRUE);
#line 928 "../src/game.vala"
			game_undo (self, (guint8) (count - 1));
#line 5916 "game.c"
		}
	}
#line 909 "../src/game.vala"
	_g_object_unref0 (tmp_current_state);
#line 5921 "game.c"
}

static guint8*
_vala_array_dup15 (guint8* self,
                   gssize length)
{
#line 940 "../src/game.vala"
	if (length > 0) {
#line 940 "../src/game.vala"
		return _vala_memdup2 (self, length * sizeof (guint8));
#line 5932 "game.c"
	}
#line 940 "../src/game.vala"
	return NULL;
#line 5936 "game.c"
}

guint8*
game_copy_neighbor_tiles (Game* self,
                          gint* result_length1,
                          gint* result_length2)
{
	guint8* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	guint8* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	guint8* result;
#line 938 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 940 "../src/game.vala"
	_tmp0_ = self->priv->neighbor_tiles;
#line 940 "../src/game.vala"
	_tmp0__length1 = self->priv->neighbor_tiles_length1;
#line 940 "../src/game.vala"
	_tmp0__length2 = self->priv->neighbor_tiles_length2;
#line 940 "../src/game.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup15 (_tmp0_, _tmp0__length1 * _tmp0__length2) : _tmp0_;
#line 940 "../src/game.vala"
	_tmp1__length1 = _tmp0__length1;
#line 940 "../src/game.vala"
	_tmp1__length2 = _tmp0__length2;
#line 940 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 940 "../src/game.vala"
	_tmp2__length1 = _tmp1__length1;
#line 940 "../src/game.vala"
	_tmp2__length2 = _tmp1__length2;
#line 940 "../src/game.vala"
	if (result_length1) {
#line 940 "../src/game.vala"
		*result_length1 = _tmp2__length1;
#line 5978 "game.c"
	}
#line 940 "../src/game.vala"
	if (result_length2) {
#line 940 "../src/game.vala"
		*result_length2 = _tmp2__length2;
#line 5984 "game.c"
	}
#line 940 "../src/game.vala"
	result = _tmp2_;
#line 940 "../src/game.vala"
	return result;
#line 5990 "game.c"
}

static void
game_init_neighbor_tiles (guint8 size,
                          guint8** neighbor_tiles,
                          gint* neighbor_tiles_length1,
                          gint* neighbor_tiles_length2)
{
	guint8* _vala_neighbor_tiles = NULL;
	gint _vala_neighbor_tiles_length1 = 0;
	gint _vala_neighbor_tiles_length2 = 0;
	guint8* _tmp0_;
	guint8 max = 0U;
	guint8* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	guint8* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	guint8* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
#line 945 "../src/game.vala"
	_tmp0_ = g_new0 (guint8, size * size);
#line 945 "../src/game.vala"
	_vala_neighbor_tiles = (g_free (_vala_neighbor_tiles), NULL);
#line 945 "../src/game.vala"
	_vala_neighbor_tiles = _tmp0_;
#line 945 "../src/game.vala"
	_vala_neighbor_tiles_length1 = size;
#line 945 "../src/game.vala"
	_vala_neighbor_tiles_length2 = size;
#line 946 "../src/game.vala"
	max = (guint8) (size - 1);
#line 6028 "game.c"
	{
		guint8 i = 0U;
#line 948 "../src/game.vala"
		i = (guint8) 1;
#line 6033 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 948 "../src/game.vala"
			_tmp1_ = TRUE;
#line 948 "../src/game.vala"
			while (TRUE) {
#line 6040 "game.c"
				guint8* _tmp3_;
				gint _tmp3__length1;
				gint _tmp3__length2;
				guint8* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				guint8* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				guint8* _tmp6_;
				gint _tmp6__length1;
				gint _tmp6__length2;
#line 948 "../src/game.vala"
				if (!_tmp1_) {
#line 6055 "game.c"
					guint8 _tmp2_;
#line 948 "../src/game.vala"
					_tmp2_ = i;
#line 948 "../src/game.vala"
					i = _tmp2_ + 1;
#line 6061 "game.c"
				}
#line 948 "../src/game.vala"
				_tmp1_ = FALSE;
#line 948 "../src/game.vala"
				if (!(i < max)) {
#line 948 "../src/game.vala"
					break;
#line 6069 "game.c"
				}
#line 951 "../src/game.vala"
				_tmp3_ = _vala_neighbor_tiles;
#line 951 "../src/game.vala"
				_tmp3__length1 = _vala_neighbor_tiles_length1;
#line 951 "../src/game.vala"
				_tmp3__length2 = _vala_neighbor_tiles_length2;
#line 951 "../src/game.vala"
				_tmp3_[(i * _tmp3__length2) + 0] = (guint8) 5;
#line 952 "../src/game.vala"
				_tmp4_ = _vala_neighbor_tiles;
#line 952 "../src/game.vala"
				_tmp4__length1 = _vala_neighbor_tiles_length1;
#line 952 "../src/game.vala"
				_tmp4__length2 = _vala_neighbor_tiles_length2;
#line 952 "../src/game.vala"
				_tmp4_[(i * _tmp4__length2) + max] = (guint8) 5;
#line 953 "../src/game.vala"
				_tmp5_ = _vala_neighbor_tiles;
#line 953 "../src/game.vala"
				_tmp5__length1 = _vala_neighbor_tiles_length1;
#line 953 "../src/game.vala"
				_tmp5__length2 = _vala_neighbor_tiles_length2;
#line 953 "../src/game.vala"
				_tmp5_[(0 * _tmp5__length2) + i] = (guint8) 5;
#line 954 "../src/game.vala"
				_tmp6_ = _vala_neighbor_tiles;
#line 954 "../src/game.vala"
				_tmp6__length1 = _vala_neighbor_tiles_length1;
#line 954 "../src/game.vala"
				_tmp6__length2 = _vala_neighbor_tiles_length2;
#line 954 "../src/game.vala"
				_tmp6_[(max * _tmp6__length2) + i] = (guint8) 5;
#line 6103 "game.c"
				{
					guint8 j = 0U;
#line 957 "../src/game.vala"
					j = (guint8) 1;
#line 6108 "game.c"
					{
						gboolean _tmp7_ = FALSE;
#line 957 "../src/game.vala"
						_tmp7_ = TRUE;
#line 957 "../src/game.vala"
						while (TRUE) {
#line 6115 "game.c"
							guint8* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
#line 957 "../src/game.vala"
							if (!_tmp7_) {
#line 6121 "game.c"
								guint8 _tmp8_;
#line 957 "../src/game.vala"
								_tmp8_ = j;
#line 957 "../src/game.vala"
								j = _tmp8_ + 1;
#line 6127 "game.c"
							}
#line 957 "../src/game.vala"
							_tmp7_ = FALSE;
#line 957 "../src/game.vala"
							if (!(j < max)) {
#line 957 "../src/game.vala"
								break;
#line 6135 "game.c"
							}
#line 958 "../src/game.vala"
							_tmp9_ = _vala_neighbor_tiles;
#line 958 "../src/game.vala"
							_tmp9__length1 = _vala_neighbor_tiles_length1;
#line 958 "../src/game.vala"
							_tmp9__length2 = _vala_neighbor_tiles_length2;
#line 958 "../src/game.vala"
							_tmp9_[(i * _tmp9__length2) + j] = (guint8) 8;
#line 6145 "game.c"
						}
					}
				}
			}
		}
	}
#line 962 "../src/game.vala"
	_tmp10_ = _vala_neighbor_tiles;
#line 962 "../src/game.vala"
	_tmp10__length1 = _vala_neighbor_tiles_length1;
#line 962 "../src/game.vala"
	_tmp10__length2 = _vala_neighbor_tiles_length2;
#line 962 "../src/game.vala"
	_tmp10_[(0 * _tmp10__length2) + 0] = (guint8) 3;
#line 963 "../src/game.vala"
	_tmp11_ = _vala_neighbor_tiles;
#line 963 "../src/game.vala"
	_tmp11__length1 = _vala_neighbor_tiles_length1;
#line 963 "../src/game.vala"
	_tmp11__length2 = _vala_neighbor_tiles_length2;
#line 963 "../src/game.vala"
	_tmp11_[(0 * _tmp11__length2) + max] = (guint8) 3;
#line 964 "../src/game.vala"
	_tmp12_ = _vala_neighbor_tiles;
#line 964 "../src/game.vala"
	_tmp12__length1 = _vala_neighbor_tiles_length1;
#line 964 "../src/game.vala"
	_tmp12__length2 = _vala_neighbor_tiles_length2;
#line 964 "../src/game.vala"
	_tmp12_[(max * _tmp12__length2) + max] = (guint8) 3;
#line 965 "../src/game.vala"
	_tmp13_ = _vala_neighbor_tiles;
#line 965 "../src/game.vala"
	_tmp13__length1 = _vala_neighbor_tiles_length1;
#line 965 "../src/game.vala"
	_tmp13__length2 = _vala_neighbor_tiles_length2;
#line 965 "../src/game.vala"
	_tmp13_[(max * _tmp13__length2) + 0] = (guint8) 3;
#line 943 "../src/game.vala"
	if (neighbor_tiles) {
#line 943 "../src/game.vala"
		*neighbor_tiles = _vala_neighbor_tiles;
#line 6188 "game.c"
	} else {
#line 943 "../src/game.vala"
		_vala_neighbor_tiles = (g_free (_vala_neighbor_tiles), NULL);
#line 6192 "game.c"
	}
#line 943 "../src/game.vala"
	if (neighbor_tiles_length1) {
#line 943 "../src/game.vala"
		*neighbor_tiles_length1 = _vala_neighbor_tiles_length1;
#line 6198 "game.c"
	}
#line 943 "../src/game.vala"
	if (neighbor_tiles_length2) {
#line 943 "../src/game.vala"
		*neighbor_tiles_length2 = _vala_neighbor_tiles_length2;
#line 6204 "game.c"
	}
}

gboolean
game_test_placing_tile (Game* self,
                        guint8 x,
                        guint8 y,
                        PossibleMove* move)
{
	PossibleMove _vala_move = {0};
	Opening _tmp0_;
	GSList* test_move = NULL;
	GSList* _tmp1_;
	GSList* _tmp2_;
	gboolean result;
#line 974 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 976 "../src/game.vala"
	_tmp0_ = self->priv->_opening;
#line 976 "../src/game.vala"
	if (_tmp0_ == OPENING_HUMANS) {
#line 978 "../src/game.vala"
		possible_move_init (&_vala_move, x, y);
#line 980 "../src/game.vala"
		result = game_humans_opening_test_placing_tile (self, x, y);
#line 980 "../src/game.vala"
		if (move) {
#line 980 "../src/game.vala"
			*move = _vala_move;
#line 6234 "game.c"
		}
#line 980 "../src/game.vala"
		return result;
#line 6238 "game.c"
	}
#line 983 "../src/game.vala"
	_tmp1_ = self->priv->possible_moves;
#line 983 "../src/game.vala"
	_tmp2_ = g_slist_nth (_tmp1_, (guint) 0);
#line 983 "../src/game.vala"
	test_move = _tmp2_;
#line 984 "../src/game.vala"
	while (TRUE) {
#line 6248 "game.c"
		GSList* _tmp3_;
		GSList* _tmp4_;
		gconstpointer _tmp5_;
		gboolean _tmp6_ = FALSE;
		PossibleMove _tmp7_;
		GSList* _tmp9_;
		GSList* _tmp10_;
#line 984 "../src/game.vala"
		_tmp3_ = test_move;
#line 984 "../src/game.vala"
		if (!(_tmp3_ != NULL)) {
#line 984 "../src/game.vala"
			break;
#line 6262 "game.c"
		}
#line 986 "../src/game.vala"
		_tmp4_ = test_move;
#line 986 "../src/game.vala"
		_tmp5_ = ((GSList*) _tmp4_)->data;
#line 986 "../src/game.vala"
		_vala_move = (PossibleMove) (*((PossibleMove*) _tmp5_));
#line 987 "../src/game.vala"
		_tmp7_ = _vala_move;
#line 987 "../src/game.vala"
		if (_tmp7_.x == x) {
#line 6274 "game.c"
			PossibleMove _tmp8_;
#line 987 "../src/game.vala"
			_tmp8_ = _vala_move;
#line 987 "../src/game.vala"
			_tmp6_ = _tmp8_.y == y;
#line 6280 "game.c"
		} else {
#line 987 "../src/game.vala"
			_tmp6_ = FALSE;
#line 6284 "game.c"
		}
#line 987 "../src/game.vala"
		if (_tmp6_) {
#line 988 "../src/game.vala"
			result = TRUE;
#line 988 "../src/game.vala"
			if (move) {
#line 988 "../src/game.vala"
				*move = _vala_move;
#line 6294 "game.c"
			}
#line 988 "../src/game.vala"
			return result;
#line 6298 "game.c"
		}
#line 989 "../src/game.vala"
		_tmp9_ = test_move;
#line 989 "../src/game.vala"
		_tmp10_ = ((GSList*) _tmp9_)->next;
#line 989 "../src/game.vala"
		test_move = _tmp10_;
#line 6306 "game.c"
	}
#line 991 "../src/game.vala"
	result = FALSE;
#line 991 "../src/game.vala"
	if (move) {
#line 991 "../src/game.vala"
		*move = _vala_move;
#line 6314 "game.c"
	}
#line 991 "../src/game.vala"
	return result;
#line 6318 "game.c"
}

static PossibleMove*
__lambda15_ (Game* self,
             PossibleMove* a)
{
	PossibleMove* _tmp0_;
	PossibleMove* result;
#line 999 "../src/game.vala"
	_tmp0_ = _possible_move_dup0 (a);
#line 999 "../src/game.vala"
	result = _tmp0_;
#line 999 "../src/game.vala"
	return result;
#line 6333 "game.c"
}

static gpointer
___lambda15__gcopy_func (gconstpointer src,
                         gpointer self)
{
	gpointer result;
	result = __lambda15_ ((Game*) self, (PossibleMove*) src);
#line 996 "../src/game.vala"
	return result;
#line 6344 "game.c"
}

void
game_get_possible_moves (Game* self,
                         GSList** moves)
{
	GSList* _vala_moves = NULL;
	GSList* _tmp0_;
	GSList* _tmp1_;
#line 994 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 996 "../src/game.vala"
	_tmp0_ = self->priv->possible_moves;
#line 996 "../src/game.vala"
	_tmp1_ = g_slist_copy_deep (_tmp0_, ___lambda15__gcopy_func, self);
#line 996 "../src/game.vala"
	(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 996 "../src/game.vala"
	_vala_moves = _tmp1_;
#line 994 "../src/game.vala"
	if (moves) {
#line 994 "../src/game.vala"
		*moves = _vala_moves;
#line 6368 "game.c"
	} else {
#line 994 "../src/game.vala"
		(_vala_moves == NULL) ? NULL : (_vala_moves = (_g_slist_free__possible_move_free0_ (_vala_moves), NULL));
#line 6372 "game.c"
	}
}

static inline void
game_update_possible_moves (Game* self)
{
	Opening _tmp0_;
#line 1003 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 1005 "../src/game.vala"
	_tmp0_ = self->priv->_opening;
#line 1005 "../src/game.vala"
	if (_tmp0_ == OPENING_HUMANS) {
#line 1006 "../src/game.vala"
		game_humans_opening_update_possible_moves (self);
#line 6388 "game.c"
	} else {
		GameStateObject* _tmp1_;
		GSList* _tmp2_ = NULL;
#line 1008 "../src/game.vala"
		_tmp1_ = self->priv->_current_state;
#line 1008 "../src/game.vala"
		game_state_object_get_possible_moves (_tmp1_, &_tmp2_);
#line 1008 "../src/game.vala"
		(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
#line 1008 "../src/game.vala"
		self->priv->possible_moves = _tmp2_;
#line 6400 "game.c"
	}
}

static inline gboolean
game_humans_opening_place_tile (Game* self,
                                guint8 x,
                                guint8 y)
{
	guint8 half_game_size = 0U;
	guint8 _tmp0_;
	gboolean even_board = FALSE;
	guint8 _tmp1_;
	gint _tmp46_ = 0;
	guint8 _tmp47_;
	guint8 _tmp48_;
	gboolean result;
#line 1015 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1017 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1017 "../src/game.vala"
	half_game_size = (guint8) (_tmp0_ / 2);
#line 1018 "../src/game.vala"
	_tmp1_ = self->priv->_size;
#line 1018 "../src/game.vala"
	even_board = (_tmp1_ % 2) == 0;
#line 1020 "../src/game.vala"
	if (!game_humans_opening_test_placing_tile (self, x, y)) {
#line 1021 "../src/game.vala"
		result = FALSE;
#line 1021 "../src/game.vala"
		return result;
#line 6433 "game.c"
	}
#line 1023 "../src/game.vala"
	if (even_board) {
#line 6437 "game.c"
		GameStateObject* _tmp2_;
		guint8 _tmp3_;
		guint8 _tmp4_;
		gboolean _tmp5_;
		GameStateObject* _tmp18_;
		GameStateObject* _tmp19_;
		GameStateObject* _tmp20_;
#line 1025 "../src/game.vala"
		_tmp2_ = self->priv->_current_state;
#line 1025 "../src/game.vala"
		_tmp3_ = game_state_object_get_n_dark_tiles (_tmp2_);
#line 1025 "../src/game.vala"
		_tmp4_ = _tmp3_;
#line 1025 "../src/game.vala"
		if (((gint) _tmp4_) == 2) {
#line 1026 "../src/game.vala"
			game_humans_opening_update_opening_even (self);
#line 6455 "game.c"
		}
#line 1028 "../src/game.vala"
		_tmp5_ = self->priv->_print_logs;
#line 1028 "../src/game.vala"
		if (_tmp5_) {
#line 6461 "game.c"
			const gchar* _tmp6_ = NULL;
			Player _tmp7_;
			Player _tmp8_;
			gchar* current_color_string = NULL;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 1030 "../src/game.vala"
			_tmp7_ = game_get_current_color (self);
#line 1030 "../src/game.vala"
			_tmp8_ = _tmp7_;
#line 1030 "../src/game.vala"
			if (_tmp8_ == PLAYER_DARK) {
#line 1030 "../src/game.vala"
				_tmp6_ = "dark :";
#line 6483 "game.c"
			} else {
#line 1030 "../src/game.vala"
				_tmp6_ = "light:";
#line 6487 "game.c"
			}
#line 1030 "../src/game.vala"
			_tmp9_ = g_strdup (_tmp6_);
#line 1030 "../src/game.vala"
			current_color_string = _tmp9_;
#line 1031 "../src/game.vala"
			_tmp10_ = current_color_string;
#line 1031 "../src/game.vala"
			_tmp11_ = string_to_string (_tmp10_);
#line 1031 "../src/game.vala"
			_tmp12_ = g_strdup_printf ("%hhu", x);
#line 1031 "../src/game.vala"
			_tmp13_ = _tmp12_;
#line 1031 "../src/game.vala"
			_tmp14_ = g_strdup_printf ("%hhu", y);
#line 1031 "../src/game.vala"
			_tmp15_ = _tmp14_;
#line 1031 "../src/game.vala"
			_tmp16_ = g_strconcat (_tmp11_, " (", _tmp13_, ", ", _tmp15_, ")\n", NULL);
#line 1031 "../src/game.vala"
			_tmp17_ = _tmp16_;
#line 1031 "../src/game.vala"
			g_print ("%s", _tmp17_);
#line 1031 "../src/game.vala"
			_g_free0 (_tmp17_);
#line 1031 "../src/game.vala"
			_g_free0 (_tmp15_);
#line 1031 "../src/game.vala"
			_g_free0 (_tmp13_);
#line 1028 "../src/game.vala"
			_g_free0 (current_color_string);
#line 6519 "game.c"
		}
#line 1033 "../src/game.vala"
		_tmp18_ = self->priv->_current_state;
#line 1033 "../src/game.vala"
		_tmp19_ = game_state_object_new_copy_and_add (_tmp18_, x, y);
#line 1033 "../src/game.vala"
		_tmp20_ = _tmp19_;
#line 1033 "../src/game.vala"
		game_set_current_state (self, _tmp20_);
#line 1033 "../src/game.vala"
		_g_object_unref0 (_tmp20_);
#line 6531 "game.c"
	} else {
		gboolean _tmp21_ = FALSE;
		Player _tmp22_;
		Player _tmp23_;
		guint8 x2 = 0U;
		guint8 y2 = 0U;
		gboolean _tmp26_;
		GameStateObject* _tmp43_;
		GameStateObject* _tmp44_;
		GameStateObject* _tmp45_;
#line 1037 "../src/game.vala"
		_tmp22_ = game_get_current_color (self);
#line 1037 "../src/game.vala"
		_tmp23_ = _tmp22_;
#line 1037 "../src/game.vala"
		if (_tmp23_ == PLAYER_LIGHT) {
#line 6548 "game.c"
			guint8 _tmp24_;
			guint8 _tmp25_;
#line 1037 "../src/game.vala"
			_tmp24_ = game_get_n_light_tiles (self);
#line 1037 "../src/game.vala"
			_tmp25_ = _tmp24_;
#line 1037 "../src/game.vala"
			_tmp21_ = ((gint) _tmp25_) != 0;
#line 6557 "game.c"
		} else {
#line 1037 "../src/game.vala"
			_tmp21_ = FALSE;
#line 6561 "game.c"
		}
#line 1037 "../src/game.vala"
		if (_tmp21_) {
#line 1038 "../src/game.vala"
			game_humans_opening_update_opening_odd (self, x, y);
#line 6567 "game.c"
		}
#line 1042 "../src/game.vala"
		if (x == half_game_size) {
#line 1042 "../src/game.vala"
			x2 = half_game_size;
#line 6573 "game.c"
		} else {
#line 1043 "../src/game.vala"
			if (((gint) x) == (half_game_size - 1)) {
#line 1043 "../src/game.vala"
				x2 = (guint8) (half_game_size + 1);
#line 6579 "game.c"
			} else {
#line 1044 "../src/game.vala"
				x2 = (guint8) (half_game_size - 1);
#line 6583 "game.c"
			}
		}
#line 1045 "../src/game.vala"
		if (y == half_game_size) {
#line 1045 "../src/game.vala"
			y2 = half_game_size;
#line 6590 "game.c"
		} else {
#line 1046 "../src/game.vala"
			if (((gint) y) == (half_game_size - 1)) {
#line 1046 "../src/game.vala"
				y2 = (guint8) (half_game_size + 1);
#line 6596 "game.c"
			} else {
#line 1047 "../src/game.vala"
				y2 = (guint8) (half_game_size - 1);
#line 6600 "game.c"
			}
		}
#line 1048 "../src/game.vala"
		_tmp26_ = self->priv->_print_logs;
#line 1048 "../src/game.vala"
		if (_tmp26_) {
#line 6607 "game.c"
			const gchar* _tmp27_ = NULL;
			Player _tmp28_;
			Player _tmp29_;
			gchar* current_color_string = NULL;
			gchar* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
#line 1050 "../src/game.vala"
			_tmp28_ = game_get_current_color (self);
#line 1050 "../src/game.vala"
			_tmp29_ = _tmp28_;
#line 1050 "../src/game.vala"
			if (_tmp29_ == PLAYER_DARK) {
#line 1050 "../src/game.vala"
				_tmp27_ = "dark :";
#line 6633 "game.c"
			} else {
#line 1050 "../src/game.vala"
				_tmp27_ = "light:";
#line 6637 "game.c"
			}
#line 1050 "../src/game.vala"
			_tmp30_ = g_strdup (_tmp27_);
#line 1050 "../src/game.vala"
			current_color_string = _tmp30_;
#line 1051 "../src/game.vala"
			_tmp31_ = current_color_string;
#line 1051 "../src/game.vala"
			_tmp32_ = string_to_string (_tmp31_);
#line 1051 "../src/game.vala"
			_tmp33_ = g_strdup_printf ("%hhu", x);
#line 1051 "../src/game.vala"
			_tmp34_ = _tmp33_;
#line 1051 "../src/game.vala"
			_tmp35_ = g_strdup_printf ("%hhu", y);
#line 1051 "../src/game.vala"
			_tmp36_ = _tmp35_;
#line 1051 "../src/game.vala"
			_tmp37_ = g_strdup_printf ("%hhu", x2);
#line 1051 "../src/game.vala"
			_tmp38_ = _tmp37_;
#line 1051 "../src/game.vala"
			_tmp39_ = g_strdup_printf ("%hhu", y2);
#line 1051 "../src/game.vala"
			_tmp40_ = _tmp39_;
#line 1051 "../src/game.vala"
			_tmp41_ = g_strconcat (_tmp32_, " (", _tmp34_, ", ", _tmp36_, ") and (", _tmp38_, ", ", _tmp40_, ")\n", NULL);
#line 1051 "../src/game.vala"
			_tmp42_ = _tmp41_;
#line 1051 "../src/game.vala"
			g_print ("%s", _tmp42_);
#line 1051 "../src/game.vala"
			_g_free0 (_tmp42_);
#line 1051 "../src/game.vala"
			_g_free0 (_tmp40_);
#line 1051 "../src/game.vala"
			_g_free0 (_tmp38_);
#line 1051 "../src/game.vala"
			_g_free0 (_tmp36_);
#line 1051 "../src/game.vala"
			_g_free0 (_tmp34_);
#line 1048 "../src/game.vala"
			_g_free0 (current_color_string);
#line 6681 "game.c"
		}
#line 1053 "../src/game.vala"
		_tmp43_ = self->priv->_current_state;
#line 1053 "../src/game.vala"
		_tmp44_ = game_state_object_new_copy_and_add_two (_tmp43_, x, y, x2, y2);
#line 1053 "../src/game.vala"
		_tmp45_ = _tmp44_;
#line 1053 "../src/game.vala"
		game_set_current_state (self, _tmp45_);
#line 1053 "../src/game.vala"
		_g_object_unref0 (_tmp45_);
#line 6693 "game.c"
	}
#line 1056 "../src/game.vala"
	if (even_board) {
#line 1056 "../src/game.vala"
		_tmp46_ = 2;
#line 6699 "game.c"
	} else {
#line 1056 "../src/game.vala"
		_tmp46_ = 4;
#line 6703 "game.c"
	}
#line 1056 "../src/game.vala"
	_tmp47_ = game_get_n_light_tiles (self);
#line 1056 "../src/game.vala"
	_tmp48_ = _tmp47_;
#line 1056 "../src/game.vala"
	if (((gint) _tmp48_) == _tmp46_) {
#line 6711 "game.c"
		GListStore* _tmp49_;
		GListStore* _tmp50_;
		GameStateObject* _tmp51_;
#line 1058 "../src/game.vala"
		_tmp49_ = self->priv->undo_stack;
#line 1058 "../src/game.vala"
		g_list_store_remove (_tmp49_, (guint) 0);
#line 1059 "../src/game.vala"
		_tmp50_ = self->priv->undo_stack;
#line 1059 "../src/game.vala"
		_tmp51_ = self->priv->_current_state;
#line 1059 "../src/game.vala"
		g_list_store_append (_tmp50_, (GObject*) _tmp51_);
#line 6725 "game.c"
	}
#line 1062 "../src/game.vala"
	game_end_of_turn (self, FALSE, FALSE);
#line 1063 "../src/game.vala"
	result = TRUE;
#line 1063 "../src/game.vala"
	return result;
#line 6733 "game.c"
}

static inline void
game_humans_opening_update_opening_even (Game* self)
{
	guint8 half_game_size = 0U;
	guint8 _tmp0_;
#line 1065 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 1067 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1067 "../src/game.vala"
	half_game_size = (guint8) (_tmp0_ / 2);
#line 1068 "../src/game.vala"
	if (game_get_owner (self, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) == PLAYER_DARK) {
#line 1070 "../src/game.vala"
		if (game_get_owner (self, half_game_size, (guint8) (half_game_size - 1)) == PLAYER_DARK) {
#line 1070 "../src/game.vala"
			game_set_opening (self, OPENING_ALTER_TOP);
#line 6753 "game.c"
		} else {
#line 1071 "../src/game.vala"
			if (game_get_owner (self, half_game_size, half_game_size) == PLAYER_DARK) {
#line 1071 "../src/game.vala"
				game_set_opening (self, OPENING_REVERSI);
#line 6759 "game.c"
			} else {
#line 1072 "../src/game.vala"
				game_set_opening (self, OPENING_ALTER_LEFT);
#line 6763 "game.c"
			}
		}
	} else {
#line 1076 "../src/game.vala"
		if (game_get_owner (self, half_game_size, (guint8) (half_game_size - 1)) == PLAYER_LIGHT) {
#line 1076 "../src/game.vala"
			game_set_opening (self, OPENING_ALTER_BOTTOM);
#line 6771 "game.c"
		} else {
#line 1077 "../src/game.vala"
			if (game_get_owner (self, half_game_size, half_game_size) == PLAYER_DARK) {
#line 1077 "../src/game.vala"
				game_set_opening (self, OPENING_ALTER_RIGHT);
#line 6777 "game.c"
			} else {
#line 1078 "../src/game.vala"
				game_set_opening (self, OPENING_INVERTED);
#line 6781 "game.c"
			}
		}
	}
}

static inline void
game_humans_opening_update_opening_odd (Game* self,
                                        guint8 x,
                                        guint8 y)
{
	guint8 half_game_size = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 1081 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 1083 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1083 "../src/game.vala"
	half_game_size = (guint8) (_tmp0_ / 2);
#line 1084 "../src/game.vala"
	if (x == half_game_size) {
#line 1084 "../src/game.vala"
		_tmp1_ = TRUE;
#line 6805 "game.c"
	} else {
#line 1084 "../src/game.vala"
		_tmp1_ = y == half_game_size;
#line 6809 "game.c"
	}
#line 1084 "../src/game.vala"
	if (_tmp1_) {
#line 1086 "../src/game.vala"
		if (game_get_owner (self, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) == PLAYER_NONE) {
#line 1087 "../src/game.vala"
			game_set_opening (self, OPENING_REVERSI);
#line 6817 "game.c"
		} else {
#line 1089 "../src/game.vala"
			game_set_opening (self, OPENING_INVERTED);
#line 6821 "game.c"
		}
	} else {
#line 1093 "../src/game.vala"
		if (x == y) {
#line 1095 "../src/game.vala"
			if (game_get_owner (self, half_game_size, (guint8) (half_game_size - 1)) == PLAYER_LIGHT) {
#line 1096 "../src/game.vala"
				game_set_opening (self, OPENING_ALTER_LEFT);
#line 6830 "game.c"
			} else {
#line 1097 "../src/game.vala"
				game_set_opening (self, OPENING_ALTER_BOTTOM);
#line 6834 "game.c"
			}
		} else {
#line 1101 "../src/game.vala"
			if (game_get_owner (self, half_game_size, (guint8) (half_game_size - 1)) == PLAYER_LIGHT) {
#line 1102 "../src/game.vala"
				game_set_opening (self, OPENING_ALTER_RIGHT);
#line 6841 "game.c"
			} else {
#line 1103 "../src/game.vala"
				game_set_opening (self, OPENING_ALTER_TOP);
#line 6845 "game.c"
			}
		}
	}
}

static gboolean
game_humans_opening_test_placing_tile (Game* self,
                                       guint8 x,
                                       guint8 y)
{
	guint8 _tmp0_;
	gboolean result;
#line 1108 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1110 "../src/game.vala"
	if (game_get_owner (self, x, y) != PLAYER_NONE) {
#line 1111 "../src/game.vala"
		result = FALSE;
#line 1111 "../src/game.vala"
		return result;
#line 6866 "game.c"
	}
#line 1113 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1113 "../src/game.vala"
	if ((_tmp0_ % 2) == 0) {
#line 1114 "../src/game.vala"
		result = game_humans_opening_test_placing_tile_even (self, x, y);
#line 1114 "../src/game.vala"
		return result;
#line 6876 "game.c"
	} else {
#line 1116 "../src/game.vala"
		result = game_humans_opening_test_placing_tile_odd (self, x, y);
#line 1116 "../src/game.vala"
		return result;
#line 6882 "game.c"
	}
}

static inline gboolean
game_humans_opening_test_placing_tile_even (Game* self,
                                            guint8 x,
                                            guint8 y)
{
	guint8 half_game_size = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	Player _tmp5_;
	Player _tmp6_;
	gboolean result;
#line 1118 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1120 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1120 "../src/game.vala"
	half_game_size = (guint8) (_tmp0_ / 2);
#line 1122 "../src/game.vala"
	if (((gint) x) < (half_game_size - 1)) {
#line 1122 "../src/game.vala"
		_tmp3_ = TRUE;
#line 6910 "game.c"
	} else {
#line 1122 "../src/game.vala"
		_tmp3_ = x > half_game_size;
#line 6914 "game.c"
	}
#line 1122 "../src/game.vala"
	if (_tmp3_) {
#line 1122 "../src/game.vala"
		_tmp2_ = TRUE;
#line 6920 "game.c"
	} else {
#line 1123 "../src/game.vala"
		_tmp2_ = ((gint) y) < (half_game_size - 1);
#line 6924 "game.c"
	}
#line 1122 "../src/game.vala"
	if (_tmp2_) {
#line 1122 "../src/game.vala"
		_tmp1_ = TRUE;
#line 6930 "game.c"
	} else {
#line 1123 "../src/game.vala"
		_tmp1_ = y > half_game_size;
#line 6934 "game.c"
	}
#line 1122 "../src/game.vala"
	if (_tmp1_) {
#line 1124 "../src/game.vala"
		result = FALSE;
#line 1124 "../src/game.vala"
		return result;
#line 6942 "game.c"
	}
#line 1126 "../src/game.vala"
	_tmp5_ = game_get_current_color (self);
#line 1126 "../src/game.vala"
	_tmp6_ = _tmp5_;
#line 1126 "../src/game.vala"
	if (_tmp6_ == PLAYER_LIGHT) {
#line 6950 "game.c"
		guint8 _tmp7_;
		guint8 _tmp8_;
#line 1126 "../src/game.vala"
		_tmp7_ = game_get_n_light_tiles (self);
#line 1126 "../src/game.vala"
		_tmp8_ = _tmp7_;
#line 1126 "../src/game.vala"
		_tmp4_ = ((gint) _tmp8_) == 0;
#line 6959 "game.c"
	} else {
#line 1126 "../src/game.vala"
		_tmp4_ = FALSE;
#line 6963 "game.c"
	}
#line 1126 "../src/game.vala"
	if (_tmp4_) {
#line 6967 "game.c"
		gint _tmp9_ = 0;
		guint8 opposite_x = 0U;
		gint _tmp10_ = 0;
		guint8 opposite_y = 0U;
#line 1128 "../src/game.vala"
		if (x == half_game_size) {
#line 1128 "../src/game.vala"
			_tmp9_ = half_game_size - 1;
#line 6976 "game.c"
		} else {
#line 1128 "../src/game.vala"
			_tmp9_ = (gint) half_game_size;
#line 6980 "game.c"
		}
#line 1128 "../src/game.vala"
		opposite_x = (guint8) _tmp9_;
#line 1129 "../src/game.vala"
		if (y == half_game_size) {
#line 1129 "../src/game.vala"
			_tmp10_ = half_game_size - 1;
#line 6988 "game.c"
		} else {
#line 1129 "../src/game.vala"
			_tmp10_ = (gint) half_game_size;
#line 6992 "game.c"
		}
#line 1129 "../src/game.vala"
		opposite_y = (guint8) _tmp10_;
#line 1130 "../src/game.vala"
		if (game_get_owner (self, opposite_x, opposite_y) == PLAYER_DARK) {
#line 1131 "../src/game.vala"
			result = FALSE;
#line 1131 "../src/game.vala"
			return result;
#line 7002 "game.c"
		}
	}
#line 1133 "../src/game.vala"
	result = TRUE;
#line 1133 "../src/game.vala"
	return result;
#line 7009 "game.c"
}

static inline gboolean
game_humans_opening_test_placing_tile_odd (Game* self,
                                           guint8 x,
                                           guint8 y)
{
	guint8 half_game_size = 0U;
	guint8 _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	Player _tmp4_;
	Player _tmp5_;
	gboolean result;
#line 1135 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1137 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1137 "../src/game.vala"
	half_game_size = (guint8) (_tmp0_ / 2);
#line 1139 "../src/game.vala"
	if (((gint) x) < (half_game_size - 1)) {
#line 1139 "../src/game.vala"
		_tmp3_ = TRUE;
#line 7035 "game.c"
	} else {
#line 1139 "../src/game.vala"
		_tmp3_ = ((gint) x) > (half_game_size + 1);
#line 7039 "game.c"
	}
#line 1139 "../src/game.vala"
	if (_tmp3_) {
#line 1139 "../src/game.vala"
		_tmp2_ = TRUE;
#line 7045 "game.c"
	} else {
#line 1140 "../src/game.vala"
		_tmp2_ = ((gint) y) < (half_game_size - 1);
#line 7049 "game.c"
	}
#line 1139 "../src/game.vala"
	if (_tmp2_) {
#line 1139 "../src/game.vala"
		_tmp1_ = TRUE;
#line 7055 "game.c"
	} else {
#line 1140 "../src/game.vala"
		_tmp1_ = ((gint) y) > (half_game_size + 1);
#line 7059 "game.c"
	}
#line 1139 "../src/game.vala"
	if (_tmp1_) {
#line 1141 "../src/game.vala"
		result = FALSE;
#line 1141 "../src/game.vala"
		return result;
#line 7067 "game.c"
	}
#line 1143 "../src/game.vala"
	_tmp4_ = game_get_current_color (self);
#line 1143 "../src/game.vala"
	_tmp5_ = _tmp4_;
#line 1143 "../src/game.vala"
	if (_tmp5_ == PLAYER_LIGHT) {
#line 7075 "game.c"
		guint8 _tmp6_;
		guint8 _tmp7_;
#line 1145 "../src/game.vala"
		_tmp6_ = game_get_n_light_tiles (self);
#line 1145 "../src/game.vala"
		_tmp7_ = _tmp6_;
#line 1145 "../src/game.vala"
		if (((gint) _tmp7_) == 0) {
#line 7084 "game.c"
			gboolean _tmp8_ = FALSE;
#line 1147 "../src/game.vala"
			if (x != half_game_size) {
#line 1147 "../src/game.vala"
				_tmp8_ = y != half_game_size;
#line 7090 "game.c"
			} else {
#line 1147 "../src/game.vala"
				_tmp8_ = FALSE;
#line 7094 "game.c"
			}
#line 1147 "../src/game.vala"
			if (_tmp8_) {
#line 1148 "../src/game.vala"
				result = FALSE;
#line 1148 "../src/game.vala"
				return result;
#line 7102 "game.c"
			}
		} else {
			gboolean _tmp9_ = FALSE;
#line 1152 "../src/game.vala"
			if (game_get_owner (self, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) != PLAYER_NONE) {
#line 1152 "../src/game.vala"
				_tmp9_ = TRUE;
#line 7110 "game.c"
			} else {
#line 1153 "../src/game.vala"
				_tmp9_ = game_get_owner (self, (guint8) (half_game_size + 1), (guint8) (half_game_size - 1)) != PLAYER_NONE;
#line 7114 "game.c"
			}
#line 1152 "../src/game.vala"
			if (_tmp9_) {
#line 7118 "game.c"
				gboolean _tmp10_ = FALSE;
#line 1155 "../src/game.vala"
				if (x != half_game_size) {
#line 1155 "../src/game.vala"
					_tmp10_ = y != half_game_size;
#line 7124 "game.c"
				} else {
#line 1155 "../src/game.vala"
					_tmp10_ = FALSE;
#line 7128 "game.c"
				}
#line 1155 "../src/game.vala"
				if (_tmp10_) {
#line 1156 "../src/game.vala"
					result = FALSE;
#line 1156 "../src/game.vala"
					return result;
#line 7136 "game.c"
				}
			}
		}
	}
#line 1160 "../src/game.vala"
	result = TRUE;
#line 1160 "../src/game.vala"
	return result;
#line 7145 "game.c"
}

static inline void
game_humans_opening_update_possible_moves (Game* self)
{
	guint8 _tmp0_;
#line 1163 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 1165 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1165 "../src/game.vala"
	if ((_tmp0_ % 2) == 0) {
#line 1166 "../src/game.vala"
		game_humans_opening_update_possible_moves_even (self);
#line 7160 "game.c"
	} else {
#line 1168 "../src/game.vala"
		game_humans_opening_update_possible_moves_odd (self);
#line 7164 "game.c"
	}
}

static inline void
game_humans_opening_update_possible_moves_even (Game* self)
{
	guint8 half_game_size = 0U;
	guint8 _tmp0_;
	gboolean top_left = FALSE;
	gboolean top_right = FALSE;
	gboolean bottom_left = FALSE;
	gboolean bottom_right = FALSE;
	gboolean _tmp1_ = FALSE;
	Player _tmp2_;
	Player _tmp3_;
#line 1170 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 1172 "../src/game.vala"
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
#line 1172 "../src/game.vala"
	self->priv->possible_moves = NULL;
#line 1174 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1174 "../src/game.vala"
	half_game_size = (guint8) (_tmp0_ / 2);
#line 1181 "../src/game.vala"
	_tmp2_ = game_get_current_color (self);
#line 1181 "../src/game.vala"
	_tmp3_ = _tmp2_;
#line 1181 "../src/game.vala"
	if (_tmp3_ == PLAYER_LIGHT) {
#line 7196 "game.c"
		guint8 _tmp4_;
		guint8 _tmp5_;
#line 1181 "../src/game.vala"
		_tmp4_ = game_get_n_light_tiles (self);
#line 1181 "../src/game.vala"
		_tmp5_ = _tmp4_;
#line 1181 "../src/game.vala"
		_tmp1_ = ((gint) _tmp5_) == 0;
#line 7205 "game.c"
	} else {
#line 1181 "../src/game.vala"
		_tmp1_ = FALSE;
#line 7209 "game.c"
	}
#line 1181 "../src/game.vala"
	if (_tmp1_) {
#line 7213 "game.c"
		gboolean _tmp6_ = FALSE;
#line 1183 "../src/game.vala"
		if (game_get_owner (self, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) == PLAYER_NONE) {
#line 1184 "../src/game.vala"
			_tmp6_ = game_get_owner (self, half_game_size, half_game_size) == PLAYER_NONE;
#line 7219 "game.c"
		} else {
#line 1183 "../src/game.vala"
			_tmp6_ = FALSE;
#line 7223 "game.c"
		}
#line 1183 "../src/game.vala"
		top_left = _tmp6_;
#line 1185 "../src/game.vala"
		top_right = !top_left;
#line 1186 "../src/game.vala"
		bottom_left = !top_left;
#line 1187 "../src/game.vala"
		bottom_right = top_left;
#line 7233 "game.c"
	} else {
#line 1191 "../src/game.vala"
		top_left = game_get_owner (self, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) == PLAYER_NONE;
#line 1192 "../src/game.vala"
		top_right = game_get_owner (self, half_game_size, (guint8) (half_game_size - 1)) == PLAYER_NONE;
#line 1193 "../src/game.vala"
		bottom_left = game_get_owner (self, (guint8) (half_game_size - 1), half_game_size) == PLAYER_NONE;
#line 1194 "../src/game.vala"
		bottom_right = game_get_owner (self, half_game_size, half_game_size) == PLAYER_NONE;
#line 7243 "game.c"
	}
#line 1197 "../src/game.vala"
	if (top_left) {
#line 7247 "game.c"
		PossibleMove _tmp7_ = {0};
		PossibleMove* _tmp8_;
#line 1197 "../src/game.vala"
		possible_move_init (&_tmp7_, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1));
#line 1197 "../src/game.vala"
		_tmp8_ = _possible_move_dup0 (&_tmp7_);
#line 1197 "../src/game.vala"
		self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp8_);
#line 7256 "game.c"
	}
#line 1198 "../src/game.vala"
	if (top_right) {
#line 7260 "game.c"
		PossibleMove _tmp9_ = {0};
		PossibleMove* _tmp10_;
#line 1198 "../src/game.vala"
		possible_move_init (&_tmp9_, half_game_size, (guint8) (half_game_size - 1));
#line 1198 "../src/game.vala"
		_tmp10_ = _possible_move_dup0 (&_tmp9_);
#line 1198 "../src/game.vala"
		self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp10_);
#line 7269 "game.c"
	}
#line 1199 "../src/game.vala"
	if (bottom_left) {
#line 7273 "game.c"
		PossibleMove _tmp11_ = {0};
		PossibleMove* _tmp12_;
#line 1199 "../src/game.vala"
		possible_move_init (&_tmp11_, (guint8) (half_game_size - 1), half_game_size);
#line 1199 "../src/game.vala"
		_tmp12_ = _possible_move_dup0 (&_tmp11_);
#line 1199 "../src/game.vala"
		self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp12_);
#line 7282 "game.c"
	}
#line 1200 "../src/game.vala"
	if (bottom_right) {
#line 7286 "game.c"
		PossibleMove _tmp13_ = {0};
		PossibleMove* _tmp14_;
#line 1200 "../src/game.vala"
		possible_move_init (&_tmp13_, half_game_size, half_game_size);
#line 1200 "../src/game.vala"
		_tmp14_ = _possible_move_dup0 (&_tmp13_);
#line 1200 "../src/game.vala"
		self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp14_);
#line 7295 "game.c"
	}
}

static inline void
game_humans_opening_update_possible_moves_odd (Game* self)
{
	guint8 half_game_size = 0U;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
#line 1202 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 1204 "../src/game.vala"
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
#line 1204 "../src/game.vala"
	self->priv->possible_moves = NULL;
#line 1206 "../src/game.vala"
	_tmp0_ = self->priv->_size;
#line 1206 "../src/game.vala"
	half_game_size = (guint8) (_tmp0_ / 2);
#line 1209 "../src/game.vala"
	_tmp1_ = game_get_n_light_tiles (self);
#line 1209 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 1209 "../src/game.vala"
	if (((gint) _tmp2_) == 0) {
#line 7322 "game.c"
		PossibleMove _tmp3_ = {0};
		PossibleMove* _tmp4_;
		PossibleMove _tmp5_ = {0};
		PossibleMove* _tmp6_;
		PossibleMove _tmp7_ = {0};
		PossibleMove* _tmp8_;
		PossibleMove _tmp9_ = {0};
		PossibleMove* _tmp10_;
#line 1211 "../src/game.vala"
		possible_move_init (&_tmp3_, (guint8) (half_game_size - 1), half_game_size);
#line 1211 "../src/game.vala"
		_tmp4_ = _possible_move_dup0 (&_tmp3_);
#line 1211 "../src/game.vala"
		self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp4_);
#line 1212 "../src/game.vala"
		possible_move_init (&_tmp5_, half_game_size, (guint8) (half_game_size - 1));
#line 1212 "../src/game.vala"
		_tmp6_ = _possible_move_dup0 (&_tmp5_);
#line 1212 "../src/game.vala"
		self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp6_);
#line 1213 "../src/game.vala"
		possible_move_init (&_tmp7_, half_game_size, (guint8) (half_game_size + 1));
#line 1213 "../src/game.vala"
		_tmp8_ = _possible_move_dup0 (&_tmp7_);
#line 1213 "../src/game.vala"
		self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp8_);
#line 1214 "../src/game.vala"
		possible_move_init (&_tmp9_, (guint8) (half_game_size + 1), half_game_size);
#line 1214 "../src/game.vala"
		_tmp10_ = _possible_move_dup0 (&_tmp9_);
#line 1214 "../src/game.vala"
		self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp10_);
#line 7355 "game.c"
	} else {
		Player _tmp11_;
		Player _tmp12_;
#line 1217 "../src/game.vala"
		_tmp11_ = game_get_current_color (self);
#line 1217 "../src/game.vala"
		_tmp12_ = _tmp11_;
#line 1217 "../src/game.vala"
		if (_tmp12_ == PLAYER_DARK) {
#line 7365 "game.c"
			{
				guint8 x = 0U;
#line 1219 "../src/game.vala"
				x = (guint8) (half_game_size - 1);
#line 7370 "game.c"
				{
					gboolean _tmp13_ = FALSE;
#line 1219 "../src/game.vala"
					_tmp13_ = TRUE;
#line 1219 "../src/game.vala"
					while (TRUE) {
#line 1219 "../src/game.vala"
						if (!_tmp13_) {
#line 7379 "game.c"
							guint8 _tmp14_;
#line 1219 "../src/game.vala"
							_tmp14_ = x;
#line 1219 "../src/game.vala"
							x = _tmp14_ + 1;
#line 7385 "game.c"
						}
#line 1219 "../src/game.vala"
						_tmp13_ = FALSE;
#line 1219 "../src/game.vala"
						if (!(((gint) x) <= (half_game_size + 1))) {
#line 1219 "../src/game.vala"
							break;
#line 7393 "game.c"
						}
						{
							guint8 y = 0U;
#line 1220 "../src/game.vala"
							y = (guint8) (half_game_size - 1);
#line 7399 "game.c"
							{
								gboolean _tmp15_ = FALSE;
#line 1220 "../src/game.vala"
								_tmp15_ = TRUE;
#line 1220 "../src/game.vala"
								while (TRUE) {
#line 1220 "../src/game.vala"
									if (!_tmp15_) {
#line 7408 "game.c"
										guint8 _tmp16_;
#line 1220 "../src/game.vala"
										_tmp16_ = y;
#line 1220 "../src/game.vala"
										y = _tmp16_ + 1;
#line 7414 "game.c"
									}
#line 1220 "../src/game.vala"
									_tmp15_ = FALSE;
#line 1220 "../src/game.vala"
									if (!(((gint) y) <= (half_game_size + 1))) {
#line 1220 "../src/game.vala"
										break;
#line 7422 "game.c"
									}
#line 1221 "../src/game.vala"
									if (game_get_owner (self, x, y) == PLAYER_NONE) {
#line 7426 "game.c"
										PossibleMove _tmp17_ = {0};
										PossibleMove* _tmp18_;
#line 1222 "../src/game.vala"
										possible_move_init (&_tmp17_, x, y);
#line 1222 "../src/game.vala"
										_tmp18_ = _possible_move_dup0 (&_tmp17_);
#line 1222 "../src/game.vala"
										self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp18_);
#line 7435 "game.c"
									}
								}
							}
						}
					}
				}
			}
		} else {
			gboolean _tmp19_ = FALSE;
#line 1225 "../src/game.vala"
			if (game_get_owner (self, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1)) == PLAYER_NONE) {
#line 1226 "../src/game.vala"
				_tmp19_ = game_get_owner (self, (guint8) (half_game_size - 1), (guint8) (half_game_size + 1)) == PLAYER_NONE;
#line 7449 "game.c"
			} else {
#line 1225 "../src/game.vala"
				_tmp19_ = FALSE;
#line 7453 "game.c"
			}
#line 1225 "../src/game.vala"
			if (_tmp19_) {
#line 7457 "game.c"
				PossibleMove _tmp20_ = {0};
				PossibleMove* _tmp21_;
				PossibleMove _tmp22_ = {0};
				PossibleMove* _tmp23_;
				PossibleMove _tmp24_ = {0};
				PossibleMove* _tmp25_;
				PossibleMove _tmp26_ = {0};
				PossibleMove* _tmp27_;
#line 1228 "../src/game.vala"
				possible_move_init (&_tmp20_, (guint8) (half_game_size - 1), (guint8) (half_game_size - 1));
#line 1228 "../src/game.vala"
				_tmp21_ = _possible_move_dup0 (&_tmp20_);
#line 1228 "../src/game.vala"
				self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp21_);
#line 1229 "../src/game.vala"
				possible_move_init (&_tmp22_, (guint8) (half_game_size - 1), (guint8) (half_game_size + 1));
#line 1229 "../src/game.vala"
				_tmp23_ = _possible_move_dup0 (&_tmp22_);
#line 1229 "../src/game.vala"
				self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp23_);
#line 1230 "../src/game.vala"
				possible_move_init (&_tmp24_, (guint8) (half_game_size + 1), (guint8) (half_game_size - 1));
#line 1230 "../src/game.vala"
				_tmp25_ = _possible_move_dup0 (&_tmp24_);
#line 1230 "../src/game.vala"
				self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp25_);
#line 1231 "../src/game.vala"
				possible_move_init (&_tmp26_, (guint8) (half_game_size + 1), (guint8) (half_game_size + 1));
#line 1231 "../src/game.vala"
				_tmp27_ = _possible_move_dup0 (&_tmp26_);
#line 1231 "../src/game.vala"
				self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp27_);
#line 7490 "game.c"
			} else {
#line 1234 "../src/game.vala"
				if (game_get_owner (self, half_game_size, (guint8) (half_game_size - 1)) == PLAYER_NONE) {
#line 7494 "game.c"
					PossibleMove _tmp28_ = {0};
					PossibleMove* _tmp29_;
					PossibleMove _tmp30_ = {0};
					PossibleMove* _tmp31_;
#line 1236 "../src/game.vala"
					possible_move_init (&_tmp28_, half_game_size, (guint8) (half_game_size - 1));
#line 1236 "../src/game.vala"
					_tmp29_ = _possible_move_dup0 (&_tmp28_);
#line 1236 "../src/game.vala"
					self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp29_);
#line 1237 "../src/game.vala"
					possible_move_init (&_tmp30_, half_game_size, (guint8) (half_game_size + 1));
#line 1237 "../src/game.vala"
					_tmp31_ = _possible_move_dup0 (&_tmp30_);
#line 1237 "../src/game.vala"
					self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp31_);
#line 7511 "game.c"
				} else {
					PossibleMove _tmp32_ = {0};
					PossibleMove* _tmp33_;
					PossibleMove _tmp34_ = {0};
					PossibleMove* _tmp35_;
#line 1242 "../src/game.vala"
					possible_move_init (&_tmp32_, (guint8) (half_game_size - 1), half_game_size);
#line 1242 "../src/game.vala"
					_tmp33_ = _possible_move_dup0 (&_tmp32_);
#line 1242 "../src/game.vala"
					self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp33_);
#line 1243 "../src/game.vala"
					possible_move_init (&_tmp34_, (guint8) (half_game_size + 1), half_game_size);
#line 1243 "../src/game.vala"
					_tmp35_ = _possible_move_dup0 (&_tmp34_);
#line 1243 "../src/game.vala"
					self->priv->possible_moves = g_slist_prepend (self->priv->possible_moves, _tmp35_);
#line 7529 "game.c"
				}
			}
		}
	}
}

guint8
game_get_number_of_moves (Game* self)
{
	guint8 result;
	guint n_items = 0U;
	GListStore* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 657 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 659 "../src/game.vala"
	_tmp0_ = self->priv->undo_stack;
#line 659 "../src/game.vala"
	n_items = g_list_model_get_n_items ((GListModel*) _tmp0_);
#line 660 "../src/game.vala"
	if (n_items == ((guint) 0)) {
#line 660 "../src/game.vala"
		_tmp1_ = TRUE;
#line 7553 "game.c"
	} else {
#line 660 "../src/game.vala"
		_tmp1_ = n_items >= ((guint) 256);
#line 7557 "game.c"
	}
#line 660 "../src/game.vala"
	if (_tmp1_) {
#line 661 "../src/game.vala"
		g_assert_not_reached ();
#line 7563 "game.c"
	}
#line 662 "../src/game.vala"
	result = (guint8) (n_items - 1);
#line 662 "../src/game.vala"
	return result;
#line 7569 "game.c"
}

guint8
game_get_size (Game* self)
{
	guint8 result;
#line 673 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 673 "../src/game.vala"
	result = self->priv->_size;
#line 673 "../src/game.vala"
	return result;
#line 7582 "game.c"
}

static void
game_set_size (Game* self,
               guint8 value)
{
#line 673 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 673 "../src/game.vala"
	self->priv->_size = value;
#line 7593 "game.c"
}

gboolean
game_get_reverse (Game* self)
{
	gboolean result;
#line 674 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 674 "../src/game.vala"
	result = self->priv->_reverse;
#line 674 "../src/game.vala"
	return result;
#line 7606 "game.c"
}

static void
game_set_reverse (Game* self,
                  gboolean value)
{
#line 674 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 674 "../src/game.vala"
	self->priv->_reverse = value;
#line 7617 "game.c"
}

Opening
game_get_opening (Game* self)
{
	Opening result;
#line 675 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 675 "../src/game.vala"
	result = self->priv->_opening;
#line 675 "../src/game.vala"
	return result;
#line 7630 "game.c"
}

void
game_set_opening (Game* self,
                  Opening value)
{
#line 675 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 675 "../src/game.vala"
	self->priv->_opening = value;
#line 7641 "game.c"
}

GameStateObject*
game_get_current_state (Game* self)
{
	GameStateObject* result;
	GameStateObject* _tmp0_;
#line 676 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 676 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 676 "../src/game.vala"
	result = _tmp0_;
#line 676 "../src/game.vala"
	return result;
#line 7657 "game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 676 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 7665 "game.c"
}

void
game_set_current_state (Game* self,
                        GameStateObject* value)
{
	GameStateObject* _tmp0_;
#line 676 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 676 "../src/game.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 676 "../src/game.vala"
	_g_object_unref0 (self->priv->_current_state);
#line 676 "../src/game.vala"
	self->priv->_current_state = _tmp0_;
#line 7681 "game.c"
}

guint8
game_get_initial_number_of_tiles (Game* self)
{
	guint8 result;
#line 677 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 677 "../src/game.vala"
	result = self->priv->_initial_number_of_tiles;
#line 677 "../src/game.vala"
	return result;
#line 7694 "game.c"
}

static void
game_set_initial_number_of_tiles (Game* self,
                                  guint8 value)
{
#line 677 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 677 "../src/game.vala"
	self->priv->_initial_number_of_tiles = value;
#line 7705 "game.c"
}

gboolean
game_get_print_logs (Game* self)
{
	gboolean result;
#line 678 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 678 "../src/game.vala"
	result = self->priv->_print_logs;
#line 678 "../src/game.vala"
	return result;
#line 7718 "game.c"
}

static void
game_set_print_logs (Game* self,
                     gboolean value)
{
#line 678 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 678 "../src/game.vala"
	self->priv->_print_logs = value;
#line 7729 "game.c"
}

gboolean
game_get_is_complete (Game* self)
{
	gboolean result;
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 843 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 843 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 843 "../src/game.vala"
	_tmp1_ = game_state_object_get_is_complete (_tmp0_);
#line 843 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 843 "../src/game.vala"
	result = _tmp2_;
#line 843 "../src/game.vala"
	return result;
#line 7751 "game.c"
}

guint8
game_get_n_light_tiles (Game* self)
{
	guint8 result;
	GameStateObject* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
#line 844 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 844 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 844 "../src/game.vala"
	_tmp1_ = game_state_object_get_n_light_tiles (_tmp0_);
#line 844 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 844 "../src/game.vala"
	result = _tmp2_;
#line 844 "../src/game.vala"
	return result;
#line 7773 "game.c"
}

guint8
game_get_n_dark_tiles (Game* self)
{
	guint8 result;
	GameStateObject* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
#line 845 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 845 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 845 "../src/game.vala"
	_tmp1_ = game_state_object_get_n_dark_tiles (_tmp0_);
#line 845 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 845 "../src/game.vala"
	result = _tmp2_;
#line 845 "../src/game.vala"
	return result;
#line 7795 "game.c"
}

gboolean
game_get_current_player_can_move (Game* self)
{
	gboolean result;
	GameStateObject* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 846 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 846 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 846 "../src/game.vala"
	_tmp1_ = game_state_object_get_current_player_can_move (_tmp0_);
#line 846 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 846 "../src/game.vala"
	result = _tmp2_;
#line 846 "../src/game.vala"
	return result;
#line 7817 "game.c"
}

Player
game_get_current_color (Game* self)
{
	Player result;
	GameStateObject* _tmp0_;
	Player _tmp1_;
	Player _tmp2_;
#line 847 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 847 "../src/game.vala"
	_tmp0_ = self->priv->_current_state;
#line 847 "../src/game.vala"
	_tmp1_ = game_state_object_get_current_color (_tmp0_);
#line 847 "../src/game.vala"
	_tmp2_ = _tmp1_;
#line 847 "../src/game.vala"
	result = _tmp2_;
#line 847 "../src/game.vala"
	return result;
#line 7839 "game.c"
}

static void
g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (gpointer data1, gboolean arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOOLEAN_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 652 "../src/game.vala"
	g_return_if_fail (n_param_values == 3);
#line 652 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 652 "../src/game.vala"
		data1 = closure->data;
#line 652 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7864 "game.c"
	} else {
#line 652 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 652 "../src/game.vala"
		data2 = closure->data;
#line 7870 "game.c"
	}
#line 652 "../src/game.vala"
	callback = (GMarshalFunc_VOID__BOOLEAN_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 652 "../src/game.vala"
	callback (data1, g_value_get_boolean (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 7876 "game.c"
}

static GObject *
game_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Game * self;
	GListStore* _tmp0_;
	GameStateObject* _tmp1_;
	gboolean _tmp2_;
#line 680 "../src/game.vala"
	parent_class = G_OBJECT_CLASS (game_parent_class);
#line 680 "../src/game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 680 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 682 "../src/game.vala"
	_tmp0_ = self->priv->undo_stack;
#line 682 "../src/game.vala"
	_tmp1_ = self->priv->_current_state;
#line 682 "../src/game.vala"
	g_list_store_append (_tmp0_, (GObject*) _tmp1_);
#line 683 "../src/game.vala"
	game_update_possible_moves (self);
#line 685 "../src/game.vala"
	_tmp2_ = self->priv->_print_logs;
#line 685 "../src/game.vala"
	if (_tmp2_) {
#line 7908 "game.c"
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_;
		gchar* e_or_i = NULL;
		gchar* _tmp5_;
		guint8 _tmp6_;
#line 687 "../src/game.vala"
		_tmp4_ = self->priv->_reverse;
#line 687 "../src/game.vala"
		if (_tmp4_) {
#line 687 "../src/game.vala"
			_tmp3_ = "e";
#line 7920 "game.c"
		} else {
#line 687 "../src/game.vala"
			_tmp3_ = "i";
#line 7924 "game.c"
		}
#line 687 "../src/game.vala"
		_tmp5_ = g_strdup (_tmp3_);
#line 687 "../src/game.vala"
		e_or_i = _tmp5_;
#line 688 "../src/game.vala"
		_tmp6_ = self->priv->_initial_number_of_tiles;
#line 688 "../src/game.vala"
		if (((gint) _tmp6_) <= 1) {
#line 7934 "game.c"
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 689 "../src/game.vala"
			_tmp7_ = e_or_i;
#line 689 "../src/game.vala"
			_tmp8_ = string_to_string (_tmp7_);
#line 689 "../src/game.vala"
			_tmp9_ = g_strconcat ("\nnew two-player revers", _tmp8_, " game\n", NULL);
#line 689 "../src/game.vala"
			_tmp10_ = _tmp9_;
#line 689 "../src/game.vala"
			g_print ("%s", _tmp10_);
#line 689 "../src/game.vala"
			_g_free0 (_tmp10_);
#line 7951 "game.c"
		} else {
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			Opening _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 691 "../src/game.vala"
			_tmp11_ = e_or_i;
#line 691 "../src/game.vala"
			_tmp12_ = string_to_string (_tmp11_);
#line 691 "../src/game.vala"
			_tmp13_ = self->priv->_opening;
#line 691 "../src/game.vala"
			_tmp14_ = opening_to_string (_tmp13_);
#line 691 "../src/game.vala"
			_tmp15_ = _tmp14_;
#line 691 "../src/game.vala"
			_tmp16_ = g_strconcat ("\nnew one-player revers", _tmp12_, " game (", _tmp15_, " opening)\n", NULL);
#line 691 "../src/game.vala"
			_tmp17_ = _tmp16_;
#line 691 "../src/game.vala"
			g_print ("%s", _tmp17_);
#line 691 "../src/game.vala"
			_g_free0 (_tmp17_);
#line 691 "../src/game.vala"
			_g_free0 (_tmp15_);
#line 7980 "game.c"
		}
#line 685 "../src/game.vala"
		_g_free0 (e_or_i);
#line 7984 "game.c"
	}
#line 680 "../src/game.vala"
	return obj;
#line 7988 "game.c"
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 652 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 652 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 652 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 652 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 652 "../src/game.vala"
	G_OBJECT_CLASS (klass)->constructor = game_constructor;
#line 652 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_NUMBER_OF_MOVES_PROPERTY, game_properties[GAME_NUMBER_OF_MOVES_PROPERTY] = g_param_spec_uchar ("number-of-moves", "number-of-moves", "number-of-moves", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SIZE_PROPERTY, game_properties[GAME_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_REVERSE_PROPERTY, game_properties[GAME_REVERSE_PROPERTY] = g_param_spec_boolean ("reverse", "reverse", "reverse", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_OPENING_PROPERTY, game_properties[GAME_OPENING_PROPERTY] = g_param_spec_enum ("opening", "opening", "opening", TYPE_OPENING, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_STATE_PROPERTY, game_properties[GAME_CURRENT_STATE_PROPERTY] = g_param_spec_object ("current-state", "current-state", "current-state", TYPE_GAME_STATE_OBJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_INITIAL_NUMBER_OF_TILES_PROPERTY, game_properties[GAME_INITIAL_NUMBER_OF_TILES_PROPERTY] = g_param_spec_uchar ("initial-number-of-tiles", "initial-number-of-tiles", "initial-number-of-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_PRINT_LOGS_PROPERTY, game_properties[GAME_PRINT_LOGS_PROPERTY] = g_param_spec_boolean ("print-logs", "print-logs", "print-logs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_IS_COMPLETE_PROPERTY, game_properties[GAME_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_LIGHT_TILES_PROPERTY, game_properties[GAME_N_LIGHT_TILES_PROPERTY] = g_param_spec_uchar ("n-light-tiles", "n-light-tiles", "n-light-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_N_DARK_TILES_PROPERTY, game_properties[GAME_N_DARK_TILES_PROPERTY] = g_param_spec_uchar ("n-dark-tiles", "n-dark-tiles", "n-dark-tiles", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY, game_properties[GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY] = g_param_spec_boolean ("current-player-can-move", "current-player-can-move", "current-player-can-move", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_CURRENT_COLOR_PROPERTY, game_properties[GAME_CURRENT_COLOR_PROPERTY] = g_param_spec_enum ("current-color", "current-color", "current-color", TYPE_PLAYER, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_EXPLICIT_NOTIFY));
#line 652 "../src/game.vala"
	game_signals[GAME_TURN_ENDED_SIGNAL] = g_signal_new ("turn-ended", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOOLEAN_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_BOOLEAN, G_TYPE_BOOLEAN);
#line 652 "../src/game.vala"
	game_signals[GAME_COMPLETENESS_UPDATED_SIGNAL] = g_signal_new ("completeness-updated", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 8035 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	GListStore* _tmp0_;
#line 652 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 654 "../src/game.vala"
	_tmp0_ = g_list_store_new (TYPE_GAME_STATE_OBJECT);
#line 654 "../src/game.vala"
	self->priv->undo_stack = _tmp0_;
#line 8049 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 652 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 654 "../src/game.vala"
	_g_object_unref0 (self->priv->undo_stack);
#line 676 "../src/game.vala"
	_g_object_unref0 (self->priv->_current_state);
#line 936 "../src/game.vala"
	self->priv->neighbor_tiles = (g_free (self->priv->neighbor_tiles), NULL);
#line 972 "../src/game.vala"
	(self->priv->possible_moves == NULL) ? NULL : (self->priv->possible_moves = (_g_slist_free__possible_move_free0_ (self->priv->possible_moves), NULL));
#line 652 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 8068 "game.c"
}

static GType
game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
	GType game_type_id;
	game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
	Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
	return game_type_id;
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__once = 0;
	if (g_once_init_enter (&game_type_id__once)) {
		GType game_type_id;
		game_type_id = game_get_type_once ();
		g_once_init_leave (&game_type_id__once, game_type_id);
	}
	return game_type_id__once;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 652 "../src/game.vala"
	switch (property_id) {
#line 652 "../src/game.vala"
		case GAME_NUMBER_OF_MOVES_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_uchar (value, game_get_number_of_moves (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_SIZE_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_uchar (value, game_get_size (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_REVERSE_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_boolean (value, game_get_reverse (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_OPENING_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_enum (value, game_get_opening (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_CURRENT_STATE_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_object (value, game_get_current_state (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_uchar (value, game_get_initial_number_of_tiles (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_PRINT_LOGS_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_boolean (value, game_get_print_logs (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_IS_COMPLETE_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_boolean (value, game_get_is_complete (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_N_LIGHT_TILES_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_light_tiles (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_N_DARK_TILES_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_uchar (value, game_get_n_dark_tiles (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_CURRENT_PLAYER_CAN_MOVE_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_boolean (value, game_get_current_player_can_move (self));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_CURRENT_COLOR_PROPERTY:
#line 652 "../src/game.vala"
		g_value_set_enum (value, game_get_current_color (self));
#line 652 "../src/game.vala"
		break;
#line 8175 "game.c"
		default:
#line 652 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 652 "../src/game.vala"
		break;
#line 8181 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 652 "../src/game.vala"
	switch (property_id) {
#line 652 "../src/game.vala"
		case GAME_SIZE_PROPERTY:
#line 652 "../src/game.vala"
		game_set_size (self, g_value_get_uchar (value));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_REVERSE_PROPERTY:
#line 652 "../src/game.vala"
		game_set_reverse (self, g_value_get_boolean (value));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_OPENING_PROPERTY:
#line 652 "../src/game.vala"
		game_set_opening (self, g_value_get_enum (value));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_CURRENT_STATE_PROPERTY:
#line 652 "../src/game.vala"
		game_set_current_state (self, g_value_get_object (value));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_INITIAL_NUMBER_OF_TILES_PROPERTY:
#line 652 "../src/game.vala"
		game_set_initial_number_of_tiles (self, g_value_get_uchar (value));
#line 652 "../src/game.vala"
		break;
#line 652 "../src/game.vala"
		case GAME_PRINT_LOGS_PROPERTY:
#line 652 "../src/game.vala"
		game_set_print_logs (self, g_value_get_boolean (value));
#line 652 "../src/game.vala"
		break;
#line 8231 "game.c"
		default:
#line 652 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 652 "../src/game.vala"
		break;
#line 8237 "game.c"
	}
}

gchar*
opening_to_string (Opening self)
{
	gchar* result;
#line 1259 "../src/game.vala"
	switch (self) {
#line 1259 "../src/game.vala"
		case OPENING_HUMANS:
#line 8249 "game.c"
		{
			gchar* _tmp0_;
#line 1261 "../src/game.vala"
			_tmp0_ = g_strdup ("humans");
#line 1261 "../src/game.vala"
			result = _tmp0_;
#line 1261 "../src/game.vala"
			return result;
#line 8258 "game.c"
		}
#line 1259 "../src/game.vala"
		case OPENING_REVERSI:
#line 8262 "game.c"
		{
			gchar* _tmp1_;
#line 1262 "../src/game.vala"
			_tmp1_ = g_strdup ("reversi");
#line 1262 "../src/game.vala"
			result = _tmp1_;
#line 1262 "../src/game.vala"
			return result;
#line 8271 "game.c"
		}
#line 1259 "../src/game.vala"
		case OPENING_INVERTED:
#line 8275 "game.c"
		{
			gchar* _tmp2_;
#line 1263 "../src/game.vala"
			_tmp2_ = g_strdup ("inverted");
#line 1263 "../src/game.vala"
			result = _tmp2_;
#line 1263 "../src/game.vala"
			return result;
#line 8284 "game.c"
		}
#line 1259 "../src/game.vala"
		case OPENING_ALTER_TOP:
#line 8288 "game.c"
		{
			gchar* _tmp3_;
#line 1264 "../src/game.vala"
			_tmp3_ = g_strdup ("alter-top");
#line 1264 "../src/game.vala"
			result = _tmp3_;
#line 1264 "../src/game.vala"
			return result;
#line 8297 "game.c"
		}
#line 1259 "../src/game.vala"
		case OPENING_ALTER_LEFT:
#line 8301 "game.c"
		{
			gchar* _tmp4_;
#line 1265 "../src/game.vala"
			_tmp4_ = g_strdup ("alter-left");
#line 1265 "../src/game.vala"
			result = _tmp4_;
#line 1265 "../src/game.vala"
			return result;
#line 8310 "game.c"
		}
#line 1259 "../src/game.vala"
		case OPENING_ALTER_RIGHT:
#line 8314 "game.c"
		{
			gchar* _tmp5_;
#line 1266 "../src/game.vala"
			_tmp5_ = g_strdup ("alter-right");
#line 1266 "../src/game.vala"
			result = _tmp5_;
#line 1266 "../src/game.vala"
			return result;
#line 8323 "game.c"
		}
#line 1259 "../src/game.vala"
		case OPENING_ALTER_BOTTOM:
#line 8327 "game.c"
		{
			gchar* _tmp6_;
#line 1267 "../src/game.vala"
			_tmp6_ = g_strdup ("alter-bottom");
#line 1267 "../src/game.vala"
			result = _tmp6_;
#line 1267 "../src/game.vala"
			return result;
#line 8336 "game.c"
		}
		default:
		{
#line 1268 "../src/game.vala"
			g_assert_not_reached ();
#line 8342 "game.c"
		}
	}
}

static GType
opening_get_type_once (void)
{
	static const GEnumValue values[] = {{OPENING_HUMANS, "OPENING_HUMANS", "humans"}, {OPENING_REVERSI, "OPENING_REVERSI", "reversi"}, {OPENING_INVERTED, "OPENING_INVERTED", "inverted"}, {OPENING_ALTER_TOP, "OPENING_ALTER_TOP", "alter-top"}, {OPENING_ALTER_LEFT, "OPENING_ALTER_LEFT", "alter-left"}, {OPENING_ALTER_RIGHT, "OPENING_ALTER_RIGHT", "alter-right"}, {OPENING_ALTER_BOTTOM, "OPENING_ALTER_BOTTOM", "alter-bottom"}, {0, NULL, NULL}};
	GType opening_type_id;
	opening_type_id = g_enum_register_static ("Opening", values);
	return opening_type_id;
}

GType
opening_get_type (void)
{
	static volatile gsize opening_type_id__once = 0;
	if (g_once_init_enter (&opening_type_id__once)) {
		GType opening_type_id;
		opening_type_id = opening_get_type_once ();
		g_once_init_leave (&opening_type_id__once, opening_type_id);
	}
	return opening_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

